jQuery.global =
{
    showLoading: function(wrapper){
        jQuery(wrapper).append('<div class="f-loading"></div>');
    },
    
    hideLoading: function(wrapper){
        jQuery(wrapper + ' .f-loading').remove();
    },
    
    disableButton: function(id, text){
        jQuery('#' + id).attr('disabled', true);
        if(typeof text != 'undefined')
        {
            jQuery('#' + id).val(text);
        }
    },
    
    enableButton: function(id, text){
        jQuery('#' + id).removeAttr('disabled');
        if(typeof text != 'undefined')
        {
            jQuery('#' + id).val(text);
        }
    },
    
    loading: function ()
    {
        return '<div class="f-loading-indicator">\n\
            <div class="f-loading-circle f-loading-circle-1"></div>\n\
            <div class="f-loading-circle f-loading-circle-2"></div>\n\
            <div class="f-loading-circle f-loading-circle-3"></div>\n\
        </div>';
    },
    
    showDialog: function (dlg, data)
    {
        dlg = jQuery(dlg);
        if (typeof data !== 'undefined' && data != '')
        {
            dlg.find('.f-body').empty().append(data).show();
        }
        dlg.find('.f-body').show();
        dlg.fadeIn();
    },

    closeDialog: function (dlg)
    {
        dlg = jQuery(dlg);
        dlg.find('.f-body').hide();
        dlg.removeClass("f-quickfire-lightbox");
        dlg.fadeOut();
        return false;
    },
    
    loadWeeklyFixture: function ()
    {
        jQuery('.fixture_weekly').hide();
        jQuery('.fixture_week_' + jQuery('#week_filter').val()).show();
    },
    
    ruleScoring: function (leagueID, tab)
    {
        jQuery.global.showDialog('#dlgInfo', this.loading());
        var data = 'leagueID=' + leagueID;
        jQuery.post(ajaxurl, "action=loadPoolInfo&" + data, function (result) {
            jQuery('#dlgInfo').addClass('f-quickfire-lightbox');
            jQuery('#dlgInfo .f-body').html(result);
            
            jQuery('#week_filter option').each(function(){
                if(jQuery('.fixture_week_' + jQuery(this).attr('value')).length == 0)
                {
                    jQuery(this).remove();
                }
            });
            jQuery.global.loadWeeklyFixture();
            switch (tab)
            {
                case 2:
                    jQuery('#tabRuleScoring li:first').next().trigger('click');
                    break;
                case 3:
                    jQuery('#tabRuleScoring li:last').prev().trigger('click');
                    break;
                case 4:
                    jQuery('#tabRuleScoring li:last').trigger('click');
                    break;
            }
        })
        return false;
    },

    loadTabScoringCategory: function (item, leagueID)
    {
        if (!item.find('a').hasClass('f-is-active'))
        {
            jQuery('#tabRuleScoring li a').removeClass('f-is-active');
            item.find('a').addClass('f-is-active');
            var data = 'leagueID=' + leagueID;
            jQuery('.f-lightbox .f-tab-game-info').empty().append(this.loading());
            jQuery.post(ajaxurl, "action=loadLeagueScoringCategory&" + data, function (result) {
                jQuery('.f-lightbox .f-tab-game-info').empty().append(result);
                jQuery('#week_filter option').each(function(){
                    if(jQuery('.fixture_week_' + jQuery(this).attr('value')).length == 0)
                    {
                        jQuery(this).remove();
                    }
                });
                jQuery.global.loadWeeklyFixture();
            })
        }
    },

    loadTabLeagueEntries: function (item, leagueID)
    {
        if (!item.find('a').hasClass('f-is-active'))
        {
            jQuery('#tabRuleScoring li a').removeClass('f-is-active');
            item.find('a').addClass('f-is-active');
            var data = 'leagueID=' + leagueID;
            jQuery('.f-lightbox .f-tab-game-info').empty().append(this.loading());
            jQuery.post(ajaxurl, "action=loadLeagueEntries&" + data, function (result) {
                jQuery('.f-tab-game-info').empty().append(result);
            })
        }
    },

    loadTabLeaguePrizes: function (item, leagueID)
    {
        if (!item.find('a').hasClass('f-is-active'))
        {
            jQuery('#tabRuleScoring li a').removeClass('f-is-active');
            item.find('a').addClass('f-is-active');

            var data = 'leagueID=' + leagueID;
            jQuery('.f-lightbox .f-tab-game-info').empty().append(this.loading());
            jQuery.post(ajaxurl, "action=loadLeaguePrizes&" + data, function (result) {
                jQuery('.f-lightbox .f-tab-game-info').empty().append(result);
            })
        }
    },
    
    loadTabInviteFriends: function (item, leagueID)
    {
        if (!item.find('a').hasClass('f-is-active'))
        {
            jQuery('#tabRuleScoring li a').removeClass('f-is-active');
            item.find('a').addClass('f-is-active');

            var data = 'leagueID=' + leagueID;
            jQuery('.f-lightbox .f-tab-game-info').empty().append(this.loading());
            jQuery.post(ajaxurl, "action=loadInviteFriends&" + data, function (result) {
                jQuery('.f-lightbox .f-tab-game-info').empty().append(result);
            })
        }
    },
    
    sendInviteFriendEmail: function ()
    {
        var warning = jQuery('.f-manual-email-form-button .f-warning');
        var dataSring = jQuery('#formInviteFriend').serialize();
        jQuery.post(ajaxurl, 'action=sendInviteFriend&' + dataSring, function (result) {
            var data = JSON.parse(result);
            if (data.notice)
            {
                warning.empty().append(data.notice).css('display', 'inline-block').delay(4000).fadeOut();
            } else
            {
                warning.empty().append(data.message).css('display', 'inline-block').delay(4000).fadeOut();
            }
        })
        return false;
    },
    
    pickSelected: function()
    {
        var ifAnyBoutChecked = true;
        jQuery('#formData table:first tr').each(function(){
            if(jQuery(this).find('input[type=radio]').length > 0 && !jQuery(this).find('input[type=radio]').is(':checked'))
            {
                ifAnyBoutChecked = false;
                return;
            }
        })

        if(!ifAnyBoutChecked )
        {
            alert(wpfs['input_picks']);
            return false;
        }
        return true;
    },
};

function checkAll()
{
    jQuery("input[name='val[friend_ids][]']").attr('checked', true);
}

function checkNone()
{
    jQuery("input[name='val[friend_ids][]']").removeAttr('checked');
}