<?php 
$ajax = new FV_Ajax();
$ajax::init();

class FV_Ajax
{
    private static $fanvictor;
    private static $pools;
    private static $fighters;
    private static $orgs;
    private static $teams;
    private static $payment;
    private static $user;
    private static $statistic;
    private static $scoringcategory;
    private static $playerposition;
    private static $players;
    private static $coupon;
    private static $sports;
    private static $leagues;
    private static $autocontest;
    
    public static function init()
    {
        self::$fanvictor = new Fanvictor();
        self::$pools = new Pools();
        self::$fighters = new Fighters();
        self::$orgs = new Organizations();
        self::$teams = new Teams();
        self::$payment = new Payment();
        self::$user = new User();
        self::$statistic = new Statistic();
        self::$scoringcategory = new ScoringCategory();
        self::$playerposition = new PlayerPosition();
        self::$players = new Players();
        self::$coupon = new FV_CouponModel();
        self::$sports = new Sports();
        self::$leagues = new Leagues();
        self::$autocontest = new AutoContest();
        
        $action = !empty($_POST['action']) ? $_POST['action'] : (!empty($_GET['action']) ? $_GET['action'] : "");
        if(isset($_REQUEST['qqfilename']))
        {
            $action = 'qqUploadFile';
        }
        
        //load translate
        load_plugin_textdomain( 'fantasy-sports', false, dirname( plugin_basename( __FILE__ ) ) . '/languages' ); 
        
        if(!empty($action) && method_exists('FV_Ajax', $action))
        {
            if($action == "createContest" && self::$fanvictor->checkBuddyPressInstalled())
            {
                add_action("wp_ajax_$action", array('FV_Ajax', $action));
            }
            else
            {
                self::$action();
            }
        }
    }
    
    public static function updateNewContests()
    {
        //leagues
        $aLeagues = self::$fanvictor->getLeagueLobby();
        $aLeagues = self::$fanvictor->parseLeagueData($aLeagues);
        exit(json_encode($aLeagues));
    }

    public static function LeagueResults()
    {
        $iLeagueId = $_POST['leagueId'];
        $isLive = isset($_POST['isLive']) ? $_POST['isLive'] : '';
        $sData = self::$fanvictor->leagueResults($iLeagueId, $isLive);
        exit(json_encode($sData));
    }
    
    public static function getNormalGameResult()
    {
        $page = isset($_POST['page']) ? $_POST['page'] : 1;
        $sort_by = isset($_POST['sort_by']) ? $_POST['sort_by'] : '';
        $sort_value = isset($_POST['sort_value']) ? $_POST['sort_value'] : '';
        $entry_number = $_POST['entry_number'];
        
        $result = self::$fanvictor->getNormalGameResult(
            $_POST['leagueID'], 
            $entry_number, 
            $page,
            $sort_by,
            $sort_value,
            $_POST['date_type'],
            $_POST['date_type_number']);
        
        $league = $result['league'];
        $pool = $result['pool'];
        $num_page = $result['num_page'];
        $current_page = $result['current_page'];
        $users = $result['users'];
        $fights = $result['fights'];

        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/pick_result.php");
        exit;
    }
    
    public static function loadLiveEntries()
    {
        $leagues = self::$fanvictor->getLiveEntries();
        $leagues = self::$fanvictor->parseLeagueData($leagues);
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/live_entries.php");
        exit;
    }
    
    public static function userpicks()
    {
        $iLeagueId = $_POST['leagueId'];
        $sData = self::$fanvictor->getUserPicks($iLeagueId);
        exit($sData);
    }
    
    public static function sendInviteFriend()
    {
        $data = $_POST['val'];
        $friend_ids = isset($data['friend_ids']) ? $data['friend_ids'] : null;
        if(!array_filter($data['emails']) && $friend_ids == null)
        {
            exit(json_encode(array('notice' => __('You have not selected any friends to invite', 'fantasy-sports'))));
        }
        else if($data['importleagueID'] == "" || $data['importleagueID'] == "0" )
        {
            exit(json_encode(array('notice' => __('Sorry the system detected a spam attempt please contact support', 'fantasy-sports'))));
        }
        else if(!self::isValidInviteEmail($data['emails']))
        {
            exit(json_encode(array('notice' => __('Please enter a valid email address', 'fantasy-sports'))));
        }
        else 
        {
            foreach($data['emails'] as $k => $item)
            {
                if($item == null)
                {
                    unset($data['emails'][$k]);
                }
            }
            array_values($data['emails']);
            $data['emails'] = implode(',', $data['emails']);
            $data['friend_ids'] = $friend_ids != null ? implode(',', $friend_ids) : null;
            $data = self::$fanvictor->inviteFriend($data);
            exit($data);
        }
    }
    
    private static function isValidInviteEmail($data)
    {
        foreach($data as $item)
        {
            if($item != null && !self::$payment->validEmail($item))
            {
                return false;
            }
        }
        return true;
    }

    public static function loadPoolsByOrg()
    {
        $orgID = $_POST['orgID'];
        $aPools = self::$pools->getPools(null, $orgID, true, true);
        $resultPools = $resultFights = $sport = null;
        if($aPools != null)
        {
            foreach($aPools as $aPool)
            {
                $resultPools .= '<option value="'.$aPool['poolID'].'">'.$aPool['poolName'].'</option>';
                $sport = $aPool['type'];
            }
        }
        exit(json_encode(array('resultPools' => $resultPools, 'resultFights' => $resultFights, 'sport' => $sport)));
    }
    
    public static function loadFights()
    {
        $poolID = $_POST['poolID'];
        $aFights = self::$pools->getFights($poolID, null, true);
        $resultFights = null;
        if($aFights != null)
        {
            foreach($aFights as $aFight)
            {
                $resultFights .= '<input type="checkbox" checked="checked" name="fixture_'.$poolID.'_'.$aFight['fightID'].'" id="fixture_'.$poolID.'_'.$aFight['fightID'].'" value="'.$aFight['fightID'].'">'
                                .'<label for="fixture_'.$poolID.'_'.$aFight['fightID'].'">'.$aFight['name'].'   '.date("H:i:s",strtotime($aFight['startDate'])) .'</label><br/>';

            }

        }
        exit($resultFights);
    }
    
    public static function calculatePrizes()
    {
        $type = $_POST['type'];
        $structure = $_POST['structure'];
        $size = $_POST['size'];
        $entryFee = $_POST['entry_fee'];
        $prizes = self::$pools->calculatePrizes($type , $structure, $size, $entryFee);
        
        $result = '<table style="width:100%">'
                . '<tr><td style="text-align:left">Pos</td><td style="text-align:right">Prize</td></tr>';
        $count = 0;
        foreach($prizes as $prize)
        {
            $count++;
            $place = null;
            switch ($count)
            {
                case 1:
                    $place = '1st';
                    break;
                case 2:
                    $place = '2nd';
                    break;
                case 3:
                    $place = '3rd';
                    break;
            }
            $result .= '<tr><td style="text-align:left">'.$place.'</td><td style="text-align:right">$'.$prize.'</td></tr>';
        }
        $result .= '</table>';
        exit($result);
    }
    
    public static function viewPoolFixture()
    {
        $iPoolID = $_POST['iPoolID'];
        $aFights = self::$pools->getFights($iPoolID, null, true);
        $sResult = '';
        $count = 0;
        if($aFights != null)
        {
            $aPool = self::$pools->getPools($iPoolID, null, false, true);
            if($aPool['type'] == 'MMA' || $aPool['type'] == 'BOXING')
            {
                $teamOrFighterHeader = __("Fighter", 'fantasy-sports');
            }
            else 
            {
                $teamOrFighterHeader = __("Team", 'fantasy-sports');
            }
            $sResult .= '<table class="table table-striped table-bordered table-responsive table-condensed">';
            foreach($aFights as $aFight)
            {
                $spread1 = $aFight['team1_spread_points'];
                $spread2 = $aFight['team2_spread_points'];
                $sResult .= '<tr>
                                <td style="text-align:center">'.$spread1.' '.$aFight['name'].' '.$spread2.'</td>
                            </tr>';
            }
            $sResult .= '</table>';
        }
        else 
        {
            $sResult = '<center>'.__("No fixtures", 'fantasy-sports').'</center>';
        }
        exit($sResult);
    }
    
    //////////////////////////////v2//////////////////////////////
    public static function loadPoolInfo()
    {
        $data = self::$fanvictor->getPoolInfo($_POST['leagueID']);
        $contest_url = FANVICTOR_URL_SUBMIT_PICKS.$_POST['leagueID'];
        $pool = $data['pool'];
        $league = $data['league'];
        $scorings = $data['scoringcats'];
        $fights = $data['fights'];
        $rounds = $data['rounds']; 
        $entries = $data['entries']; 
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/contest_detail_popup.php");
        exit;
    }
    
    public static function loadLeagueScoringCategory()
    {
        $data = self::$fanvictor->getPoolInfo($_POST['leagueID']);
        $contest_url = FANVICTOR_URL_SUBMIT_PICKS.$_POST['leagueID'];
        $pool = $data['pool'];
        $league = $data['league'];
        $scorings = $data['scoringcats'];
        $fights = $data['fights'];
        $rounds = $data['rounds']; 
        $entries = $data['entries']; 
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/contest_detail_tab_scoring.php");
        exit;
    }
    
    public static function loadLeagueEntries()
    {
        $leagueID = $_POST['leagueID'];
        $users = self::$fanvictor->getEntries($leagueID);
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/contest_detail_tab_entry.php");
        exit;
    }
    
    public static function loadLeaguePrizes()
    {
        $league = self::$fanvictor->getLeagueDetail($_POST['leagueID']);
        $league = $league[0];
        
        $structure = '';
        if($league['prize_structure'] == 'WINNER')
        {
            $structure = 'winnertakeall';
        }
        else if($league['prize_structure'] == 'MULTI_PAYOUT')
        {
            $structure = 'multi_payout';
        }
        else 
        {
            $structure = 'top3';
        }
        $payouts = null;
        if(!empty($league['payouts']))
        {
            $payouts = json_decode($league['payouts'], true);
        }
        $prizes = self::$pools->calculatePrizes('' , $structure, $league['size'], $league['entry_fee'], $payouts, $league['winner_percent'], $league['first_percent'], $league['second_percent'], $league['third_percent']);
        $aDatas = array();
        if($prizes != null)
        {
            foreach($prizes as $place => $prize)
            {
                $aDatas[] = array('place' => $place, 'prize' => $prize);
            }
        }
        else 
        {
            $aDatas[] = array('place' => '1st', 'prize' => 0);
        }
        $prizes = $aDatas;
        $note = $league['note'];
        
        //guaranteed prize
        $guaranteed_prizes = array();
        if($league['is_guaranteed'])
        {
            $guaranteed_payouts = null;
            if(!empty($league['guaranteed_payouts']))
            {
                $guaranteed_payouts = json_decode($league['guaranteed_payouts'], true);
            }
            $guaranteed_prizes = self::$pools->calculatePrizes('' , $structure, 1, $league['guaranteed_prize'], $guaranteed_payouts, 100, $league['guaranteed_first_percent'], $league['guaranteed_second_percent'], $league['guaranteed_third_percent']);
            $aDatas = array();
            if($guaranteed_prizes != null)
            {
                foreach($guaranteed_prizes as $place => $prize)
                {
                    $aDatas[] = array('place' => $place, 'prize' => $prize);
                }
            }
            else 
            {
                $aDatas[] = array('place' => '1st', 'prize' => 0);
            }
            $guaranteed_prizes = $aDatas;
        }
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/contest_detail_tab_prize.php");
        exit;
    }
    
    public static function loadInviteFriends()
    {
        $leagueID = $_POST['leagueID'];
        //list friend
        $aFriends = self::$fanvictor->getAllPlayerInfo();
        $iTotalFriends = count($aFriends);
        sort($aFriends, SORT_ASC);
        usort($aFriends, function($a, $b) {
            $a = strtolower($a['full_name'] ? $a['full_name'] : $a['user_name']);
            $b = strtolower($b['full_name'] ? $b['full_name'] : $b['user_name']);
            return strcmp($a, $b);
        });
        foreach ($aPlayers as $player) {
            $quote_list_data[] = $player['name'];
        }
        $quote_list_data = implode(',', $quote_list_data);
        
        $link_contest = FANVICTOR_URL_GAME;
        if ($league['gameType'] == 'GOLFSKIN') {
            $link_contest = FANVICTOR_URL_GAME;
        }
        
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/contest_detail_tab_invite.php");
        exit;
    }
    
    public static function loadLeagueDetail()
    {
        $league = self::$fanvictor->getLeagueDetail($_POST['leagueID']);
        if($league != null)
        {
            $league = $league[0];
        }
        exit(json_encode($league));
    }
    
    public static function updatePlayerDraftResult()
    {
        if(!self::$pools->updatePlayerDraftResult($_POST))
        {
            exit('<div class=\"error_message\">'.__('Something went wrong! Please try again', 'fantasy-sports').'</div>');
        }
        exit('Successfully updated');
    }
    
    public static function loadUserResult()
    {
        $data = self::$fanvictor->getPlayerPicksResult($_POST['leagueID'], $_POST['userID'], $_POST['entry_number'],$_POST['roundID'],$_POST['week']);
        if(isset($data['stats']))
        {
            $players = $data['stats'];
            $change_players = $data['change_players'];
        }
        else
        {
            $players = $data;
            $change_players = null;
        }
        $is_motocross = $_POST['is_motocross'];
        $gameType = $_POST['gameType'];
        $leagueOptionType = $_POST['leagueOptionType'];
        $rank = $_POST['rank'];
        $username = $_POST['username'];
        $totalScore = $_POST['totalScore'];
        $avatar = $_POST['avatar'];
        $name = $gameType == 'GOLFSKIN' ? __("Skin", "fantasy-sports") : __("Score", "fantasy-sports");

        //exit(json_encode($aResults));
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/user_result.php");
        exit;
    }
    
    public static function loadLeagueLobby()
    {
        //leagues
        $leagues = self::$fanvictor->getLeagueLobby(array(
            'game_type' => !empty($_POST['game_type']) ? $_POST['game_type'] : ''
        ));
        if(!empty($_POST['poolId']) && (int)$_POST['poolId'] > 0 && $leagues != null)
		{
			foreach($leagues as $k => $league)
			{
				if($league['poolID'] != $_POST['poolId'])
				{
					unset($leagues[$k]);
				}
			}
			$leagues = array_values($leagues);
		}
        $leagues = self::$fanvictor->parseLeagueData($leagues);
        $no_cash = get_option('fanvictor_no_cash');

        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/lobby_list.php");
        exit;
    }
    
    public static function liveEntriesResult()
    {
       self::$fanvictor->liveEntriesResult($_POST['leagueID']);
       exit;
    }
    
    public static function loadContestScores()
    {
        $leagueID = $_POST['leagueID'];
        $multiEntry = $_POST['multiEntry'];
        $no_cash = get_option('fanvictor_no_cash');
        $week = $_POST['week'];        
        //scores
        $scores = self::$fanvictor->getScores($leagueID,$week);
        
        //cur user scores
        $currUserScore = null;
        if($scores != null)
        {
            foreach($scores as $k => $aScore)
            {
                $aScore[$k]['current'] = false;
                if($aScore['userID'] == $_COOKIE['fanvictor_user_id'] && $aScore['entry_number'] == $_POST['entry_number'])
                {
                    $scores[$k]['current'] = true;
                }
            }
        }
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/user_score.php");
        exit;
        //exit(json_encode($aScores));
    }
    
    public static function loadFixtureScores()
    {
        $data = self::$fanvictor->loadFixtureScores($_POST['leagueID']);
        $aFights = $data['fights'];
        $aRounds = $data['rounds'];
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/fixture_result.php");
        exit;
    }
    
    public static function loadPlayerStatistics()
    {
        $data = self::$fanvictor->getPlayerStatistics($_POST['orgID'], $_POST['playerID'], $_POST['poolID']);
        $player = $data['player'];
        $sport = $data['sport'];
        $player_stats = $data['scoring_category'];
        $opponent_stats = $data['opponent_scoring_category'];
        $opponent_name = $data['opponent_name'];
        $opponent_played = $data['opponent_played'];
        $stats = $data['stats'];
        $player_news = $data['news'];
        $played = $data['played'];
        $allow_google_news = $data['allow_google_news'];
        $performance_chart = $data['performance_chart'];
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/player_info.php");
        exit;
    }
    
    public static function loadPlayerNews()
    {
        require_once(FANVICTOR__PLUGIN_DIR_MODEL.'simple_html_dom.php');
        header('Content-Type: text/html; charset=ISO-8859-15');
        $site_url = 'https://www.google.com';
        
        //check url
        $keyword = $_POST['player_name'].' '.$_POST['player_team'];
        $keyword = str_replace(' ', '%20', $keyword);
        if(!empty($_POST['lang']))
        {
            $locale = $_POST['lang'];
        }
        else
        {
            $locale = explode('_', get_locale());
            $locale = !empty($locale[0]) ? $locale[0] : 'en';
        }
        $url = $site_url.'/search?q='.$keyword.'&lr=lang_'.$locale.'&tbm=nws&*';
        if(!empty($_POST['link']))
        {
            $url = $_POST['link'];
        }
        
        //load data
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_RETURNTRANSFER => 1,
            CURLOPT_URL => $url,
            CURLOPT_SSL_VERIFYPEER => 0,
			CURLOPT_SSL_VERIFYHOST => 0,
			CURLOPT_FOLLOWLOCATION => true
        ));
        $resp = curl_exec($curl);
        
        //parse html
        $html = str_get_html($resp);
        
        //check has result
        if(!$html->find('#search', 0) || trim($html->find('#search', 0)->plaintext) == '')
        {
            echo __("No news", "fantasy-sports");
            exit;
        }
        
        //has result
        $result = $html->find('#search', 0)->innertext;
        $result = str_replace('href="', 'target="_blank" href="'.$site_url, $result);
        $result .= '<div><ul id="player_news_paging" class="pagination">';
        foreach($html->find('#nav tbody td') as $link)
        {
            if($link->find('a', 0))
            {
                $result .= '<li><a href="'.$site_url.$link->find('a', 0)->href.'">'.$link->plaintext.'</a></li>';
            }
            else
            {
                $result .= '<li><span>'.$link->plaintext.'</span></li>';
            }
        }
        $result .= '</div></ul>';
        echo $result;
        exit;
    }

    //////////////////
    ///   payment   //
    /////////////////
    public static function addCredits()
    {
        $credits = $_POST['credits'];
        $gateway = $_POST['gateway'];
		unset($_SESSION['paypal_complete']);

        if(!isset($_SESSION['is_transaction']))
        {
            if((!is_numeric($credits) || (int)$credits < 1) && 
               $gateway != FANVICTOR_GATEWAY_DFSCOIN && 
               $gateway != FANVICTOR_GATEWAY_FOOTYCASHCOIN &&
               $gateway != FANVICTOR_GATEWAY_BITCOIN &&
               $gateway != FANVICTOR_GATEWAY_CHEESE)
            {
                exit(json_encode(array('notice' => __('Credits not valid', 'fantasy-sports'))));
            }
            else if($credits < get_option('fanvictor_minimum_deposit') && 
                $gateway != FANVICTOR_GATEWAY_FTTECH && 
                $gateway != FANVICTOR_GATEWAY_DFSCOIN && 
                $gateway != FANVICTOR_GATEWAY_FOOTYCASHCOIN && 
                $gateway != FANVICTOR_GATEWAY_BITCOIN &&
                $gateway != FANVICTOR_GATEWAY_CHEESE)
            {
                exit(json_encode(array('notice' => __('Credits must be greater than ').get_option('fanvictor_minimum_deposit', 'fantasy-sports'))));
            }
            else if(!empty($_POST['coupon_code']) && 
                    !self::$coupon->isCouponCodeExist($_POST['coupon_code'], CP_ACTION_EXTRA_DEPOSIT) && $gateway != FANVICTOR_GATEWAY_FTTECH)
            {
                exit(json_encode(array('notice' => __('This code does not exist', 'fantasy-sports'))));
            }
            else if(!empty($_POST['coupon_code']) && 
                    self::$coupon->isCouponCodeUsed($_POST['coupon_code'], CP_ACTION_EXTRA_DEPOSIT) && $gateway != FANVICTOR_GATEWAY_FTTECH)
            {
                exit(json_encode(array('notice' => __('This code has already used', 'fantasy-sports'))));
            }
            else if(!empty($_POST['coupon_code']) && 
                    self::$coupon->isCouponCodeLimit($_POST['coupon_code'], CP_ACTION_EXTRA_DEPOSIT) && $gateway != FANVICTOR_GATEWAY_FTTECH)
            {
                exit(json_encode(array('notice' => __('This code has reached to limit', 'fantasy-sports'))));
            }
            else if(!self::$payment->isGatewayExist($gateway) && $gateway != FANVICTOR_GATEWAY_FTTECH)
            {
                exit(json_encode(array('notice' => __('Please select gateway', 'fantasy-sports'))));
            }

            //validate gateway
            switch($gateway)
            {
                case FANVICTOR_GATEWAY_PAYPAL_PRO:
                    self::validDateGatewayPaypalpro($_POST);
                    break;
                case FANVICTOR_GATEWAY_PRIORITY:
                    self::validDateGatewayPriority($_POST);
                    break;
                case FANVICTOR_GATEWAY_MONEYWAVE:
                    self::validDateGatewayMoneywave($_POST);
                    break;
                case FANVICTOR_GATEWAY_FLUTTERWAVE:
                    self::validDateGatewayFlutterwave($_POST);
                    break;
                case FANVICTOR_GATEWAY_FTTECH:
                    self::validDateGatewayFttech($_POST);
                    break;
                case FANVICTOR_GATEWAY_BILLMAP:
                    self::validDateGatewayBillMap($_POST);
                    break;
                case FANVICTOR_GATEWAY_DFSCOIN:
                    self::validDateGatewayDfscoin($_POST);
                    break;
                case FANVICTOR_GATEWAY_FOOTYCASHCOIN:
                    self::validDateGatewayFootycashcoin($_POST);
                    break;
                case FANVICTOR_GATEWAY_BITCOIN:
                    self::validDateGatewayBitcoin($_POST);
                    break;
                case FANVICTOR_GATEWAY_CHEESE:
                    self::validDateGatewayCheese($_POST);
                    break;
            }
            
            if($gateway != FANVICTOR_GATEWAY_DFSCOIN && 
               $gateway != FANVICTOR_GATEWAY_FOOTYCASHCOIN &&
               $gateway != FANVICTOR_GATEWAY_BITCOIN &&
               $gateway != FANVICTOR_GATEWAY_CHEESE)
            {
                $money = self::$payment->changeCreditToCash($credits);
                $site_profit = $credits - $money;
                $credits = self::$payment->feePercentage($credits);

                $reason = '';
                if(!empty($_POST['coupon_code']))
                {
                    $coupon = self::$coupon->getCouponByCode($_POST['coupon_code'], CP_ACTION_EXTRA_DEPOSIT);
                    if($coupon != null)
                    {
                        $money += self::$coupon->getTotalDiscountValue($coupon->discount_type, $coupon->discount_value, $money);
                        $reason = __("Coupon code: ".$_POST['coupon_code'], 'fantasy-sports');
                        self::$coupon->addCouponUsed($coupon->id, $_COOKIE['fanvictor_user_id']);
                    }
                }
                $params = array(
                    'amount' => $money,
                    'operation' => 'ADD',
                    'type' => 'DEPOSIT',
                    'gateway' => $gateway,
                    'reason' => $reason,
                    'site_profit' => $site_profit,
                    'cash_to_credit' => (int)get_option('fanvictor_cash_to_credit'),
                );
                $iFundHitoryId = self::$payment->addFundhistory($params);
            }
            if((int)$iFundHitoryId > 0 || 
               $gateway == FANVICTOR_GATEWAY_DFSCOIN || 
               $gateway == FANVICTOR_GATEWAY_FOOTYCASHCOIN ||
               $gateway == FANVICTOR_GATEWAY_BITCOIN ||
               $gateway == FANVICTOR_GATEWAY_CHEESE ||
               $gateway != FANVICTOR_GATEWAY_MOLPAY)
            {
                //gateway checkout
                switch($gateway)
                {
                    case FANVICTOR_GATEWAY_PAYPAL_PRO:
                        self::gatewayPaypalpro($_POST, $credits, $gateway, $aSettings, $iFundHitoryId,$money);
                        break;
                    case FANVICTOR_GATEWAY_PRIORITY:
                        self::gatewayPriority($_POST, $credits, $gateway, $aSettings, $iFundHitoryId,$money);
                        break;
                    case FANVICTOR_GATEWAY_MONEYWAVE:
                        self::gatewayMoneywave($_POST, $credits, $gateway, $iFundHitoryId,$money);
                        break;
                    case FANVICTOR_GATEWAY_FLUTTERWAVE:
                        self::gatewayFlutterwave($_POST, $credits, $gateway, $iFundHitoryId,$money);
                        break;
                    case FANVICTOR_GATEWAY_FTTECH:
                        self::getwayFttechwave($_POST, $credits, $gateway, $iFundHitoryId, $money);
                        break;
                    case FANVICTOR_GATEWAY_BILLMAP:
                        self::getwayBillMap($_POST, $credits, $gateway, $iFundHitoryId, $money);
                        break;
                    case FANVICTOR_GATEWAY_DFSCOIN:
                        self::getwayDfscoin($_POST);
                        break;
                    case FANVICTOR_GATEWAY_FOOTYCASHCOIN:
                        self::getwayFootycashcoin($_POST);
                        break;
                    case FANVICTOR_GATEWAY_BITCOIN:
                        self::getwayBitcoin($_POST);
                        break;
                    case FANVICTOR_GATEWAY_CHEESE:
                        self::getwayCheese($_POST);
                        break;
                    case FANVICTOR_GATEWAY_MOLPAY:
                        self::gatewayMolpay($_POST, $credits, $iFundHitoryId);
                        break;
                    default :
                        $aSettings = array(
                            'paypal_email' => get_option('paypal_email_account'),
                            'business' => get_option('paypal_email_account'),
                            'item_name' => "Deposit ".$iFundHitoryId,
                            'item_number' => 1,
                            'amount' => $credits,
                            'notify_url' => FANVICTOR_URL_NOTIFY_ADD_FUNDS,
                            'return' => FANVICTOR_URL_SUCCESS_ADD_FUNDS,
                            'cancel_return' => FANVICTOR_URL_ADD_FUNDS,
                            'custom' => $_COOKIE['fanvictor_user_id'].'|'.$iFundHitoryId.'|'.$money
                        );

                        $sUrl = self::$payment->onlineTransaction($gateway, $aSettings,NULL,$money);
                        if($sUrl)
                        {
                            unset($_SESSION['is_transaction']);
                            if(strstr($sUrl, "//"))
                                exit(json_encode(array('result' => $sUrl)));
                            else
                                exit(json_encode(array('notice' => $sUrl)));
                        }
                        else
                        {
                            self::$payment->deleteFundhistory(array(
                                'id' => $iFundHitoryId
                            ));
                            exit(json_encode(array('notice' => __('Something went wrong! Please try again.', 'fantasy-sports'))));
                        }
                }
            }
            else
            {
                exit(json_encode(array('notice' => __('Something went wrong! Please try again.', 'fantasy-sports'))));
            }
        }
        else 
        {
            exit(json_encode(array('notice' => __('You are in transaction session. To start new session please refresh this page', 'fantasy-sports'))));
        }
    }

    private static function validDateGatewayBillMap($data){
        if(empty($data['subscriber_id']))
        {
            exit(json_encode(array('notice' => __('Please input subscriberID', 'fantasy-sports'))));
        }
    }
    
    private static function validDateGatewayDfscoin($data){
        if(empty($data['transaction_id']))
        {
            exit(json_encode(array('notice' => __('Please input transaction id', 'fantasy-sports'))));
        }
        else if(self::$payment->checkAppliedDfscoinTransaction($data['transaction_id']))
        {
            exit(json_encode(array('notice' => __('This transaction id already exists', 'fantasy-sports'))));
        }
    }
    
    private static function validDateGatewayFootycashcoin($data){
        if(empty($data['transaction_id']))
        {
            exit(json_encode(array('notice' => __('Please input transaction id', 'fantasy-sports'))));
        }
        else if(self::$payment->checkAppliedFootycashcoinTransaction($data['transaction_id']))
        {
            exit(json_encode(array('notice' => __('This transaction id already exists', 'fantasy-sports'))));
        }
    }
    
    private static function validDateGatewayBitcoin($data){
        if(empty($data['transaction_id']))
        {
            exit(json_encode(array('notice' => __('Please input transaction id', 'fantasy-sports'))));
        }
        else if(self::$payment->checkAppliedBitcoinTransaction($data['transaction_id']))
        {
            exit(json_encode(array('notice' => __('This transaction id already exists', 'fantasy-sports'))));
        }
    }
    
    private static function validDateGatewayCheese($data){
        if(empty($data['transaction_id']))
        {
            exit(json_encode(array('notice' => __('Please input transaction id', 'fantasy-sports'))));
        }
        else if(self::$payment->checkAppliedCheeseTransaction($data['transaction_id']))
        {
            exit(json_encode(array('notice' => __('This transaction id already exists', 'fantasy-sports'))));
        }
    }
    
    private static function validDateGatewayPaypalpro($data)
    {
        if(empty($data['first_name']))
        {
            exit(json_encode(array('notice' => __('Please input first name', 'fantasy-sports'))));
        }
        else if(empty($data['street']))
        {
            exit(json_encode(array('notice' => __('Please input address', 'fantasy-sports'))));
        }
        else if(empty($data['last_name']))
        {
            exit(json_encode(array('notice' => __('Please input last name', 'fantasy-sports'))));
        }
        else if(empty($data['credit_card_number']))
        {
            exit(json_encode(array('notice' => __('Please input credit card number', 'fantasy-sports'))));
        }
        else if(empty($data['city']))
        {
            exit(json_encode(array('notice' => __('Please input city', 'fantasy-sports'))));
        }
        else if(empty($data['credit_card_type']))
        {
            exit(json_encode(array('notice' => __('Please select credit card type', 'fantasy-sports'))));
        }
        else if(empty($data['countrycode']))
        {
            exit(json_encode(array('notice' => __('Please select country', 'fantasy-sports'))));
        }
        else if(empty($data['expire_month']))
        {
            exit(json_encode(array('notice' => __('Please input expire month', 'fantasy-sports'))));
        }
        else if(empty($data['expire_year']))
        {
            exit(json_encode(array('notice' => __('Please input expire year', 'fantasy-sports'))));
        }
        else if(empty($data['cvv']))
        {
            exit(json_encode(array('notice' => __('Please input security code', 'fantasy-sports'))));
        }
        else if(empty($data['state']))
        {
            exit(json_encode(array('notice' => __('Please input state', 'fantasy-sports'))));
        }
    }
    
    private static function gatewayPaypalpro($data, $credits, $gateway, $aSettings, $iFundHitoryId,$money)
    {
        $aSettings = array(
            'CREDITCARDTYPE' => $data['credit_card_type'],
            'ACCT' => $data['credit_card_number'],
            'EXPDATE' => $data['expire_month'].$data['expire_year'],
            'CVV2' => $data['cvv'],
            'FIRSTNAME' => $data['first_name'],
            'LASTNAME' => $data['last_name'],
            'STREET' => $data['street'],
            'CITY' => $data['city'],
            'STATE' => $data['state'],
            'COUNTRYCODE' => $data['countrycode'],
            'ZIP' => $data['zipcode'],
            'AMT' => $credits
        );
        $result = self::$payment->onlineTransaction($gateway, $aSettings, $iFundHitoryId,$money);
        if($result)
        {
            FV_SetMessage(__('Successfully add fund', 'fantasy-sports'));
            if(!is_bool($result))
            {
                exit(json_encode(array('notice' => $result)));
            }
            exit(json_encode(array('result' => FANVICTOR_URL_ADD_FUNDS.'?type='.FANVICTOR_GATEWAY_PAYPAL)));
        }
        else
        {
            exit(json_encode(array('notice' => __('Something went wrong, please try again.', 'fantasy-sports'))));
        }
    }
    
    private static function validDateGatewayPriority($data)
    {
        if(empty($_POST['ccnumber']))
        {
            exit(json_encode(array('notice' => __('Please input credit card number', 'fantasy-sports'))));
        }
        else if(empty($_POST['cvv']))
        {
            exit(json_encode(array('notice' => __('Please input cvv', 'fantasy-sports'))));
        }
    }
    
    private static function gatewayPriority($data, $credits, $gateway, $aSettings, $iFundHitoryId,$money)
    {
        $data['ccexp'] = $data['ccexp_month'].$data['ccexp_year'];
        $result = self::$payment->onlineTransaction($gateway, $data, $iFundHitoryId,$money);
        if($result['success'] == 1)
        {
            FV_SetMessage(__('Successfully add fund', 'fantasy-sports'));
            exit(json_encode(array('result' => FANVICTOR_URL_ADD_FUNDS.'?type='.FANVICTOR_GATEWAY_PRIORITY)));
        }
        else
        {
            exit(json_encode(array('notice' => $result['msg'])));
        }
    }
    
    private static function validDateGatewayMoneywave($data)
    {
        if(empty($data['firstname']))
        {
            exit(json_encode(array('notice' => __('Please input first name', 'fantasy-sports'))));
        }
        else if(empty($data['lastname']))
        {
            exit(json_encode(array('notice' => __('Please input last name', 'fantasy-sports'))));
        }
        if(empty($data['phonenumber']))
        {
            exit(json_encode(array('notice' => __('Please input phone number', 'fantasy-sports'))));
        }
        else if(empty($data['email']))
        {
            exit(json_encode(array('notice' => __('Please input email', 'fantasy-sports'))));
        }
        else if(empty($data['card_no']))
        {
            exit(json_encode(array('notice' => __('Please input credit card number', 'fantasy-sports'))));
        }
        else if(empty($data['cvv']))
        {
            exit(json_encode(array('notice' => __('Please input cvv', 'fantasy-sports'))));
        }
        else if(empty($data['pin']))
        {
            exit(json_encode(array('notice' => __('Please input pin', 'fantasy-sports'))));
        }
    }
    
    private static function gatewayMoneywave($data, $credits, $gateway, $iFundHitoryId,$money)
    {
        $params = array(
            "firstname" => $data['firstname'],
            "lastname" => $data['lastname'],
            "phonenumber" => $data['phonenumber'],
            "email" => $data['email'],
            "card_no" => $data['card_no'],
            "cvv" => $data['cvv'],
            "expiry_year" => $data['expiry_year'],
            "expiry_month" => $data['expiry_month'],
            "amount" => $data['credits'],
            "fee" => 0,
            "redirecturl" => FANVICTOR_URL_ADD_FUNDS.'?type='.FANVICTOR_GATEWAY_MONEYWAVE,
        );
        $result = self::$payment->onlineTransaction($gateway, $params, $iFundHitoryId,$money);
        if($result['success'])
        {
            FV_SetMessage(__('Successfully add fund', 'fantasy-sports'));
            exit(json_encode(array('result' => FANVICTOR_URL_ADD_FUNDS.'?type='.FANVICTOR_GATEWAY_MONEYWAVE)));
        }
        else
        {
            exit(json_encode(array('notice' => $result['msg'])));
        }
    }
    
    private static function validDateGatewayFlutterwave($data)
    {
        if(empty($data['ccnumber']))
        {
            exit(json_encode(array('notice' => __('Please input credit card number', 'fantasy-sports'))));
        }
        else if(empty($data['cvv']))
        {
            exit(json_encode(array('notice' => __('Please input cvv', 'fantasy-sports'))));
        }
    }

    public static function validDateGatewayFttech($data){
        if(empty($data['first_name']))
        {
            exit(json_encode(array('notice' => __('Please input first name', 'fantasy-sports'))));
        }
        else if(empty($data['last_name']))
        {
            exit(json_encode(array('notice' => __('Please input last name', 'fantasy-sports'))));
        }
        // else if(!preg_match('/^\d+$/', $data['phone']))
        // {
        //     exit(json_encode(array('notice' => __('Invalid Phone Format', 'fantasy-sports'))));
        // }
        // else if(empty($data['card_number']))
        // {
        //     exit(json_encode(array('notice' => __('Please input card number', 'fantasy-sports'))));
        // }
    }
    
    private static function gatewayFlutterwave($data, $credits, $gateway, $iFundHitoryId,$money)
    {
        $result = self::$payment->onlineTransaction($gateway, $data, $iFundHitoryId,$money);
		if($result['success'] == 2)
        {
            FV_SetMessage($result['msg']);
            exit(json_encode(array('url' => $result['url'])));
        }
        else if($result['success'])
        {
            FV_SetMessage(__('Successfully add fund', 'fantasy-sports'));
            exit(json_encode(array('result' => FANVICTOR_URL_ADD_FUNDS.'?type='.FANVICTOR_GATEWAY_FLUTTERWAVE)));
        }
        else
        {
            exit(json_encode(array('notice' => $result['msg'])));
        }
    }

    private static function getwayFttechwave($data, $credits, $gateway, $iFundHitoryId,$money){
        $result = self::$payment->onlineTransaction($gateway, $data, $iFundHitoryId,$money);
        if($result['success'] == 2)
        {
            FV_SetMessage($result['msg']);
            exit(json_encode(array('url' => $result['url'])));
        }
        else if($result['success'])
        {
            FV_SetMessage(__('Successfully add fund', 'fantasy-sports'));
            exit(json_encode(array('result' => FANVICTOR_URL_ADD_FUNDS.'?type='.FANVICTOR_GATEWAY_FTTECH)));
        }
        else
        {
            exit(json_encode(array('notice' => $result['msg'])));
        }
    }

    private static function getwayBillMap($data, $credits, $gateway, $iFundHitoryId,$money){
        $result = self::$payment->onlineTransaction($gateway, $data, $iFundHitoryId,$money);
        if($result['success'] == 2)
        {
            FV_SetMessage($result['msg']);
            exit(json_encode(array('url' => $result['url'])));
        }
        else if($result['success'])
        {
            FV_SetMessage(__('Successfully add fund', 'fantasy-sports'));
            exit(json_encode(array('result' => FANVICTOR_URL_ADD_FUNDS.'?type='.FANVICTOR_GATEWAY_BILLMAP)));
        }
        else
        {
            exit(json_encode(array('notice' => $result['msg'])));
        }
    }
    
    private static function getwayDfscoin($data)
    {
        $result = self::$payment->onlineTransaction(FANVICTOR_GATEWAY_DFSCOIN, $data);
        if($result['success'] == 1)
        {
            $amount = $result['amount'];
            $amount = self::$payment->exchangeRateDfscoin($amount);
            $money = self::$payment->changeCreditToCash($amount);
            $site_profit = $amount - $money;
            $amount = $money;
            $user = self::$payment->getUserData();

            $reason = '';
            if(!empty($_POST['coupon_code']))
            {
                $coupon = self::$coupon->getCouponByCode($_POST['coupon_code'], CP_ACTION_EXTRA_DEPOSIT);
                if($coupon != null)
                {
                    $amount += self::$coupon->getTotalDiscountValue($coupon->discount_type, $coupon->discount_value, $amount);
                    $reason = __("Coupon code: ".$_POST['coupon_code'], 'fantasy-sports');
                    self::$coupon->addCouponUsed($coupon->id, $_COOKIE['fanvictor_user_id']);
                }
            }
            
            $params = array(
                'amount' => $amount,
                'operation' => 'ADD',
                'type' => 'DEPOSIT',
                'new_balance' => $user['balance'] + $amount,
                'gateway' => FANVICTOR_GATEWAY_DFSCOIN,
                'cash_to_credit' => (int)get_option('fanvictor_cash_to_credit'),
                'status' => "completed",
                'transactionID' => $result['txid'],
                'is_checkout' => 1,
                'site_profit' => $site_profit
            );
            $iFundHitoryId = self::$payment->addFundhistory($params);
            if($iFundHitoryId > 0)
            {
                self::$payment->updateUserBalance($amount, false, 0, $_COOKIE['fanvictor_user_id']);
                FV_SetMessage(__('Successfully add fund', 'fantasy-sports'));
                exit(json_encode(array('result' => FANVICTOR_URL_ADD_FUNDS.'?type='.FANVICTOR_GATEWAY_DFSCOIN)));
            }
            else
            {
                exit(json_encode(array('notice' => __('Cannot add fund! Please try again.', 'fantasy-sports'))));
            }
        }
        else
        {
            exit(json_encode(array('notice' => $result['message'])));
        }
    }
    
    private static function getwayFootycashcoin($data)
    {
        $result = self::$payment->onlineTransaction(FANVICTOR_GATEWAY_FOOTYCASHCOIN, $data);
        if($result['success'] == 1)
        {
            $amount = $result['amount'];
            $amount = self::$payment->exchangeRateFootycashcoin($amount);
            $money = self::$payment->changeCreditToCash($amount);
            $site_profit = $amount - $money;
            $amount = $money;
            $user = self::$payment->getUserData();

            $reason = '';
            if(!empty($_POST['coupon_code']))
            {
                $coupon = self::$coupon->getCouponByCode($_POST['coupon_code'], CP_ACTION_EXTRA_DEPOSIT);
                if($coupon != null)
                {
                    $amount += self::$coupon->getTotalDiscountValue($coupon->discount_type, $coupon->discount_value, $amount);
                    $reason = __("Coupon code: ".$_POST['coupon_code'], 'fantasy-sports');
                    self::$coupon->addCouponUsed($coupon->id, $_COOKIE['fanvictor_user_id']);
                }
            }
            
            $params = array(
                'amount' => $amount,
                'operation' => 'ADD',
                'type' => 'DEPOSIT',
                'new_balance' => $user['balance'] + $amount,
                'gateway' => FANVICTOR_GATEWAY_FOOTYCASHCOIN,
                'cash_to_credit' => (int)get_option('fanvictor_cash_to_credit'),
                'status' => "completed",
                'transactionID' => $result['txid'],
                'is_checkout' => 1,
                'site_profit' => $site_profit
            );
            $iFundHitoryId = self::$payment->addFundhistory($params);
            if($iFundHitoryId > 0)
            {
                self::$payment->updateUserBalance($amount, false, 0, $_COOKIE['fanvictor_user_id']);
                FV_SetMessage(__('Successfully add fund', 'fantasy-sports'));
                exit(json_encode(array('result' => FANVICTOR_URL_ADD_FUNDS.'?type='.FANVICTOR_GATEWAY_FOOTYCASHCOIN)));
            }
            else
            {
                exit(json_encode(array('notice' => __('Cannot add fund! Please try again.', 'fantasy-sports'))));
            }
        }
        else
        {
            exit(json_encode(array('notice' => $result['message'])));
        }
    }
    
    private static function getwayBitcoin($data)
    {
        $result = self::$payment->onlineTransaction(FANVICTOR_GATEWAY_BITCOIN, $data);
        if($result['success'] == 1)
        {
            $amount = $result['amount'];
            $amount = self::$payment->exchangeRateBitcoin($amount);
            $money = self::$payment->changeCreditToCash($amount);
            $site_profit = $amount - $money;
            $amount = $money;
            $user = self::$payment->getUserData();

            $reason = '';
            if(!empty($_POST['coupon_code']))
            {
                $coupon = self::$coupon->getCouponByCode($_POST['coupon_code'], CP_ACTION_EXTRA_DEPOSIT);
                if($coupon != null)
                {
                    $amount += self::$coupon->getTotalDiscountValue($coupon->discount_type, $coupon->discount_value, $amount);
                    $reason = __("Coupon code: ".$_POST['coupon_code'], 'fantasy-sports');
                    self::$coupon->addCouponUsed($coupon->id, $_COOKIE['fanvictor_user_id']);
                }
            }
            
            $params = array(
                'amount' => $amount,
                'operation' => 'ADD',
                'type' => 'DEPOSIT',
                'new_balance' => $user['balance'] + $amount,
                'gateway' => FANVICTOR_GATEWAY_BITCOIN,
                'cash_to_credit' => (int)get_option('fanvictor_cash_to_credit'),
                'status' => "completed",
                'transactionID' => $result['txid'],
                'is_checkout' => 1,
                'site_profit' => $site_profit
            );
            $iFundHitoryId = self::$payment->addFundhistory($params);
            if($iFundHitoryId > 0)
            {
                self::$payment->updateUserBalance($amount, false, 0, $_COOKIE['fanvictor_user_id']);
                FV_SetMessage(__('Successfully add fund', 'fantasy-sports'));
                exit(json_encode(array('result' => FANVICTOR_URL_ADD_FUNDS.'?type='.FANVICTOR_GATEWAY_BITCOIN)));
            }
            else
            {
                exit(json_encode(array('notice' => __('Cannot add fund! Please try again.', 'fantasy-sports'))));
            }
        }
        else
        {
            exit(json_encode(array('notice' => $result['message'])));
        }
    }
    
    private static function getwayCheese($data)
    {
        $result = self::$payment->onlineTransaction(FANVICTOR_GATEWAY_CHEESE, $data);
        if($result['success'] == 1)
        {
            $amount = $result['amount'];
            $amount = self::$payment->exchangeRateCheese($amount);
            $money = self::$payment->changeCreditToCash($amount);
            $site_profit = $amount - $money;
            $amount = $money;
            $user = self::$payment->getUserData();

            $reason = '';
            if(!empty($_POST['coupon_code']))
            {
                $coupon = self::$coupon->getCouponByCode($_POST['coupon_code'], CP_ACTION_EXTRA_DEPOSIT);
                if($coupon != null)
                {
                    $amount += self::$coupon->getTotalDiscountValue($coupon->discount_type, $coupon->discount_value, $amount);
                    $reason = __("Coupon code: ".$_POST['coupon_code'], 'fantasy-sports');
                    self::$coupon->addCouponUsed($coupon->id, $_COOKIE['fanvictor_user_id']);
                }
            }
            
            $params = array(
                'amount' => $amount,
                'operation' => 'ADD',
                'type' => 'DEPOSIT',
                'new_balance' => $user['balance'] + $amount,
                'gateway' => FANVICTOR_GATEWAY_CHEESE,
                'cash_to_credit' => (int)get_option('fanvictor_cash_to_credit'),
                'status' => "completed",
                'transactionID' => $result['txid'],
                'is_checkout' => 1,
                'site_profit' => $site_profit
            );
            $iFundHitoryId = self::$payment->addFundhistory($params);
            if($iFundHitoryId > 0)
            {
                self::$payment->updateUserBalance($amount, false, 0, $_COOKIE['fanvictor_user_id']);
                FV_SetMessage(__('Successfully add fund', 'fantasy-sports'));
                exit(json_encode(array('result' => FANVICTOR_URL_ADD_FUNDS.'?type='.FANVICTOR_GATEWAY_CHEESE)));
            }
            else
            {
                exit(json_encode(array('notice' => __('Cannot add fund! Please try again.', 'fantasy-sports'))));
            }
        }
        else
        {
            exit(json_encode(array('notice' => $result['message'])));
        }
    }
    
    public static function gatewayMolpay($data, $credits, $fundHitoryId){
        require_once(FANVICTOR__PLUGIN_DIR_MODEL."molpay.php");
        $params = array(
			'referenceId' => $fundHitoryId,
            'amount' => $credits,
			'returnUrl' => FANVICTOR_URL_ADD_FUNDS."?type=".FANVICTOR_GATEWAY_MOLPAY."&return_url=1",
			'customerId' => $_COOKIE['fanvictor_user_id'],
			'description' => 'Molpay '.$fundHitoryId
        );
        $molpay = new FV_MolPay();
        $result = $molpay->checkout($params);
		if(!$result['success'])
		{
			exit(json_encode(array('notice' => $result['message'])));
		}
        exit(json_encode(array(
            'url' => $result['params']['paymentUrl']
        )));
    }

    public static function requestPayment()
    {
        $data = $_POST['val'];

        $online = false;
        $priority = false;
        $flutterwave = false;
        $gateway_id = $data['gateway_id'];
        $credits = $data['credits'];
        $reason = $data['reason'];
        
        if(!is_numeric($credits) || (int)$credits < 1)
        {
            exit(json_encode(array('notice' => 'Credits not valid')));
        }
        else if(!self::$payment->isAllowWithdraw($credits))
        {
            exit(json_encode(array('notice' => __('Credits must not exceed your available balance', 'fantasy-sports'))));
        }
        
        //validate gateway
        $data['gateway'] = $gateway_id;
        switch($gateway_id)
        {
            case FANVICTOR_GATEWAY_PAYPAL:
                $online = true;
                self::validDateRequestPaymentPaypal($data);
                break;
            case FANVICTOR_GATEWAY_PRIORITY:
                $priority = true;
                self::validDateRequestPaymentPriority($data);
                break;
            case FANVICTOR_GATEWAY_MONEYWAVE:
                self::validDateRequestPaymentMoneywave($data);
                break;
            case FANVICTOR_GATEWAY_FTTECH:
                self::validDateRequestPaymentFttechwave($data);
                break;
            case FANVICTOR_GATEWAY_DFSCOIN:
                self::validDateRequestPaymentDFSCoin($data);
                break;
            case FANVICTOR_GATEWAY_FOOTYCASHCOIN:
                self::validDateRequestPaymentFootycashCoin($data);
                break;
            case FANVICTOR_GATEWAY_BITCOIN:
                self::validDateRequestPaymentBitcoin($data);
                break;
            case FANVICTOR_GATEWAY_CHEESE:
                self::validDateRequestPaymentCheese($data);
                break;
            case FANVICTOR_GATEWAY_MOLPAY:
                self::validDateRequestPaymentMolpay($data);
                break;
            default :
                self::validDateRequestPaymentCheque($data);
        }

        //update data
        if(self::$payment->updateUserBalance($credits, true, 0))
        {
            //add withdrawl
            $aUser = self::$payment->getUserData();
            $withdraw_data = array(
                'userID' => $aUser['ID'], 
                'amount' => $credits,
                'new_balance' => $aUser['balance'],
                'reason' => $reason,
                'gateway' => $data['gateway']
            );
            if($gateway_id == FANVICTOR_GATEWAY_FTTECH)
            {
                $withdraw_data['fftech_app_name'] = $data['fftech_app_name'];
                $withdraw_data['fftech_app_password'] = $data['fftech_app_password'];
            }
            if($gateway_id == FANVICTOR_GATEWAY_DFSCOIN)
            {
                $withdraw_data['dfscoin_wallet_address'] = $data['dfscoin_wallet_address'];
            }
            if($gateway_id == FANVICTOR_GATEWAY_FOOTYCASHCOIN)
            {
                $withdraw_data['footycashcoin_address'] = $data['footycashcoin_address'];
            }
            if($gateway_id == FANVICTOR_GATEWAY_BITCOIN)
            {
                $withdraw_data['bitcoin_wallet_address'] = $data['bitcoin_wallet_address'];
            }
            if($gateway_id == FANVICTOR_GATEWAY_CHEESE)
            {
                $withdraw_data['cheese_wallet_address'] = $data['cheese_wallet_address'];
            }
            if($gateway_id == FANVICTOR_GATEWAY_MOLPAY)
            {
                $withdraw_data['molpay_application_code'] = $data['molpay_application_code'];
                $withdraw_data['molpay_secret_key'] = $data['molpay_secret_key'];
            }
            $withdrawlId = self::$payment->addWithdraw($withdraw_data);
                    
            //update user info
            unset($data['credits']);
            unset($data['reason']);
            unset($data['gateway_id']);
            unset($data['gateway']);
 
            if(!self::$payment->isUserPaymentInfoExist($data))
            {
                self::$payment->addUserPaymentInfo($data);
            }
            else 
            {
                self::$payment->updateUserPaymentInfo($data);
            }
			$params = array(
                'amount' => $credits,
                'operation' => 'DEDUCT',
                'type' => 'WITHDRAW',
                'gateway' => $data['gateway'],
                'new_balance' => $aUser['balance'],
                'reason' => 'request withdrawl',
                'status' => 'completed',
                'withdrawlID' => $withdrawlId
            );
			self::$payment->addFundhistory($params);
            
            //send email
            self::$fanvictor->sendRequestPaymentEmail($withdrawlId, $credits);

            exit(json_encode(array('result' => __('Your request has been sent', 'fantasy-sports'), 'redirect' => FANVICTOR_URL_REQUEST_HISTORY)));
        }
        else
        {
            exit(json_encode(array('notice' => __('Something went wrong! Please try again.', 'fantasy-sports'))));
        }
    }
    
    public static function userWithdrawlDlg()
    {
        $data = $_POST;
        if(empty($data))
        {
            exit(__('No data', 'fantasy-sports'));
        }
        $id = $data['id'];
        $withdraw = self::$payment->getWithdraw($id);
        if(empty($withdraw))
        {
            exit(__('No data', 'fantasy-sports'));
        }
        $user = self::$payment->getUserData($withdraw['userID']);
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."/withdrawls/dlg_user_withdrawls.php");
        exit();
    }

    private static function validDateRequestPaymentCheque($data)
    {
        if(empty($data['name']))
        {
            exit(json_encode(array('notice' => __('Please provide your name', 'fantasy-sports'))));
        }
        else if(empty($data['street']))
        {
            exit(json_encode(array('notice' => __('Please provide street', 'fantasy-sports'))));
        }
        else if(empty($data['city']))
        {
            exit(json_encode(array('notice' => __('Please provide city', 'fantasy-sports'))));
        }
        else if(empty($data['state']))
        {
            exit(json_encode(array('notice' => __('Please provide state', 'fantasy-sports'))));
        }
        else if(empty($data['country']))
        {
            exit(json_encode(array('notice' => __('Please provide country', 'fantasy-sports'))));
        }
    }
    
    private static function validDateRequestPaymentPaypal($data)
    {
        if(empty($data['email']))
        {
            exit(json_encode(array('notice' => __('Please provide your email', 'fantasy-sports'))));
        }
    }
    
    private static function validDateRequestPaymentPriority($data)
    {
        if(empty($data['username']))
        {
            exit(json_encode(array('notice' => __('Please provide user name', 'fantasy-sports'))));
        }
        elseif(empty($data['password']))
        {
            exit(json_encode(array('notice' => __('Please provide password', 'fantasy-sports'))));
        }
    }
    
    private static function validDateRequestPaymentMoneywave($data)
    {
        if(empty($data['moneywave_sender_name']))
        {
            exit(json_encode(array('notice' => __('Please provide name', 'fantasy-sports'))));
        }
        else if(empty($data['moneywave_account_number']))
        {
            exit(json_encode(array('notice' => __('Please provide account number', 'fantasy-sports'))));
        }
        else if(empty($data['moneywave_bank']))
        {
            exit(json_encode(array('notice' => __('Please select bank', 'fantasy-sports'))));
        }
    }

    private static function validDateRequestPaymentFttechwave($data)
    {
        if(empty($data['fttech_app_name'])){
            exit(json_encode(array('notice' => __('Please provide app name', 'fantasy-sports'))));
        }else if(empty($data['fttech_app_password'])){
            exit(json_encode(array('notice' => __('Please provide app password', 'fantasy-sports'))));
        }
    }

    private static function validDateRequestPaymentDFSCoin($data)
    {
        if(empty($data['dfscoin_wallet_address'])){
            exit(json_encode(array('notice' => __('Please provide wallet address', 'fantasy-sports'))));
        }
    }
    
    private static function validDateRequestPaymentFootycashCoin($data)
    {
        if(empty($data['footycashcoin_address'])){
            exit(json_encode(array('notice' => __('Please provide address', 'fantasy-sports'))));
        }
    }
    
    private static function validDateRequestPaymentBitcoin($data)
    {
        if(empty($data['bitcoin_wallet_address'])){
            exit(json_encode(array('notice' => __('Please provide wallet address', 'fantasy-sports'))));
        }
    }
    
    private static function validDateRequestPaymentCheese($data)
    {
        if(empty($data['cheese_wallet_address'])){
            exit(json_encode(array('notice' => __('Please provide wallet address', 'fantasy-sports'))));
        }
    }
    
    private static function validDateRequestPaymentMolpay($data)
    {
        if(empty($data['molpay_application_code'])){
            exit(json_encode(array('notice' => __('Please provide application code', 'fantasy-sports'))));
        }
        else if(empty($data['molpay_secret_key'])){
            exit(json_encode(array('notice' => __('Please provide secret key', 'fantasy-sports'))));
        }
    }
    
    public static function loadUserBalance()
    {
        $aUser = self::$payment->getUserData();
        exit($aUser['balance']);
    }

    //////////////////
    ///   admin   ///
    /////////////////
    
    public static function activeAutoContest(){
        $id = $_POST['id'];
        $active = $_POST['active'];
        if(self::$autocontest->updateAutoContestStatus(array('id' => $id, 'status' => $active))){
            exit(json_encode(array('result' => 'true')));
        }
        exit(json_encode(array('notice' => __('Something went wrong! Please try again.', 'fantasy-sports'))));
    }

    public static function activeOrgs()
    {
        $orgID = $_POST['id'];
        $active = $_POST['active'];
        if(self::$orgs->updateOrgsActive($orgID, $active))
        {
            exit(json_encode(array('result' => 'true')));
        }
        exit(json_encode(array('notice' => __('Something went wrong! Please try again.', 'fantasy-sports'))));
    }
	
	public static function reversePointOrgs()
    {
        $orgID = $_POST['id'];
        $active = $_POST['active'];
        if(self::$orgs->updateOrgsReversePoint($orgID, $active))
        {
            exit(json_encode(array('result' => 'true')));
        }
        exit(json_encode(array('notice' => __('Something went wrong! Please try again.', 'fantasy-sports'))));
    }
    
    public static function activeScoringCategory()
    {
        $id = $_POST['id'];
        $active = $_POST['active'];
        if(self::$scoringcategory->updateScoringCategoryActive($id, $active))
        {
            exit(json_encode(array('result' => 'true')));
        }
        exit(json_encode(array('notice' => __('Something went wrong! Please try again.', 'fantasy-sports'))));
    }
    
    public static function loadCbOrgs()
    {
        $sport = $_POST['sport'];
        $sel = $_POST['sel'];
        $aOrgs = self::$orgs->getOrgs(null, $sport, true);
        $result = null;
        if($aOrgs != null)
        {
            foreach($aOrgs as $aOrg)
            {
                $select = null;
                if($aOrg['organizationID'] == $sel)
                {
                    $select = 'selected="true"';
                }
                $result .= '<option value="'.$aOrg['organizationID'].'" '.$select.'>'.$aOrg['description'].'</option>';
            }
        }
        exit($result);
    }
    
    public static function loadCbFighters()
    {
        $orgsID = $_POST['orgsID'];
        $aFighters = self::$fighters->getFighters(null, $orgsID, true);
        $result = '<option value="">--'.__('Please select fighter', 'fantasy-sports').'--</option>';
        if($aFighters != null)
        {
            foreach($aFighters as $aFighter)
            {
                $result .= '<option value="'.$aFighter['fighterID'].'">'.$aFighter['name'].'</option>';
            }
        }
        exit($result);
    }
    
    public static function loadCbTeams()
    {
        $orgsID = $_POST['orgsID'];
        $aTeams = self::$teams->getTeams(null, $orgsID, true);
        $result = '<option value="">--'.__('Please select team', 'fantasy-sports').'--</option>';
        if($aTeams != null)
        {
            foreach($aTeams as $aTeam)
            {
                $result .= '<option value="'.$aTeam['teamID'].'">'.$aTeam['name'].'</option>';
            }
        }
        exit($result);
    }
    
    public static function loadUser()
    {
        $user_id = $_POST['user_id'];
        $aUser = self::$user->getUser($user_id);
        exit(json_encode($aUser));
    }
    
    /////////////////////////////////payment/////////////////////////////////
    public static function sendUserCredits()
    {
        $task = $_POST['task'];
        $user_id = $_POST['user_id'];
        $credits = $_POST['credits'];
        $reason = $_POST['reason'];
        if(!is_numeric($credits) || (int)$credits < 1)
        {
            exit(json_encode(array('notice' => __('Credits not valid', 'fantasy-sports'))));
        }
        else if($task == 'remove' && !self::$payment->isAllowWithdraw($credits, $user_id))
        {
            exit(json_encode(array('notice' => __('Credits must not exceed your available balance', 'fantasy-sports'))));
        }
        else
        {
            switch($task)
            {
                case 'remove':
                    $decrease = true;
                    $operation = 'DEDUCT';
                    $msg = __('Successfully deducted', 'fantasy-sports');
                    break;
                default :
                    $decrease = false;
                    $operation = 'ADD';
                    $msg = __('Successfully added', 'fantasy-sports');
                    break;
            }
            if(self::$payment->updateUserBalance($credits, $decrease, 0, $user_id))
            {
                $aUser = self::$payment->getUserData($user_id);
                $params = array(
                    'userID' => $user_id,
                    'amount' => $credits,
                    'operation' => $operation,
                    'type' => 'CREDITS',
                    'new_balance' => $aUser['balance'],
                    'reason' => $reason,
                    'status' => 'completed'
                );
                self::$payment->addFundhistory($params);
				self::$fanvictor->sendUserCreditEmail($user_id, $credits, $operation, $reason);
                exit(json_encode(array('result' => $msg)));
            }
            else
            {
                exit(json_encode(array('notice' => __('Something went wrong! Please try again.', 'fantasy-sports'))));
            }
        }
    }
    
    public static function sendUserWithdrawls()
    {
        $withdrawlID = $_POST['withdrawlID'];
        $action = isset($_POST['status']) ? $_POST['status'] : '';
        $gateway = isset($_POST['gateway']) ? $_POST['gateway'] : '';
        $response_message = $_POST['response_message'];
        if($action != 'APPROVED' && $action != 'DECLINED')
        {
            exit(json_encode(array('notice' => __('Please select action', 'fantasy-sports'))));
        }
        else
        {
            $aWithdrawl = self::$payment->getWithdraw($withdrawlID);
            if(empty($aWithdrawl))
            {
                exit(json_encode(array('notice' => __('Request withdrawl not found', 'fantasy-sports'))));
            }
            $aVals = array('status' => $action, 
                           'response_message' => $response_message,
                           'processedDate' => date('Y-m-d H:i:s'));
            if($action == 'DECLINED' && $aWithdrawl['status'] != 'DECLINED')
            {
                if(self::$payment->updateWithdraw($withdrawlID, $aVals) &&
                   self::$payment->updateUserBalance($aWithdrawl['amount'], false, 0, $aWithdrawl['userID']))
                {
                    $aUser = self::$payment->getUserData($aWithdrawl['userID']);
                    $params = array(
                        'userID' => $aWithdrawl['userID'],
                        'amount' => $aWithdrawl['amount'],
                        'new_balance' => $aUser['balance'],
                        'gateway' => $aWithdrawl['gateway'],
                        'operation' => 'ADD',
                        'type' => 'WITHDRAW',
                        'reason' => 'declined withdrawl',
                        'status' => 'completed'
                    );
                    self::$payment->addFundhistory($params);
                    self::$fanvictor->sendApplyWithdrawlEmail($withdrawlID, $action);
                    exit(json_encode(array('result' => __('Successfully updated', 'fantasy-sports'))));
                }
                else
                {
                    exit(json_encode(array('result' => __('Something went wrong! Please try again.', 'fantasy-sports'))));
                }
            }
            else if($action == 'APPROVED' && $aWithdrawl['status'] != 'APPROVED')
            {
                if($aWithdrawl['gateway'] == FANVICTOR_GATEWAY_PAYPAL)
                {
                    $aUserPaymentInfo = self::$payment->getUserPaymentInfo($aWithdrawl['userID']);
                    if(isset($aUserPaymentInfo['email']) && $aUserPaymentInfo['email'] != null)
                    {
                        $aSettings = array(
                            'paypal_email' => $aUserPaymentInfo['email'],
                            'business' => $aUserPaymentInfo['email'],
                            'item_name' => "withdraw ".$withdrawlID,
                            'item_number' => 1,
                            'amount' => $aWithdrawl['real_amount'],
                            'notify_url' => FANVICTOR_URL_NOTIFY_WITHDRAWLS,
                            'return' => FANVICTOR_URL_SUCCESS_WITHDRAWLS,
                            'cancel_return' => admin_url().'admin.php?page=withdrawls',
                            'custom' => $withdrawlID.'|'.$response_message);
                        $paypal = new Paypal();
                        $url = $paypal->parseData($aSettings);
                        exit(json_encode(array('redirect' => $url)));
                    }
                    else 
                    {
                        exit(json_encode(array('notice' => __('This user does not provide email for online transaction', 'fantasy-sports'))));
                    }
                }elseif($aWithdrawl['gateway'] == FANVICTOR_GATEWAY_PRIORITY){
                    $aUserPaymentInfo = self::$payment->getUserPaymentInfo($aWithdrawl['userID']);
                    if(!empty($aUserPaymentInfo['username']) && !empty($aUserPaymentInfo['password']) ){
                        require_once FANVICTOR__PLUGIN_DIR_MODEL .'priority.php';
                        $gw = new gwapii();
                        $gw->setLogin($aUserPaymentInfo['username'], $aUserPaymentInfo['password']);
                        $gw->doSale($aWithdrawl['real_amount'], get_option('fanvictor_priority_credit_card'), get_option('fanvictor_priority_credit_card_expiration_date'), get_option('fanvictor_priority_credit_card_ccv'));
                        $result = $gw->responses;
                        
                        if($result['response_code'] == 100 && $result['responsetext'] == 'SUCCESS'){
                            $aVals = array(
                                'status'=>'APPROVED',
                                'transactionID'=>$result['transactionid'],
                                'processedDate' => date('Y-m-d H:i:s'), 
                                'response_message' => $response_message,
                            );
                            self::$payment->updateWithdraw($aWithdrawl['withdrawlID'],$aVals);
                            if($aWithdrawl['status'] == 'DECLINED'){
                            self::$payment->updateUserBalance($aWithdrawl['amount'], true, 0, $aWithdrawl['userID']);
                            $aUser = self::$payment->getUserData($aWithdrawl['userID']);
                            $params = array(
                                'userID' => $aWithdrawl['userID'],
                                'amount' => $aWithdrawl['amount'],
                                'new_balance' => $aUser['balance'],
                                'operation' => 'DEDUCT',
                                'type' => 'WITHDRAW',
                                'reason' => 'approved withdrawl',
                                'status' => 'completed'
                            );
                            self::$payment->addFundhistory($params);
                        
                            }
                        self::$fanvictor->sendApplyWithdrawlEmail($withdrawlID, $action);
                        exit(json_encode(array('result' => __('Successfully updated', 'fantasy-sports'))));
                        }else{
                           exit(json_encode(array('notice' => $result['responsetext']))); 
                        }
                        
                    }else{
                        exit(json_encode(array('notice' => __('This user does not provide username/password for  transaction', 'fantasy-sports'))));
                    }
                }elseif($aWithdrawl['gateway'] == FANVICTOR_GATEWAY_MONEYWAVE){
                    $aUserPaymentInfo = self::$payment->getUserPaymentInfo($aWithdrawl['userID']);
                    if (!empty($aUserPaymentInfo['moneywave_account_number'])) {
                        $params = array(
                            "sender_name" => $aUserPaymentInfo['moneywave_sender_name'],
                            "sender_account_number" => $aUserPaymentInfo['moneywave_account_number'],
                            "sender_bank" => $aUserPaymentInfo['moneywave_bank'],
                            "amount" => $aWithdrawl['real_amount']
                        );
                        $response = self::$payment->moneywaveWithdrawl($params, $aWithdrawl['withdrawlID']);

                        if ($response['success']) {
                            $aVals = array(
                                'status' => 'APPROVED',
                                'transactionID' => $response['data']['transactionID'],
                                'processedDate' => date('Y-m-d H:i:s'),
                                'response_message' => $response_message,
                            );
                              self::$payment->updateWithdraw($aWithdrawl['withdrawlID'],$aVals);
                            if ($aWithdrawl['status'] == 'DECLINED') {
                                self::$payment->updateUserBalance($aWithdrawl['amount'], true, 0, $aWithdrawl['userID']);
                                $aUser = self::$payment->getUserData($aWithdrawl['userID']);
                                $params = array(
                                    'userID' => $aWithdrawl['userID'],
                                    'amount' => $aWithdrawl['amount'],
                                    'new_balance' => $aUser['balance'],
                                    'operation' => 'DEDUCT',
                                    'type' => 'WITHDRAW',
                                    'reason' => 'approved withdrawl',
                                    'status' => 'completed'
                                );
                                self::$payment->addFundhistory($params);
                            }
                            self::$fanvictor->sendApplyWithdrawlEmail($withdrawlID, $action);
                            exit(json_encode(array('result' => __('Successfully updated', 'fantasy-sports'))));
                        } else {
                            exit(json_encode(array('notice' => $response['msg'])));
                        }
                    } else {
                        exit(json_encode(array('notice' => __('This user does not provide account number for  transaction', 'fantasy-sports'))));
                    }
                }
                elseif($aWithdrawl['gateway'] == FANVICTOR_GATEWAY_FTTECH){
                    require_once("model".DIRECTORY_SEPARATOR."fttechware.php");

                    $objFttech = new FttechWare();

                    $current_user = self::$payment->getUserData();

                    //check user exist in app (app verify user data)
                    $data_app_verify_user_default_card = array(
                        'applicationName'       => $aWithdrawl['fftech_app_name'],
                        'applicationPassword'   => $aWithdrawl['fftech_app_password'],
                        'userName'              => get_option('fanvictor_fttech_username')
                    );

                    $response_app_verify_user_default_card = $objFttech->app_verify_user_default_card($data_app_verify_user_default_card);

                    $receiver = array(
                        'applicationName'       => $aWithdrawl['fftech_app_name'],
                        'applicationPassword'   => $aWithdrawl['fftech_app_password']
                    );

                    $sender = array(
                        'ID'                => $current_user['ID'],
                        'userName'          => get_option('fanvictor_fttech_username'),
                        'cardDescription'   => get_option('fanvictor_fttech_username'),
                        'primaryAccountNumber' => get_option('fanvictor_fttech_card_number'),
                        'expirationMonth'   => get_option('fanvictor_fttech_expire_month'),
                        'expirationYear'    => get_option('fanvictor_fttech_expire_year'),
                        'verificationValue' => get_option('fanvictor_fttech_card_verification_value'),
                        'credits'           => $aWithdrawl['amount'],
                        'fftech_cardtoken'  => ($response_app_verify_user_default_card['cardTokenId'] != '') ? $response_app_verify_user_default_card['cardTokenId'] : $current_user['fftech_cardtoken']
                    );

                    $options = array();

                    if($response_app_verify_user_default_card['isApproved']){
                        $options = array('task' => 'exist_account');
                        $sender['userPassword'] = get_option('fanvictor_fttech_user_password');
                    }else{
                        // user not exist in app
                        $data_create = array(
                            'applicationName'   => $aWithdrawl['fftech_app_name'],
                            'userName'          => get_option('fanvictor_fttech_username'),
                            'userFirstName'     => get_option('fanvictor_fttech_first_name'),
                            'userLastName'      => get_option('fanvictor_fttech_last_name'),
                            'userPassword'      => get_option('fanvictor_fttech_user_password'),
                            'userEmail'         => get_option('fanvictor_fttech_user_email'),
                            'userCallerId'      => get_option('fanvictor_fttech_phone')
                        );

                        $response_create_user = $objFttech->user_create($data_create);
                        if(!$response_create_user['isApproved']){
                            exit(json_encode(array('notice' => $response_create_user['apiStatus'])));
                        }else{
                            global $wpdb;
                            $table_user_extended = $wpdb->prefix.'user_extended';
                            $data_user_ext = array(
                                'fttech_password' => $data_create['userPassword']
                            );
                            $wpdb->update($table_user_extended, $data_user_ext, array('user_id' => $current_user['ID']));
                        }

                        $options = array('task' => 'exist_account');
                        $sender['userPassword'] = $data_create['userPassword'];
                    }

                    $result = $objFttech->charge($sender, $receiver, $options);
                    if(isset($result['success']) && $result['success']){
                        $aVals = array(
                            'status'=>'APPROVED',
                            'transactionID'=> $result['transactionID'],
                            'processedDate' => date('Y-m-d H:i:s'), 
                            'response_message' => $response_message,
                        );
                        self::$payment->updateWithdraw($aWithdrawl['withdrawlID'],$aVals);
                        if($aWithdrawl['status'] == 'DECLINED'){
                        self::$payment->updateUserBalance($aWithdrawl['amount'], true, 0, $aWithdrawl['userID']);
                        $aUser = self::$payment->getUserData($aWithdrawl['userID']);
                        $params = array(
                            'userID' => $aWithdrawl['userID'],
                            'amount' => $aWithdrawl['amount'],
                            'new_balance' => $aUser['balance'],
                            'operation' => 'DEDUCT',
                            'type' => 'WITHDRAW',
                            'reason' => 'approved withdrawl',
                            'status' => 'completed'
                        );
                        self::$payment->addFundhistory($params);
                    
                        }
                        self::$fanvictor->sendApplyWithdrawlEmail($withdrawlID, $action);
                        exit(json_encode(array('result' => __('Successfully updated', 'fantasy-sports'))));
                    }else{
                        exit(json_encode($result));
                    }

                }
                elseif($aWithdrawl['gateway'] == FANVICTOR_GATEWAY_DFSCOIN)
                {
                    if(empty($_POST['transactionID']))
                    {
                        exit(json_encode(array('notice' => __('Please input transaction id', 'fantasy-sports'))));
                    }
                    else if(empty($aWithdrawl['dfscoin_wallet_address']))
                    {
                        exit(json_encode(array('notice' => __('No wallet address', 'fantasy-sports'))));
                    }
                    else if(self::$payment->checkAppliedDfscoinTransaction($_POST['transactionID']))
                    {
                        exit(json_encode(array('notice' => __('This transaction id already exists', 'fantasy-sports'))));
                    }
                    
                    require_once("model".DIRECTORY_SEPARATOR."dfscoin.php");
                    $dfscoin = new Dfscoin();
                    $response = $dfscoin->transactionDetail($_POST['transactionID'], $aWithdrawl['dfscoin_wallet_address']);
                    if ($response['success'] == 1) 
                    {
                        $withdraw_data = array(
                            'status' => 'APPROVED',
                            'transactionID' => $response['data']['transactionID'],
                            'processedDate' => date('Y-m-d H:i:s'),
                            'response_message' => $response_message,
                        );
                        self::$payment->updateWithdraw($aWithdrawl['withdrawlID'], $withdraw_data);
                        self::$payment->updateFundhistoryByWithdrawl($aWithdrawl['withdrawlID'], array(
                            'transactionID' => $_POST['transactionID']
                        ));
                        
                        self::$fanvictor->sendApplyWithdrawlEmail($aWithdrawl['withdrawlID'], $action);
                        exit(json_encode(array('result' => __('Successfully updated', 'fantasy-sports'))));
                    } 
                    else
                    {
                        exit(json_encode(array('notice' => $response['message'])));
                    }
                }
                elseif($aWithdrawl['gateway'] == FANVICTOR_GATEWAY_FOOTYCASHCOIN)
                {
                    if(empty($_POST['transactionID']))
                    {
                        exit(json_encode(array('notice' => __('Please input transaction id', 'fantasy-sports'))));
                    }
                    else if(empty($aWithdrawl['footycashcoin_address']))
                    {
                        exit(json_encode(array('notice' => __('No wallet address', 'fantasy-sports'))));
                    }
                    else if(self::$payment->checkAppliedFootycashcoinTransaction($_POST['transactionID']))
                    {
                        exit(json_encode(array('notice' => __('This transaction id already exists', 'fantasy-sports'))));
                    }
                    
                    require_once("model".DIRECTORY_SEPARATOR."footycashcoin.php");
                    $footycashcoin = new Footycashcoin();
                    $response = $footycashcoin->transactionDetail($_POST['transactionID'], $aWithdrawl['footycashcoin_address']);
                    if ($response['success'] == 1) 
                    {
                        $withdraw_data = array(
                            'status' => 'APPROVED',
                            'transactionID' => $response['data']['transactionID'],
                            'processedDate' => date('Y-m-d H:i:s'),
                            'response_message' => $response_message,
                        );
                        self::$payment->updateWithdraw($aWithdrawl['withdrawlID'], $withdraw_data);
                        self::$payment->updateFundhistoryByWithdrawl($aWithdrawl['withdrawlID'], array(
                            'transactionID' => $_POST['transactionID']
                        ));
                        
                        self::$fanvictor->sendApplyWithdrawlEmail($aWithdrawl['withdrawlID'], $action);
                        exit(json_encode(array('result' => __('Successfully updated', 'fantasy-sports'))));
                    } 
                    else
                    {
                        exit(json_encode(array('notice' => $response['message'])));
                    }
                }
                elseif($aWithdrawl['gateway'] == FANVICTOR_GATEWAY_BITCOIN)
                {
                    if(empty($_POST['transactionID']))
                    {
                        exit(json_encode(array('notice' => __('Please input transaction id', 'fantasy-sports'))));
                    }
                    else if(empty($aWithdrawl['bitcoin_wallet_address']))
                    {
                        exit(json_encode(array('notice' => __('No wallet address', 'fantasy-sports'))));
                    }
                    else if(self::$payment->checkAppliedBitcoinTransaction($_POST['transactionID']))
                    {
                        exit(json_encode(array('notice' => __('This transaction id already exists', 'fantasy-sports'))));
                    }
                    
                    require_once("model".DIRECTORY_SEPARATOR."bitcoin.php");
                    $bitcoin = new Bitcoin();
                    $response = $bitcoin->transactionDetail($_POST['transactionID'], $aWithdrawl['bitcoin_wallet_address']);
                    if ($response['success'] == 1) 
                    {
                        $withdraw_data = array(
                            'status' => 'APPROVED',
                            'transactionID' => $response['data']['transactionID'],
                            'processedDate' => date('Y-m-d H:i:s'),
                            'response_message' => $response_message,
                        );
                        self::$payment->updateWithdraw($aWithdrawl['withdrawlID'], $withdraw_data);
                        self::$payment->updateFundhistoryByWithdrawl($aWithdrawl['withdrawlID'], array(
                            'transactionID' => $_POST['transactionID']
                        ));
                        
                        self::$fanvictor->sendApplyWithdrawlEmail($aWithdrawl['withdrawlID'], $action);
                        exit(json_encode(array('result' => __('Successfully updated', 'fantasy-sports'))));
                    } 
                    else
                    {
                        exit(json_encode(array('notice' => $response['message'])));
                    }
                }
                elseif($aWithdrawl['gateway'] == FANVICTOR_GATEWAY_CHEESE)
                {
                    if(empty($_POST['transactionID']))
                    {
                        exit(json_encode(array('notice' => __('Please input transaction id', 'fantasy-sports'))));
                    }
                    else if(empty($aWithdrawl['cheese_wallet_address']))
                    {
                        exit(json_encode(array('notice' => __('No wallet address', 'fantasy-sports'))));
                    }
                    else if(self::$payment->checkAppliedCheeseTransaction($_POST['transactionID']))
                    {
                        exit(json_encode(array('notice' => __('This transaction id already exists', 'fantasy-sports'))));
                    }
                    
                    require_once("model".DIRECTORY_SEPARATOR."cheese.php");
                    $cheese = new Cheese();
                    $response = $cheese->transactionDetail($_POST['transactionID'], $aWithdrawl['cheese_wallet_address']);
                    if ($response['success'] == 1) 
                    {
                        $withdraw_data = array(
                            'status' => 'APPROVED',
                            'transactionID' => $response['data']['transactionID'],
                            'processedDate' => date('Y-m-d H:i:s'),
                            'response_message' => $response_message,
                        );
                        self::$payment->updateWithdraw($aWithdrawl['withdrawlID'], $withdraw_data);
                        self::$payment->updateFundhistoryByWithdrawl($aWithdrawl['withdrawlID'], array(
                            'transactionID' => $_POST['transactionID']
                        ));
                        
                        self::$fanvictor->sendApplyWithdrawlEmail($aWithdrawl['withdrawlID'], $action);
                        exit(json_encode(array('result' => __('Successfully updated', 'fantasy-sports'))));
                    } 
                    else
                    {
                        exit(json_encode(array('notice' => $response['message'])));
                    }
                }
                elseif($aWithdrawl['gateway'] == FANVICTOR_GATEWAY_MOLPAY)
                {
                    require_once(FANVICTOR__PLUGIN_DIR_MODEL."molpay.php");
                    $params = array(
                        'molpay_application_code' => $aWithdrawl['molpay_application_code'],
                        'molpay_secret_key' => $aWithdrawl['molpay_secret_key'],
                        'referenceId' => $aWithdrawl['withdrawlID'],
                        'amount' => $aWithdrawl['amount'],
                        'returnUrl' => admin_url().'admin.php?page=withdrawls',
                        'customerId' => $aWithdrawl['userID'],
                        'description' => 'Molpay request withdrawl '.$aWithdrawl['withdrawlID']
                    );
                    $molpay = new FV_MolPay();
                    $result = $molpay->checkout($params);
                    if(!$result['success'])
                    {
                        exit(json_encode(array('notice' => $result['message'])));
                    }
                    exit(json_encode(array(
                        'redirect' => $result['params']['paymentUrl']
                    )));
                }
                else 
                {
                    $aVals = array('status' => 'APPROVED', 
                                    'response_message' => $response_message,
                                    'processedDate' => date('Y-m-d H:i:s'));
                    if(self::$payment->updateWithdraw($withdrawlID, $aVals))
                    {
                        if($aWithdrawl['status'] == 'DECLINED')
                        {
                            self::$payment->updateUserBalance($aWithdrawl['amount'], true, 0, $aWithdrawl['userID']);
                            $aUser = self::$payment->getUserData($aWithdrawl['userID']);
                            $params = array(
                                'userID' => $aWithdrawl['userID'],
                                'amount' => $aWithdrawl['amount'],
                                'new_balance' => $aUser['balance'],
                                'operation' => 'DEDUCT',
                                'type' => 'WITHDRAW',
                                'reason' => 'approved withdrawl',
                                'status' => 'completed'
                            );
                            self::$payment->addFundhistory($params);
                        }
                        self::$fanvictor->sendApplyWithdrawlEmail($withdrawlID, $action);
                        exit(json_encode(array('result' => __('Successfully updated', 'fantasy-sports'))));
                    }
                    else
                    {
                        exit(json_encode(array('result' => __('Something went wrong! Please try again.', 'fantasy-sports'))));
                    }
                }
            }
            else if($action == 'APPROVED' && $aWithdrawl['status'] == 'APPROVED')
            {
                exit(json_encode(array('result' => __('This item already approved', 'fantasy-sports'))));
            }
            else if($action == 'DECLINED' && $aWithdrawl['status'] == 'DECLINED')
            {
                exit(json_encode(array('result' => __('This item already declined', 'fantasy-sports'))));
            }
            else
            {
                exit(json_encode(array('result' => __('Something went wrong! Please try again.', 'fantasy-sports'))));
            }
        }
    }
    
    /////////////////////////////////view result/////////////////////////////////
    public static function viewResult()
    {
        $iPoolID = $_POST['iPoolID'];
        $aFights = self::$pools->getFights($iPoolID);

        $sResult = '';
        $count = 0;
        if($aFights != null)
        {
            $sResult .= '<div id="resultMessage"></div>
                        <form id="formResult">
                        <input type="hidden" name="val[poolID]" value="'.$iPoolID.'" />';
            foreach($aFights as $aFight)
            {
                $count++;
                $aPool = self::$pools->getPools($aFight['poolID'], null, false, true);
                if($aPool['is_team'] == 0)
                {
                    $sFighterName1 = self::$fighters->getFighterName($aFight['fighterID1'], true);
                    $sFighterName2 = self::$fighters->getFighterName($aFight['fighterID2'], true);
                    $teamOrFighterHeader = "Fighter";
                    $sHtmlType = self::viewFighterHtmlType($aFight['fightID'], $aFight['methodID'], $aFight['roundID'], $aFight['minuteID']);
                }
                else 
                {
                    $sFighterName1 = self::$teams->getTeamName($aFight['fighterID1'], true);
                    $sFighterName2 = self::$teams->getTeamName($aFight['fighterID2'], true);
                    $teamOrFighterHeader = "Team";
                    $sHtmlType = self::viewTeamHtmlType($aFight['fightID'], $aFight['team1score'], $aFight['team2score']);
                }
                
                $aFight['fighterID1'] == $aFight['winnerID'] ? $win1 = 'selected = "true"' : $win1 = null;
                $aFight['fighterID2'] == $aFight['winnerID'] ? $win2 = 'selected = "true"' : $win2 = null;
                 ($win1 == null && $win2 == null)? $tie =  'selected = "true"' :$tie = null;
                $sResult .= '<div class="fight_container">
                                <div class="title_area">
                                    <div class="fight_number_title">'.$aFight['name'].'</div>
                                </div>
                                <table>
                                    <tr>
                                        <th>'.$teamOrFighterHeader.' 1</th>
                                        <th>'.$teamOrFighterHeader.' 2</th>
                                    </tr>
                                    <tr>
                                        <td>'.$sFighterName1.'</td>
                                        <td>'.$sFighterName2.'</td>
                                    </tr>
                                    <tr>
                                        <td colspan="6">
                                            <div class="table">
                                                <div class="table_left">
                                                    '.__('Winner', 'fantasy-sports').':
                                                </div>
                                                <div class="table_right">
                                                    <select data-name="rounds" name="val[winnerID]['.$aFight['fightID'].']">
                                                        <option value="">Please select winner</option>
                                                        <option value="'.$aFight['fighterID1'].'" '.$win1.'>'.$sFighterName1.'</option>
                                                        <option value="'.$aFight['fighterID2'].'" '.$win2.'>'.$sFighterName2.'</option>
                                                         <option value="0" '.$tie.'>Draw</option>
                                                    </select>
                                                </div>
                                                <div class="clear"></div>
                                            </div>
                                        </td>
                                    </tr>
                                    '.$sHtmlType.'
                                </table>
                            </div>';
            }
            $sResult .= '</form>';
        }
        exit($sResult);
    }
    
    private static function viewFighterHtmlType($fightID, $methodID = null, $roundID = null, $minuteID = null)
    {
        $sResult =  self::viewMethodOfVictoryHtml($fightID, $methodID).
                    self::viewRoundHtml($fightID, $roundID).
                    self::viewMinuteHtml($fightID, $minuteID);
        return $sResult;
    }
    
    private static function viewTeamHtmlType($fightID, $team1score = 0, $team2score = 0)
    {
        $sResult =  '<tr>
                        <td colspan="6">
                            <div class="table">
                                <div class="table_left">
                                    '.__('Team Score', 'fantasy-sports').' 1:
                                </div>
                                <div class="table_right">
                                    <input type="text" size="10" name="val[team1score]['.$fightID.']" value="'.$team1score.'">
                                </div>
                                <div class="clear"></div>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td colspan="6">
                            <div class="table">
                                <div class="table_left">
                                    '.__('Team Score', 'fantasy-sports').' 2:
                                </div>
                                <div class="table_right">
                                    <input type="text" size="10" name="val[team2score]['.$fightID.']" value="'.$team2score.'">
                                </div>
                                <div class="clear"></div>
                            </div>
                        </td>
                    </tr>';
        return $sResult;
    }

    private static function viewMethodOfVictoryHtml($fightID, $methodID = null)
    {
        $aMethods = self::$fighters->getMethods();
        $sResult = '<td colspan="6">
                                        <div class="table">
                                            <div class="table_left">
                                                '.__('Method of victory', 'fantasy-sports').':
                                            </div>
                                            <div class="table_right">
                                                <select data-name="rounds" name="val[methodID]['.$fightID.']">
                                                <option value="-1">Please select method</option>';
        foreach($aMethods as $aMethod)
        {
            $select = null;
            if($aMethod['methodID'] == $methodID)
            {
                $select = 'selected="true"';
            }
            $sResult .= '<option value="'.$aMethod['methodID'].'" '.$select.'>'.$aMethod['description'].'</option>';
        }
        $sResult .= '                     </select>
                                            </div>
                                            <div class="clear"></div>
                                        </div>
                                    </td>
                                </tr>';
        return $sResult;
    }
    
    private static function viewRoundHtml($fightID, $roundID = null)
    {
        $aRounds = self::$fighters->getRounds();
        $sResult = '<td colspan="6">
                                        <div class="table">
                                            <div class="table_left">
                                                '.__('Round', 'fantasy-sports').':
                                            </div>
                                            <div class="table_right">
                                                <select data-name="rounds" name="val[roundID]['.$fightID.']">
                                                <option value="-1">Please select round</option>';
        foreach($aRounds as $aRound)
        {
            $select = null;
            if($aRound == $roundID)
            {
                $select = 'selected="true"';
            }
            $sResult .= '<option value="'.$aRound.'" '.$select.'>'.$aRound.'</option>';
        }
        $sResult .= '                     </select>
                                            </div>
                                            <div class="clear"></div>
                                        </div>
                                    </td>
                                </tr>';
        return $sResult;
    }
    
    private static function viewMinuteHtml($fightID, $minuteID = null)
    {
        $aMinutes = self::$fighters->getMinutes();
        $sResult = '<td colspan="6">
                                        <div class="table">
                                            <div class="table_left">
                                                '.__('Minute', 'fantasy-sports').':
                                            </div>
                                            <div class="table_right">
                                                <select data-name="rounds" name="val[minuteID]['.$fightID.']">
                                                <option value="-1">Please select minute</option>';
        foreach($aMinutes as $aMinute)
        {
            $select = null;
            if($aMinute['minuteID'] == $minuteID)
            {
                $select = 'selected="true"';
            }
            $sResult .= '<option value="'.$aMinute['minuteID'].'" '.$select.'>'.$aMinute['description'].'</option>';
        }
        $sResult .= '                     </select>
                                            </div>
                                            <div class="clear"></div>
                                        </div>
                                    </td>
                                </tr>';
        return $sResult;
    }
    /////////////////////////////////end view result/////////////////////////////////
    
    /////////////////////////////////update complete/////////////////////////////////
    public static function updateResult()
    {
        $aVals = $_POST['val'];
        $aFights = self::$pools->getFights($aVals['poolID']);
        $success = true;
        foreach($aFights as $aFight)
        {
            $fightID = $aFight['fightID'];
            $data = array('poolID' => $aFight['poolID'],
                          'fightID' => $fightID,
                          'winnerID' => $aVals['winnerID'][$fightID],
                          'methodID' => isset($aVals['methodID'][$fightID]) ? $aVals['methodID'][$fightID] : '-1',
                          'roundID' => isset($aVals['roundID'][$fightID]) ? $aVals['roundID'][$fightID] : '-1',
                          'minuteID' => isset($aVals['minuteID'][$fightID]) ? $aVals['minuteID'][$fightID] : '-1',
                          'team1score' => isset($aVals['team1score'][$fightID]) ? $aVals['team1score'][$fightID] : 0,
                          'team2score' => isset($aVals['team2score'][$fightID]) ? $aVals['team2score'][$fightID] : 0);
            if(!self::$pools->updateFightResult($data))
            {
                $success = false;
            }
        }
        if(!$success)
        {
            exit('<div class=\"error_message\">'.__('Something went wrong! Please try again', 'fantasy-sports').'</div>');
        }
        exit('Successfully updated');
    }
    
    public static function updatePoolComplete()
    {
        $iPoolID = $_POST['iPoolID'];
        $status = $_POST['status'];
        if(!self::$pools->isPoolExist($iPoolID))
        {
            exit(json_encode(array('notice' => __('This pool does not exist', 'fantasy-sports'))));
        }
        else if($status != "NEW" && $status != "COMPLETE")
        {
            exit(json_encode(array('notice' => __('Please select status', 'fantasy-sports'))));
        }
        else if(!self::$pools->isPoolResultsUpdated($iPoolID))
        {
            exit(json_encode(array('notice' => __('Please update pool result', 'fantasy-sports'))));
        }
        else if($status == 'COMPLETE')
        {
            if(self::$pools->updatePoolComplete($iPoolID))
            {
                exit(json_encode(array('result' => 'Successfully updated')));
            }
            else 
            {
                exit(json_encode(array('notice' => __('Something went wrong! Please try again', 'fantasy-sports'))));
            }
        }
        else 
        {
            self::$pools->updatePoolStatus($iPoolID, 'NEW');
            exit(json_encode(array('result' => __('Successfully updated', 'fantasy-sports'))));
        }
    }
    
    public static function reverseResult()
    {
        $result = self::$pools->reverseResult($_POST['poolID']);
        switch($result)
        {
            case 2:
                exit(json_encode(array('notice' => __('Event does not exist', 'fantasy-sports'))));
                break;
            case 1:
                exit(json_encode(array('result' => __('Successfully reversed', 'fantasy-sports'))));
                break;;
            default :
                exit(json_encode(array('notice' => __('Something went wrong! Please try again', 'fantasy-sports'))));
        }
    }
    /////////////////////////////////end update complete/////////////////////////////////
    
    /////////////////////////////////v2/////////////////////////////////
    public static function viewPlayerDraftResult()
    {
        $iPoolID = $_POST['iPoolID'];
        $data = self::$pools->viewPlayerDraftResult($iPoolID);
        exit(json_encode($data));
    }
    
    public static function loadPlayerPoints()
    {
        $poolID = $_POST['poolID'];
        $fightID = $_POST['fightID'];
        $roundID = $_POST['roundID'];
        $playerID = $_POST['playerID'];
        $page = $_POST['page'];
        
        //scoring category
        $item_per_page = 10;
        $aScorings = self::$scoringcategory->getPlayerStatsScoring($poolID, $fightID, $roundID, $playerID, $item_per_page, $page);
        
        $big = 999999999;
        /*$paging = paginate_links( array(
            'base' => str_replace( $big, '%#%', esc_url( get_pagenum_link( $big ) ) ),
            'format' => '#',
            'current' => max($page, get_query_var('paged') ),
            'total' => ceil($aScorings['total'] / $item_per_page)
        ));*/
        //$aScorings['paging'] = $paging;
        exit(json_encode($aScorings));
    }
    
    public static function addMoneyByCoupon()
    {        
        try
        {
            $res = self::applyCouponAddMoney($_POST['coupon_code']);
            $resp = array('result' => $res['result']);
        }
        catch (Exception $ex)
        {
            $resp = array('notice' => $ex->getMessage());
        }
        exit(json_encode($resp));
    }
    
    private static function applyCouponAddMoney($code)
    {
        if(empty($code))
        {
            throw new Exception(__('Please input coupon code', 'fantasy-sports'));
        }
        else if(!self::$coupon->isCouponCodeExist($code, CP_ACTION_ADD_MONEY))
        {
            throw new Exception(__('This code does not exist', 'fantasy-sports'));
        }
        else if(self::$coupon->isCouponCodeUsed($code, CP_ACTION_ADD_MONEY))
        {
            throw new Exception(__('This code has already used', 'fantasy-sports'));
        }
        else if(self::$coupon->isCouponCodeLimit($code, CP_ACTION_ADD_MONEY))
        {
            throw new Exception(__('This code has reached to limit', 'fantasy-sports'));
        }
        else 
        {
            $coupon = self::$coupon->getCouponByCode($code, CP_ACTION_ADD_MONEY);
            if(!empty($coupon))
            {
                $user = self::$payment->getUserData();
                $discount_value = self::$coupon->getTotalDiscountValue($coupon->discount_type, $coupon->discount_value, $user['balance']);
                if(self::$payment->updateUserBalance($discount_value, false, 0, $_COOKIE['fanvictor_user_id']))
                {
                    $params = array(
                        'amount' => $discount_value,
                        'new_balance' => ($user['balance'] + $discount_value),
                        'operation' => 'ADD',
                        'type' => 'COUPON',
                        'status' => 'completed'
                    );
                    self::$payment->addFundhistory($params);
                    self::$coupon->addCouponUsed($coupon->id, $_COOKIE['fanvictor_user_id']);
                    return array(
                        'result' => __('Successfully added', 'fantasy-sports'),
                        'amount' => $discount_value,
                        'balance' => ($user['balance'] + $discount_value),
                        'code' => $code
                        );
                }
            }
            throw new Exception(__('Something went wrong, please try again', 'fantasy-sports'));
        }
    }
    
    public static function applyCoupon()
    {
        $code = $_POST['coupon_code'];
        $msg = array(
            'text' => __('This code does not exist', 'fantasy-sports'),
            'title' => __('Coupon Info', 'fantasy-sports')
            );
        $resp = array('msg' => &$msg, 'ok' => false);
        if(self::$coupon->isCouponCodeExist($code, CP_ACTION_ADD_MONEY))
        {
            try
            {
                $res = self::applyCouponAddMoney($code);
                $msg['text'] = __('Money has been added.', 'fantasy-sports');
                $resp['ok'] = $msg['reload'] = true;
                $resp['details'] = $res;
            }
            catch (Exception $ex)
            {
                $msg['text'] = $ex->getMessage();
            }
        }
        elseif(self::$coupon->isCouponCodeExist($code, CP_ACTION_EXTRA_DEPOSIT))
        {
            $msg['text'] = __('Extra money will be added to your account after the deposit', 'fantasy-sports');
            $resp['ok'] = $resp['needSubmit'] = true;
        }
        exit(json_encode($resp));
    }
    
    public static function createContest()
    {
        if(!empty($_POST['live_draft_start_date']))
        {
            $_POST['live_draft_start'] = date("Y-m-d H:i:s", strtotime($_POST['live_draft_start_date']." ".$_POST['live_draft_start_hour'].":".$_POST['live_draft_start_minute'].":00"));
        }
        if(!empty($_POST['yearly_contest_start']))
        {
            $_POST['yearly_contest_start'] = date('Y-m-d', strtotime($_POST['yearly_contest_start']))." 00:00:00";
        }
        if(!empty($_POST['yearly_contest_end']))
        {
            $_POST['yearly_contest_end'] = date('Y-m-d', strtotime($_POST['yearly_contest_end']))." 23:59:00";
        }
            
        //check valid
        self::validCreateContestData();
        
        //add
        $_POST['is_refund'] = 1;
        $_POST['is_payouts'] = 1;

        $leagueID = self::$fanvictor->createLeague($_POST);
        if((int)$leagueID < 1)
        {
            echo json_encode(array(
                'result' => 1,
                'msg' =>  __("Something went wrong! Please try again", 'fantasy-sports')
            )); 
            exit;
        }
        $league = self::$fanvictor->getLeagueDetail($leagueID);
        if($league == null)
        {
            echo json_encode(array(
                'result' => 1,
                'msg' =>  __("Something went wrong! Please try again", 'fantasy-sports')
            )); 
            exit;
        }
        $league = $league[0];
        
        //buddy press integration
        self::$fanvictor->addCreateContestActivity($league, $_COOKIE['fanvictor_user_id']);
        
        if($league['is_live_draft'])
        {
            FV_SetMessage(__("Your contest has been created successfully", 'fantasy-sports'));
            echo json_encode(array(
                'result' => 1,
                'url' => FANVICTOR_URL_LOBBY,
            )); 
            exit;
        }
        else 
        {
            echo json_encode(array(
                'result' => 1,
                'url' => FANVICTOR_URL_GAME.$leagueID
            )); 
            exit;
        }
    }

	public static function getStat()
    {
        $dat=$_POST;
        if(empty($dat['sid']))
        {
            echo json_encode(array(
                'result' => 0,
                'msg' =>  __("No sport selected", 'fantasy-sports')
            )); 
            exit;
        }
        $dat['sid']+=0;
        
        if(empty($dat['pid']))
        {
            echo json_encode(array(
                'result' => 0,
                'msg' =>  __("No pool selected", 'fantasy-sports')
            )); 
            exit;
        }
        
       
       $filters=array("pg"=>$dat['pg'], "posID" => $dat['posid']);
       $item_per_page=20;
        
        //fetch data
        $data = self::$fanvictor->getStatJS($dat['sid'], $dat['pid'], $filters, $item_per_page, $dat['sort_name'], $dat['sort_value'], $dat['team_id'], $dat['posid']);
        
        if($data){
            exit(json_encode(array(
                    'result' => 1,
                    'data' =>  $data
                )
            ));
		}

        exit(json_encode(array(
                'result' => 0,
                'msg' =>  __("No data", 'fantasy-sports')
            )
        ));
    }
    
    private static function validCreateContestData()
    {

        $valid = self::$fanvictor->validCreateLeague($_POST);
        $msg = '';
        switch($valid)
        {
            case 2;
                $msg = __('Sport does not exist. Please try again.', 'fantasy-sports');
                //FV_Redirect(FANVICTOR_URL_CREATE_CONTEST, __('Sport does not exist. Please try again.', 'fantasy-sports'), true);
                break;
            case 3;
                $msg = __('Date does not exist. Please try again.', 'fantasy-sports');
                break;
            case 4;
                $msg = __('Fixture does not exist. Please try again.', 'fantasy-sports');
                break;
            case 5;
                $msg = __('Please select at least a fixture.', 'fantasy-sports');
                break;
            case 6;
                $msg = __('This game type does not exist.', 'fantasy-sports');
                break;
            case 7;
                $msg = __('This sport does not support playerdraft type.', 'fantasy-sports');
                break;
            case 8;
                $msg = __('Please enter league name', 'fantasy-sports');
                break;
            case 9;
                $msg = __('Round does not exist. Please try again', 'fantasy-sports');
                break;
            case 10;
                $msg = __('Please select at least one round', 'fantasy-sports');
                break;
            case 11;
                $msg = __('Invalid payouts', 'fantasy-sports');
                break;
            case 13;
                $msg = __('Invalid player change quantity', 'fantasy-sports');
                break;
            case 14;
                $msg = __('Please enter number of minutes a contestant has to draft', 'fantasy-sports');
                break;
            case 15;
                $msg = __('Number of players that be changed via Waiver Wire must be lower than player quantity of lineup', 'fantasy-sports');
                break;
            case 16;
                $msg = __('Invalid league size', 'fantasy-sports');
                break;
            case 17;
                $msg = __('Please enter start draft date time', 'fantasy-sports');
                break;
            case 21;
                $msg = __('Waiver wire start day can not be behind waiver wire end day', 'fantasy-sports');
                break;
            case 23;
                $msg = __('No games for select date range', 'fantasy-sports');
                break;
        }

        if(!in_array($_POST['leagueSize'], get_option('fanvictor_league_size')))
        {
            $msg = __('League size does not exist', 'fantasy-sports');
        }
        else if($_POST['entry_fee'] > 0 && !in_array($_POST['entry_fee'], get_option('fanvictor_entry_fee')))
        {
            $msg = __('Entry fee does not exist', 'fantasy-sports');
        }
        if($msg != '')
        {
            echo json_encode(array(
                'result' => 0,
                'msg' => $msg
            )); 
            exit;
        }
    }
    
    private static function getMessageValidCreateContest($valid){
        switch($valid)
        {
            case 2;
                $msg = __('Sport does not exist. Please try again.', 'fantasy-sports');
                FV_Redirect(FANVICTOR_URL_CREATE_CONTEST, __('Sport does not exist. Please try again.', 'fantasy-sports'), true);
                break;
            case 3;
                $msg = __('Date does not exist. Please try again.', 'fantasy-sports');
                break;
            case 4;
                $msg = __('Fixture does not exist. Please try again.', 'fantasy-sports');
                break;
            case 5;
                $msg = __('Please select at least a fixture.', 'fantasy-sports');
                break;
            case 6;
                $msg = __('This game type does not exist.', 'fantasy-sports');
                break;
            case 7;
                $msg = __('This sport does not support playerdraft type.', 'fantasy-sports');
                break;
            case 8;
                $msg = __('Please enter league name', 'fantasy-sports');
                break;
            case 9;
                $msg = __('Round does not exist. Please try again', 'fantasy-sports');
                break;
            case 10;
                $msg = __('Please select at least two rounds', 'fantasy-sports');
                break;
            case 11;
                $msg = __('Invalid payouts', 'fantasy-sports');
                break;
        }
        return $msg;
    }
    private static function validMixingCreateContestData()
    {

        $data = array();
        if(isset($_POST['mixingPools'])){
            $data = $_POST['mixingPools'];
        }
        $msg = '';
        foreach($data as $index=>$item){
            $orgID = $index;
            $poolID = array_keys($item);
            $poolID = $poolID[0];
            $fights = $item[$poolID];
            $valid = self::$fanvictor->validCreateLeague($orgID, $poolID, 
                                                     $_POST['game_type'], $_POST['leaguename'], 
                                                     $fights, 
                                                     isset($_POST['roundID']) ? $_POST['roundID'] : null, 
                                                     isset($_POST['payouts_from']) ? $_POST['payouts_from'] : null,
                                                     isset($_POST['payouts_to']) ? $_POST['payouts_to'] : null,
                                                     isset($_POST['percentage']) ? $_POST['percentage'] : null);
            if($valid > 1){
                $msg =  self::getMessageValidCreateContest($valid);
            }
        }
        if(empty($data)){
           $msg =  self::getMessageValidCreateContest(4);
        }
        

        if(!in_array($_POST['leagueSize'], get_option('fanvictor_league_size')))
        {
            $msg = __('League size does not exist', 'fantasy-sports');
        }
        else if($_POST['entry_fee'] > 0 && !in_array($_POST['entry_fee'], get_option('fanvictor_entry_fee')))
        {
            $msg = __('Entry fee does not exist', 'fantasy-sports');
        }
        if($msg != '')
        {
            echo json_encode(array(
                'result' => 0,
                'msg' => $msg
            )); 
            exit;
        }
    }
	
	public static function showPoolStatisticDetail()
    {
        $leagueID = $_POST['leagueID'];
        $aLeagues = self::$statistic->eventStatistic($leagueID);
        exit(json_encode($aLeagues));
    }
    
    public static function showUserPicks()
    {
        $leagueID = $_POST['leagueID'];
        $data = self::$fanvictor->showUserPicks($leagueID);
        if($data['result'] == 0)
        {
            echo __("This league does not exist", 'fantasy-sports');
            exit;
        }
        $users = $data['picks'];
        $league = $data['league'];
        
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."/Elements/contest_picks.php");
        exit();
    }
    
    public static function sendUserPickEmail()
    {
        /*if(!empty($_SESSION['userPicksInfo']))
        {
            $info = $_SESSION['userPicksInfo'];
            if($info[0] == $_POST['leagueID'])
            {
                self::$fanvictor->sendUserPickEmail($info[0], $info[1], $info[2]);
            }
            unset($_SESSION['userPicksInfo']);
        }*/
        exit;
    }
    
    public static function loadSummary()
    {
        $data = self::$fanvictor->getGamesummary($_POST['page'], $_POST['sort_by'], $_POST['sort_type']);
        $users = $data['users'];
        $num_page = $data['num_page'];
        $current_page = $data['current_page'];
        include FANVICTOR__PLUGIN_DIR_VIEW.'Elements/user_summary.php';
        exit;
    }
    
    public static function sendPrivateInvitationEmail()
    {
        $data = $_POST;
        if(!self::$fanvictor->isLeagueExist($data['leagueID']))
        {
            echo json_encode(array(
                'message' => __('Contest does not exist', 'fantasy-sports')
            ));
            exit;
        }
        else
        {
            $params = array(
                'friend_ids' => !empty($data['friend_ids']) ? implode(',', $data['friend_ids']) : null,
                'importleagueID' => $data['leagueID'],
                'emails' => !empty($data['emails']) ? implode(',', explode(PHP_EOL, $data['emails'])) : null
            );
            echo self::$fanvictor->inviteFriend($params);
            exit;
        }
    }
    public function getUserbalance(){
        $user = self::$payment->getUserData();
        echo json_encode(array('balance'=>$user['balance'],'url'=>FANVICTOR_URL_ADD_FUNDS));exit;
    }
    public function sendUploadedFileStats(){
        $file = $_FILES['file'];
        if(empty($file)){
            echo json_encode(array('result'=>'0'));exit;
        }
        if($file['error'] >0){
                echo json_encode(array('result'=>'1'));exit;
        }
        $extension = end(explode('.', $file['name']));
         if(strtolower($extension) != 'csv'){
                echo json_encode(array('result'=>'2'));exit;
        }
        $data['file_name'] = $file['name'];
        $data['poolID'] = $_POST['poolID'];
        $data['org_id'] = $_POST['org_id'];
        $tool_url = self::$fanvictor->createFolderCustomSport($data);
        
        $upload['filename'] = $file['name'];
        $upload['upload_file'] = $file['tmp_name'];
        $upload['dir_path'] = $tool_url[0];
        $upload['filesize'] = $file['size'];
        $upload['poolID'] = $_POST['poolID'];

        self::sendFile($upload);
            
        
    }
    public static  function sendFile($file){
    $url = get_option('fanvictor_api_url_admin').'/upload_file.php';
        $headers = array("Content-Type:multipart/form-data"); // cURL headers for file uploading
        $postfields = array("filedata" => new \CurlFile($file['upload_file'], 'application/vnd.ms-excel', $file['filename']), "filename" => $file['filename'],'dir_path'=>$file['dir_path'],'poolID'=>$file['poolID']);
        $ch = curl_init();
        $options = array(
            CURLOPT_URL => $url,
            CURLOPT_HEADER => false,
            CURLOPT_POST => 1,
            //CURLOPT_HTTPHEADER => $headers,
            CURLOPT_POSTFIELDS => $postfields,
            CURLOPT_INFILESIZE => $file['filesize'],
            CURLOPT_RETURNTRANSFER => 1
        ); // cURL options
        curl_setopt_array($ch, $options);
        $is_success = curl_exec($ch);
        if(curl_errno($ch)){
            $is_success = false;
        }else{
            $resultStatus = curl_getinfo($ch,CURLINFO_HTTP_CODE);
            if($resultStatus != 200){
                $is_success = false;
            }
        }
        curl_close($ch);
        if($is_success){
            echo json_encode(array('result'=>'3','filename'=>$file['filename']));exit;
        }else{
            echo json_encode(array('result'=>'1'));exit;
        }
    }  
    
    public function loadStatsUploadedFile(){
        $data = self::$fanvictor->loadStatsUploadedFile($_POST);
        exit(json_encode($data));
    }
    
    public function sendUserJoincontestEmail() {
        if (get_option('fanvictor_get_email_from_better_join_contest')) {
            self::$fanvictor->sendUserJoincontestEmail($_POST['league_id'], $_POST['entry_number']);
          
        }
    }
    
    public function deleteBackgroundTeamImage() {
        $res = array();

        $team_id = $_POST['teamID'];

        if ($team_id) {
            $dir_image = FANVICTOR__PLUGIN_DIR . 'assets/teams/';
            $old_image = $dir_image . $team_id . '.*';
            $glob = glob($old_image);
            if (!empty($glob)) {
                foreach ($glob as $item) {
                    unlink($item);
                }
            }
        }

        
    }
    
    public function suggestUsername()
    {
        $data = self::$fanvictor->suggestUsername($_POST['username']);
        $result = array();
        if($data != null)
        {
            foreach($data as $item)
            {
                $result[] = array(
                    'value' => $item['ID'],
                    'label' => $item['user_login']
                );
            }
        }
        echo json_encode($result);exit;
    }
    
    public function transferToAccount()
    {
        $amount = $_POST['amount'];
        $from_user_id = $_COOKIE['fanvictor_user_id'];
        $transfer_username = $_POST['username'];
        $transfer_user = self::$payment->getUserByLoginName($transfer_username);
        if(!is_numeric($amount) || (int)$amount < 1)
        {
            exit(json_encode(array('notice' => 'Invalid amount')));
        }
        else if(!self::$payment->isAllowWithdraw($amount))
        {
            exit(json_encode(array('notice' => __('Amount must not exceed your available balance', 'fantasy-sports'))));
        }
        else if($transfer_user == null)
        {
            exit(json_encode(array('notice' => __('User dose not exist', 'fantasy-sports'))));
        }
        else
        {
            $transfer_user_id = $transfer_user['ID'];
            
            //deduct for current user
            if(self::$payment->updateUserBalance($amount, true, $leagueID = 0, $from_user_id))
            {
                $user = self::$payment->getUserData($from_user_id);
                $params = array(
                    'userID' => $from_user_id,
                    'amount' => $amount,
                    'operation' => 'DEDUCT',
                    'type' => 'TRANSFER',
                    'new_balance' => $user['balance'],
                    'reason' => 'transfered to user id '.$transfer_user_id,
                    'status' => 'completed'
                );
                self::$payment->addFundhistory($params);
            }
            
            //transfer funds to new user
            if(self::$payment->updateUserBalance($amount, false, $leagueID = 0, $transfer_user_id))
            {
                $user = self::$payment->getUserData($transfer_user_id);
                $params = array(
                    'userID' => $transfer_user_id,
                    'amount' => $amount,
                    'operation' => 'ADD',
                    'type' => 'TRANSFER',
                    'new_balance' => $user['balance'],
                    'reason' => 'transfered from user id '.$from_user_id,
                    'status' => 'completed'
                );
                self::$payment->addFundhistory($params);
            }
            
            exit(json_encode(array('result' => __('Successfully transfered', 'fantasy-sports'))));
        }
    }
    
    public function loadMotocrossPlayerPoints(){
        $result = self::$fanvictor->loadMotocrossPlayerPoints($_POST);
        echo json_encode($result);exit;
    }
    
    public function updateMotocrossPlayerResult(){

        self::$fanvictor->updateMotocrossPlayerResult($_POST);
        exit('Successfully updated');
    }
    
    public function liveDraftLoadListUserInLeague(){
        $league_id = $_POST['leagueID'];
        $entry_number = $_POST['entry_number'];
        $page = isset($_POST['page']) ? $_POST['page'] : 1;
        $data = self::$fanvictor->liveDraftLoadListUserInLeague($league_id, $page);
        $users = !empty($data['data']) ? $data['data'] : null;
        $page += 1;
        
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/live_draft_change_user_list.php");
        exit;
    }
    
    public function liveDraftSendTradePlayers(){
       $_POST['user_positions'] = json_decode(  $_POST['user_positions'],true);
       $_POST['target_positions'] = json_decode(  $_POST['target_positions'],true);
       
       $data = self::$fanvictor->liveDraftSendTradePlayers($_POST);

       if($data['error']){
           exit(json_encode($data));
       }

       // send mail
       self::$fanvictor->sendLiveDraftRequestTradeMail($data);
       FV_SetMessage(__('Your request has been sent', 'fantasy-sports'));
       $data['redirect'] = FANVICTOR_URL_MY_LIVE_ENTRIES;
       exit(json_encode($data));
       
    }
    public function liveDraftApprovedTradeRequest(){
        $request_id = $_POST['request_id'];
         $data = self::$fanvictor->liveDraftApprovedTradeRequest($request_id);

         switch ($data['error']){
             case '0':
                 self::$fanvictor->liveDraftSendmailApproved($data['request']);
                  $data['mss'] = __('Successfully traded','fantasy-sports');
                 break;
             case '1':
                 $data['mss'] = __('Invalid request','fantasy-sports');
                 break;
             case '2';
                 $data['mss'] = __('YThe players requested to be changed are no longer available.  Please reject.','fantasy-sports');
                 break;
             case '3':
                 $data['mss'] = __('The players requested to be changed are no longer available','fantasy-sports');
                 break;
         }
         FV_SetMessage($data['mss']);
         exit(json_encode($data));
    }
    public function liveDraftRejectTradeRequest() {
        $request_id = $_POST['request_id'];
        $data = self::$fanvictor->liveDraftRejectTradeRequest($request_id);    
        switch ($data['error']) {
            case '0':
                self::$fanvictor->liveDraftSendmailReject($data['request']);
                $data['mss'] = __('Successfully rejected', 'fantasy-sports');
                break;
            case '1':
                $data['mss'] = __('Invalid request', 'fantasy-sports');
                break;
        }
        FV_SetMessage($data['mss']);
        exit(json_encode($data));
    }
    
    public function loadFlutterwaveBankEnquiry(){
        require_once FANVICTOR__PLUGIN_DIR_MODEL . 'flutterwave.php';

        $flw = new FlutterWave();
        $banks = $flw->loadBankEnquiry();
        $userBankCode = self::$payment->getUserPaymentBankCode();

        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/list_flutterwave_banks.php");
        exit;
    }

    public static function liveDraft()
    {
        $params = $_POST;
        $user_id = $_COOKIE['fanvictor_user_id'];
        $data = self::$fanvictor->liveDraftData($params['leagueID'], $params['entry_number'], $params['current_turn']);
        $data['is_full_draft'] = 0;
        $data['msg'] = '';
        if(!empty($data['last_pick_user_id']))
        {
            if($user_id == $data['last_pick_user_id'])
            {
                $data['msg'] = sprintf(__('You have selected player %s. Please wait for your next turn to pick more players.', 'fantasy-sports'), $data['last_pick_player_name']);
            }
            else
            {
                $data['msg'] = sprintf(__('%s has selected player %s. Please wait for your next turn to pick more players.', 'fantasy-sports'), $data['last_pick_username'], $data['last_pick_player_name']);
            }
        }
        echo json_encode($data);
        exit;
    }
    
    public static function liveDraftPickPlayer()
    {
        $params = $_POST;
        $user_id = $_COOKIE['fanvictor_user_id'];
        $data = self::$fanvictor->liveDraftPickPlayer($params);
        if(!empty($data['error']))
        {
            switch($data['error'])
            {
                case 0:
                    $msg = __('Can not save your pick, please try again.', 'fantasy-sports');
                    break;
                case 1:
                    $msg = __('Contest does not exist.', 'fantasy-sports');
                    break;
                case 2:
                    $msg = __('You are not allowed to draft player at this time. Please wait for your turn.', 'fantasy-sports');
                    break;
                case 3:
                    $msg = __('Please select a player.', 'fantasy-sports');
                    break;
                case 4:
                    $msg = __('The player that you pick has already picked by other users. Please select other player.', 'fantasy-sports');
                    break;
            }
            echo json_encode(array(
                'result' => 0,
                'msg' => $msg
            )); 
            exit;
        }
        $data['msg'] = '';
        if($data['last_pick_user_id'] > 0)
        {
            if($user_id == $data['last_pick_user_id'])
            {
                $data['msg'] = sprintf(__('You have selected player %s. Please wait for your next turn to pick more players.', 'fantasy-sports'), $data['last_pick_player_name']);
            }
            else
            {
                $data['msg'] = sprintf(__('%s has selected player %s. Please wait for your next turn to pick more players.', 'fantasy-sports'), $data['last_pick_username'], $data['last_pick_player_name']);
            }
        }
        echo json_encode(array(
            'result' => 1,
            'is_full_draft' => $data['is_full_draft'],
            'msg' => $data['msg'],
            'change_sort' => $data['change_sort']
        )); 
        exit;
    }
    
    public function liveDraftLoadOpponentScores()
    {
        $params = $_POST;
        $data = self::$fanvictor->liveDraftLoadOpponentScores($params);
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/user_result_live_draft.php");
        exit;
    }
    
    public static function liveDraftLoadContestScores()
    {
        $params = $_POST; 
        
        //scores
        $scores = self::$fanvictor->liveDraftLoadContestScores($params);
        
        //cur user scores
        $currUserScore = null;
        if($scores != null)
        {
            foreach($scores as $k => $aScore)
            {
                $aScore[$k]['current'] = false;
                if($aScore['userID'] == $_COOKIE['fanvictor_user_id'] && $aScore['entry_number'] == $_POST['entry_number'])
                {
                    $scores[$k]['current'] = true;
                }
            }
        }
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/user_score_live_draft.php");
        exit;
    }
    
    public static function liveDraftCheckChangedTurn()
    {
        $params = $_POST; 
        $user_id = $_COOKIE['fanvictor_user_id'];
        $data = self::$fanvictor->liveDraftCheckChangedTurn($params);
        
        if($data['last_pick_user_id'] > 0)
        {
            if($user_id == $data['last_pick_user_id'])
            {
                $data['msg'] = sprintf(__('You have selected player %s. Please wait for your next turn to pick more players.', 'fantasy-sports'), $data['last_pick_player_name']);
            }
            else
            {
                $data['msg'] = sprintf(__('%s has selected player %s. Please wait for your next turn to pick more players.', 'fantasy-sports'), $data['last_pick_username'], $data['last_pick_player_name']);
            }
        }
        echo json_encode($data);
        exit;
    }
    
    public static function liveDraftRequestChangePlayer()
    {
        $params = $_POST; 
        $data = self::$fanvictor->liveDraftRequestChangePlayer($params);
        if($data['success'] == 0)
        {
            switch($data['error'])
            {
                case 1:
                    $msg = __('You are not allowed to request to change player at this time.', 'fantasy-sports');
                    break;
                case 2:
                    $msg = __('Number of players you request is over max players.', 'fantasy-sports');
                    break;
                default :
                    $msg = __('Something went wrong, please try again.', 'fantasy-sports');
            }
            echo json_encode(array(
                'result' => 1,
                'msg' => $msg
            )); 
            exit;
        }
        
        //success
        FV_SetMessage(__('Your request has been sent. System will check before the next game starts. If valid, your requested players will be changed automatically.', 'fantasy-sports'));
        echo json_encode(array(
            'result' => 1
        )); 
        exit;
    }
    
    public static function liveDraftGetUserInDraftRoom()
    {
        $params = $_POST; 
        $users = self::$fanvictor->liveDraftGetUserInDraftRoom($params);
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/live_draft_user_draft_room.php");
        exit;
    }
    
    public static function liveDraftSeeUserLineup()
    {
        $params = $_POST; 
        $users = self::$fanvictor->liveDraftSeeUserLineup($params);
        echo json_encode($users);
        exit;
    }
    
    public static function liveDraftCheckAllowDraft()
    {
        $data = self::$fanvictor->liveDraftCheckAllowDraft(array(
            'leagueID' => $_POST['leagueID']
        ));
        echo json_encode($data);
        exit;
    }

    public static function liveDraftPickBenchPlayer()
    {
        $params = $_POST; 
        $result = self::$fanvictor->liveDraftPickBenchPlayer($params);
        if($result['success'] == 1)
        {
            FV_SetMessage(__('Successfully changed', 'fantasy-sports'));
            exit(json_encode(array('success' => 1)));
        }
        echo json_encode(array('success' => 0, 'msg' => __('Something went wrong! Please try again', 'fantasy-sports')));
        exit;
    }
    
    public static function loadStatsSportInfo()
    {
        $params = $_POST; 
        $data = self::$fanvictor->loadStatsSportInfo($params);
        
        $pools = $data['pools'];
        $teams = $data['teams'];
        $player_positions = $data['player_positions'];
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/stats_sport_info.php");
        exit;
    }
    
    public static function loadStatsData()
    {
        $params = $_POST; 
        $data = self::$fanvictor->loadStatsData($params);
        
        $sport = $data['sport'];
        $playerstats = $data['playerstats'];
        $scoring_categories = $data['scoring_categories'];
        $total_page = $data['total_page'];
        $page = $data['page'];
        $sort_name = $data['sort_name'];
        $sort_value = $data['sort_value'];
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/stats_data.php");
        exit;
    }
    
    public static function rugbyLoadStatsData()
    {
        $params = $_POST; 
        $data = self::$fanvictor->rugbyLoadStatsData($params);
        
        $sport = $data['sport'];
        $playerstats = $data['playerstats'];
        $total_page = $data['total_page'];
        $page = $data['page'];
        $sort_name = $data['sort_name'];
        $sort_value = $data['sort_value'];
        require_once(FANVICTOR__PLUGIN_DIR_VIEW."Elements/stats_data_rugby.php");
        exit;
    }

    public static function loadDashboardStatsAjax(){
        $stats_type = ($_POST['stats_type'] != '') ? $_POST['stats_type'] : 'total_contest';
        $stats_year = ($_POST['stats_year'] != '') ? $_POST['stats_year'] : date('Y');
        switch ($stats_type) {
            case 'total_money':
                $cond = 'YEAR(date) = '.$stats_year;
                $list_all_fundhistory = self::$payment->getAllFundhistory($cond);
                $str_chart = "['Month', 'Total Money']";

                if(count($list_all_fundhistory) > 0){
                    foreach ($list_all_fundhistory as $key => $value) {
                        $str_chart .= ",['".$key."', ".$value."]";
                    }
                }else{
                    $str_chart .= ",['January', 0],['February', 0],['March', 0],['April', 0],['May', 0],['June', 0],['July', 0],['August', 0],['September', 0],['October', 0],['November', 0],['December', 0]"; 
                }
                break;

            case 'total_users_played':
                $total_users_played  = self::$sports->getUserPlayed($stats_year);
                
                $str_chart = "['Month', 'Total Users Played']";

                if(count($total_users_played) > 0){
                    foreach ($total_users_played as $key => $value) {
                        $str_chart .= ",['".$key."', ".$value."]";
                    }
                }else{
                    $str_chart .= ",['January', 0],['February', 0],['March', 0],['April', 0],['May', 0],['June', 0],['July', 0],['August', 0],['September', 0],['October', 0],['November', 0],['December', 0]"; 
                }
                break;
            
             case 'total_contest':
                $total_contest  = self::$leagues->getLeagueByYear($stats_year);
                $str_chart = "['Month', 'Total Contests']";
                if(count($total_contest) > 0){
                    foreach ($total_contest as $key => $value) {
                        $str_chart .= ",['".$key."', ".$value."]";
                    }
                }else{
                    $str_chart .= ",['January', 0],['February', 0],['March', 0],['April', 0],['May', 0],['June', 0],['July', 0],['August', 0],['September', 0],['October', 0],['November', 0],['December', 0]"; 
                }                
                break;
            default:
                break;
        }
        require_once(FANVICTOR__PLUGIN_DIR_VIEW . 'Elements/dashboard_stats_chart.php');
        exit;
    }

    public static function loadDateType(){
        $date_type  = $_POST['date_type'];
        $leagueID   = $_POST['leagueID'];

        $date_type = self::$fanvictor->getListDateType($leagueID, $date_type);
        $str = '<option value="">Please select...</option>';
        foreach ($date_type['date_type'] as $key => $value) {
            if(isset($value['week']))
                $str.= '<option value="'.$value['week'].'">'.$value['week'].'</option>';
            if(isset($value['month']))
                $str.= '<option value="'.$value['month'].'">'.$value['month'].'</option>';
        }
        echo $str;
        exit;
    }

    public static function liveEntriesResultWithDateTypeAjax(){
        $leagueID = $_POST['leagueID'];
        $entry_number = $_POST['entry_number'];
        $date_type = $_POST['date_type'];
        $date_type_number = $_POST['date_type_number'];

        $aDatas = self::$fanvictor->getLeagueDetail($leagueID);
        $aLeague = $aDatas['league'];
        $aPool = $aDatas['pool'];
        //allow show popup
        $showInviteFriends = false;
        if(isset($_SESSION['showInviteFriends'.$leagueID]) && $aPool['status'] == "NEW")
        {
            unset($_SESSION['showInviteFriends'.$leagueID]);
            $showInviteFriends = true;
        }

        require_once(FANVICTOR__PLUGIN_DIR_VIEW . 'Elements/rankings_picktie.php');
        exit;
    }
    
    public static function cancelContest()
    {
        $result = self::$pools->cancelContest($_POST);
        switch($result)
        {
            case 2:
                exit(json_encode(array('notice' => __('Contest does not exist', 'fantasy-sports'))));
                break;
            case 1:
                exit(json_encode(array('result' => __('Contest has been cancelled', 'fantasy-sports'))));
                break;;
            default :
                exit(json_encode(array('notice' => __('Something went wrong! Please try again', 'fantasy-sports'))));
        }
    }
    
    public static function testConnection()
    {
        $checkAPIToken = self::$fanvictor->checkAPITokenAdmin();
        if(get_option('fanvictor_api_token') == null)
        {
            $checkAPIToken = 505;
        }
        if ($checkAPIToken != 1) 
        {
            exit(__('Connection failed, please check api key.', 'fantasy-sports'));
        }
        exit(__('Connected', 'fantasy-sports'));
    }
    
    public static function dlgSetFeatureContest()
    {
        $data = $_POST;
        $league_id = $data['league_id'];
        $is_feature = $data['is_feature'];
        $league = self::$fanvictor->getLeagueDetail($league_id);

        require_once(FANVICTOR__PLUGIN_DIR_VIEW."contests/dlg_feature_contest.php");
        exit;
    }
    
    public static function qqUploadFile()
    {
        if (!function_exists('wp_handle_upload')) 
        {
            require_once( ABSPATH . 'wp-admin/includes/file.php' );
        }
        $uploadedfile = $_FILES['qqfile'];
        $upload_overrides = array( 'test_form' => false );
        $movefile = wp_handle_upload( $uploadedfile, $upload_overrides );
        $filepath = "";
        if($movefile)
        {
            $filepath = str_replace(FANVICTOR_IMAGE_URL, '', $movefile['url']);
        }
        
        $source_file = FANVICTOR_IMAGE_DIR.$filepath;
        $filepath = image_resize($source_file, FANVICTOR_FEATURE_IMAGE_WIDTH, FANVICTOR_FEATURE_IMAGE_HEIGHT, true, null, null, 100);
        $filepath = str_replace(FANVICTOR_IMAGE_DIR, '', $filepath);
        unlink($source_file);
        echo json_encode(array(
            'success' => true,
            'filepath' => $filepath,
            'url' => $movefile['url']
        ));
        exit;
    }
    
    public static function doSetFeatureContest()
    {
        $data = $_POST;
        $result = self::$leagues->setFeatureContest($data);
        if($result)
        {
            echo json_encode(array(
                'success' => 1,
                'message' => __('Successfully set feature.', 'fantasy-sports'),
                'is_feature' => $data['is_feature'],
                'id' => $data['id']
            ));
            exit;
        }
        echo json_encode(array(
            'success' => 0,
            'message' => __('Cannot set feature, please try again.', 'fantasy-sports'),
            'is_feature' => $data['is_feature'],
            'id' => $data['id']
        ));
        exit;
    }
    
    public static function roundPickemLoadResult()
    {
        $data = $_POST;
        $league_id = $data['league_id'];
        $week = $data['week'];
        $user_id = $data['user_id'];
        $entry_number = $data['entry_number'];
        $current_page = $data['page'];
        
        $result = self::$fanvictor->getRoundPickemResult($league_id, $week, $current_page);
        $standing = $result['standing'];
        $total_page = $result['total_page'];
        $predict_match = $result['predict_match'];
        $total_predict_match_score = $result['total_predict_match_score'];

        require_once(FANVICTOR__PLUGIN_DIR_VIEW_ELEMENT."roundpickem/result.php");
        exit;
    }
    
    public static function roundPickemLoadResultDetail()
    {
        $data = $_POST;
        $league_id = $data['league_id'];
        $week = $data['week'];
        $user_id = $data['user_id'];
        $entry_number = $data['entry_number'];
        $opponent_id = $data['opponent_id'];
        $opponent_entry_number = $data['opponent_entry_number'];
        
        $result = self::$fanvictor->getRoundPickemResultDetail($league_id, $week, $user_id, $entry_number, $opponent_id, $opponent_entry_number);
        $fights = $result['fights'];
        $total_my_points = $result['total_my_points'];
        $total_opponent_points = $result['total_opponent_points'];
		$bonus_my_points = $result['bonus_my_points'];
        $bonus_opponent_points = $result['bonus_opponent_points'];
        $current_user = self::$payment->getUserData();
        $opponent_user = self::$payment->getUserData($opponent_id);
        
        require_once(FANVICTOR__PLUGIN_DIR_VIEW_ELEMENT."roundpickem/result_detail.php");
        exit;
    }
    
    public static function showInviteFriendDlg()
    {
        $data = $_POST;
        $league_id = $data['league_id'];
        $link_contest = FANVICTOR_URL_SUBMIT_PICKS;
        if(!empty($aLeague)){
            if($aLeague['gameType'] == 'PICKSQUARES'){
                $link_contest = FANVICTOR_URL_PICK_SQUARES;
            }
        }
        //friend
        $aFriends = self::$fanvictor->getAllPlayerInfo();
        sort($aFriends, SORT_ASC);
        usort($aFriends, function($a, $b){
            $a = strtolower($a['full_name'] ? $a['full_name'] : $a['user_name']);
            $b = strtolower($b['full_name'] ? $b['full_name'] : $b['user_name']);
            return strcmp($a, $b);
        });
        $quote_list_data = self::$fanvictor->getListPickemTeamByLeagueID($leagueID,$entry_number);
        $quote_list_data = $quote_list_data['result'];
        
        require_once(FANVICTOR__PLUGIN_DIR_VIEW.'dlg_info_friends.php');
        exit;
    }
    
    /////////////////////////////////////live score/////////////////////////////////////
    public static function liveScoreLatestDailyEvents()
    {
        $sport_id = !empty($_GET['sport_id']) ? $_GET['sport_id'] : "";
        $events = self::$fanvictor->getLatestDailyEvents($sport_id);
        
        require_once(FANVICTOR__PLUGIN_DIR_VIEW.'Elements/livescore/latest_events.php');
        exit;
    }
    
    public static function liveScoreFixtureScores()
    {
        $event_id = !empty($_GET['event_id']) ? $_GET['event_id'] : "";
        $fixtures = self::$fanvictor->getFixtureScores($event_id);

        require_once(FANVICTOR__PLUGIN_DIR_VIEW.'Elements/livescore/fixture_scores.php');
        exit;
    }
    
    public static function liveScoreTeamRoster()
    {
        $team_id = !empty($_GET['team_id']) ? $_GET['team_id'] : "";
        $sort_by = !empty($_GET['sort_by']) ? $_GET['sort_by'] : "";
        $sort_type = !empty($_GET['sort_type']) ? $_GET['sort_type'] : "";
        
        $data = self::$fanvictor->liveScoreTeamRoster($team_id, $sort_by, $sort_type);
        $players = $data['players'];

        require_once(FANVICTOR__PLUGIN_DIR_VIEW.'Elements/livescore/roster.php');
        exit;
    }

    public static function liveScoreTeamSchedule()
    {
        $team_id = !empty($_GET['team_id']) ? $_GET['team_id'] : "";
        
        $data = self::$fanvictor->liveScoreTeamSchedule($team_id, true);
        $team = $data['team'];
        $schedule = $data['schedule'];
        
        require_once(FANVICTOR__PLUGIN_DIR_VIEW.'Elements/livescore/schedule.php');
        exit;
    }
    
    public static function liveScoreTeamNews()
    {
        $team_id = !empty($_POST['team_id']) ? $_POST['team_id'] : "";
        $team = self::$fanvictor->getTeamDetail($team_id);
        
        $news = array();
        if($team != null)
        {
            $team = $team['team'];
            require_once(FANVICTOR__PLUGIN_DIR_MODEL.'simple_html_dom.php');
            header('Content-Type: text/html; charset=ISO-8859-15');
            $site_url = 'https://www.google.com';

            //check url
            $keyword = str_replace(' ', '%20', $team['name']);
            $locale = "en";
            $url = $site_url.'/search?q='.$keyword.'&lr=lang_'.$locale.'&tbm=nws&*';
            if(!empty($_POST['link']))
            {
                $url = $_POST['link'];
            }

            //load data
            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_RETURNTRANSFER => 1,
                CURLOPT_URL => $url,
                CURLOPT_SSL_VERIFYPEER => 0,
                CURLOPT_SSL_VERIFYHOST => 0,
                CURLOPT_FOLLOWLOCATION => true
            ));
            $resp = curl_exec($curl);

            //parse html
            $html = str_get_html($resp);

            //check has result
            if(!$html->find('#search', 0) || trim($html->find('#search', 0)->plaintext) == '')
            {
                echo __("No news", "fantasy-sports");
                exit;
            }

            $news = array();
            foreach($html->find('#search .g') as $item)
            {
                $link = $item->find('h3.r a', 0)->href;
                $link = str_replace('/url?q=', '', $link);
                $link = substr($link, 0, strpos($link, "&amp;sa="));
                $news[] = array(
                    'link' => $link,
                    'title' => $item->find('h3.r a', 0)->innertext,
                    'brief' => $item->find('.st', 0)->innertext,
                    'image' => $item->find('.th', 0)->src
                );
            }

            //has result
            $paging = '<div class="paginationContainer"><div class="ng-table-pager"><ul id="player_news_paging">';
            foreach($html->find('#nav tbody td') as $link)
            {
                if($link->find('a', 0))
                {
                    $paging .= '<li><a href="'.$site_url.$link->find('a', 0)->href.'">'.$link->plaintext.'</a></li>';
                }
                else
                {
                    $paging .= '<li class="disabled"><a href="javascript:void(0)"><span>'.$link->plaintext.'</span></a></li>';
                }
            }
            $paging .= '</div></div></ul>';
        }
        
        require_once(FANVICTOR__PLUGIN_DIR_VIEW.'Elements/livescore/news.php');
        exit;
    }
    
    public static function liveScoreTeamStatistic()
    {
        $team_id = !empty($_GET['team_id']) ? $_GET['team_id'] : "";
        $position_id = !empty($_GET['position_id']) ? $_GET['position_id'] : "";
        $keyword = !empty($_GET['keyword']) ? $_GET['keyword'] : "";
        $page = !empty($_GET['page']) ? $_GET['page'] : 1;
        $sort_by = !empty($_GET['sort_by']) ? $_GET['sort_by'] : "";
        $sort_type = !empty($_GET['sort_type']) ? $_GET['sort_type'] : "";
        $sort_scoring_id = !empty($_GET['sort_scoring_id']) ? $_GET['sort_scoring_id'] : "";
        
        $data = self::$fanvictor->liveScoreTeamStatistic(array(
            "team_id" => $team_id, 
            "position_id" => $position_id, 
            "keyword" => $keyword, 
            "sort_by" => $sort_by, 
            "sort_type" => $sort_type, 
            "page" => $page,
            "sort_scoring_id" => $sort_scoring_id
        ));
        $players = $data['players'];
        $teams = $data['teams'];
        $player_positions = $data['player_positions'];
        $scoring_categories = $data['scoring_categories'];
        $total_pages = $data['total_pages'];
        
        require_once(FANVICTOR__PLUGIN_DIR_VIEW.'Elements/livescore/statistics.php');
        exit;
    }
    
    public static function liveScoreTeamInjuries()
    {
        $team_id = !empty($_GET['team_id']) ? $_GET['team_id'] : "";
        
        $data = self::$fanvictor->liveScoreTeamInjuries($team_id);
        $players = $data['players'];

        require_once(FANVICTOR__PLUGIN_DIR_VIEW.'Elements/livescore/injuries.php');
        exit;
    }
    /////////////////////////////////////end live score/////////////////////////////////////
    
    /////////////////////////////////////firebase push notification/////////////////////////////////////
    public static function subscribePushNotification()
    {
        $data = $_POST;
        $user_id = $_COOKIE['fanvictor_user_id'];
        self::$fanvictor->subscribePushNotification($user_id, $data['token']);
        exit;
    }
    
    public static function unSubcribePushNotification()
    {
        $user_id = $_COOKIE['fanvictor_user_id'];
        self::$fanvictor->unSubscribePushNotification($user_id);
        exit;
    }
    /////////////////////////////////////end firebase push notification/////////////////////////////////////
    
    /////////////////////////////////////bracket/////////////////////////////////////
    public static function submitPickBracket()
    {
        $params = $_POST;
        $user_id = $_COOKIE['fanvictor_user_id'];
        $params['user_id'] = $user_id;
        $league_id = !empty($params['league_id']) ? $params['league_id'] : "";
        $entry_number = !empty($params['entry_number']) ? $params['entry_number'] : 1;
        
        //load league
        $league = self::$fanvictor->getLeagueDetail($league_id);
        if($league == null)
        {
            exit(json_encode(array('success' => false, 'message' => __('Contest does not exist', 'fantasy-sports'))));
        }
        $league = $league[0];
        
        //check enough funds
        $makeBet = true;
        if($league['entry_fee'] > 0)
        {
            $makeBet = self::$payment->isMakeBetForLeague($league_id, $entry_number);
            if (!$makeBet && !self::$payment->isUserEnoughMoneyToJoin($league['entry_fee'], $league_id, $entry_number, $league['multi_entry'])) 
            {
                exit(json_encode(array('success' => false, 'message' => __('You do not have enough funds to enter. Please add funds', 'fantasy-sports'))));
            }
        }

        //submit data
        $result = self::$fanvictor->submitPickBracket($params);
        if($result['success'] == false)
        {
            switch ($result['code']) {
                
                case 1:
                    $message = __('Contest does not exist', 'fantasy-sports');
                    break;
                case 2:
                    $message = __('This contest has ended', 'fantasy-sports');
                    break;
                case 3:
                    $message = __('Sorry! This contest is full', 'fantasy-sports');
                    break;
                case 4:
                    $message = __('You must select two teams for each group','fantasy-sports');
                    break;
                case 5:
                    $message = __('You reached maximum number of multi entries.', 'fantasy-sports');
                    break;
                case 6:
                    $message = __('Only users who entered 50 contests or less can join this contest.', 'fantasy-sports');
                    break;
                default :
                    $message = __('Unknown error', 'fantasy-sports');
            }
            exit(json_encode(array('success' => 0, 'message' => $message)));
        }

        //make bet and deduct balance
        if ($makeBet == false) 
        {
            //decrease user money
            self::$payment->updateUserBalance($league['entry_fee'], true, $league_id);

            //add to history
            $user = self::$payment->getUserData();
            $params = array(
                'amount' => $league['entry_fee'],
                'leagueID' => $league_id,
                'new_balance' => $user['balance'],
                'operation' => 'DEDUCT',
                'type' => 'MAKE_BET',
                'entry_number' => $entry_number,
                'status' => 'completed'
            );
            self::$payment->addFundhistory($params);
        }
        
        //send pick email
        self::$fanvictor->sendUserPickEmail($league_id, $_COOKIE['fanvictor_user_id'], $entry_number);
            
        //buddy press integration
        if($league != null)
        {
            self::$fanvictor->addEnterContestActivity($league, $_COOKIE['fanvictor_user_id']);
        }
            
        exit(json_encode(array('success' => 1, 'redirect' => FANVICTOR_URL_ENTRY.$league_id. "/?num=" . $entry_number)));
    }
    
    public static function bracketLoadResult()
    {
        $params = $_POST;
        $user_id = $_COOKIE['fanvictor_user_id'];
        $league_id = !empty($params['league_id']) ? $params['league_id'] : "";
        $entry_number = !empty($params['entry_number']) ? $params['entry_number'] : 1;
        $current_page = !empty($params['page']) ? $params['page'] : 1;
        
        //load league
        $league = self::$fanvictor->getLeagueDetail($league_id);
        $league = $league[0];
        
        //scores
        $data = self::$fanvictor->bracketResult($league_id, $current_page);
        $scores = $data['scores'];
        $total_page = $data['total_page'];
        
        //cur user scores
        $currUserScore = null;
        if($scores != null)
        {
            foreach($scores as $k => $aScore)
            {
                $aScore[$k]['current'] = false;
                if($aScore['userID'] == $user_id && $aScore['entry_number'] == $_POST['entry_number'])
                {
                    $scores[$k]['current'] = true;
                }
            }
        }
        require_once(FANVICTOR__PLUGIN_DIR_VIEW_ELEMENT."bracket/result.php");
        exit;
    }
    
    public static function bracketLoadResultDetail()
    {
        $params = $_POST;
        $user_id = !empty($params['user_id']) ? $params['user_id'] : "";
        $league_id = !empty($params['league_id']) ? $params['league_id'] : "";
        $entry_number = !empty($params['entry_number']) ? $params['entry_number'] : 1;
        $user = get_user_by('ID', $user_id);
        
        //get data
        $data = self::$fanvictor->bracketResultDetail($league_id, $user_id, $entry_number);
        $team_groups = $data['team_groups'];
        $picks = $data['picks'];
        $fixture16 = $data['fixture16'];
        $fixture8 = $data['fixture8'];
        $fixture4 = $data['fixture4'];
        $fixture2 = $data['fixture2'];
        $fixture1st = $data['fixture1st'];
        $fixture3rd = $data['fixture3rd'];
        list($group_left, $group_right) = self::$fanvictor->bracketGroupTeam($team_groups);
        list($group_left16, $group_right16) = self::$fanvictor->bracketGroupTeam($fixture16);
        list($group_left8, $group_right8) = self::$fanvictor->bracketGroupTeam($fixture8);
        list($group_left4, $group_right4) = self::$fanvictor->bracketGroupTeam($fixture4);
        
        require_once(FANVICTOR__PLUGIN_DIR_VIEW_ELEMENT."bracket/result_detail.php");
        exit;
    }
    /////////////////////////////////////bracket/////////////////////////////////////
    
    /////////////////////////////////////roundpickem/////////////////////////////////////
    public static function submitRoundPickem()
    {
        $params = $_POST;
        $league_id = $params['leagueID'];
        $entry_number = !empty($params['entry_number']) ? $params['entry_number'] : 1;
        
        //league
        $league = self::$fanvictor->getLeagueDetail($league_id);
        
        //validate
        self::validateForAllGameType($league, $entry_number);
        $league = $league[0];
        
        //submit data
        $data = self::$fanvictor->submitUserPickRoundPickem($params);
        if(!empty($data['success']))
        {
            self::doAfterEnterContest($league, $entry_number);
            
            exit(json_encode(array('success' => 1, 'redirect' => FANVICTOR_URL_CONTEST.$league_id.'/?num='.$entry_number.'&invite=1')));
        }
        FV_SetMessage(__('Cannot save data! Please try again.', 'fantasy-sports'));
        exit(json_encode(array('success' => 0, 'redirect' => FANVICTOR_URL_GAME.$league_id.'/?num='.$entry_number)));
    }
    /////////////////////////////////////end roundpickem/////////////////////////////////////
    
    /////////////////////////////////////pickem/////////////////////////////////////
    public static function submitPickem()
    {
        $params = $_POST;
        $league_id = $params['leagueID'];
        $entry_number = !empty($params['entry_number']) ? $params['entry_number'] : 1;
        
        //league
        $league = self::$fanvictor->getLeagueDetail($league_id);
        
        //validate
        self::validateForAllGameType($league, $entry_number);
        $league = $league[0];
        
        //submit data
        $data = self::$fanvictor->postUserPicks($params);
        if(!empty($data['success']))
        {
            self::doAfterEnterContest($league, $entry_number);
            
            exit(json_encode(array('success' => 1, 'redirect' => FANVICTOR_URL_CONTEST.$league_id.'/?num='.$entry_number.'&invite=1')));
        }
        FV_SetMessage(__('Cannot save data! Please try again.', 'fantasy-sports'));
        exit(json_encode(array('success' => 0, 'redirect' => FANVICTOR_URL_GAME.$league_id.'/?num='.$entry_number)));
    }
    /////////////////////////////////////end pickem/////////////////////////////////////
    
    /////////////////////////////////////playerdraft/////////////////////////////////////
    public static function submitPlayerdraft()
    {
        $params = $_POST;
        $league_id = $params['leagueID'];
        $entry_number = isset($params['entry_number']) ? $params['entry_number'] : 0;
        $action = 0;
        if (isset($_POST['action']) && !empty($_POST['action']))
        {
            $action = $_POST['action'];
        }

        //get league data
        $league = self::$fanvictor->getLeagueDetail($league_id);

        //validate
        self::validateForAllGameType($league, $entry_number);
        self::validateSubmitPlayerdraft($params);
        $league = $league[0];

        //insert pick
        $data = array('leagueID' => $_POST['leagueID'],
            'player_id' => $_POST['player_id'],
            'entry_number' => $entry_number,
            'player_position' => $_POST['player_position'],
            'injury' => isset($_POST['injury']) ? $_POST['injury'] : "",
            'action' => $action);
        $data = self::$fanvictor->insertPlayerPicks($data);
        if($data == 1)
        {
            self::doAfterEnterContest($league, $entry_number);

            //push notification for user who joined contest
            $fanvictor_firebase_apikey = get_option('fanvictor_firebase_apikey');
			$fanvictor_firebase_senderid = get_option('fanvictor_firebase_senderid');
			if(!empty($fanvictor_firebase_apikey) && !empty($fanvictor_firebase_senderid))
            {
                $user_ids = self::$fanvictor->getUserIdsJoinContest($league_id, $_COOKIE['fanvictor_user_id']);
                if (!empty($user_ids['user_ids']))
                {
                    self::$fanvictor->sendNotificationUserJoinContest($user_ids['user_ids'], $_COOKIE['fanvictor_user_id'], $league['name'], FANVICTOR_URL_CONTEST . $league['leagueID'] . "?num=" . $entry_number);
                }
            }
            exit(json_encode(array('success' => 1, 'redirect' => FANVICTOR_URL_ENTRY.$league_id.'/?num='.$entry_number.'&invite=1')));
        }
        FV_SetMessage(__('Cannot save data! Please try again.', 'fantasy-sports'));
        exit(json_encode(array('success' => 0, 'redirect' => FANVICTOR_URL_ENTRY.$league_id.'/?num='.$entry_number)));
    }
    
    private static function validateSubmitPlayerdraft($params)
    {
        $valid = self::$fanvictor->validEnterPlayerdraft($params['leagueID'], $params['player_id']);
        switch ($valid)
        {
            case 2:
                $message = __("This contest has ended", 'fantasy-sports');
                break;
            case 3:
                $message = __('Contest does not exist', 'fantasy-sports');
                break;
            case 4:
                $message = __('Sorry! This contest is full', 'fantasy-sports');
                break;
            case 5:
                $message = __("Your team has exceeded this game's salary cap. Please change your team so it fits under the salary cap before entering", 'fantasy-sports');
                break;
            case 6:
                $message = __("Please select a player for each position", 'fantasy-sports');
                break;
            case 7:
                $message = __("You can not pick players of started game", 'fantasy-sports');
                break;
            case 8:
                $message = __("You are only able to change one player", 'fantasy-sports');
                break;
            case 10:
                $message = __("One of these players already picked by other users. Please select other players.", 'fantasy-sports');
                break;
            case 12:
                $message = __('Only users who entered 50 contests or less can join this contest.', 'fantasy-sports');
                break;
            case 13:
                $message = __('Your picks has exceeded player limitation per team.', 'fantasy-sports');
                break;
            case 14:
                $message = __('You reached maximum number of multi entries.', 'fantasy-sports');
                break;
            default :
                $message = "";
        }
        if($message != "")
        {
            exit(json_encode(array('success' => 0, 'message' => $message)));
        }
    }
    /////////////////////////////////////end playerdraft/////////////////////////////////////
    
    /////////////////////////////////////picksquares/////////////////////////////////////
    public static function submitPickSquares()
    {
        $params = $_POST;
        $league_id = $params['leagueID'];
        $entry_number = !empty($params['entry_number']) ? $params['entry_number'] : 1;
        
        //league
        $league = self::$fanvictor->getLeagueDetail($league_id);
        
        //validate
        self::validateForAllGameType($league, $entry_number);
        $league = $league[0];
       
        //submit data
        $data = self::$fanvictor->postUserPicks($params);
        if(!empty($data['success']))
        {
            self::doAfterEnterContest($league, $entry_number);
            
            exit(json_encode(array('success' => 1, 'redirect' => FANVICTOR_URL_CONTEST.$league_id.'/?num='.$entry_number.'&invite=1')));
        }
        FV_SetMessage(__('Cannot save data! Please try again.', 'fantasy-sports'));
        exit(json_encode(array('success' => 0, 'redirect' => FANVICTOR_URL_GAME.$league_id.'/?num='.$entry_number)));
    }
    /////////////////////////////////////end picksquares/////////////////////////////////////
    
    /////////////////////////////////////pickultimate/////////////////////////////////////
    public static function submitPickUltimate()
    {
        $params = $_POST;
        $league_id = $params['leagueID'];
        $entry_number = !empty($params['entry_number']) ? $params['entry_number'] : 1;
        
        //league
        $league = self::$fanvictor->getLeagueDetail($league_id);
        
        //validate
        self::validateForAllGameType($league, $entry_number);
        $league = $league[0];
        
        //submit data
        $data = self::$fanvictor->postUserPicks($params);
        if(!empty($data['success']))
        {
            self::doAfterEnterContest($league, $entry_number);
            
            exit(json_encode(array('success' => 1, 'redirect' => FANVICTOR_URL_CONTEST.$league_id.'/?num='.$entry_number.'&invite=1')));
        }
        FV_SetMessage(__('Cannot save data! Please try again.', 'fantasy-sports'));
        exit(json_encode(array('success' => 0, 'redirect' => FANVICTOR_URL_GAME.$league_id.'/?num='.$entry_number)));
    }
    /////////////////////////////////////end pickultimate/////////////////////////////////////
    
    /////////////////////////////////////goliath/////////////////////////////////////
    private static function validateSubmitGoliath()
    {
        $params = $_POST;
        $data = self::$fanvictor->validateSubmitGoliath($params);
        if(!$data['success'])
        {
            switch ($data['code']) 
            {
                case 1:
                    $message = __('Contest was ended', 'fantasy-sports');
                    break;
                case 2:
                    $message = __('You need to pick at least a winner or a pass', 'fantasy-sports');
                    break;
                case 3:
                    $message = __('You reach maximum pass', 'fantasy-sports');
                    break;
                case 4:
                    $message = __('Sorry! You were kicked', 'fantasy-sports');
                    break;
                case 5:
                    $message = __('Sorry! You cannot re-up at this time', 'fantasy-sports');
                    break;
                default :
                    $message = __('Unknown error', 'fantasy-sports');
            }
            exit(json_encode(array('success' => 0, 'message' => $message)));
        }
    }
    
    public static function submitGoliath()
    {
        $params = $_POST;
        $league_id = $params['league_id'];
        $entry_number = !empty($params['entry_number']) ? $params['entry_number'] : 1;
        
        //league
        $league = self::$fanvictor->getLeagueDetail($league_id);
        
        //validate
        self::validateForAllGameType($league, $entry_number);
        self::validateSubmitGoliath($params);
        $league = $league[0];
        
        //submit data
        $data = self::$fanvictor->submitGoliath($params);
        if(!empty($data['success']))
        {
            self::doAfterEnterContest($league, $entry_number, $data['can_reup_free']);
            
            exit(json_encode(array('success' => 1, 'redirect' => FANVICTOR_URL_CONTEST.$league_id.'/?num='.$entry_number.'&invite=1')));
        }
        FV_SetMessage(__('Cannot save data! Please try again.', 'fantasy-sports'));
        exit(json_encode(array('success' => 0, 'redirect' => FANVICTOR_URL_GAME.$league_id.'/?num='.$entry_number)));
    }
    
    public static function goliathLoadResult()
    {
        $params = $_POST;
        $user_id = $_COOKIE['fanvictor_user_id'];
        $league_id = !empty($params['league_id']) ? $params['league_id'] : "";
        $entry_number = !empty($params['entry_number']) ? $params['entry_number'] : 1;
        $standing_type = !empty($params['standing_type']) ? $params['standing_type'] : 1;
        $current_page = !empty($params['page']) ? $params['page'] : 1;
        
        //load league
        $league = self::$fanvictor->getLeagueDetail($league_id);
        $league = $league[0];
        
        //scores
        $data = self::$fanvictor->goliathResult($league_id, $standing_type, $current_page);
        $scores = $data['scores'];
        $fights = $data['fights'];
        $total_page = $data['total_page'];
        
        //cur user scores
        if($scores != null)
        {
            foreach($scores as $k => $score)
            {
                $score[$k]['current'] = false;
                if($score['userID'] == $user_id && $score['entry_number'] == $_POST['entry_number'])
                {
                    $scores[$k]['current'] = true;
                }
            }
        }
        require_once(FANVICTOR__PLUGIN_DIR_VIEW_ELEMENT."goliath/result.php");
        exit;
    }
    
    public static function goliathLoadResultDetail()
    {
        $params = $_POST;
        $user_id = !empty($params['user_id']) ? $params['user_id'] : "";
        $league_id = !empty($params['league_id']) ? $params['league_id'] : "";
        $entry_number = !empty($params['entry_number']) ? $params['entry_number'] : 1;
        $opponent_id = $params['opponent_id'];
        $opponent_entry_number = $params['opponent_entry_number'];
        
        //get data
        $data = self::$fanvictor->goliathResultDetail($league_id, $user_id, $entry_number, $opponent_id, $opponent_entry_number);
        $fights = $data['fights'];
        $total_my_points = $data['total_my_points'];
        $total_opponent_points = $data['total_opponent_points'];
        $current_user = self::$payment->getUserData();
        $opponent_user = self::$payment->getUserData($opponent_id);
        
        require_once(FANVICTOR__PLUGIN_DIR_VIEW_ELEMENT."goliath/result_detail.php");
        exit;
    }
    
    public static function goliathLoadContestStats()
    {
        $params = $_POST;
        $league_id = !empty($params['league_id']) ? $params['league_id'] : "";
        $week = !empty($params['week']) ? $params['week'] : "";
        $fight_id = !empty($params['fight_id']) ? $params['fight_id'] : "";
        
        //get data
        $data = self::$fanvictor->goliathContestStats($league_id, $week, $fight_id);
        $fight = $data['fight'];
        $stats = $data['stats'];
        $week_stats = $data['week_stats'];
        
        require_once(FANVICTOR__PLUGIN_DIR_VIEW_ELEMENT."goliath/contest_stats.php");
        exit;
    }
    
    public static function goliathMakeDecision()
    {
        $params = $_POST;
        $data = self::$fanvictor->goliathMakeDecision($params['type']);
        if(!$data['success'])
        {
            exit(json_encode(array('success' => 0, 'message' => __('Something went wrong! Please try again', 'fantasy-sports'))));
        }
        exit(json_encode(array('success' => 1, 'message' => __('Successfully updated', 'fantasy-sports'))));
    }

    /////////////////////////////////////end goliath/////////////////////////////////////
    
    /////////////////////////////////////minigoliath/////////////////////////////////////
    private static function validateSubmitMiniGoliath()
    {
        $params = $_POST;
        $data = self::$fanvictor->validateSubmitMiniGoliath($params);
        if(!$data['success'])
        {
            switch ($data['code']) 
            {
                case 1:
                    $message = __('Contest was ended', 'fantasy-sports');
                    break;
                case 2:
                    $message = __('You need to pick at least a winner or a tie', 'fantasy-sports');
                    break;
                case 3:
                    $message = __('You reach maximum join', 'fantasy-sports');
                    break;
                case 4:
                    $message = __('Sorry! You were kicked', 'fantasy-sports');
                    break;
                default :
                    $message = __('Unknown error', 'fantasy-sports');
            }
            exit(json_encode(array('success' => 0, 'message' => $message)));
        }
    }
    
    public static function submitMiniGoliath()
    {
        $params = $_POST;
        $league_id = $params['league_id'];
        $entry_number = !empty($params['entry_number']) ? $params['entry_number'] : 1;
        
        //league
        $league = self::$fanvictor->getLeagueDetail($league_id);
        
        //validate
        self::validateForAllGameType($league, $entry_number);
        self::validateSubmitMiniGoliath($params);
        $league = $league[0];
        
        //submit data
        $data = self::$fanvictor->submitMiniGoliath($params);
        if(!empty($data['success']))
        {
            self::doAfterEnterContest($league, $entry_number);
            
            exit(json_encode(array('success' => 1, 'redirect' => FANVICTOR_URL_CONTEST.$league_id.'/?num='.$entry_number.'&invite=1')));
        }
        FV_SetMessage(__('Cannot save data! Please try again.', 'fantasy-sports'));
        exit(json_encode(array('success' => 0, 'redirect' => FANVICTOR_URL_GAME.$league_id.'/?num='.$entry_number)));
    }
    
    public static function minigoliathLoadResult()
    {
        $params = $_POST;
        $user_id = $_COOKIE['fanvictor_user_id'];
        $league_id = !empty($params['league_id']) ? $params['league_id'] : "";
        $entry_number = !empty($params['entry_number']) ? $params['entry_number'] : 1;
        $standing_type = !empty($params['standing_type']) ? $params['standing_type'] : 1;
        $current_page = !empty($params['page']) ? $params['page'] : 1;
        
        //load league
        $league = self::$fanvictor->getLeagueDetail($league_id);
        $league = $league[0];
        
        //scores
        $data = self::$fanvictor->minigoliathResult($league_id, $standing_type, $current_page);
        $scores = $data['scores'];
        $fights = $data['fights'];
        $total_page = $data['total_page'];
        
        //cur user scores
        if($scores != null)
        {
            foreach($scores as $k => $score)
            {
                $score[$k]['current'] = false;
                if($score['userID'] == $user_id && $score['entry_number'] == $_POST['entry_number'])
                {
                    $scores[$k]['current'] = true;
                }
            }
        }
        require_once(FANVICTOR__PLUGIN_DIR_VIEW_ELEMENT."minigoliath/result.php");
        exit;
    }
    
    public static function minigoliathLoadResultDetail()
    {
        $params = $_POST;
        $user_id = !empty($params['user_id']) ? $params['user_id'] : "";
        $league_id = !empty($params['league_id']) ? $params['league_id'] : "";
        $entry_number = !empty($params['entry_number']) ? $params['entry_number'] : 1;
        $opponent_id = $params['opponent_id'];
        $opponent_entry_number = $params['opponent_entry_number'];
        
        //get data
        $data = self::$fanvictor->minigoliathResultDetail($league_id, $user_id, $entry_number, $opponent_id, $opponent_entry_number);
        $fights = $data['fights'];
        $total_my_points = $data['total_my_points'];
        $total_opponent_points = $data['total_opponent_points'];
        $current_user = self::$payment->getUserData();
        $opponent_user = self::$payment->getUserData($opponent_id);
        
        require_once(FANVICTOR__PLUGIN_DIR_VIEW_ELEMENT."minigoliath/result_detail.php");
        exit;
    }
    /////////////////////////////////////end minigoliath/////////////////////////////////////
    
    private static function validateForAllGameType($league, $entry_number)
    {
		if($entry_number < 1)
        {
            $entry_number = 1;
        }
        if($league == null)
        {
            exit(json_encode(array('success' => 0, 'message' => __('Contest does not exist', 'fantasy-sports'))));
        }
        $league = $league[0];
        $league_id = $league['leagueID'];
        
        $data = self::$fanvictor->validateForAllGameType($league_id, $entry_number);
        if(!$data['success'])
        {
            switch ($data['code']) {
                
                case 1:
                    $message = __('Contest does not exist', 'fantasy-sports');
                    break;
                case 2:
                    $message = __('This contest has ended', 'fantasy-sports');
                    break;
                case 3:
                    $message = __('Sorry! This contest is full', 'fantasy-sports');
                    break;
                case 4:
                    $message = __('You reached maximum number of multi entries', 'fantasy-sports');
                    break;
                case 5:
                    $message = __('Only users who entered 50 contests or less can join this contest', 'fantasy-sports');
                    break;
                default :
                    $message = __('Unknown error', 'fantasy-sports');
            }
            exit(json_encode(array('success' => 0, 'message' => $message)));
        }
        
        //validate for make bet
        $makeBet = true;
        if($league['entry_fee'] > 0)
        {
            $makeBet = self::$payment->isMakeBetForLeague($league_id, $entry_number);
            if (!$makeBet && !self::$payment->isUserEnoughMoneyToJoin($league['entry_fee'], $league_id, $entry_number, $league['multi_entry'])) 
            {
                exit(json_encode(array('success' => false, 'message' => __('You do not have enough funds to enter. Please add funds', 'fantasy-sports'))));
            }
        }
    }
    
    private static function payForContest($league, $entry_number)
    {
        $makeBet = true;
        if($league['entry_fee'] > 0)
        {
            $makeBet = self::$payment->isMakeBetForLeague($league['leagueID'], $entry_number);
        }
        if($makeBet == false)
        {
            //decrease user money
            self::$payment->updateUserBalance($league['entry_fee'], true, $league['leagueID']);

            //add to history
            $user = self::$payment->getUserData();
            $params = array(
                'amount' => $league['entry_fee'],
                'leagueID' => $league['leagueID'],
                'new_balance' => $user['balance'],
                'operation' => 'DEDUCT',
                'type' => 'MAKE_BET',
                'entry_number' => $entry_number,
                'status' => 'completed'
            );
            self::$payment->addFundhistory($params);
        }
    }
    
    private static function doAfterEnterContest($league, $entry_number, $no_pay = false)
    {
		if($entry_number < 1)
        {
            $entry_number = 1;
        }
        $user_id = $_COOKIE['fanvictor_user_id'];
        
        //pay for contest
        if(!$no_pay)
        {
            self::payForContest($league, $entry_number);
        }

        //send email
        self::$fanvictor->sendUserPickEmail($league['leagueID'], $user_id, $entry_number);

        //buddy press integration
        if ($league != null)
        {
            self::$fanvictor->addEnterContestActivity($league, $user_id);
        }
    }
    
    /////////////////////////////////////leaderboard/////////////////////////////////////
    public function getLivePoint()
    {
        $data = self::$fanvictor->getLivePoint($_POST['leagueid'], $_POST['page'], $_POST['city'], $_POST['sort']);
		$scores = $data['scores'];
		$pages = $data['pages'];
		$sort = $data['sort'];

        require_once(FANVICTOR__PLUGIN_DIR_VIEW.'Elements/live_point.php');
        exit();
    }
    
    public function getLeagueByGameType()
    {
        $data =  self::$fanvictor->getLeagueByGameType($_POST['gameType']);
        $leagues = $data['leagues'];
        
        require_once(FANVICTOR__PLUGIN_DIR_VIEW.'Elements/live_point_contest.php');
        exit();
    }
    /////////////////////////////////////end leaderboard/////////////////////////////////////
    
    /////////////////////////////////////cancel contest/////////////////////////////////////
    public static function userCancelContest()
    {
        $league_id = $_POST['league_id'];
        
        //validate
        $result = self::$fanvictor->validateCancelContest($league_id);
        if(!$result['success'])
        {
            switch($result['code'])
            {
                case 1:
                    exit(json_encode(array('notice' => __('Contest does not exist', 'fantasy-sports'),'balance'=>$res['balance'])));
                    break;
                case 2:
                    exit(json_encode(array('notice' => __('Only creator can delete this contest', 'fantasy-sports'))));
                    break;
            }
        }
        
        //cancel contest
        $result = self::$fanvictor->cancelContest($league_id);
        $task = "ADD";
        $users = $result['users'];
        $league = $result['league'];
        $curent_user = wp_get_current_user();
        
        if($league['entry_fee'] > 0 && $users != null){
            $credits = $league['entry_fee'];
            foreach($users as $user){
                $userID = $user['userID'];
                //update balance
                if(self::$payment->updateUserBalance($credits, false, 0, $userID)){
                    $aUser = self::$payment->getUserData($userID);
                    $params = array(
                        'userID' => $userID,
                        'amount' => $credits,
                        'operation' => "ADD",
                        'type' => 'CREDITS',
                        'new_balance' => $aUser['balance'],
                        'reason' => "User Cancel Contest",
                        'status' => 'completed',
                        'leagueID'=>$league_id
                    );
                    self::$payment->addFundhistory($params);
                    //self::$fanvictor->sendUserCreditEmail($userID, $credits, $task, $reason);
                }
            }
            /*self::$payment->deleteFundhistory(array(
                'league_id' => $league_id,
                'type' => 'MAKE_BET',
                'operation' => 'DEDUCT'
            ));*/
        }  
        
        FV_SetMessage(__('Contest was cancelled', 'fantasy-sports'));
        exit(json_encode(array(
            'redirect' => FANVICTOR_URL_LOBBY
        )));
    }
    /////////////////////////////////////end cancel contest/////////////////////////////////////
}

?>