<?php
class Fanvictor_Admin
{
    public function __construct() 
    {
        add_action( 'admin_head', array( &$this, 'admin_header' ) );
    }
    public static function init()
    {
        add_action('admin_menu', array('Fanvictor_Admin', 'loadMenuSetting'));
        add_action('admin_menu', array('Fanvictor_Admin', 'loadMenuBar'));
    }
    
    static function admin_header() {
        echo '<style type="text/css">';
        echo '.wp-list-table .column-ID, .wp-list-table .column-uID  { width: 60px; }';
        echo '.wp-list-table .column-payment_request_pending,'
           . '.wp-list-table .column-action { width: 200px; }';
        echo '.wp-list-table .column-balance , '
           . '.wp-list-table .column-startDate { width: 150px; }';
        echo '.wp-list-table .column-status, '
           . '.wp-list-table .column-action2 { width: 132px; }';
        echo '.wp-list-table .column-result, '
           . '.wp-list-table .column-image, '
		   . '.wp-list-table .column-requestDate, '
           . '.wp-list-table .column-active, '
           . '.wp-list-table .column-edit, '
           . '.wp-list-table .column-detail { width: 70px; }';
        echo '.wp-list-table .column-new_balance, '
           . '.wp-list-table .column-amount, '
           . '.wp-list-table .column-playerdraft_result, '
           . '.wp-list-table .column-reverse_points, '
           . '.wp-list-table .column-real_amount { width: 90px; } ';
        echo '</style>';
    }

    //setting
    public static function loadMenuSetting()
    {
        add_options_page( 'Fan Victor Settings', 'Fan Victor', 'manage_options', 'fanvictor', array( 'Fanvictor_Admin', 'options'));
        add_action('admin_init', array( 'Fanvictor_Admin', 'registerSettings'));
        wp_enqueue_script('option.js', FANVICTOR__PLUGIN_URL_JS.'admin/option.js');
    }
    
    public static function options() 
    {
        if ( !current_user_can( 'manage_options' ) )  {
            wp_die( __( 'You do not have sufficient permissions to access this page.' ) , 'fantasy-sports');
        }
        include FANVICTOR__PLUGIN_DIR_VIEW.'settings.php';
    }
    
    public static function registerSettings()
    { 
        register_setting('fanvictor-settings-group', 'fanvictor_api_token');
        register_setting('fanvictor-settings-group', 'fanvictor_api_url');
        register_setting('fanvictor-settings-group', 'fanvictor_api_url_admin');
        register_setting('fanvictor-settings-group', 'fanvictor_image_dir');
        register_setting('fanvictor-settings-group', 'fanvictor_image_thumb_size');
        register_setting('fanvictor-settings-group', 'fanvictor_entry_fee');
        register_setting('fanvictor-settings-group', 'fanvictor_league_size');
        register_setting('fanvictor-settings-group', 'fanvictor_winner_percent');
        register_setting('fanvictor-settings-group', 'fanvictor_first_place_percent');
        register_setting('fanvictor-settings-group', 'fanvictor_second_place_percent');
        register_setting('fanvictor-settings-group', 'fanvictor_third_place_percent');
        register_setting('fanvictor-settings-group', 'fanvictor_cash_to_credit');
        register_setting('fanvictor-settings-group', 'fanvictor_credit_to_cash');
        register_setting('fanvictor-settings-group', 'fanvictor_create_contest');
        register_setting('fanvictor-settings-group', 'fanvictor_payout_gateway');
        register_setting('fanvictor-settings-group', 'fanvictor_payout_method');
        register_setting('fanvictor-settings-group', 'fanvictor_priority_username');
        register_setting('fanvictor-settings-group', 'fanvictor_priority_password');
        register_setting('fanvictor-settings-group', 'fanvictor_priority_credit_card');
        register_setting('fanvictor-settings-group', 'fanvictor_priority_credit_card_expiration_date');
        register_setting('fanvictor-settings-group', 'fanvictor_priority_credit_card_ccv');
        register_setting('fanvictor-settings-group', 'paypal_test');
        register_setting('fanvictor-settings-group', 'paypal_email_account');
        register_setting('fanvictor-settings-group', 'fanvictor_minimum_deposit');
        register_setting('fanvictor-settings-group', 'fanvictor_fee_percentage');
        register_setting('fanvictor-settings-group', 'fanvictor_no_cash');
        register_setting('fanvictor-settings-group', 'fanvictor_no_invite_user_list');
        register_setting('fanvictor-settings-group', 'fanvictor_show_import_pick');
        register_setting('fanvictor-settings-group', 'fanvictor_paypal_type');
        register_setting('fanvictor-settings-group', 'fanvictor_paypal_pro_username');
        register_setting('fanvictor-settings-group', 'fanvictor_paypal_pro_password');
        register_setting('fanvictor-settings-group', 'fanvictor_paypal_pro_signature');
        register_setting('fanvictor-settings-group', 'fanvictor_get_email_from_better_join_contest');
        register_setting('fanvictor-settings-group', 'fanvictor_paypal_client_id');
        register_setting('fanvictor-settings-group', 'fanvictor_currency');
        register_setting('fanvictor-settings-group', 'fanvictor_currency_position');
        register_setting('fanvictor-settings-group', 'fanvictor_share_teams_players');
        register_setting('fanvictor-settings-group', 'fanvictor_facebook_app_id');
        register_setting('fanvictor-settings-group', 'fanvictor_flutterwave_merchant_key');
        register_setting('fanvictor-settings-group', 'fanvictor_flutterwave_api_key');
        register_setting('fanvictor-settings-group', 'fanvictor_flutterwave_expiry');
        register_setting('fanvictor-settings-group', 'fanvictor_flutterwave_cvv');
        register_setting('fanvictor-settings-group', 'fanvictor_flutterwave_credit_card');
        register_setting('fanvictor-settings-group', 'fanvictor_flutterwave_country_currency');
        register_setting('fanvictor-settings-group', 'fanvictor_b_icon');
        register_setting('fanvictor-settings-group', 'fanvictor_timezone');
        register_setting('fanvictor-settings-group', 'fanvictor_flutterwave_mode');
        register_setting('fanvictor-settings-group', 'fanvictor_flutterwave_otp_validate1');
        register_setting('fanvictor-settings-group', 'fanvictor_flutterwave_otptype_validate1');
        register_setting('fanvictor-settings-group', 'fanvictor_flutterwave_otp_validate2');
        register_setting('fanvictor-settings-group', 'fanvictor_flutterwave_otptype_validate2');
        register_setting('fanvictor-settings-group', 'fanvictor_date_format');
        register_setting('fanvictor-settings-group', 'fanvictor_weekly_statistic_email');
        register_setting('fanvictor-settings-group', 'fanvictor_last_report_date');
        register_setting('fanvictor-settings-group', 'fanvictor_moneywave_api_key');
        register_setting('fanvictor-settings-group', 'fanvictor_moneywave_secret');
        register_setting('fanvictor-settings-group', 'fanvictor_moneywave_bank');
        register_setting('fanvictor-settings-group', 'fanvictor_moneywave_accountnumber');
        register_setting('fanvictor-settings-group', 'fanvictor_moneywave_wallet_password');
        register_setting('fanvictor-settings-group', 'fanvictor_fttech_app_name');
        register_setting('fanvictor-settings-group', 'fanvictor_fttech_app_password');
        register_setting('fanvictor-settings-group', 'fanvictor_fftech_test');
        register_setting('fanvictor-settings-group', 'fanvictor_fttech_user_email');
        register_setting('fanvictor-settings-group', 'fanvictor_fttech_username');
        register_setting('fanvictor-settings-group', 'fanvictor_fttech_user_password');
        register_setting('fanvictor-settings-group', 'fanvictor_fttech_first_name');
        register_setting('fanvictor-settings-group', 'fanvictor_fttech_last_name');
        register_setting('fanvictor-settings-group', 'fanvictor_fttech_phone');
        register_setting('fanvictor-settings-group', 'fanvictor_fttech_card_number');
        register_setting('fanvictor-settings-group', 'fanvictor_fttech_card_verification_value');
        register_setting('fanvictor-settings-group', 'fanvictor_fttech_expire_month');
        register_setting('fanvictor-settings-group', 'fanvictor_fttech_expire_year');
        register_setting('fanvictor-settings-group', 'fanvictor_fttech_card_description');
        register_setting('fanvictor-settings-group', 'fanvictor_billmap_username');
        register_setting('fanvictor-settings-group', 'fanvictor_billmap_password');
        register_setting('fanvictor-settings-group', 'fanvictor_billmap_service_code');
        register_setting('fanvictor-settings-group', 'fanvictor_billmap_subscriber_id');
        register_setting('fanvictor-settings-group', 'fanvictor_billmap_reference');
        register_setting('fanvictor-settings-group', 'fanvictor_dfscoin_wallet_address');
        register_setting('fanvictor-settings-group', 'fanvictor_dfscoin_exchange_rate');
        register_setting('fanvictor-settings-group', 'fanvictor_footycashcoin_address');
        register_setting('fanvictor-settings-group', 'fanvictor_footycashcoin_exchange_rate');
        register_setting('fanvictor-settings-group', 'fanvictor_bitcoin_wallet_address');
        register_setting('fanvictor-settings-group', 'fanvictor_bitcoin_exchange_rate');
        register_setting('fanvictor-settings-group', 'fanvictor_cheese_wallet_address');
        register_setting('fanvictor-settings-group', 'fanvictor_cheese_exchange_rate');
        register_setting('fanvictor-settings-group', 'fanvictor_global_currency_enable');
        register_setting('fanvictor-settings-group', 'fanvictor_global_currency_name');
        register_setting('fanvictor-settings-group', 'fanvictor_global_currency_symbol');
        register_setting('fanvictor-settings-group', 'fanvictor_firebase_apikey');
        register_setting('fanvictor-settings-group', 'fanvictor_firebase_senderid');
        register_setting('fanvictor-settings-group', 'fanvictor_bracket_point_group_winner');
        register_setting('fanvictor-settings-group', 'fanvictor_bracket_point_group_runnerup');
        register_setting('fanvictor-settings-group', 'fanvictor_bracket_point_16');
        register_setting('fanvictor-settings-group', 'fanvictor_bracket_point_8');
        register_setting('fanvictor-settings-group', 'fanvictor_bracket_point_4');
        register_setting('fanvictor-settings-group', 'fanvictor_bracket_point_first');
        register_setting('fanvictor-settings-group', 'fanvictor_bracket_point_second');
        register_setting('fanvictor-settings-group', 'fanvictor_bracket_point_third');
        register_setting('fanvictor-settings-group', 'fanvictor_molpay_application_code');
        register_setting('fanvictor-settings-group', 'fanvictor_molpay_secret_key');
        register_setting('fanvictor-settings-group', 'fanvictor_molpay_test');
        if(isset($_GET['page']) && $_GET['page'] == 'fanvictor')
		{
			wp_enqueue_script('jquery-1.12.4.js', FANVICTOR__PLUGIN_URL_JS . 'jquery-1.12.4.js', 1);
			wp_enqueue_script('ui.js', FANVICTOR__PLUGIN_URL_JS . 'ui.js', 5);
			wp_enqueue_style('admin-ui.css', FANVICTOR__PLUGIN_URL_CSS . 'ui/admin-ui.css', 5);
			wp_enqueue_script('option.js', FANVICTOR__PLUGIN_URL_JS . 'admin/option.js', 5);
		}
        
        //update setting to server
        add_action("updated_option", function($option_name, $option_value){
            if (strpos($option_name, 'fanvictor_') !== false) {
                $fanvictor = new Fanvictor();
                $fanvictor->postUserInfo();
            }
        }, 10, 2);
    }
    
    //menu bar
    public static function loadMenuBar()
    {
        $fanvictor = new Fanvictor();
        $global_setting = $fanvictor->getGlobalSetting();
        add_menu_page("Fan Victor Pages", "Fan Victor", '', 'fanvictor_page', '');

        $hook = add_submenu_page('fanvictor_page', __('DashBoard', 'fantasy-sports'), __('DashBoard', 'fantasy-sports'), 'manage_options', 'manage-dashboard', array('Fanvictor_Sports', 'manageDashboard'));
        add_action("load-$hook", array('Fanvictor_Admin', "dashboard_screen"));
        add_submenu_page('', __('Add Sport', 'fantasy-sports'), __('Add Sport', 'fantasy-sports'), 'manage_options', 'add-sports', array('Fanvictor_Sports', 'addSports'));

        if($global_setting['allow_auto_create_contest'] == 1)
        {
            $hook = add_submenu_page('fanvictor_page', __('Manage Auto Contests', 'fantasy-sports'), __('Manage Auto Contests', 'fantasy-sports'), 'manage_options', 'manage-auto-contests', array('Fanvictor_AutoContest', 'manageAutoContest'));
            add_action("load-$hook", array('Fanvictor_Admin', "auto_contest_screen"));
            add_submenu_page('manage-auto-contests', __('Add Auto Contests', 'fantasy-sports'), __('Add Auto Contests', 'fantasy-sports'), 'manage_options', 'add-auto-contest', array('Fanvictor_AutoContest', 'addAutoContest'));
        }
        
        $hook = add_submenu_page('fanvictor_page', __('Manage Sports', 'fantasy-sports'), __('Manage Sports', 'fantasy-sports'), 'manage_options', 'manage-sports', array('Fanvictor_Sports', 'manageSports'));
        add_action("load-$hook", array('Fanvictor_Admin', "sports_screen"));
        add_submenu_page('', __('Add Sport', 'fantasy-sports'), __('Add Sport', 'fantasy-sports'), 'manage_options', 'add-sports', array('Fanvictor_Sports', 'addSports'));
        
        $hook = add_submenu_page('fanvictor_page', __('Manage Events', 'fantasy-sports'), __('Manage Events', 'fantasy-sports'), 'manage_options', 'manage-pools', array('Fanvictor_Pools', 'managePools'));
        add_action("load-$hook", array('Fanvictor_Admin', "pools_screen"));
        add_submenu_page('', __('Add Events', 'fantasy-sports'), __('Add Events', 'fantasy-sports'), 'manage_options', 'add-pools', array('Fanvictor_Pools', 'addPools'));
        
        $hook = add_submenu_page('fanvictor_page', __('Manage Contests', 'fantasy-sports'), __('Manage Contests', 'fantasy-sports'), 'manage_options', 'manage-contests', array('Fanvictor_Contests', 'manageContests'));
        add_action("load-$hook", array('Fanvictor_Admin', "contests_screen"));
        add_submenu_page('', __('Add Contests', 'fantasy-sports'), __('Add Contests', 'fantasy-sports'), 'manage_options', 'add-contests', array('Fanvictor_Contests', 'addContests'));
        
        $hook = add_submenu_page('fanvictor_page', __('Manage Fighters', 'fantasy-sports'), __('Manage Fighters', 'fantasy-sports'), 'manage_options', 'manage-fighters', array('Fanvictor_Fighters', 'manageFighters'));
        add_action("load-$hook", array('Fanvictor_Admin', "fighters_screen"));
        add_submenu_page('', __('Add Fighters', 'fantasy-sports'), __('Add Fighters', 'fantasy-sports'), 'manage_options', 'add-fighters', array('Fanvictor_Fighters', 'addFighters'));
        
        $hook = add_submenu_page('fanvictor_page', __('Manage Teams', 'fantasy-sports'), __('Manage Teams', 'fantasy-sports'), 'manage_options', 'manage-teams', array('Fanvictor_Teams', 'manageTeams'));
        add_action("load-$hook", array('Fanvictor_Admin', "team_screen"));
        add_submenu_page('', __('Add Teams', 'fantasy-sports'), __('Add Teams', 'fantasy-sports'), 'manage_options', 'add-teams', array('Fanvictor_Teams', 'addTeams'));
        
        $hook = add_submenu_page('fanvictor_page', __('Manage Player Positions', 'fantasy-sports'), __('Manage Player Positions', 'fantasy-sports'), 'manage_options', 'manage-playerposition', array('Fanvictor_PlayerPosition', 'managePlayerPosition'));
        add_action("load-$hook", array('Fanvictor_Admin', "playerposition_screen"));
        add_submenu_page('', __('Add Player Position', 'fantasy-sports'), __('Add Player Position', 'fantasy-sports'), 'manage_options', 'add-playerposition', array('Fanvictor_PlayerPosition', 'addPlayerPosition'));
        
        $hook = add_submenu_page('fanvictor_page', __('Manage Scoring Categories', 'fantasy-sports'), __('Manage Scoring Categories', 'fantasy-sports'), 'manage_options', 'manage-scoringcategory', array('Fanvictor_ScoringCategory', 'manageScoringCategory'));
        add_action("load-$hook", array('Fanvictor_Admin', "scoringcategory_screen"));
        add_submenu_page('', __('Add Scoring Category', 'fantasy-sports'), __('Add Scoring Category', 'fantasy-sports'), 'manage_options', 'add-scoringcategory', array('Fanvictor_ScoringCategory', 'addScoringCategory'));

        $hook = add_submenu_page('fanvictor_page', __('Manage Players', 'fantasy-sports'), __('Manage Players', 'fantasy-sports'), 'manage_options', 'manage-players', array('Fanvictor_Players', 'managePlayers'));
        add_action("load-$hook", array('Fanvictor_Admin', "players_screen"));
        add_submenu_page('', __('Add Players', 'fantasy-sports'), __('Add Players', 'fantasy-sports'), 'manage_options', 'add-players', array('Fanvictor_Players', 'addPlayers'));
    
        $hook = add_submenu_page('fanvictor_page', __('Manage Player News', 'fantasy-sports'), __('Manage Player News', 'fantasy-sports'), 'manage_options', 'manage-playernews', array('Fanvictor_PlayerNews', 'managePlayerNews'));
        add_action("load-$hook", array('Fanvictor_Admin', "playernews_screen"));
        add_submenu_page('', __('Add Player News', 'fantasy-sports'), __('Add Player News', 'fantasy-sports'), 'manage_options', 'add-playernews', array('Fanvictor_PlayerNews', 'addPlayerNews'));
        
        $hook = add_submenu_page('fanvictor_page', __('Manage Credits', 'fantasy-sports'), __('Manage Credits', 'fantasy-sports'), 'manage_options', 'credits', array('Fanvictor_Credits', 'manageCredits'));
        add_action("load-$hook", array('Fanvictor_Admin', "credits_screen"));
        
        $hook = add_submenu_page('fanvictor_page', __('Manage Withdrawls', 'fantasy-sports'), __('Manage Withdrawls', 'fantasy-sports'), 'manage_options', 'withdrawls', array('Fanvictor_Withdrawls', 'manageWithdrawls'));
        add_action("load-$hook", array('Fanvictor_Admin', "withdrawls_screen"));

        $hook = add_submenu_page('fanvictor_page', __('Manage Transactions', 'fantasy-sports'), __('Manage Transactions', 'fantasy-sports'), 'manage_options', 'transactions', array('Fanvictor_Transactions', 'manageTransactions'));
        add_action("load-$hook", array('Fanvictor_Admin', "transactions_screen"));
        
        $hook = add_submenu_page('fanvictor_page', __('Event Statistics', 'fantasy-sports'), __('Event Statistics', 'fantasy-sports'), 'manage_options', 'statistic', array('Fanvictor_Statistic', 'manageStatistic'));
        add_action("load-$hook", array('Fanvictor_Admin', "event_statistics_screen"));
        
        if(fanvictorCheckAllowChangebackground()){
            $hook = add_submenu_page('fanvictor_page', __('Teams Backgournd', 'fantasy-sports'), __('Teams Backgournd', 'fantasy-sports'), 'manage_options', 'teams-background', array('Fanvictor_Teams', 'manageBgTeams'));
            add_action("load-$hook", array('Fanvictor_Admin', "team_backgrounds_screen"));
        }

    }

    static function auto_contest_screen(){
        $option = 'per_page';
        $args = array(
            'label' => 'Pages',
            'default' => 15,
            'option' => 'manage_sports_per_page'
        );
        add_screen_option( $option, $args );
    }

    static function dashboard_screen(){
        $option = 'per_page';
        $args = array(
            'label' => 'Pages',
            'default' => 15,
            'option' => 'manage_sports_per_page'
        );
        add_screen_option( $option, $args );
    }
    
    static function sports_screen() 
    {
        $option = 'per_page';
        $args = array(
            'label' => 'Pages',
            'default' => 15,
            'option' => 'manage_sports_per_page'
        );
        add_screen_option( $option, $args );
    }
    
    static function pools_screen() 
    {
        $option = 'per_page';
        $args = array(
            'label' => 'Pages',
            'default' => 15,
            'option' => 'manage_pools_per_page'
        );
        add_screen_option( $option, $args );
    }
    
    static function team_screen() 
    {
        $option = 'per_page';
        $args = array(
            'label' => 'Pages',
            'default' => 15,
            'option' => 'manage_team_per_page'
        );
        add_screen_option( $option, $args );
    }
    
    static function fighters_screen() 
    {
        $option = 'per_page';
        $args = array(
            'label' => 'Pages',
            'default' => 15,
            'option' => 'manage_fighters_per_page'
        );
        add_screen_option( $option, $args );
    }
    
    static function event_statistics_screen() 
    {
        $option = 'per_page';
        $args = array(
            'label' => 'Pages',
            'default' => 15,
            'option' => 'event_statistics_per_page'
        );
        add_screen_option( $option, $args );
    }
    
    static function credits_screen() 
    {
        $option = 'per_page';
        $args = array(
            'label' => 'Pages',
            'default' => 15,
            'option' => 'credits_per_page'
        );
        add_screen_option( $option, $args );
    }
    
    static function withdrawls_screen() 
    {
        $option = 'per_page';
        $args = array(
            'label' => 'Pages',
            'default' => 15,
            'option' => 'withdrawls_per_page'
        );
        add_screen_option( $option, $args );
    }
    
    //v2
    static function playerposition_screen() 
    {
        $option = 'per_page';
        $args = array(
            'label' => 'Pages',
            'default' => 15,
            'option' => 'manage_playerposition_per_page'
        );
        add_screen_option( $option, $args );
    }
    
    static function scoringcategory_screen() 
    {
        $option = 'per_page';
        $args = array(
            'label' => 'Pages',
            'default' => 15,
            'option' => 'manage_scoringcategory_per_page'
        );
        add_screen_option( $option, $args );
    }
    
    static function players_screen() 
    {
        $option = 'per_page';
        $args = array(
            'label' => 'Pages',
            'default' => 15,
            'option' => 'manage_players_per_page'
        );
        add_screen_option( $option, $args );
    }
    
    static function playernews_screen() 
    {
        $option = 'per_page';
        $args = array(
            'label' => 'Pages',
            'default' => 15,
            'option' => 'manage_player_news_per_page'
        );
        add_screen_option( $option, $args );
    }
    
    static function contests_screen() 
    {
        $option = 'per_page';
        $args = array(
            'label' => 'Pages',
            'default' => 15,
            'option' => 'manage_contests_per_page'
        );
        add_screen_option( $option, $args );
    }
    
    static function transactions_screen() 
    {
        $option = 'per_page';
        $args = array(
            'label' => 'Pages',
            'default' => 15,
            'option' => 'transactions_per_page'
        );
        add_screen_option( $option, $args );
    }
    static function team_backgrounds_screen() 
    {
        $option = 'per_page';
        $args = array(
            'label' => 'Pages',
            'default' => 15,
            'option' => 'transactions_per_page'
        );
        add_screen_option( $option, $args );
    }
}
?>