<?php 
$Fanvictor_AutoContest = new Fanvictor_AutoContest();
class Fanvictor_AutoContest
{
	private static $urladdnewautocontest;
    private static $urlmanageautocontest;
    private static $fanvictor;
    private static $autocontest;
    private static $sports;

	function __construct()
	{
	    self::$autocontest = new AutoContest();
        self::$fanvictor = new Fanvictor();
        self::$sports = new Sports();
        self::$urladdnewautocontest = admin_url().'admin.php?page=add-auto-contest';
        self::$urlmanageautocontest = admin_url().'admin.php?page=manage-auto-contests';
	}

    public static function manageAutoContest(){
        //check allow auto contest
        $global_setting = self::$fanvictor->getGlobalSetting();
        if($global_setting['allow_auto_create_contest'] == 0)
        {
            FV_Redirect(admin_url().'admin.php?page=manage-dashboard', 'You are not allowed to view this page');
        }
        
        //load css js
        wp_enqueue_script('jquery-1.12.4.js', FANVICTOR__PLUGIN_URL_JS . 'jquery-1.12.4.js', 1);
        wp_enqueue_script('admin.js', FANVICTOR__PLUGIN_URL_JS.'admin/admin.js');
        wp_enqueue_style('ui.css', FANVICTOR__PLUGIN_URL_CSS.'ui/ui.css');
        wp_enqueue_script('ui.js', FANVICTOR__PLUGIN_URL_JS.'ui.js');
        wp_enqueue_style('admin-ui.css', FANVICTOR__PLUGIN_URL_CSS . 'ui/admin-ui.css', 5);

        include FANVICTOR__PLUGIN_DIR_VIEW."Elements/check-api-token.php";
        include FANVICTOR__PLUGIN_DIR_VIEW.'autocontest/class.table-autocontests.php';

        $myListTable = new TableAutoContests();
        $myListTable->prepare_items(); 

        if(isset($_POST['id'])){
            $iDeleted = 0;
            foreach ($_POST['id'] as $id)
            {
                if (self::$autocontest->delete($id))
                {
                    $iDeleted++;
                }
            }

            if ($iDeleted > 0)
            {
                FV_Redirect(self::$urlmanageautocontest, 'Succesfully deleted');
            }
        }

        include FANVICTOR__PLUGIN_DIR_VIEW.'autocontest/index.php';
    }

    public static function addAutoContest(){
        //check allow auto contest
        $global_setting = self::$fanvictor->getGlobalSetting();
        if($global_setting['allow_auto_create_contest'] == 0)
        {
            FV_Redirect(admin_url().'admin.php?page=manage-dashboard', 'You are not allowed to view this page');
        }
        
        //load css js
        wp_enqueue_script('jquery-1.12.4.js', FANVICTOR__PLUGIN_URL_JS . 'jquery-1.12.4.js', 1);
        wp_enqueue_script('admin.js', FANVICTOR__PLUGIN_URL_JS.'admin/admin.js');
        wp_enqueue_style('ui.css', FANVICTOR__PLUGIN_URL_CSS.'ui/ui.css');
        wp_enqueue_script('ui.js', FANVICTOR__PLUGIN_URL_JS.'ui.js');
        wp_enqueue_style('admin-ui.css', FANVICTOR__PLUGIN_URL_CSS . 'ui/admin-ui.css', 5);

        $aSports = self::$sports->getSportsBySite();
        
        $aLeagueSizes = get_option('fanvictor_league_size');
        $aEntryFees = get_option('fanvictor_entry_fee');
        $game_type = array(
            "playerdraft" => "Player Draft",
            "pickem" => "Pick 'Em",
        );
        
        //edit 
        $auto_contest = array();
        $bIsEdit = false;
        if(!empty($_GET['id']))
        {
            $bIsEdit = true;
            $auto_contest = self::$autocontest->getAutoContest($_GET['id']);
            if($auto_contest == null)
            {
                FV_Redirect(self::$urlmanageautocontest, __('Item could not be found', 'fantasy-sports'));
            }
        }

        if(isset($_POST) && !empty($_POST)){
            if(self::validData($_POST['val'])){
                $aResults = self::$autocontest->saveAutoContests($_POST['val']);
                if($aResults) FV_Redirect(self::$urlmanageautocontest, __('Succesfully added', 'fantasy-sports'));
            }
            
        }

        include FANVICTOR__PLUGIN_DIR_VIEW.'autocontest/add.php';
    }

    public static function validData($data){
        if(empty($data['sports'])){
            FV_Redirect(self::$urladdnewautocontest, __('Pick Your Sports is required.', 'fantasy-sports'));
            exit;
        }

        if(empty($data['game_type'])){
            FV_Redirect(self::$urladdnewautocontest, __('Game Type is required.', 'fantasy-sports'));
            exit;
        }

        if(empty($data['name'])){
            FV_Redirect(self::$urladdnewautocontest, __('Name is required.', 'fantasy-sports'));
            exit;
        }
        return true;
    }
}

 ?>