<?php
$Fanvictor_Contests = new Fanvictor_Contests();
class Fanvictor_Contests
{
    private static $orgs;
    private static $fanvictor;
    private static $leagues;
    private static $url;
    private static $urladdnew;
    private static $urladd;
    private static $playerposition;
    private static $pools;
    public function __construct() 
    {
        self::$orgs = new Organizations();
        self::$fanvictor = new Fanvictor();
        self::$leagues = new Leagues();
        self::$playerposition = new PlayerPosition();
        self::$pools = new Pools();
        self::$url = admin_url().'admin.php?page=manage-contests';
        self::$urladdnew = admin_url().'admin.php?page=add-contests';
        self::$urladd = wp_get_referer();
    }
    
    public static function manageContests()
    {
        if(!empty($_GET['leagueID']))
        {
            self::exportUserPicks($_GET['leagueID']);
        }
        
        //must check that the user has the required capability 
        if (!current_user_can('manage_options'))
        {
            wp_die( __('You do not have sufficient permissions to access this page.') , 'fantasy-sports');
        }

        //load css js
        wp_enqueue_script('admin.js', FANVICTOR__PLUGIN_URL_JS.'admin/admin.js');
        wp_enqueue_script('ui.js', FANVICTOR__PLUGIN_URL_JS.'ui.js');
        wp_enqueue_script('fine-uploader.js', FANVICTOR__PLUGIN_URL_JS.'fine-uploader.js');
        wp_enqueue_style('ui.css', FANVICTOR__PLUGIN_URL_CSS.'ui/ui.css');
        wp_enqueue_style('fine-uploader-new.css', FANVICTOR__PLUGIN_URL_CSS.'fine-uploader-new.css');
        
        //task action delete
        if(isset($_POST["task"]) && $task = $_POST["task"])
        {
            switch($task)
            {
                case "delete":
                    self::delete();
                    break;
            }
        }
        
        //list friend
        $aFriends = self::$fanvictor->getAllPlayerInfo();
        $iTotalFriends = count($aFriends);
        sort($aFriends, SORT_ASC);
        usort($aFriends, function($a, $b){
            $a = strtolower($a['full_name'] ? $a['full_name'] : $a['user_name']);
            $b = strtolower($b['full_name'] ? $b['full_name'] : $b['user_name']);
            return strcmp($a, $b);
        });
        include FANVICTOR__PLUGIN_DIR_VIEW."Elements/check-api-token.php";
        include FANVICTOR__PLUGIN_DIR_VIEW.'contests/class.table-contests.php';
        $myListTable = new TableContests();
        $myListTable->prepare_items(isset($_GET['s']) ? $_GET['s'] : null);
        include FANVICTOR__PLUGIN_DIR_VIEW.'contests/index.php';
    }
    
    private static function exportUserPicks($leagueID)
    {
        if($leagueID > 0)
        {
            $data = self::$fanvictor->showUserPicks($leagueID);
            $users = $data['picks'];
            $league = $data['league'];
            if($data['result'] == 0)
            {
                FV_Redirect(self::$url, __('This league does not exist.', 'fantasy-sports'));
            }
            else 
            {
                ob_clean();
                header('Pragma: public');
                header('Expires: 0');
                header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                header('Cache-Control: private', false);
                header('Content-Type: text/csv');
                header('Content-Disposition: attachment; filename=data.csv');
                $file = fopen('php://output', 'w');
                
                fputcsv($file, array('League Name: '.$league['name']));
                fputcsv($file, array('Game Type: '.$league['gameType']));
                
                if($users != null)
                {
                    if(($league['gameType'] == 'PLAYERDRAFT' || $league['gameType'] == 'BEST5'))
                    {
                        fputcsv($file, array('Num', 'User', 'Entry Number', 'ID', 'Team Name', 'Pick Name'));
                    }
                    else if($league['gameType'] != 'PLAYERDRAFT') 
                    {
                        fputcsv($file, array('Num', 'User', 'Entry Number', 'ID', 'Fight Name', 'Pick Name'));
                    }
                    else 
                    {
                        fputcsv($file, array('Num', 'User', 'Entry Number', 'ID', 'Pick Name'));
                    }
                    foreach ($users as $ku => $user)
                    {
                        if($user['entries'] != null)
                        {
                            foreach ($user['entries'] as $entry)
                            {
                                if($entry['pick_items'] != null)
                                {
                                    foreach ($entry['pick_items'] as $k => $pick)
                                    {
                                        $num = $login_name = $entry_number = '';
                                        if($k == 0)
                                        {
                                            $num = $ku + 1;
                                            $login_name = $user['user_login'];
                                            $entry_number = $entry['entry_number'];
                                        }
                                        if(($league['gameType'] == 'PLAYERDRAFT' || $league['gameType'] == 'BEST5'))
                                        {
                                            fputcsv($file, array($num, $login_name, $entry_number, $pick['id'], $pick['team_name'], $pick['name']));
                                        }
                                        else if($league['gameType'] != 'PLAYERDRAFT') 
                                        {
                                            fputcsv($file, array($num, $login_name, $entry_number, $pick['id'], $pick['fight_name'], $pick['name']));
                                        }
                                        else 
                                        {
                                            fputcsv($file, array($num, $login_name, $entry_number, $pick['id'], $pick['name']));
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                else 
                {
                    fputcsv($file, array("No picks"));
                }

                fclose($file);
                exit;
            }
        }
    }
    
    public static function addContests()
    {
        //must check that the user has the required capability 
        if (!current_user_can('manage_options'))
        {
            wp_die( __('You do not have sufficient permissions to access this page.') , 'fantasy-sports');
        }
        
        //load css js
        wp_enqueue_script('admin.js', FANVICTOR__PLUGIN_URL_JS.'admin/admin.js');
        wp_enqueue_script('fight.js', FANVICTOR__PLUGIN_URL_JS.'admin/fight.js');
        wp_enqueue_script('createcontest.js', FANVICTOR__PLUGIN_URL_JS.'createcontest.js', 5);
        wp_enqueue_script('accounting.js', FANVICTOR__PLUGIN_URL_JS.'accounting.js');
        wp_enqueue_script('ui.js', FANVICTOR__PLUGIN_URL_JS.'ui.js',5);
        wp_enqueue_style('ui.css', FANVICTOR__PLUGIN_URL_CSS.'ui/ui.css');
        wp_enqueue_style('admin.css', FANVICTOR__PLUGIN_URL_CSS.'admin.css');
        
        //edit data
        $iEditId = isset($_GET['id']) ? $_GET['id'] : null;
        $bIsEdit = $iEditId > 0 ? true : false;

        //add or update
		self::modify($bIsEdit);

        //pools and fights
        $global_setting = self::$fanvictor->getGlobalSetting();
        $aDatas = self::$fanvictor->loadCreateLeagueForm($iEditId);

        $aPools = $aDatas['pools'];
        $aFights = $aDatas['fights'];
        $aRounds = $aDatas['rounds'];
        $aSports = $aDatas['sports'];
        $aPositions = $aDatas['player_positions'];
        $aForms = $aDatas['league'];
        $allowCustomSpread = $aDatas['allow_custom_spread'];
        $allowEditStartedContests = $aDatas['allow_edit_started_contests'];
        
        $aLeagueSizes = get_option('fanvictor_league_size');
        $aEntryFees = get_option('fanvictor_entry_fee');
        $is_allow_tie = $aDatas['league']['allow_tie'];
        $is_allow_new_tie_breaker = $aDatas['league']['allow_new_tie_breaker'];
        $game_type = $aDatas['league']['gameType'];
        //mixing sport
        $allow_mixing_sport = $aDatas['allow_mixing_sport'];
        $aDates = $aDatas['mixing_pools'];
        $aMixingPools = $aDatas['mixing_pools'];
        $is_mixing = $aDatas['league']['is_mixing'];
		$trade_player = $aDatas['trade_player'];		
        $list_motocross_sports = $aDatas['list_motocross_org'];
        $motocross_id = $aDatas['motocross_id'];
        $is_league_motocross = false;
        $allow_motocross = $aDatas['allow_motocross'];
        $is_single_game = $aDatas['is_single_game'];
        $is_mixing_game = $aDatas['is_mixing_game'];
        $is_motocross_game = $aDatas['is_motocross_game'];
        $allow_guaranteed_prize = $aDatas['allow_guaranteed_prize'];
        $is_show_weekly_pick = $aDatas['is_show_weekly_pick'];
        $contest_only_rookies = $aDatas['contest_only_rookies'];

        if($aDatas['league']){
            $is_league_motocross = $aDatas['league']['is_motocross'];
        }        
        include FANVICTOR__PLUGIN_DIR_VIEW.'contests/add.php';
    }

    private static function validData($aVals)
    {
        $valid = self::$fanvictor->validCreateLeague($_POST);
        
        switch($valid)
        {
            case 2;
                FV_Redirect(self::$urladd, __('Sport does not exist. Please try again.', 'fantasy-sports'));
                break;
            case 3;
                FV_Redirect(self::$urladd, __('Date does not exist. Please try again.', 'fantasy-sports'));
                break;
            case 4;
                FV_Redirect(self::$urladd, __('Fixture does not exist. Please try again.', 'fantasy-sports'));
                break;
            case 5;
                FV_Redirect(self::$urladd, __('Please select at least a fixture.', 'fantasy-sports'));
                break;
            case 6;
                FV_Redirect(self::$urladd, __('This game type does not exist.', 'fantasy-sports'));
                break;
            case 7;
                FV_Redirect(self::$urladd, __('This sport does not support playerdraft type.', 'fantasy-sports'));
                break;
            case 8;
                FV_Redirect(self::$urladd, __('Please enter league name', 'fantasy-sports'));
                break;
            case 9;
                FV_Redirect(self::$urladd, __('Round does not exist. Please try again', 'fantasy-sports'));
                break;
            case 10;
                FV_Redirect(self::$urladd, __('Please select at least two rounds', 'fantasy-sports'));
                break;
            case 11;
                FV_Redirect(self::$urladd, __('Invalid payouts', 'fantasy-sports'));
                break;
            case 12;
                FV_Redirect(self::$urladd, __('Max player restriction is 4', 'fantasy-sports'));
                break;
            case 13;
                FV_Redirect(self::$urladd, __('Invalid player change quantity', 'fantasy-sports'));
                break;
            case 14;
                FV_Redirect(self::$urladd, __('Please enter number of minutes a contestant has to draft', 'fantasy-sports'));
                break;
            case 15;
                FV_Redirect(self::$urladd, __('Number of players that be changed via Waiver Wire must be lower than player quantity of lineup', 'fantasy-sports'));
                break;
            case 16;
                FV_Redirect(self::$urladd, __('Invalid league size', 'fantasy-sports'));
                break;
            case 17;
                FV_Redirect(self::$urladd, __('Please enter start draft date time', 'fantasy-sports'));
                break;
            case 18;
                FV_Redirect(self::$urladd, __('Please input guaranteed prize', 'fantasy-sports'));
                break;
            case 19;
            case 20;
                FV_Redirect(self::$urladd, __('Please input all guaranteed prize structure fields and total percent must be 100%', 'fantasy-sports'));
                break;
            case 20;
                FV_Redirect(self::$urladd, __('Waiver wire start day can not be behind waiver wire end day', 'fantasy-sports'));
                break;
            case 22;
                FV_Redirect(self::$urladd, __('Number of entries to close a contest must be lower than league size', 'fantasy-sports'));
                break;
            case 23;
                FV_Redirect(self::$urladd, __('No games for select date range', 'fantasy-sports'));
                break;
        }
        
        if(!in_array($_POST['leagueSize'], get_option('fanvictor_league_size')))
        {
            FV_Redirect(self::$urladd, __('League size does not exist', 'fantasy-sports'));
        }
        else if($_POST['entry_fee'] > 0 && !in_array($_POST['entry_fee'], get_option('fanvictor_entry_fee')))
        {
            FV_Redirect(self::$urladd, __('Entry fee does not exist', 'fantasy-sports'));
        }
        return true;
    }
    
    private static function modify()
    {
        if(!empty($_POST['live_draft_start_date']))
        {
            $_POST['live_draft_start'] = date("Y-m-d H:i:s", strtotime($_POST['live_draft_start_date']." ".$_POST['live_draft_start_hour'].":".$_POST['live_draft_start_minute'].":00"));
        }
        if(!empty($_POST['yearly_contest_start']))
        {
            $_POST['yearly_contest_start'] = date('Y-m-d', strtotime($_POST['yearly_contest_start']))." 00:00:00";
        }
        if(!empty($_POST['yearly_contest_end']))
        {
            $_POST['yearly_contest_end'] = date('Y-m-d', strtotime($_POST['yearly_contest_end']))." 23:59:00";
        }
        if (isset($_POST) && $aVals = $_POST)
		{
			if (self::validData($aVals))
			{
                if(self::$fanvictor->isLeagueExist($aVals['leagueID'])) //update
                {
                    if (self::$fanvictor->createLeague($_POST))
                    {
                        FV_Redirect(self::$urladd, __('Succesfully updated', 'fantasy-sports'));
                    }
                }
                else //add
                {   
                    $leagueID = self::$fanvictor->createLeague($_POST);
                    if((int)$leagueID > 0)
                    {
                        //buddy press integration
                        $league = self::$fanvictor->getLeagueDetail($leagueID);
                        if($league != null)
                        {
                            $league = $league[0];
                            self::$fanvictor->addCreateContestActivity($league, $_COOKIE['fanvictor_user_id']);
                        }
        
                        FV_Redirect(self::$url, __('Succesfully added', 'fantasy-sports'));
                    }
                }
                FV_Redirect(self::$urladd, __('Something went wrong! Please try again.', 'fantasy-sports'));
			}
		}
    }
    
    private static function delete()
	{
        if ($aIds = $_POST['id'])
		{
			$iDeleted = 0;
			foreach ($aIds as $iId)
			{
				if (self::$leagues->delete($iId))
				{
                    self::$fanvictor->deleteContestActivities($iId);
					$iDeleted++;
				}
			}
			
			if ($iDeleted > 0)
			{
                FV_Redirect(self::$url, 'Succesfully deleted');
			}
		}
        FV_Redirect(self::$url);
	}
}
?>