<?php

$Fanvictor_Players = new Fanvictor_Players();

class Fanvictor_Players
{

    private static $fanvictor;
    private static $teams;
    private static $playerposition;
    private static $players;
    private static $url_select;
    private static $url;
    private static $urladdnew;
    private static $urladd;

    public function __construct()
    {
        self::$fanvictor = new Fanvictor();
        self::$teams = new Teams();
        self::$playerposition = new PlayerPosition();
        self::$players = new Players();
        self::$url_select = admin_url() . 'admin.php?page=manage-players';
        self::$url = admin_url() . 'admin.php?page=manage-players' . (!empty($_REQUEST['sport_id']) ? '&sport_id=' . $_REQUEST['sport_id'] : '');
        self::$urladdnew = admin_url() . 'admin.php?page=add-players' . (!empty($_REQUEST['sport_id']) ? '&sport_id=' . $_REQUEST['sport_id'] : '');
        self::$urladd = wp_get_referer();
    }

    public static function managePlayers()
    {
        //must check that the user has the required capability 
        if (!current_user_can('manage_options'))
        {
            wp_die(__('You do not have sufficient permissions to access this page.'), 'fantasy-sports');
        }

        //load css js
        wp_enqueue_script('admin.js', FANVICTOR__PLUGIN_URL_JS . 'admin/admin.js');
        wp_enqueue_script('accounting.js', FANVICTOR__PLUGIN_URL_JS . 'accounting.js');
        if (empty($_GET['sport_id']))
        {
            $aSports = self::$fanvictor->getListSports(array('is_motocross' => true));
            include FANVICTOR__PLUGIN_DIR_VIEW . 'Elements/select_sport.php';
        }
        else
        {
            //task action delete
            if (isset($_POST["task"]) && $task = $_POST["task"])
            {
                switch ($task)
                {
                    case "delete":
                        self::delete();
                        break;
                    case "save":
                        self::saveChanges();
                        break;
                }
            }
            include FANVICTOR__PLUGIN_DIR_VIEW . "Elements/check-api-token.php";
            include FANVICTOR__PLUGIN_DIR_VIEW . 'players/class.table-players.php';
            $myListTable = new TablePlayers();
            $myListTable->prepare_items(isset($_GET['s']) ? $_GET['s'] : null);
            include FANVICTOR__PLUGIN_DIR_VIEW . 'players/index.php';
        }
    }

    public static function addPlayers()
    {
        //must check that the user has the required capability 
        if (!current_user_can('manage_options'))
        {
            wp_die(__('You do not have sufficient permissions to access this page.'), 'fantasy-sports');
        }

        //load css js
        wp_enqueue_script('admin.js', FANVICTOR__PLUGIN_URL_JS . 'admin/admin.js');
        wp_enqueue_script('players.js', FANVICTOR__PLUGIN_URL_JS . 'admin/players.js');
        wp_enqueue_script('accounting.js', FANVICTOR__PLUGIN_URL_JS . 'accounting.js');


        $bIsEdit = !empty($_GET['id']) ? true : false;
        $iEditId = !empty($_GET['id']) ? $_GET['id'] : 0;
        $sport_id = !empty($_GET['sport_id']) ? $_GET['sport_id'] : 0;

        //add or update
        self::modify();

        //data
        $data = self::$players->getAddPlayer($iEditId, $sport_id);
        $aForms = $data['player'];
        $aForms = self::$players->parsePlayersData($aForms, false);
        $aSports = $data['sports'];
        $aTeams = $data['teams'];
        $aPositions = $data['player_positions'];
        $aIndicators = self::$players->getIndicator();
        $aMotocross = self::$fanvictor->getListMotocrossSports();
        $aListMotocross = $aMotocross['result'];
        include FANVICTOR__PLUGIN_DIR_VIEW . 'players/add.php';
    }

    private static function modify()
    {
        if (isset($_POST['val']) && $aVals = $_POST['val'])
        {
            $valid = self::$players->add($aVals);
            switch ($valid)
            {
                case 'v1':
                    FV_Redirect(self::$urladd, __('Please select an organization ', 'fantasy-sports'));
                    break;
                case 'v2':
                    FV_Redirect(self::$urladd, __('Please select a team', 'fantasy-sports'));
                    break;
                case 'v3':
                    FV_Redirect(self::$urladd, __('Please select a position ', 'fantasy-sports'));
                    break;
                case 'v4':
                    FV_Redirect(self::$urladd, __('Provide name', 'fantasy-sports'));
                    break;
                case 'v5':
                    FV_Redirect(self::$urladd, __('Provide salary', 'fantasy-sports'));
                    break;
                case 'u1':
                    FV_Redirect(self::$urladd, __('Succesfully updated', 'fantasy-sports'));
                    break;
                case 'u1':
                    FV_Redirect(self::$urladd, __('Something went wrong! Please try again.', 'fantasy-sports'));
                    break;
            }
            FV_Redirect(self::$url, 'Succesfully added');
        }
    }

    private static function delete()
    {
        if ($aIds = $_POST['id'])
        {
            $iDeleted = 0;
            foreach ($aIds as $iId)
            {
                if (self::$players->delete($iId))
                {
                    $iDeleted++;
                }
            }

            if ($iDeleted > 0)
            {
                FV_Redirect(self::$url, 'Succesfully deleted');
            }
        }
        FV_Redirect(self::$url);
    }

    private static function saveChanges()
    {
        $player_ids = !empty($_POST['player_id']) ? $_POST['player_id'] : array();
        $salaries = !empty($_POST['salary']) ? $_POST['salary'] : array();
        if($salaries != null)
        {
            foreach($salaries as $player_id => $salary)
            {
                $salary = str_replace(',', '', $salary);
                self::$players->updatePlayer(array(
                    'id' => $player_id,
                    'salary' => $salary
                ));
            }
        }
        FV_Redirect(self::$url, 'Succesfully updated');
    }
}

?>