<?php
$Fanvictor_Sports = new Fanvictor_Sports();
class Fanvictor_Sports
{
    private static $sports;
    private static $payment;
    private static $leagues;
    private static $url;
    private static $urladd;
    private static $urladdnew;
    private static $fanvictor;

    public function __construct() 
    {
        self::$sports = new Sports();
        self::$payment = new Payment();
        self::$leagues = new Leagues();
        self::$fanvictor = new Fanvictor();
        self::$url = admin_url().'admin.php?page=manage-sports';
        self::$urladd = wp_get_referer();
        self::$urladdnew = admin_url().'admin.php?page=add-sports';
    }

    public static function manageDashboard(){
        //load css js
        wp_enqueue_script('jquery-1.12.4.js', FANVICTOR__PLUGIN_URL_JS . 'jquery-1.12.4.js', 1);
        wp_enqueue_script('admin.js', FANVICTOR__PLUGIN_URL_JS.'admin/admin.js');
        wp_enqueue_style('ui.css', FANVICTOR__PLUGIN_URL_CSS.'ui/ui.css');
        wp_enqueue_script('ui.js', FANVICTOR__PLUGIN_URL_JS.'ui.js');
        wp_enqueue_style('admin-ui.css', FANVICTOR__PLUGIN_URL_CSS . 'ui/admin-ui.css', 5);

        $list_sport     = self::$sports->getSportsBySite();
        $list_premium_feature = self::$fanvictor->getPremiumFeatures();
        $site_setting   = self::$sports->getSportBySiteSetting();

        $stats_type = isset($_GET['stats_type']) ? $_GET['stats_type'] : 'total_contest';
        $stats_year = isset($_GET['stats_year']) ? $_GET['stats_year'] : date('Y');
        switch ($stats_type) {
            case 'total_money':
                $cond = 'YEAR(date) = '.$stats_year;
                $list_all_fundhistory = self::$payment->getAllFundhistory($cond);
                $str_chart = "['Month', 'Total Money']";

                if(count($list_all_fundhistory) > 0){
                    foreach ($list_all_fundhistory as $key => $value) {
                        $str_chart .= ",['".$key."', ".$value."]";
                    }
                }else{
                    $str_chart .= ",['January', 0],['February', 0],['March', 0],['April', 0],['May', 0],['June', 0],['July', 0],['August', 0],['September', 0],['October', 0],['November', 0],['December', 0]"; 
                }
                break;

            case 'total_users_played':
                $total_users_played  = self::$sports->getUserPlayed($stats_year);
                $str_chart = "['Month', 'Total Users Played']";

                if(count($total_users_played) > 0){
                    foreach ($total_users_played as $key => $value) {
                        $str_chart .= ",['".$key."', ".$value."]";
                    }
                }else{
                    $str_chart .= ",['January', 0],['February', 0],['March', 0],['April', 0],['May', 0],['June', 0],['July', 0],['August', 0],['September', 0],['October', 0],['November', 0],['December', 0]"; 
                }
                break;
            
            default:
                $total_contest  = self::$leagues->getLeagueByYear($stats_year);
                $str_chart = "['Month', 'Total Contests']";
                if(count($total_contest) > 0){
                    foreach ($total_contest as $key => $value) {
                        $str_chart .= ",['".$key."', ".$value."]";
                    }
                }else{
                    $str_chart .= ",['January', 0],['February', 0],['March', 0],['April', 0],['May', 0],['June', 0],['July', 0],['August', 0],['September', 0],['October', 0],['November', 0],['December', 0]"; 
                }                
                break;
        }        

        include FANVICTOR__PLUGIN_DIR_VIEW.'sports/dashboard.php';
    }
    
    public static function manageSports()
    {
        //load css js
        wp_enqueue_script('admin.js', FANVICTOR__PLUGIN_URL_JS.'admin/admin.js');
        wp_enqueue_style('ui.css', FANVICTOR__PLUGIN_URL_CSS.'ui/ui.css');
        wp_enqueue_script('ui.js', FANVICTOR__PLUGIN_URL_JS.'ui.js');
        
        //task action delete
        if(isset($_POST["task"]) && $task = $_POST["task"])
        {
            switch($task)
            {
                case "delete":
                    self::delete();
                    break;
            }
        }
        include FANVICTOR__PLUGIN_DIR_VIEW."Elements/check-api-token.php";
        include FANVICTOR__PLUGIN_DIR_VIEW.'sports/class.table-sports.php';
        $myListTable = new TableSports();
        $myListTable->prepare_items(); 
        include FANVICTOR__PLUGIN_DIR_VIEW.'sports/index.php';
    }
    
    public static function addSports()
    {
        //must check that the user has the required capability 
        if (!current_user_can('manage_options'))
        {
            wp_die( __('You do not have sufficient permissions to access this page.') , 'fantasy-sports');
        }
        
        //load css js
        wp_enqueue_script('admin.js', FANVICTOR__PLUGIN_URL_JS.'admin/admin.js');
        
        //edit data
        $bIsEdit = false;
		if (isset($_GET['id']) && $iEditId = $_GET['id'])
		{
            $bIsEdit = true;
            $aForms = self::$sports->getSportById($iEditId);
            $aForms = self::$sports->parseSportsData($aForms);
            $aForms = $aForms[0];
		}
        else
        {
            $aForms = null;
        }

        //add or update
		self::modify($bIsEdit);

        $aSports = self::$sports->getSports();
        include FANVICTOR__PLUGIN_DIR_VIEW.'sports/add.php';
    }

    private static function validData($aVals)
    {
        if(empty($aVals['name']))
        {
            FV_Redirect(self::$urladd, 'Provide a name');
        }
        return true;
    }
    
    private static function modify()
    {
        if (isset($_POST['val']) && $aVals = $_POST['val'])
		{
			if (self::validData($aVals))
			{
                if(self::$sports->isSportExist($aVals['id'])) //update
                {
                    if (self::$sports->update($aVals))
                    {
                        FV_Redirect(self::$urladd, 'Succesfully updated');
                    }
                }
                else //add
                {
                    if (self::$sports->add($aVals))
                    {
                        FV_Redirect(self::$url, 'Succesfully added');
                    }
                }
                FV_Redirect(self::$urladd, 'Something went wrong! Please try again.');
			}
		}
    }
    
    private static function delete()
	{
        if ($aIds = $_POST['id'])
		{
			$iDeleted = 0;
			foreach ($aIds as $iId)
			{
				if (self::$sports->delete($iId))
				{
					$iDeleted++;
				}
			}
			
			if ($iDeleted > 0)
			{
                FV_Redirect(self::$url, 'Succesfully deleted');
			}
		}
        FV_Redirect(self::$url);
	}
}
?>