<?php
class FV_LivescoreController
{
    private static $fanvictor;
    public function __construct() 
    {
        self::$fanvictor = new Fanvictor();
    }
    
	public static function process()
	{
		add_action( 'wp_enqueue_scripts', array('FV_LivescoreController', 'stat_scripts') );
        add_filter('the_content', array('FV_LivescoreController', 'addContent'));
	}
    
    public static function stat_scripts()
    {
        wp_enqueue_script('livescore.js', FANVICTOR__PLUGIN_URL_JS.'livescore.js');
        wp_enqueue_script('jquery.flexslider.js', FANVICTOR__PLUGIN_URL_JS.'jquery.flexslider.js');
        wp_enqueue_style('live_score.css', FANVICTOR__PLUGIN_URL_CSS . 'live_score.css');
    }

	public static function addContent()
	{
        if(!in_the_loop()){
            return;
        }

        if(isset($_GET['detail']))
        {
            self::liveScoreDetail();
        }
        else
        {
            self::liveScore();
        }
	}
    
    private static function liveScore()
    {
        $sports = self::$fanvictor->getSportTree(true);
        include FANVICTOR__PLUGIN_DIR_VIEW.'live_score.php';
    }
    
    private static function liveScoreDetail()
    {
        $params = $_GET;
        if(empty($params['team_id']))
        {
            FV_Redirect(FANVICTOR_URL_LIVESCORE, __('Team not found', 'fantasy-sports'), true);
        }
        $team_id = $params['team_id'];

        //get data
        $data = self::$fanvictor->liveScoreTeamSchedule($team_id);
        $team = $data['team'];
        $nearest_fixtures = $data['nearest_fixtures'];
        
        include FANVICTOR__PLUGIN_DIR_VIEW.'live_score_detail.php';
    }
    
    public static function showLivePoint(){
        wp_enqueue_script('livepoint.js', FANVICTOR__PLUGIN_URL_JS.'livepoint.js');
        wp_enqueue_style('live_score.css', FANVICTOR__PLUGIN_URL_CSS . 'live_score.css');
        
        self::$fanvictor = new Fanvictor();
        $gameType = self::$fanvictor->getGameType();
        $citys = self::$fanvictor->getCountryList();
        include FANVICTOR__PLUGIN_DIR_VIEW.'live_point.php';
    }
}
?>