<?php
class FV_LobbyController
{
    private static $fanvictor;
    public static function show($game_type = null)
    {
        self::$fanvictor = new Fanvictor();
        $pool = new Pools();
        $pool->updateUserMoneyWon();
        self::content($game_type);
    }

    private static function content($game_type = null)
    {
        if(isset($_GET['entry_close_contest']) && $_GET['entry_close_contest'] == 1)
        {
            self::entry_close_contest();
            exit;
        }
        else if(isset($_GET['send_injuiry_email']) && $_GET['send_injuiry_email'] == 1)
        {
            self::send_injuiry_email();
            exit;
        }
        else if(isset($_GET['live_draft_start']) && $_GET['live_draft_start'] == 1)
        {
            self::live_draft_start();
            self::weekly_stats();
            exit;
        }
        else if(isset($_GET['roundpickem_notification']) && $_GET['roundpickem_notification'] == 1)
        {
            self::roundpickem_notification();
            exit;
        }
        else if(isset($_GET['push_notification_team_score']) && $_GET['push_notification_team_score'] == 1)
        {
            self::push_notification_team_score();
            exit;
        }
        else if(isset($_GET['push_notification_player_red_card']) && $_GET['push_notification_player_red_card'] == 1)
        {
            self::push_notification_player_red_card();
            exit;
        }
        else if(isset($_GET['push_notification_contest_start']) && $_GET['push_notification_contest_start'] == 1)
        {
            self::push_notification_contest_start();
            exit;
        }
        else if(isset($_GET['push_notification_contest_end']) && $_GET['push_notification_contest_end'] == 1)
        {
            self::push_notification_contest_end();
            exit;
        }
        else if(isset($_GET['survivor_reminder']) && $_GET['survivor_reminder'] == 1)
        {
            self::survivor_reminder();
            exit;
        }
        else if(isset($_GET['survivor_reminder_decision']) && $_GET['survivor_reminder_decision'] == 1)
        {
            self::survivor_reminder_decision();
            exit;
        }
        else
        {
            wp_enqueue_script('global.js', FANVICTOR__PLUGIN_URL_JS.'global.js');
            wp_enqueue_script('playerdraft.js', FANVICTOR__PLUGIN_URL_JS.'playerdraft.js');
            wp_enqueue_script('lobby_page.js', FANVICTOR__PLUGIN_URL_JS.'lobby_page.js');
            wp_enqueue_script('countdown.min.js', FANVICTOR__PLUGIN_URL_JS.'countdown.min.js');
            wp_enqueue_script('tablesorter.js', FANVICTOR__PLUGIN_URL_JS.'tablesorter.js');
            wp_enqueue_script('accounting.js', FANVICTOR__PLUGIN_URL_JS.'accounting.js');
            wp_enqueue_script('ui.js', FANVICTOR__PLUGIN_URL_JS.'ui.js');
            wp_enqueue_script('jquery.flexslider.js', FANVICTOR__PLUGIN_URL_JS.'jquery.flexslider.js');
            wp_enqueue_style('style.css', FANVICTOR__PLUGIN_URL_CSS.'style.css');
            wp_enqueue_style('lobby.css', FANVICTOR__PLUGIN_URL_CSS.'lobby.css');
            wp_enqueue_style('font-awesome.css', FANVICTOR__PLUGIN_URL_CSS.'font-awesome/css/font-awesome.css');
            wp_enqueue_style('flexslider.css', FANVICTOR__PLUGIN_URL_CSS.'flexslider.css');
            wp_enqueue_style('ui.css', FANVICTOR__PLUGIN_URL_CSS.'ui/ui.css');
            
            $global_setting = self::$fanvictor->getGlobalSetting();
			$fanvictor_firebase_apikey = get_option('fanvictor_firebase_apikey');
			$fanvictor_firebase_senderid = get_option('fanvictor_firebase_senderid');
            if(!empty($_COOKIE['fanvictor_user_id']) && 
               !empty($fanvictor_firebase_apikey) && 
               !empty($fanvictor_firebase_senderid) &&
               $global_setting['allow_push_notification'])
            {
                wp_enqueue_script('firebase.js', 'https://www.gstatic.com/firebasejs/4.8.1/firebase.js');
                wp_enqueue_script('firebase-messaging.js', 'https://www.gstatic.com/firebasejs/4.8.1/firebase-messaging.js');
                wp_enqueue_script('push_notification.js', FANVICTOR__PLUGIN_URL_JS.'push_notification.js');
            }
            else if(!empty($_COOKIE['fanvictor_user_id']))
            {
                self::$fanvictor->unSubscribePushNotification($_COOKIE['fanvictor_user_id']);
            }

            $aSports = self::$fanvictor->getListSports();
            $time_zone_abbr = 'CET';
            try{
                $timezone = get_option('fanvictor_timezone');
                $dateTime = new DateTime(); 
                $dateTime->setTimeZone(new DateTimeZone($timezone)); 
                $time_zone_abbr  = $dateTime->format('T');
            } catch (Exception $ex) {

            }
            
            $feature_leagues = self::$fanvictor->getFeatureLeagues();
            
            //goliath decision popup
            $goliathDecision = self::$fanvictor->checkGoliathDecision();
            
            include FANVICTOR__PLUGIN_DIR_VIEW.'lobby.php';
        }
    }
    
    private static function live_draft_waiver_wire()
    {
        $date = date('Y-m-d');
        $result = self::$fanvictor->liveDraftChangePlayerWaiverWire($date);
        if(!empty($result['leagues']))
        {
            foreach($result['leagues'] as $league)
            {
                foreach($league['change_list'] as $user_id => $players)
                {
                    $change_list = array();
                    if($players != null)
                    {
                        foreach($players as $player)
                        {
                            $change_list[] = $player['from_name']." ".__('to', 'fantasy-sports')." ".$player['to_name'];
                        }
                    }
                    self::$fanvictor->sendLiveDraftChangePlayerWaiverWireEmail($user_id, $league['leagueID'], $change_list, $league);
                }
            }
        }
        return;
    }
    
    private static function live_draft_start()
    {
        $data = self::$fanvictor->liveDraftStart();
        if(!empty($data['data']))
        {
            foreach($data['data'] as $item)
            {
                if(!empty($item['user_ids']))
                {
                    $user_ids = explode(",", $item['user_ids']);
                    foreach($user_ids as $user_id)
                    {
                        if(isset($item['error']) && $item['error'] == 1) //send cancel contest
                        {
                            self::$fanvictor->sendLiveDraftCancelContestEmail($user_id, $item['league']);
                        }
                        else
                        {
                            self::$fanvictor->sendLiveDraftStartDraftEmail($user_id, $item['league']);
                        }
                    }
                }
            }
        }
        
        //change players
        self::live_draft_waiver_wire();
    }
    
    private static function weekly_stats()
    {
        $day = date('D');
        $fanvictor_last_report_date = get_option('fanvictor_last_report_date');
        if($day != 'Mon' || ($fanvictor_last_report_date != null && strtotime($fanvictor_last_report_date) <= strtotime(date('Y-m-d'))))
        {
            return;
        }
        $playerstats = self::$fanvictor->getWeeklyPlayerStats();
        if($playerstats == null)
        {
            return;
        }
        $excel_column = array(
            __('Player Name', 'fantasy-sports'),
            __('Player Position', 'fantasy-sports'),  
            __('Player Team', 'fantasy-sports'),  
            __('Date of Game', 'fantasy-sports'),  
            __('Opposition Team', 'fantasy-sports'),  
            __('Total Fantasy Points', 'fantasy-sports'), 
            __('Scrum Won', 'fantasy-sports'), 
            __('Penalties', 'fantasy-sports'), 
            __('Runs', 'fantasy-sports'), 
            __('Passes', 'fantasy-sports'), 
            __('Missed Goal', 'fantasy-sports'), 
            __('Lineout Won', 'fantasy-sports'), 
            __('Kicks Caught', 'fantasy-sports'), 
            __('Kicks a Goal', 'fantasy-sports'), 
            __('Tries', 'fantasy-sports'), 
            __('Offload', 'fantasy-sports'), 
            __('Metres', 'fantasy-sports'), 
            __('Try assist', 'fantasy-sports'), 
            __('Defenders Beaten', 'fantasy-sports'), 
            __('Clean Breaks', 'fantasy-sports'), 
            __('Red Cards', 'fantasy-sports'), 
            __('Yellow Cards', 'fantasy-sports'), 
            __('Tackles', 'fantasy-sports'), 
            __('Missed Tackles', 'fantasy-sports'), 
            __('Turnovers', 'fantasy-sports'), 
            __('Kicks', 'fantasy-sports') 
        );
        
        //export to excel
        ob_clean();
        $file = fopen(FANVICTOR__PLUGIN_DIR.'assets/weekly_stats.csv', 'w');
        fputcsv($file, $excel_column);
        if($playerstats != null)
        {
            foreach($playerstats as $playerstat)
            {
                fputcsv($file, $playerstat);
            }
        }
        else
        {
            fputcsv($file, array("No stats"));
        }
        fclose($file);

        $is_sent = self::$fanvictor->sendWeeklyPlayerStats();
        if($is_sent)
        {
            update_option('fanvictor_last_report_date', date('Y-m-d'));
        }
        return;
    }
    
    private static function entry_close_contest()
    {
        $result = self::$fanvictor->checkEntryCloseContest();
    }
    
    private static function send_injuiry_email()
    {
        $result = self::$fanvictor->sendInjuiryEmail();
    }
    
    private static function roundpickem_notification()
    {
        if(!empty($_GET['weekly_winner']))
        {
            $data = self::$fanvictor->roundPickemWeeklyWinner();
            if(!empty($data['notifications']))
            {
                $notifications = $data['notifications'];
                foreach($notifications as $notification)
                {
                    if(empty($notification['winner_id']))
                    {
                        continue;
                    }
                    $user_ids = explode(',', $notification['user_ids']);
                    foreach($user_ids as $user_id)
                    {
                        self::$fanvictor->sendRoundPickemWeeklyWinner($notification['league'], $notification['week'], $user_id, $notification['winner_id']);
                    }
                }
            }
        }
        else if(!empty($_GET['reminder']))
        {
            $data = self::$fanvictor->roundPickemReminder();
            if(!empty($data['notifications']))
            {
                $notifications = $data['notifications'];
                foreach($notifications as $notification)
                {
                    if(empty($notification['user_ids']))
                    {
                        continue;
                    }
                    $user_ids = explode(',', $notification['user_ids']);
                    foreach($user_ids as $user_id)
                    {
                        self::$fanvictor->sendRoundPickemWeeklyNotification($notification['league'], $notification['week'], $user_id);
                    }
                }
            }
        }
    }
    
    /////////////////////////////////////firebase push notification/////////////////////////////////////
    private static function push_notification_team_score()
    {
        $fanvictor_firebase_apikey = get_option('fanvictor_firebase_apikey');
		$fanvictor_firebase_senderid = get_option('fanvictor_firebase_senderid');
		if(empty($fanvictor_firebase_apikey) || empty($fanvictor_firebase_senderid))
        {
            return;
        }
        $league_id = !empty($_GET['league_id']) ? $_GET['league_id'] : "";
        $team_name1 = !empty($_GET['team_name1']) ? html_entity_decode($_GET['team_name1']) : "";
        $team_name2 = !empty($_GET['team_name2']) ? html_entity_decode($_GET['team_name2']) : "";
        $team_score1 = !empty($_GET['team_score1']) ? urldecode($_GET['team_score1']) : 0;
        $team_score2 = !empty($_GET['team_score2']) ? urldecode($_GET['team_score2']) : 0;
        $player_score = !empty($_GET['player_score']) ? urldecode($_GET['player_score']) : 0;
        $minute = !empty($_GET['minute_score']) ? urldecode($_GET['minute_score']) : 0;
        if($league_id == "" || $team_name1 == "")
        {
            return;
        }
        
        $user_ids = self::$fanvictor->getUserIdsJoinContest($league_id);

        if($user_ids == null)
        {
            return;
        }
        $link = FANVICTOR_URL_CONTEST.$league_id."?num=1";
        $data = self::$fanvictor->sendNotificationTeamScore($user_ids['user_ids'], $team_name1, $team_name2, $team_score1, $team_score2, $player_score, $minute, $link);
    }
    
    private static function push_notification_player_red_card()
    {
        $fanvictor_firebase_apikey = get_option('fanvictor_firebase_apikey');
		$fanvictor_firebase_senderid = get_option('fanvictor_firebase_senderid');
		if(empty($fanvictor_firebase_apikey) || empty($fanvictor_firebase_senderid))
        {
            return;
        }
        $league_id = !empty($_GET['league_id']) ? $_GET['league_id'] : "";
        $player_name = !empty($_GET['player_name']) ? $_GET['player_name'] : "";
        $minute = !empty($_GET['player_minute']) ? $_GET['player_minute'] : "";
        if($league_id == "" || $player_name == "")
        {
            return;
        }
        
        $user_ids = self::$fanvictor->getUserIdsJoinContest($league_id);
        
        if($user_ids == null)
        {
            return;
        }
        $link = FANVICTOR_URL_CONTEST.$league_id."?num=1";
        $data = self::$fanvictor->sendNotificationRedCard($user_ids['user_ids'], $player_name, $minute, $link);
    }
    
    private static function push_notification_contest_start()
    {
        $fanvictor_firebase_apikey = get_option('fanvictor_firebase_apikey');
		$fanvictor_firebase_senderid = get_option('fanvictor_firebase_senderid');
		if(empty($fanvictor_firebase_apikey) || empty($fanvictor_firebase_senderid))
        {
            return;
        }
        $league_id = !empty($_GET['league_id']) ? $_GET['league_id'] : "";
        $time = !empty($_GET['time']) ? $_GET['time'] : "";
        $team_name1 = !empty($_GET['team_name1']) ? html_entity_decode($_GET['team_name1']) : "";
        $team_name2 = !empty($_GET['team_name2']) ? html_entity_decode($_GET['team_name2']) : "";
        if($league_id == "" || $time == "")
        {
            return;
        }
        
        $user_ids = self::$fanvictor->getUserIdsJoinContest($league_id);
        
        if($user_ids == null)
        {
            return;
        }
        $link = FANVICTOR_URL_CONTEST.$league_id."?num=1";
        $data = self::$fanvictor->sendNotificationContestStart($user_ids['user_ids'], $time, $team_name1, $team_name2, $link);
    }
    
    private static function push_notification_contest_end()
    {
        $fanvictor_firebase_apikey = get_option('fanvictor_firebase_apikey');
		$fanvictor_firebase_senderid = get_option('fanvictor_firebase_senderid');
		if(empty($fanvictor_firebase_apikey) || empty($fanvictor_firebase_senderid))
        {
            return;
        }
        $league_id = !empty($_GET['league_id']) ? $_GET['league_id'] : "";
        $team_name1 = !empty($_GET['team_name1']) ? html_entity_decode($_GET['team_name1']) : "";
        $team_name2 = !empty($_GET['team_name2']) ? html_entity_decode($_GET['team_name2']) : "";
        $team_score1 = !empty($_GET['team_score1']) ? urldecode($_GET['team_score1']) : 0;
        $team_score2 = !empty($_GET['team_score2']) ? urldecode($_GET['team_score2']) : 0;
        if($league_id == "" || $team_name1 == "")
        {
            return;
        }
        
        $user_ids = self::$fanvictor->getUserIdsJoinContest($league_id);
        
        if($user_ids == null)
        {
            return;
        }
        $link = FANVICTOR_URL_CONTEST.$league_id."?num=1";
        $data = self::$fanvictor->sendNotificationContestEnd($user_ids['user_ids'], $team_name1, $team_name2, $team_score1, $team_score2, $link);
    }
    /////////////////////////////////////end firebase push notification/////////////////////////////////////
    
    /////////////////////////////////////survivor/////////////////////////////////////
    private static function survivor_reminder()
    {
        if(empty($_POST))
        {
            return;
        }
        $data = $_POST;
        foreach($data as $item)
        {
            $user_ids = $item['user_ids'];
            if($user_ids == null)
            {
                continue;
            }
            $league = $item['league'];
            $fight = $item['fight'];
            foreach($user_ids as $user_id)
            {
                self::$fanvictor->sendSurvivorReminderEmail($user_id, $league, $fight);
            }
        }
    }
    
    private static function survivor_reminder_decision()
    {
        if(empty($_POST))
        {
            return;
        }
        $data = $_POST;
        foreach($data as $item)
        {
            $user_ids = $item['user_ids'];
            if($user_ids == null)
            {
                continue;
            }
            $league = $item['league'];
            foreach($user_ids as $user_id)
            {
                self::$fanvictor->sendSurvivorReminderDecisionEmail($user_id, $league);
            }
        }
    }
    /////////////////////////////////////survivor/////////////////////////////////////
}
?>