<?php
class FV_PaymentCallbackController
{
    public static function callback()
    {
		require_once(FANVICTOR__PLUGIN_DIR_MODEL."payment.php");
        require_once(FANVICTOR__PLUGIN_DIR_MODEL."molpay.php");
		$payment = new Payment();
        $molpay = new FV_MolPay();

		$molpay->write_log("Receive callback");
		if(empty($_POST))
		{
			$molpay->write_log("no data params");
			exit;
		}
		$params = $_POST;
		$molpay->write_log($params);
		if(empty($params['applicationCode']) && $params['applicationCode'] != trim(get_option('fanvictor_molpay_application_code')))
		{
			$molpay->write_log("applicationCode not found");
			exit;
		}
		
		$fundhistory_id = $params['referenceId'];
		$fundhistory = $payment->getFundhistoryDetail(array(
			"fundshistoryID" => $fundhistory_id
		));
		if(empty($fundhistory))
		{
			$molpay->write_log("fundhistory not found");
			exit;
		}
		if($fundhistory['is_checkout'] == 1)
		{
			$molpay->write_log("This transaction has already finished");
			exit;
		}
        if (!empty($params['paymentStatusCode']) && $params['paymentStatusCode'] == "00")
        {
			$molpay->write_log("fund history data");
			$molpay->write_log($fundhistory);
			$molpay->write_log("start updating user balance");
			if ($payment->updateUserBalance((int) $fundhistory['amount'], false, 0, $fundhistory['userID']))
			{
				$fund_data = array(
					'transactionID' => $params['paymentId'], 
					'is_checkout' => 1
				);
				$payment->updateFundhistory($fundhistory['fundshistoryID'], $fund_data, $fundhistory['userID'], 'completed');
				$molpay->write_log("Successfully transaction ");
				exit;
			}
        }
		$payment->updateFundhistory($fundhistory['fundshistoryID'], array('is_checkout' => 1), $fundhistory['userID'], 'failed');
		$molpay->write_log("Transaction failed");
		exit;
    }
}

?>