<?php
class FV_StatisticsController
{
    private static $fanvictor;
    public function __construct() 
    {
        self::$fanvictor = new Fanvictor();
    }
    
	public static function process()
	{
		add_action( 'wp_enqueue_scripts', array('FV_StatisticsController', 'stat_scripts') );
        add_filter('the_content', array('FV_StatisticsController', 'addContent'));
	}
    
    public static function stat_scripts()
    {
        wp_enqueue_script('playerdraft.js', FANVICTOR__PLUGIN_URL_JS . 'playerdraft.js', 5);
        wp_enqueue_script('ui.js', FANVICTOR__PLUGIN_URL_JS . 'ui.js', 5);
        wp_enqueue_script('stats.js', FANVICTOR__PLUGIN_URL_JS.'stats.js', 5);
        wp_enqueue_style('font-awesome.css', FANVICTOR__PLUGIN_URL_CSS.'font-awesome/css/font-awesome.css');
        wp_enqueue_style('stats.css', FANVICTOR__PLUGIN_URL_CSS.'stats.css');
        wp_enqueue_style('playerdraft.css', FANVICTOR__PLUGIN_URL_CSS . 'playerdraft.css');
    }

	public static function addContent()
	{
        if(!in_the_loop()){
            return;
        }

        if(isset($_GET['rugby']) && $_GET['rugby'] == 1)
        {
            $data = self::$fanvictor->rugbyLoadStatsInfo(array(
                'league_id' => $_GET['league_id']
            ));
            if($data == null)
            {
                FV_Redirect(FANVICTOR_URL_LOBBY, __("You are not allowed to view this page", 'fantasy-sports'), true);
            }
            if($data['leagues'] == null)
            {
                FV_Redirect(FANVICTOR_URL_MY_LIVE_ENTRIES, __("Contest not found", 'fantasy-sports'), true);
            }
            $scoring_categories = $data['scoring_categories'];
            $player_positions = $data['player_positions'];
            $teams = $data['teams'];
            $leagues = $data['leagues'];
            include FANVICTOR__PLUGIN_DIR_VIEW.'statistics_rugby.php';
        }
        else
        {
            $data = self::$fanvictor->loadStatsSport();
            $sports = $data['sports'];
            $allow_statistic = $data['allow_statistic'];
            $is_loggedin = ($_COOKIE['fanvictor_user_id'] > 0) ? 1 : 0;
            include FANVICTOR__PLUGIN_DIR_VIEW.'statistics.php';
        }
	}
}
?>