<?php

class Cheese{
    public function __construct()
    {
        $this->base_url = "http://explorermn.cheesecoin.tk/api";
    }
    
    public function curl($url, $data = null){
        $ch = curl_init($url);
        if($data != null)
        {
            $data = http_build_query($data);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
            curl_setopt($ch, CURLOPT_POST, true);
        }
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        $result = curl_exec($ch);
        return json_decode($result, true);
    }
    
    public function transactionDetail($transaction_id, $wallet_address)
    {
        $url = $this->base_url."/getrawtransaction?txid={tx_id}&decrypt=1";
        $url = str_replace('{tx_id}', $transaction_id, $url);
        $transaction = $this->curl($url);

        //check valid wallet address
        $valid_wallet_address = false;
        $amount = 0;
        if(!empty($transaction['vout']))
        {
            foreach($transaction['vout'] as $vout)
            {
                foreach($vout['scriptPubKey']['addresses'] as $address)
                {
                    if($wallet_address == $address)
                    {
                        $valid_wallet_address = true;
                        $amount = $vout['value'];
                        $amount = round($amount, 2);
                    }
                }
            }
        }
        if(!empty($transaction['err']))
        {
            $result = array(
                'success' => 0,
                'message' => $transaction['err']['message'],
                'name' => $transaction['err']['name'],
                'code' => $transaction['err']['code'],
            );
        }
        else if(!empty($transaction['error']))
        {
            $result = array(
                'success' => 0,
                'message' => $transaction['message']
            );
        }
        else if(!empty($transaction['vout']))
        {
            if(!$valid_wallet_address)
            {
                $result = array(
                    'success' => 0,
                    'message' => __('Incorrect wallet address. You need to pay for this wallet address '.$wallet_address, 'fantasy-sports')
                );
            }
            else if($transaction['confirmations'] == 0)
            {
                $result = array(
                    'success' => 0,
                    'message' => __('This transaction is not confirmed yet.', 'fantasy-sports')
                );
            }
            else if($amount > 0)
            {
                $result = array(
                    'success' => 1,
                    'amount' => $amount,
                    'txid' => $transaction_id
                );
            }
            else
            {
                $result = array(
                    'success' => 0,
                    'message' => __('No amount data', 'fantasy-sports')
                );
            }
        }
        else
        {
            $result = array(
                'success' => 0,
                'message' => __('No data', 'fantasy-sports')
            );
        }
        return $result;
    }
}

?>