<?php 

class FttechWare{

    private $_url_create                = null;

    private $_url_login                 = null;

    private $_url_user_include_card     = null;

    private $_url_app_include_charge    = null;

    private $_url_user_request_charge   = null;

    private $_url_user_apply_charge     = null;

    private $_url_app_verify_user_default_card  = null;

    private $_url_user_update_card      = null;

    private $_url_user_delete_card      = null;

    private $_url_app_delete_charge     = null;



    public function __construct(){

        $url = ( get_option('fanvictor_fftech_test') == 1 ) ? 'https://www.fttserver.com:2143/' : 'https://www.fttserver.com:2165/'; 

        $this->write_log('url: '.$url.'\n');

        $this->_url_create              = $url.'api/createUser';

        $this->_url_login               = $url.'api/logOnUser';

        $this->_url_user_include_card   = $url.'api/UserIncludeCard';

        $this->_url_app_include_charge  = $url.'api/AppIncludeCharge';

        $this->_url_user_request_charge = $url.'api/UserRequestCharges';

        $this->_url_user_apply_charge   = $url.'api/UserApplyCharge';

        $this->_url_app_verify_user_default_card = $url.'api/AppVerifyUserDefaultCard';

        $this->_url_user_update_card    = $url.'api/UserUpdateCard';

        $this->_url_user_delete_card    = $url.'api/UserDeleteCard';

        $this->_url_app_delete_charge   = $url.'api/AppDeleteCharge';

    }



    public function curl_fftech($url, $data){

        $data = http_build_query($data);



        $this->url  = $url;

        $ch = curl_init($this->url);

        $this->ch   = $ch;



        curl_setopt($this->ch, CURLOPT_POSTFIELDS, $data);

        curl_setopt($this->ch, CURLOPT_POST, true);

        curl_setopt($this->ch, CURLOPT_RETURNTRANSFER, TRUE);

        $result = curl_exec($this->ch);



        return json_decode($result, true);

    }



    public function random_pass( $length = 12, $special_chars = true, $extra_special_chars = false ){

        $chars = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';

        if ( $special_chars )

            $chars .= '!@#$%^&*()';

        if ( $extra_special_chars )

            $chars .= '-_ []{}<>~`+=,.;:/?|';

     

        $password = '';

        for ( $i = 0; $i < $length; $i++ ) {

            $password .= substr($chars, rand(0, strlen($chars) - 1), 1);

        }

        return $password;

    }

    public function app_delete_charge($data){
        $result = $this->curl_fftech($this->_url_app_delete_charge, $data);
        return $result;
    }


    public function user_delete_card($data){ 
        $result = $this->curl_fftech($this->_url_user_delete_card, $data);
        return $result;
    }


    public function user_login($data){

        $result = $this->curl_fftech($this->_url_login, $data);

        return $result;

    }



    public function user_create($data){

        $result = $this->curl_fftech($this->_url_create, $data);

        return $result;

    }



    public function include_card($data){

        $result = $this->curl_fftech($this->_url_user_include_card, $data);

        return $result;

    }



    public function app_include_charge($data){

        $result = $this->curl_fftech($this->_url_app_include_charge, $data);

        return $result;

    }



    public function user_request_charge($data){

        $result = $this->curl_fftech($this->_url_user_request_charge, $data);

        return $result;

    }



    public function user_apply_charge($data){

        $result = $this->curl_fftech($this->_url_user_apply_charge, $data);

        return $result;

    }



    public function app_verify_user_default_card($data){

        $result = $this->curl_fftech($this->_url_app_verify_user_default_card, $data);

        return $result;

    }



    public function user_update_card($data){

        $result = $this->curl_fftech($this->_url_user_update_card, $data);

        return $result;

    }



    public function charge($sender = array(), $receiver = array(), $options = array()){

            $data_login = array(

                'applicationName'   => $receiver['applicationName'],

                'userName'          => $sender['userName'],

                'userPassword'      => $sender['userPassword']

            );

            $response_login = $this->user_login($data_login);

            if($response_login['isApproved']){

                //update new card

                if($sender['cardTokenId'] != ''){

                    $data_card_update = array(

                        'applicationName'   => $receiver['applicationName'],

                        'userName'          => $sender['userName'],

                        'userPassword'      => $sender['userPassword'],

                        'cardTokenId'       => $sender['cardTokenId'],

                        'cardDescription'   => $sender['cardDescription'],

                        'primaryAccountNumber' => $sender['primaryAccountNumber'],

                        'expirationMonth'   => $sender['expirationMonth'],

                        'expirationYear'    => $sender['expirationYear'],

                        'verificationValue' => $sender['verificationValue']

                    );

                    $response_user_update_card = $this->user_update_card($data_card_update);

                    if(!$response_user_update_card['isApprove']){

                        return array('notice' => $response_user_update_card['apiStatus']);

                    }

                }



                //include card

                $data_card = array(

                    'applicationName'   => $receiver['applicationName'],

                    'userName'          => $sender['userName'],

                    'userPassword'      => $sender['userPassword'],

                    'cardDescription'   => $sender['cardDescription'],

                    'primaryAccountNumber' => $sender['primaryAccountNumber'],

                    'expirationMonth'   => $sender['expirationMonth'],

                    'expirationYear'    => $sender['expirationYear'],

                    'verificationValue' => $sender['verificationValue']

                );

                

                $response_inlucde_card = $this->include_card($data_card);

                if( $response_inlucde_card['isApproved'] || strpos($response_inlucde_card['apiStatus'], 'Already Exist') !== false ){

                    //after include card success

                    //update card token user_extended

                    if($response_inlucde_card['cardTokenId'] != ''){

                        global $wpdb;

                        $table_user_extended = $wpdb->prefix.'user_extended';

                        $data_user_ext = array(

                            'fftech_cardtoken' => $response_inlucde_card['cardTokenId']

                        );

                        $wpdb->update($table_user_extended, $data_user_ext, array('user_id' => $sender['ID']));

                    }

                    

                    //app include charge

                    $data_app_include_charge = array(

                        'applicationName'       => $receiver['applicationName'],

                        'applicationPassword'   => $receiver['applicationPassword'],

                        'chargeDescription'     => $sender['cardDescription'],

                        'userName'              => $sender['userName'],

                        'transactionCurrency'   => 'CRC', 

                        'transactionAmount'     => $sender['credits']

                    );

                    $response_app_include_charge = $this->app_include_charge($data_app_include_charge);


                    if($response_app_include_charge['isApproved']){

                        //user request charge

                        

                        $data_user_request_charge = array(

                            'applicationName'   => $receiver['applicationName'],

                            'userName'          => $sender['userName'],

                            'userPassword'      => $sender['userPassword']

                        );



                        $response_user_request_charge = $this->user_request_charge($data_user_request_charge);



                        if($response_user_request_charge['isAvailableCharge']){

                            //app apply charge

                            $data_user_apply_charge = array(

                                'applicationName'       => $receiver['applicationName'],

                                'userName'              => $sender['userName'],

                                'userPassword'          => $sender['userPassword'],

                                'chargeTokenId'         => trim($response_app_include_charge['chargeTokenId']),

                                'cardTokenId'           => (($response_inlucde_card['cardTokenId'] != '') ? $response_inlucde_card['cardTokenId'] : trim($sender['fftech_cardtoken']))

                            );



                            $response_app_apply_charge = $this->user_apply_charge($data_user_apply_charge);



                            if($response_app_apply_charge['isApproved']){

                                return array('success' => 1, 'transactionID' => $response_app_apply_charge['authorizationId']);

                            }else{

                                 return array('notice' => $response_app_apply_charge['apiStatus']);

                            }

                        }else{

                            return array('notice' => $response_user_request_charge['apiStatus']);

                        }

                    }else{

                        return array('notice' => $response_app_include_charge['apiStatus']);

                    }

                }else{

                    return array('notice' => $response_inlucde_card['apiStatus']);

                }

            }else{

                return array('notice' => $response_login['apiStatus']);

            }

    }

    public function write_log($log = null)  
    {
        $file = FANVICTOR__PLUGIN_DIR_MODEL."fttechware_log.txt";
        if($log != null)
        {
            $content = '';
            if(file_exists($file))
            {
                $content = file_get_contents($file)."\n";
            }
            $myfile = fopen(FANVICTOR__PLUGIN_DIR_MODEL."fttechware_log.txt", "w");
            fwrite($myfile, $content.$log);
            fclose($myfile);
        }
    }

}



?>