<?php
require_once("admin/RestClient.php");
class Model
{
    public $api_debug = false;
    public function __construct() 
    {
        $this->selectField = null;
    }
    
    private function getRestClient($method, $url)
    {
        $ret = false;
        $ret = new RestClient($method, $url);
        return $ret;
    }
    
    public function selectField($params = array())
    {
        $this->selectField = $params;
    }
    
    public function sendRequest($task, $params = array(), $is_admin = true, $json = true)
    {
        $user_id = 0;
        if(!empty($_COOKIE['fanvictor_user_id']))
        {
            $user_id = $_COOKIE['fanvictor_user_id'];
        }
        $api_token = get_option('fanvictor_api_token');
        $params['v2'] = true;
        //parse url
        if($is_admin)
        {
            $url = get_option('fanvictor_api_url_admin')."/$task/".$api_token;
        }
        else 
        {
            $url = get_option('fanvictor_api_url')."/$task/".$api_token.'/'.$user_id;
        }
        
        if(isset($this->selectField) && $this->selectField != null)
        {
            $params['field'] = $this->selectField;
        }
        //send request
        $client = $this->getRestClient('POST', $url);
        $data = $client->send($params);
        $this->selectField = null;
        if($json && !$this->api_debug)
        {
            $data = json_decode($data, true);
        }
        if (isset($data['code']) && isset($data['message'])) {
            $data = null;
        }
        return $data;
    }
    
    protected function send($task, $params = array())
    {
        $result = $this->sendRequest($task, $params, false);
        if($this->api_debug)
        {
            echo $result;exit;
        }
        return $result;
    }
    
    public static function parseImageSuffix($image = null, $suf = null)
    {
        $suffix = '_80';
        if($suf != null)
        {
            $suffix = $suf;
        }
        if($image != null)
        {
            $img = explode('.', $image);
            $img[count($img) - 2] = $img[count($img) - 2].$suffix.".".$img[count($img) - 1];
			unset($img[count($img) - 1]);
			array_values($img);
            $img = implode('.', $img);
            return $img;
        }
        return null;
    }
    
    public static function replaceSuffix($image = null, $suf = 'suf')
    {
        $suffix = '_80';
        if($suf != 'suf')
        {
            $suffix = $suf;
        }
        if($image != null)
        {
            $image = sprintf($image, $suffix);
        }
        return $image;
    }
    
    public function deleteImage($sFileName = null)
    {
        if (!empty($sFileName))
        {
            $originalImagePath = FANVICTOR_IMAGE_DIR.$this->replaceSuffix($sFileName, '');
            $thumbImagePath = FANVICTOR_IMAGE_DIR.$this->replaceSuffix($sFileName);

            if(file_exists($originalImagePath))
            {
                unlink($originalImagePath);
            }
            if(file_exists($thumbImagePath))
            {
                unlink($thumbImagePath);
            }
        }
        return true;
    }
    
    public function uploadImage($resize = true)
    {
        if (!function_exists('wp_handle_upload')) 
        {
            require_once( ABSPATH . 'wp-admin/includes/file.php' );
        }
        $uploadedfile = $_FILES['image'];
        $upload_overrides = array( 'test_form' => false );
        $movefile = wp_handle_upload( $uploadedfile, $upload_overrides );
        if($movefile) 
        {
            if($resize)
            {
                $image = str_replace(FANVICTOR_IMAGE_URL, '', $this->parseImageSuffix($movefile['url'], '%s'));

                //resize 
                $img = wp_get_image_editor($movefile['file']);
                if (!is_wp_error($img)) 
                {
                    $img->resize(80,80, true );
                    $img->save($this->parseImageSuffix($movefile['file'], '_80'));
                }
            }
            else 
            {
                $image = str_replace(FANVICTOR_IMAGE_URL, '', $movefile['url']);;
            }
        }
        return $image;
    }

    public function checkAPITokenAdmin() {
        $api_token = get_option('fanvictor_api_token');
        $params['v2'] = true;

        $url = get_option('fanvictor_api_url_admin')."/getSports/".$api_token;

        if(isset($this->selectField) && $this->selectField != null)
        {
            $params['field'] = $this->selectField;
        }
        //send request
        $client = $this->getRestClient('POST', $url);
        $data = $client->send($params);
        $this->selectField = null;
        //$data = json_decode($data, true);
        $result = true;
        if ($data == 'code_505') {
            $result = $data;
            $result = str_replace('code_', '', $result);
        }
        return $result;
    }
    
    public function formatOffsetTimeZone($tz){
        if($tz != ""){
            if(preg_match('/\\d/', $tz)  && preg_match('/UTC/', $tz)){
               $tz = str_replace('UTC', "", $tz);
                if(strpos($tz, '.')){
                    $new_value = explode(".", $tz);
                   $minutes = $new_value[1] < 10 ? $new_value[1] * 10 : $new_value[1];
                   $minutes = round(($minutes/100)*60);
                   $new_tz = $new_value[0].":".$minutes;
                  $tz = $new_tz;
                }
            }
        }
		return $tz;
    }
}
?>