<?php
class FV_MolPay
{
    function __construct()
    {
        $this->applicationCode = trim(get_option('fanvictor_molpay_application_code'));
        $this->currencyCode = "USD";
        $this->secretKey = trim(get_option('fanvictor_molpay_secret_key'));
        $this->molpaymode = get_option('fanvictor_molpay_test') ? "sandbox-" : "";
        $this->url = 'https://' . $this->molpaymode . 'api.mol.com/payout';
        $this->api_version = 'v1';
        $this->exchange_rate = 100; //100 gold = 1 USD
    }

    public function checkout($params)
    {
        if(!empty($params['molpay_application_code']))
        {
            $this->applicationCode = trim($params['molpay_application_code']);
        }
        if(!empty($params['molpay_secret_key']))
        {
            $this->secretKey = trim($params['molpay_secret_key']);
        }
        $amount = (int)$params['amount'] * $this->exchange_rate;
		$customerId = $params['customerId'];
        $referenceId = $params['referenceId'];
        $description = $params['description'];
        $returnUrl = $params['returnUrl'];
        $channelId = 1;
        $signature = md5($amount . $this->applicationCode .$channelId. $this->currencyCode . $customerId . $description . $referenceId . $returnUrl . $this->api_version . $this->secretKey);

        // Store request params in an array
        $request_params = array
        (
            'applicationCode' => $this->applicationCode,
            'referenceId' => $referenceId,
            'version' => $this->api_version,
            'amount' => $amount,
            'currencyCode' => $this->currencyCode,
            'returnUrl' => $returnUrl,
            'customerId' => $params['customerId'],
            'description' => $description,
            'signature' => $signature,
            'channelId' => $channelId
        );
        // Loop through $request_params array to generate the NVP string.
        $nvp_string = '';
        foreach ($request_params as $var => $val)
        {
            $nvp_string .= '&' . $var . '=' . urlencode($val);
        }

		$this->write_log("Start new transaction");
		$this->write_log($request_params);
		
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_VERBOSE, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($curl, CURLOPT_TIMEOUT, 30);
        curl_setopt($curl, CURLOPT_URL, $this->url . "/payments");
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $nvp_string);
        curl_setopt($curl, CURLOPT_SSLVERSION, 6);
        $result = curl_exec($curl);
        curl_close($curl);
        $response = json_decode($result, true);
		
		if(!empty($response['message']))
		{
			return array(
				'success' => false,
				'message' => $response['message']
			);
		}
		return array(
			'success' => true,
			'params' => $response
		);
        return $nvp_response_array['paymentUrl'];
    }

    public function write_log($log = null)
    {
        $file = FANVICTOR__PLUGIN_DIR_LOG . "molpay_log.txt";
        if ($log != null)
        {
            $content = '';
            if (file_exists($file))
            {
                $content = file_get_contents($file) . "\n";
            }
            $myfile = fopen(FANVICTOR__PLUGIN_DIR_LOG . "molpay_log.txt", "w");
            fwrite($myfile, $content . date("M d Y H:i:s") . " " . print_r($log, true));
            fclose($myfile);
        }
    }

}
