<?php
include_once("paypal.php");

use \HngX\Moneywave\Moneywave;
use \HngX\Moneywave\Transactions;
require_once(FANVICTOR__PLUGIN_DIR_LIB.'moneywave/vendor/autoload.php');
class Payment
{
    function validEmail($email)
    {
        $regex = '/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$/'; 
        if (preg_match($regex, $email)) {
            return true;
        } else { 
            return false;
        } 
    }
    
    function isGatewayExist($data)
    {
        $gatewayList = $this->gatewayList();
        if(array_key_exists($data, $gatewayList))
        {
            return true;
        }
        return false;
    }
    
    function gatewayList($withdrawl = false)
    {
        $gateways = array(
            FANVICTOR_GATEWAY_PAYPAL => __('Paypal Gateway', 'fantasy-sports'),
            FANVICTOR_GATEWAY_PRIORITY => __('Priority Gateway', 'fantasy-sports'),
            FANVICTOR_GATEWAY_MONEYWAVE => __('Moneywave Gateway', 'fantasy-sports'),
            FANVICTOR_GATEWAY_FLUTTERWAVE => __('Flutterwave Gateway', 'fantasy-sports'),
            FANVICTOR_GATEWAY_FTTECH => __('FT Tech Gateway', 'fantasy-sports'),
            FANVICTOR_GATEWAY_BILLMAP => __('BillMap Gateway', 'fantasy-sports'),
            FANVICTOR_GATEWAY_BITCOIN => __('Bitcoin Gateway', 'fantasy-sports'),
            FANVICTOR_GATEWAY_CHEESE => __('Cheesecoin Gateway', 'fantasy-sports'),
            FANVICTOR_GATEWAY_MOLPAY => __('Molpay Gateway', 'fantasy-sports')
        );
        $allow_gateway = array();
        if(!$withdrawl)
        {
            $allow_gateway = get_option('fanvictor_payout_gateway');
            if($allow_gateway == null)
            {
                return array();
            }
        }
        else
        {
            $allow_gateway = get_option('fanvictor_payout_method');
            if($allow_gateway == null)
            {
                return array();
            }
        }
        foreach($gateways as $k => $gateway)
        {
            if(!in_array($k, $allow_gateway))   
            {
                unset($gateways[$k]);
            }
        }
        return $gateways;
    }
    
    function viewGateway()
    {
        $gateway = array();
        if(get_option('paypal_email_account') != null)
        {
            $gateway[] = PAYPAL;
        }
        return $gateway;
    }
    
    function feePercentage($value)
    {
        $fee = get_option('fanvictor_fee_percentage');
        if($fee > 0)
        {
            $value = $value + round(($value * $fee / 100), 2);
        }
        return $value;
    }
    
    // for widthrawal
    function changeCashToCredit($iCash)
    {
        $credit = get_option('fanvictor_credit_to_cash');
        if($credit > 1){
            $iCash = round($iCash/$credit,2);
        }
        return $iCash;
    }
    
    // for deposit
    function changeCreditToCash($iCredit)
    {
        $money = 1;
        $credit = get_option('fanvictor_cash_to_credit');
        
        return $iCredit * $credit;
    }
    
    function onlineTransaction($gateway = PAYPAL, $aSettings, $fundshistoryID = null,$real_balance=0)
    {
        global $wpdb;
        switch($gateway)
        {
            case FANVICTOR_GATEWAY_PAYPAL:
                $paypal = new Paypal();
                return $paypal->parseData($aSettings);
                break;
            case FANVICTOR_GATEWAY_PAYPAL_PRO:
                return $this->gatewayPaypalpro($aSettings, $fundshistoryID, $real_balance);
                break;
            case FANVICTOR_GATEWAY_PRIORITY:
                return $this->gatewayPriority($aSettings, $fundshistoryID, $real_balance);
                break;
            case FANVICTOR_GATEWAY_MONEYWAVE:
                return $this->gatewayMoneywave($aSettings, $fundshistoryID, $real_balance);
                break;
            case FANVICTOR_GATEWAY_FLUTTERWAVE:
                return $this->gatewayFlutterwave($aSettings, $fundshistoryID, $real_balance);
                break;
            case FANVICTOR_GATEWAY_FTTECH:
                return $this->gatewayFttechgwave($aSettings, $fundshistoryID, $real_balance);
                break;
            case FANVICTOR_GATEWAY_BILLMAP:
                return $this->gatewayBillMap($aSettings, $fundshistoryID, $real_balance);
                break;
            case FANVICTOR_GATEWAY_DFSCOIN:
                return $this->gatewayDfscoin($aSettings);
                break;
            case FANVICTOR_GATEWAY_FOOTYCASHCOIN:
                return $this->gatewayFootycashcoin($aSettings);
                break;
            case FANVICTOR_GATEWAY_BITCOIN:
                return $this->gatewayBitcoin($aSettings);
                break;
            case FANVICTOR_GATEWAY_CHEESE:
                return $this->gatewayCheese($aSettings);
                break;
            default :
                return false;
        }
        return false;
    }
    
    private function gatewayPaypalpro($aSettings, $fundshistoryID = null, $real_balance = 0)
    {
        $paypal = new PaypalPro();
        $result = $paypal->checkout($aSettings);
        if($result['success'] == 1)
        {
            $this->updateUserBalance(/*$aSettings['AMT']*/$real_balance, false, 0, $_COOKIE['fanvictor_user_id']);
            $this->updateFundhistory($fundshistoryID, array(
                'transactionID' => $result['transactionID'], 
                'is_checkout' => 0), $_COOKIE['fanvictor_user_id'], "completed");
            return true;
        }
        else if($result['success'] == 0 && !empty($result['message']))
        {
            return $result['message'];
        }
    }
    
    private function gatewayPriority($aSettings, $fundshistoryID = null, $real_balance = 0)
    {
        require_once("priority.php");  
        $username = get_option('fanvictor_priority_username');  
        $password = get_option('fanvictor_priority_password');
        $gw = new gwapii();
        $gw->setLogin($username, $password);
        $gw->setBilling(
                $aSettings['first_name'],
                $aSettings['last_name'],
                $aSettings['address1'],
                $aSettings['city'],
                $aSettings['state'], 
                $aSettings['country'],
                $aSettings['email']);
        $gw->doSale($aSettings['credits'],$aSettings['ccnumber'],$aSettings['ccexp'],$aSettings['cvv']);
        $result = $gw->responses;
        if($result['response_code'] == 100){
            $this->updateUserBalance(/*$aSettings['credits']*/$real_balance, false, 0, $_COOKIE['fanvictor_user_id']);
            $this->updateFundhistory($fundshistoryID, array(
                'transactionID' => $result['transactionid'], 
                'is_checkout' => 1), $_COOKIE['fanvictor_user_id'], "completed");
            return array('success'=>1);
        }else{
            $this->updateFundhistory($fundshistoryID, array('transactionID' => $pm->responses['transactionid'], 'is_checkout' => 0), $_COOKIE['fanvictor_user_id'], "failed");
            return array('success'=>0,'msg'=> $result['responsetext']);
        }
    }
    
    private function gatewayMoneywave($data, $fundshistoryID = null, $real_balance = 0)
    {
        $moneywave = new Moneywave(get_option('fanvictor_moneywave_api_key'), get_option('fanvictor_moneywave_secret'));
        $tran = new \HngX\Moneywave\Transactions\CardToWalletTransaction($moneywave);
        $tran->setDetails(array(
            "firstname" => !empty($data['firstname']) ? $data['firstname'] : '',
            "lastname" => !empty($data['lastname']) ? $data['lastname'] : '',
            "phonenumber" => !empty($data['phonenumber']) ? $data['phonenumber'] : '',
            "email" => !empty($data['email']) ? $data['email'] : '',
            "recipient" => "wallet",
            "card_no" => !empty($data['card_no']) ? $data['card_no'] : '',
            "cvv" => !empty($data['cvv']) ? $data['cvv'] : '',
            "pin" => !empty($data['pin']) ? $data['pin'] : '',
            "expiry_year" =>!empty($data['expiry_year']) ? $data['expiry_year'] : '',
            "expiry_month" => !empty($data['expiry_month']) ? $data['expiry_month'] : '',
            "amount" => !empty($data['amount']) ? $data['amount'] : '',
            "fee" => !empty($data['fee']) ? $data['fee'] : '',
            "redirecturl" => !empty($data['redirecturl']) ? $data['redirecturl'] : '',
            "medium" => "web",
        ))->dispatch();
        $response = $tran->getResponse();
        
        if($response != null)
        {
            if($response['status'] == "success")
            {
                $this->updateUserBalance($real_balance, false, 0, $_COOKIE['fanvictor_user_id']);
                $this->updateFundhistory($fundshistoryID, array(
                'transactionID' => $response['data']['transfer']['id'], 
                'is_checkout' => 1), $_COOKIE['fanvictor_user_id'], "completed");
                return array('success' => 1);
            }
            else
            {
                $this->updateFundhistory($fundshistoryID, array('transactionID' => "", 'is_checkout' => 0), $_COOKIE['fanvictor_user_id'], "failed");
                return array(
                    'success' => 0,
                    'msg' => $response['message']
                );
            }
        }
        else
        {
            $this->updateFundhistory($fundshistoryID, array('transactionID' => "", 'is_checkout' => 0), $_COOKIE['fanvictor_user_id'], "failed");
            return array(
                'success' => 0,
                'msg'=> __('Failed!!','fantasy-sports')
            );
        }
    }
    
    private function gatewayFlutterwave($data, $fundshistoryID = null, $real_balance = 0)
    {
        require_once("flutterwave.php");
        $merchant_key = get_option('fanvictor_flutterwave_merchant_key');
        $api_key = get_option('fanvictor_flutterwave_api_key');
        $flw =new FlutterWave();
        $flw->setMerchantCredentials($merchant_key, $api_key);
        $flw->setCardForCharge($data['ccnumber'], $data['cvv'], $data['ccexp_month'], $data['ccexp_year']);
        $place_info = explode('_',$data['country_currency']);
        /*$country = $place_info[0];
        $currency = $place_info[1];*/
        $country = 'NG';
        $currency = 'NGN';
        //$authModel = 'NOAUTH'; //For Verve Cards
        $authModel = 'VBVSECURECODE'; //For Visa Card and Nigerian Mastercards
        $response = $flw->charge($data['credits'], $fundshistoryID, $currency, $country, $authModel, "Add fund for id $fundshistoryID", FANVICTOR_URL_SUCCESS_ADD_FUNDS);

        if($response)
        {
			if($response['data']['responsecode'] == "02")
            {
				$this->updateFundhistory($fundshistoryID, array(
                'transactionID' => $response['data']['transactionreference']), $_COOKIE['fanvictor_user_id'], "pending");
				return array('success'=>2,'msg'=> $response['data']['responsemessage'], 'url' => $response['data']['authurl']);
			}
            else if($response['data']['responsecode'] == "00")
            {
                $this->updateUserBalance(/*$aSettings['real_balance']*/$real_balance, false, 0, $_COOKIE['fanvictor_user_id']);
                $this->updateFundhistory($fundshistoryID, array(
                'transactionID' => $response['data']['transactionreference'], 
                'is_checkout' => 1), $_COOKIE['fanvictor_user_id'], "completed");
                return array('success'=>1);
            }
            else
            {
                $this->updateFundhistory($fundshistoryID, array('transactionID' => "", 'is_checkout' => 0), $_COOKIE['fanvictor_user_id'], "failed");
                return array('success'=>0,'msg'=> (isset($response['data']['responsemessage']) ? $response['data']['responsemessage'] : $response['data']));
            }
        }
        else
        {
            $this->updateFundhistory($fundshistoryID, array('transactionID' => "", 'is_checkout' => 0), $_COOKIE['fanvictor_user_id'], "failed");
            return array('success'=>0,'msg'=> __('Failed!!','fantasy-sports'));
        }
    }

    private function gatewayFttechgwave($data, $fundshistoryID = null, $real_balance = 0){
        require_once("fttechware.php");

        $objFttech = new FttechWare();

        $current_user = $this->getUserData();

        //check user exist in app (app verify user data)
        $data_app_verify_user_default_card = array(
            'applicationName'       => get_option('fanvictor_fttech_app_name'),
            'applicationPassword'   => get_option('fanvictor_fttech_app_password'),
            'userName'              => $current_user['user_name']
        );

        $response_app_verify_user_default_card = $objFttech->app_verify_user_default_card($data_app_verify_user_default_card);

        //check user exist in app
        $receiver = array(
            'applicationName'       => get_option('fanvictor_fttech_app_name'),
            'applicationPassword'   => get_option('fanvictor_fttech_app_password')
        );

        $sender = array(
            'ID'                => $current_user['ID'],
            'userName'          => $current_user['user_name'],
            'cardDescription'   => $current_user['user_name'],
            'primaryAccountNumber' => $data['card_number'],
            'expirationMonth'   => $data['expire_month'],
            'expirationYear'    => $data['expire_year'],
            'verificationValue' => $data['card_verification_value'],
            'credits'           => $data['credits'],
            'fftech_cardtoken'  => $current_user['fftech_cardtoken']
        );

        $options = array();

        if(!$response_app_verify_user_default_card['isApproved'] && $current_user['fftech_cardtoken'] == '' && $current_user['fttech_password'] == ''){
            //user exist
            $data_create = array(
                'applicationName'   => get_option('fanvictor_fttech_app_name'),
                'userName'          => $current_user['user_name'],
                'userFirstName'     => $data['first_name'],
                'userLastName'      => $data['last_name'],
                'userPassword'      => $objFttech->random_pass(20).'%',
                'userEmail'         => $current_user['user_email'],
                'userCallerId'      => $data['phone']
            );

            $response_create_user = $objFttech->user_create($data_create);
            if(!$response_create_user['isApproved']){
                exit(json_encode(array('notice' => $response_create_user['apiStatus'])));
            }else{
                global $wpdb;
                $table_user_extended = $wpdb->prefix.'user_extended';
                $data_user_ext = array(
                    'fttech_password' => $data_create['userPassword']
                );
                $wpdb->update($table_user_extended, $data_user_ext, array('user_id' => $current_user['ID']));
            }
            $options = array('task' => 'new_account');
            $sender['userPassword'] = $data_create['userPassword'];
        }else{
            $options                    = array('task' => 'exist_account');
            $sender['userPassword']     = $current_user['fttech_password'];
            $sender['fftech_cardtoken'] = ($response_app_verify_user_default_card['cardTokenId'] != '') ? $response_app_verify_user_default_card['cardTokenId'] : $sender['fftech_cardtoken'];
        }

        $result = $objFttech->charge($sender, $receiver, $options);
        
        if(isset($result['success']) && $result['success']){
            //update history & balance
            $this->updateUserBalance($real_balance, false, 0, $_COOKIE['fanvictor_user_id']);
            $this->updateFundhistory(
                $fundshistoryID, 
                array(
                    'transactionID' => $result['transactionID'],
                    'is_checkout' => 1
                ), 
                $_COOKIE['fanvictor_user_id'], 
                "completed"
            ); 
            return array('success' => 1);
        }else{
            exit(json_encode($result));
        }
    }

    private function gatewayBillMap($data, $fundshistoryID = null, $real_balance = 0){
        ini_set('max_execution_time', 3000000);
		ini_set('default_socket_timeout', 60000);
        require_once("billmap.php");

        $objBillMap = new BillMap();

        // $objBillMap->User           = $data['username'];
        // $objBillMap->Password       = $data['password'];

        $objBillMap->User           = get_option('fanvictor_billmap_username');
        $objBillMap->Password       = get_option('fanvictor_billmap_password');
        $objBillMap->ServiceCode    = get_option('fanvictor_billmap_service_code');
        $objBillMap->Reference      = get_option('fanvictor_billmap_reference');


        $objBillMap->SubscriberID   = $data['subscriber_id'];
        // $objBillMap->ServiceCode    = $data['service_code'];
        // $objBillMap->Reference      = $data['reference'];
        $objBillMap->Balance        = $data['credits'];
        $objBillMap->TextMessage    = '';
        $objBillMap->Token          = '';
        $objBillMap->ImmediateReply = true;
        $objBillMap->ImmediatePayment = true;

        try{
            $client = new SoapClient("https://billmap.mtn.ci/WebServices/BillPayment.asmx?op=ProcessOnlinePayment_V1.2&wsdl");
        } catch (Exception $ex) {
			exit(json_encode(array('notice' => $ex->getMessage()))); 
        }
        $result = $client->ProcessOnlinePayment_V2($objBillMap); 
        
        if(isset($result->{'ProcessOnlinePayment_V1.2Result'}->RESPONSECODE) && $result->{'ProcessOnlinePayment_V1.2Result'}->RESPONSECODE == '01'){
            //update history & balance
            $this->updateUserBalance($real_balance, false, 0, $_COOKIE['fanvictor_user_id']);
            $this->updateFundhistory(
                $fundshistoryID, 
                array(
                    'transactionID' => $result->{'ProcessOnlinePayment_V1.2Result'}->FUNDAMOTRANSACTIONID,
                    'is_checkout' => 1
                ), 
                $_COOKIE['fanvictor_user_id'], 
                "completed"
            ); 
            return array('success' => 1);
        }
        // elseif($result->{'ProcessOnlinePayment_V1.2Result'}->RESPONSECODE == '100'){
        //     exit(json_encode(array('notice' => __('Please click button add again', 'fantasy-sports'))));
        // }
        else{
            exit(json_encode(array('notice' => __($result->{'ProcessOnlinePayment_V1.2Result'}->RESPONSEMESSAGE, 'fantasy-sports'))));            
        }
    }
    
    public function moneyWaveGetBankList()
    {
        if(get_option('fanvictor_moneywave_api_key') == null || get_option('fanvictor_moneywave_secret') == null)
        {
            return array();
        }
        try{
            $moneywave = new Moneywave(get_option('fanvictor_moneywave_api_key'), get_option('fanvictor_moneywave_secret'));
            $tran = new \HngX\Moneywave\Resources\BankList($moneywave);
            $tran->dispatch();
            $response = $tran->getResponse();

            if(!empty($response['status']) && $response['status'] == 'success')
            {
                return $response['data'];
            }
        } 
        catch (Exception $ex) {
            return array();
        }
        return array();
    }
            
    function confirmPaypal()
    {
        //Paypal redirects back to this page using ReturnURL, We should receive TOKEN and Payer ID
        if(isset($_GET["token"]) && isset($_GET["PayerID"]))
        {
            //we will be using these two variables to execute the "DoExpressCheckoutPayment"
            //Note: we haven't received any payment yet.

            $token = $_GET["token"];
            $payer_id = $_GET["PayerID"];

            //get session variables
            $ItemName 			= $_SESSION['ItemName']; //Item Name
            $ItemPrice 			= $_SESSION['ItemPrice'] ; //Item Price
            $ItemNumber 		= $_SESSION['ItemNumber']; //Item Number
            $ItemDesc 			= $_SESSION['ItemDesc']; //Item Number
            $ItemQty 			= $_SESSION['ItemQty']; // Item Quantity
            $ItemTotalPrice 	= $_SESSION['ItemTotalPrice']; //(Item Price x Quantity = Total) Get total amount of product; 

            $padata = 	'&TOKEN='.urlencode($token).
                        '&PAYERID='.urlencode($payer_id).
                        '&PAYMENTREQUEST_0_PAYMENTACTION='.urlencode("SALE").

                        //set item info here, otherwise we won't see product details later	
                        '&L_PAYMENTREQUEST_0_NAME0='.urlencode($ItemName).
                        '&L_PAYMENTREQUEST_0_NUMBER0='.urlencode($ItemNumber).
                        '&L_PAYMENTREQUEST_0_DESC0='.urlencode($ItemDesc).
                        '&L_PAYMENTREQUEST_0_AMT0='.urlencode($ItemPrice).
                        '&L_PAYMENTREQUEST_0_QTY0='. urlencode($ItemQty).
                        '&PAYMENTREQUEST_0_ITEMAMT='.urlencode($ItemTotalPrice).
                        '&PAYMENTREQUEST_0_AMT='.urlencode($ItemTotalPrice).
                        '&PAYMENTREQUEST_0_CURRENCYCODE='.urlencode('USD');
            
            $paypal = new MyPayPal(Phpfox::getParam('fanvictor.fanvictor_paypal_username'),
                                   Phpfox::getParam('fanvictor.fanvictor_paypal_password'),
                                   Phpfox::getParam('fanvictor.fanvictor_paypal_signature'),
                                   Phpfox::getParam('fanvictor.paypal_test'));
            return $paypal->confirm($padata);
        }
        return false;
    }
    
    private function gatewayDfscoin($data)
    {
        require_once("dfscoin.php");
        $dfscoin = new Dfscoin();
        return $dfscoin->transactionDetail($data['transaction_id'], get_option('fanvictor_dfscoin_wallet_address'));
    }
    
    public function checkAppliedDfscoinTransaction($transaction_id)
    {
        global $wpdb;
        $table_fundhistory = $wpdb->prefix.'fundhistory';
        $sql = "SELECT * "
                . "FROM $table_fundhistory "
                . "WHERE transactionID = '$transaction_id' AND type = 'DEPOSIT' AND operation = 'ADD' AND gateway = '".FANVICTOR_GATEWAY_DFSCOIN."'";
        $data = $wpdb->get_var($sql);
        if($data > 0)
        {
            return true;
        }
        return false;
    }
    
    function exchangeRateDfscoin($value)
    {
        $credit = get_option('fanvictor_dfscoin_exchange_rate');
        if($credit == null)
        {
            $credit = 1;
        }
        return round($value * $credit, 3);
    }
    
    private function gatewayFootycashcoin($data)
    {
        require_once("footycashcoin.php");
        $footycashcoin = new Footycashcoin();
        return $footycashcoin->transactionDetail($data['transaction_id'], get_option('fanvictor_footycashcoin_address'));
    }
    
    public function checkAppliedFootycashcoinTransaction($transaction_id)
    {
        global $wpdb;
        $table_fundhistory = $wpdb->prefix.'fundhistory';
        $sql = "SELECT * "
                . "FROM $table_fundhistory "
                . "WHERE transactionID = '$transaction_id' AND type = 'DEPOSIT' AND operation = 'ADD' AND gateway = '".FANVICTOR_GATEWAY_FOOTYCASHCOIN."'";
        $data = $wpdb->get_var($sql);
        if($data > 0)
        {
            return true;
        }
        return false;
    }
    
    function exchangeRateFootycashcoin($value)
    {
        $credit = get_option('fanvictor_footycashcoin_exchange_rate');
        if($credit == null)
        {
            $credit = 1;
        }
        return round($value * $credit, 3);
    }
    
    private function gatewayBitcoin($data)
    {
        require_once("bitcoin.php");
        $bitcoin = new Bitcoin();
        return $bitcoin->transactionDetail($data['transaction_id'], get_option('fanvictor_bitcoin_wallet_address'));
    }
    
    public function checkAppliedBitcoinTransaction($transaction_id)
    {
        global $wpdb;
        $table_fundhistory = $wpdb->prefix.'fundhistory';
        $sql = "SELECT * "
                . "FROM $table_fundhistory "
                . "WHERE transactionID = '$transaction_id' AND type = 'DEPOSIT' AND operation = 'ADD' AND gateway = '".FANVICTOR_GATEWAY_BITCOIN."'";
        $data = $wpdb->get_var($sql);
        if($data > 0)
        {
            return true;
        }
        return false;
    }
    
    function exchangeRateBitcoin($value)
    {
        $credit = get_option('fanvictor_bitcoin_exchange_rate');
        if($credit == null)
        {
            $credit = 1;
        }
        return round($value * $credit, 3);
    }
    
    private function gatewayCheese($data)
    {
        require_once("cheese.php");
        $cheese = new Cheese();
        return $cheese->transactionDetail($data['transaction_id'], get_option('fanvictor_cheese_wallet_address'));
    }
    
    public function checkAppliedCheeseTransaction($transaction_id)
    {
        global $wpdb;
        $table_fundhistory = $wpdb->prefix.'fundhistory';
        $sql = "SELECT * "
                . "FROM $table_fundhistory "
                . "WHERE transactionID = '$transaction_id' AND type = 'DEPOSIT' AND operation = 'ADD' AND gateway = '".FANVICTOR_GATEWAY_CHEESE."'";
        $data = $wpdb->get_var($sql);
        if($data > 0)
        {
            return true;
        }
        return false;
    }
    
    function exchangeRateCheese($value)
    {
        $credit = get_option('fanvictor_cheese_exchange_rate');
        if($credit == null)
        {
            $credit = 1;
        }
        return round($value * $credit, 3);
    }
    
    ###########################
	#
	#       USER
	#
	###########################
    function getUserData($userID = null)
    {
        $user_id = (int)$_COOKIE['fanvictor_user_id'];
        if((int)$userID > 0)
        {
            $user_id = $userID;
        }
        
        global $wpdb;
        $table_user = $wpdb->prefix.'users';
        $table_user_extended = $wpdb->prefix.'user_extended';
        $sCond = "WHERE u.ID = ".$user_id;
        $sql = "SELECT u.*, u.display_name as full_name, u.user_email as email, u.user_login as user_name, IFNULL(ue.balance, 0.00) as balance, ue.* "
             . "FROM $table_user u "
             . "LEFT JOIN $table_user_extended ue ON ue.user_id = u.ID "
             . $sCond;
        $data = $wpdb->get_row($sql, ARRAY_A);
        return $data;
    }
    
    public function isUserExtendedExist($user_id)
    {
        global $wpdb;
        $table_name = $wpdb->prefix.'user_extended';
        $sCond = "WHERE user_id = ".(int)$user_id;
        $sql = "SELECT COUNT(*) "
             . "FROM $table_name "
             . $sCond;
        $data = $wpdb->get_var($sql);
        if($data == 1)
        {
            return true;
        }
        return false;
    }
    
    public function isUserExist($user_id)
    {
        global $wpdb;
        $table_name = $wpdb->prefix.'users';
        $sCond = "WHERE ID = ".(int)$user_id;
        $sql = "SELECT COUNT(*) "
             . "FROM $table_name "
             . $sCond;
        $data = $wpdb->get_var($sql);
        if($data == 1)
        {
            return true;
        }
        return false;
    }
    
    public function getUserByLoginName($user_login)
    {
        if(empty($user_login))
        {
            return null;
        }
        global $wpdb;
        $table_name = $wpdb->prefix.'users';
        $sCond = "WHERE user_login = '$user_login'";
        $sql = "SELECT * "
             . "FROM $table_name "
             . $sCond;
        $data = $wpdb->get_row($sql);
        return json_decode(json_encode($data), true);
    }
    
    public function checkUserAlreadyJoinFeeContest($leagueID){
        global $wpdb;
        $sCons = "WHERE userID = ".$_COOKIE['fanvictor_user_id']." AND leagueID = ".(int)$leagueID;
        $table_name = $wpdb->prefix.'fundhistory';
        $sql = "SELECT count(*) "
             . "FROM $table_name "
             . $sCons;
        $data = $wpdb->get_var($sql);
        if($data > 0)
        {
            return true;
        }
        return false;
    }
    
    public function isUserEnoughMoneyToJoin($prize = 0, $leagueID = null, $entry_number = 1,$multi_entry=0)
    {
        $is_allow_check_bet = true;
        if($entry_number == 0 && $prize > 0){
            $is_user_join_contest = $this->checkUserAlreadyJoinFeeContest($leagueID);
            if($is_user_join_contest){
                $is_allow_check_bet = empty($multi_entry) ? true : false;
            }
            $entry_number = 1;
        }
        if($is_allow_check_bet == true && $this->isMakeBetForLeague($leagueID, $entry_number))
        {
            return true;
        }
        $user = $this->getUserData();
        if((int)$user['balance'] < $prize)
        {
            return false;
        }
        return true;
    }
    
    public function isUserEnoughMoneyToChangePlayer($prize = 0)
    {
        $user = $this->getUserData();
        if((int)$user['balance'] < $prize)
        {
            return false;
        }
        return true;
    }
    
    public function updateUserBalance($prize = 0, $decrease = false, $leagueID = 0, $user_id = null)
    {
        global $wpdb;
        
        $user = $this->getUserData($user_id);
        $deposit = $user['balance'] + $prize;
        if($decrease)
        {
            $deposit = $user['balance'] - $prize;
        }
        
        $values = array('user_id' => $user['ID'], 'balance' => $deposit);
        $table_name = $wpdb->prefix.'user_extended';
        if($this->isUserExtendedExist($user['ID']))
        {
            return $wpdb->update($table_name, $values, array('user_id' => $user['ID']));
        }
        else 
        {
            $result = $wpdb->insert($table_name, $values);
            if($result === false)
            {
                return false;
            }
            return true;
        }
    }
    
    public function isUserPaymentInfoExist($aVals)
    {
        global $wpdb;
        $sCond = "WHERE user_id = ".$_COOKIE['fanvictor_user_id'];
        $table_name = $wpdb->prefix."user_payment";
        $sql = "SELECT user_id "
             . "FROM $table_name "
             . $sCond;
        $aData = $wpdb->get_row($sql);

        if(count($aData) == 1)
        {
            return true;
        }
        return false;
    }

    function getUserPaymentBankCode($userId = null)
    {
        global $wpdb;

        if (is_null($userId))
        {
            $userId = intval($_COOKIE['fanvictor_user_id']);
        }

        $table = $wpdb->prefix."user_payment";
        $sql = "SELECT bankcode FROM $table where user_id = $userId limit 1";
        $row = $wpdb->get_row($sql);

        return is_null($row) ? null : intval($row->bankcode);
    }

    function getUserPaymentInfo($user_id = null)
    {
        global $wpdb;
        $sCond = "WHERE up.user_id = ".(int)$_COOKIE['fanvictor_user_id'];
        if((int)$user_id > 0)
        {
            $sCond = "WHERE up.user_id = ".(int)$user_id;
        }
        $table_userpayment = $wpdb->prefix."user_payment";
        $table_user = $wpdb->prefix."users";
        $table_userextended = $wpdb->prefix."user_extended";
        $sql = "SELECT up.*, u.display_name as full_name, IFNULL(ue.balance, 0.00) as balance "
             . "FROM $table_userpayment up "
             . "INNER JOIN $table_user u ON up.user_id = u.ID "
             . "LEFT JOIN $table_userextended ue ON ue.user_id = u.ID "
             . $sCond;
        $data = $wpdb->get_row($sql);
        $data = json_decode(json_encode($data), true);
        return $data;
    }
    
    public function addUserPaymentInfo($aVals)
    {
        global $wpdb;
        $aVals['user_id'] = $_COOKIE['fanvictor_user_id'];
        $aVals['time_stamp'] = current_time('timestamp');
        $aVals['time_update'] = current_time('timestamp');
        return $wpdb->insert($wpdb->prefix."user_payment", $aVals);
    }
    
    public function updateUserPaymentInfo($aVals)
    {
        global $wpdb;
        $aVals['time_update'] = current_time('timestamp');
        return $wpdb->update($wpdb->prefix."user_payment", $aVals, array('user_id' => $_COOKIE['fanvictor_user_id']));
    }
    
    ###########################
	#
	#       FUNDHISTORY
	#
	###########################
    public function isMakeBetForLeague($leagueID, $entry_number = 1)
    {
        global $wpdb;
        $sCons = "WHERE userID = ".$_COOKIE['fanvictor_user_id']." AND leagueID = ".(int)$leagueID." AND entry_number = ".$entry_number;
        $table_name = $wpdb->prefix.'fundhistory';
        $sql = "SELECT count(*) "
             . "FROM $table_name "
             . $sCons;
        $data = $wpdb->get_var($sql);
        if($data > 0)
        {
            return $data;
        }
        return false;
    }
    
    public function isPaypalCompleted($fundshistoryID)
    {
        global $wpdb;
        $sCons = "WHERE userID = ".$_COOKIE['fanvictor_user_id']." AND transactionID != '' AND fundshistoryID = ".(int)$fundshistoryID;
        $table_name = $wpdb->prefix.'fundhistory';
        $sql = "SELECT count(*) "
             . "FROM $table_name "
             . $sCons;
        $data = $wpdb->get_var($sql);
        if($data == 1)
        {
            return true;
        }
        return false;
    }
	
	function checkMoneyWonAdded($user_id, $amount, $operation, $type, $leagueID, $entry_number = 1)
    {
        global $wpdb;
        $sCons = "WHERE userID = $user_id AND amount = '".$amount."' AND operation = '".$operation."' AND type = '".$type."' AND leagueID = ".$leagueID." AND entry_number = $entry_number ";
        $table_name = $wpdb->prefix.'fundhistory';
        $sql = "SELECT count(*) "
             . "FROM $table_name "
             . $sCons;
        $data = $wpdb->get_var($sql);
        if($data == 1)
        {
            return true;
        }
        return false;
    }
    
    public function getFundhistory($aConds, $sSort = 'fundshistoryID DESC', $iPage = '', $iLimit = '')
	{	
        global $wpdb;
        $table_fundhistory = $wpdb->prefix."fundhistory";
        $aConds .= 'userID = '.(int)$_COOKIE['fanvictor_user_id'];
        $sCond = $aConds != null ? "WHERE ".$aConds : '';
        $sql = "SELECT COUNT(*) "
             . "FROM $table_fundhistory "
             . $sCond;
        $iCnt = $wpdb->get_var($sql);

        $sCond = $aConds != null ? "WHERE ".$aConds : '';
        $sql = "SELECT *, DATE_FORMAT(date, '%Y-%m-%d') as date "
             . "FROM $table_fundhistory "
             . $sCond." "
             . "ORDER BY $sSort "
             . "limit $iPage, $iLimit ";
        $aRows = $wpdb->get_results($sql);
        $aRows = json_decode(json_encode($aRows), true);
        
        return array($iCnt, $aRows);
	}
    
    public function getFundhistoryDetail($params)
	{
		global $wpdb;
        $table_fundhistory = $wpdb->prefix."fundhistory";
		
		if(empty($params))
		{
			return array();
		}
		$where = array();
		foreach($params as $k => $v)
		{
			if(is_string($v) && $v == '')
			{
				$where[] = $k;
			}
			else 
			{
				$where[] = $k."= '".$v."'";
			}
		}
		$where = "WHERE ".implode(' AND ', $where);
		
		$sql = "SELECT * "
             . "FROM $table_fundhistory "
             . $where;
		return $wpdb->get_row($sql, ARRAY_A);
	}

    public function getAllFundhistory($aConds = null, $sSort = 'fundshistoryID DESC', $iPage = '', $iLimit = '')
    {   
        global $wpdb;
        $table_fundhistory = $wpdb->prefix."fundhistory";
        // $aConds .= 'userID = '.(int)$_COOKIE['fanvictor_user_id'];

        $sCond = $aConds != null ? "WHERE ".$aConds : '';
        $sql = "SELECT site_profit, DATE_FORMAT(date, '%M') as month "
             . "FROM $table_fundhistory "
             . $sCond." ";
        $aRows = $wpdb->get_results($sql);

        $newArr = array();
        foreach ($aRows as $key => $value) {
            $newArr[$value->month] += $value->site_profit;
        }
        return $newArr;
    }
    
    public function parseFunhistoryData($aDatas = null)
    {
		// get list league
        $listLeagueID = array();
        foreach($aDatas as $item)
        {
            $listLeagueID[] = $item['leagueID'];

        }
        if($listLeagueID)
        {
            require_once'fanvictor.php';
            $fanvictor = new Fanvictor();
            $aListNameLeague = $fanvictor->getLeagueName($listLeagueID);
        }
		
        if($aDatas != null)
        {
            foreach($aDatas as $k => $aData)
            {
				$nameContest = '--';
                if(isset($aListNameLeague[$aData['leagueID']]))
				{
                    $nameContest = $aListNameLeague[$aData['leagueID']];
				}
                $aDatas[$k]['name_contest'] = $nameContest;
                if($aData['operation'] == 'ADD')
                {
                    $aDatas[$k]['operation_sign'] = "+";
                }
                else if($aData['operation'] == 'DEDUCT')
                {
                    $aDatas[$k]['operation_sign'] = "-";
                }
                if($aData['type'] == 'MAKE_BET')
                {
                    $aDatas[$k]['type'] = "ENTRY FEE";
                }
            }
        }
        return $aDatas;
    }
    
    public function addFundhistory($params)
    {
        global $wpdb;
        $prize = !empty($params['amount']) ? $params['amount'] : 0;
        if($prize > 0)
        {
            $userID = (int)$_COOKIE['fanvictor_user_id'];
            if(!empty($params['userID']))
            {
                $userID = $params['userID'];
            }
            
            //site profit
            if($params['type'] == 'MAKE_BET' && $params['operation'] == 'DEDUCT' && !empty($params['leagueID']) && $params['leagueID'] > 0)
            {
                $payout_percentage = get_option('fanvictor_winner_percent');
                $params['site_profit'] = $prize * (100 - $payout_percentage) / 100;
            }
            
            $values = array(
                'userID' => $userID, 
                'amount' => $prize,
                'operation' => $params['operation'],
                'type' => $params['type'],
                'new_balance' => !empty($params['new_balance']) ? $params['new_balance'] : 0,
                'gateway' => !empty($params['gateway']) ? $params['gateway'] : "",
                'reason' => !empty($params['reason']) ? $params['reason'] : "",
                'cash_to_credit' => !empty($params['cash_to_credit']) ? $params['cash_to_credit'] : "",
                'leagueID' => !empty($params['leagueID']) ? $params['leagueID'] : 0,
                'entry_number' => !empty($params['entry_number']) ? $params['entry_number'] : 1,
                'date' => date('Y-m-d H:i:s'),
                'site_profit' => !empty($params['site_profit']) ? $params['site_profit'] : 0,
                'status' => !empty($params['status']) ? $params['status'] : "initial",
                'transactionID' => !empty($params['transactionID']) ? $params['transactionID'] : "",
                'is_checkout' => !empty($params['is_checkout']) ? $params['is_checkout'] : 0,
                'withdrawlID' => !empty($params['withdrawlID']) ? $params['withdrawlID'] : ""
            );
            $table_name = $wpdb->prefix.'fundhistory';
            $wpdb->insert($table_name, $values);
            return $wpdb->insert_id;
        }
        return 0;
    }
    
    public function updateFundhistory($iId, $aValues, $user_id = null, $status = '')
    {
        global $wpdb;
        $iUserId = $_COOKIE['fanvictor_user_id'];
        if((int)$user_id > 0)
        {
            $iUserId = $user_id;
        }
        $user = $this->getUserData($iUserId);
        $aValues['new_balance'] = $user['balance'];
        $aValues['status'] = $status;
        return $wpdb->update($wpdb->prefix.'fundhistory', $aValues, array('fundshistoryID' => (int)$iId));
    }
    
    public function updateFundhistoryByWithdrawl($id, $params)
    {
        global $wpdb;
        if($params == null)
        {
            return false;
        }
        return $wpdb->update($wpdb->prefix.'fundhistory', $params, array('withdrawlID' => (int)$id));
    }
    
    public function deleteFundhistory($params)
    {
        global $wpdb;
        $where = array();
        if(!empty($params['id']))
        {
            $where['fundshistoryID'] = $params['id'];
        }
        if(!empty($params['league_id']))
        {
            $where['leagueID'] = $params['league_id'];
        }
        if(!empty($params['operation']))
        {
            $where['operation'] = $params['operation'];
        }
        if(!empty($params['type']))
        {
            $where['type'] = $params['type'];
        }
        if($where == null)
        {
            return;
        }
        return $wpdb->delete($wpdb->prefix.'fundhistory', $where);
    }
    
    public function getFundhistoryList($leagueID)
    {
        global $wpdb;
		$table_name = $wpdb->prefix.'fundhistory';
		$sql = "SELECT * "
             . "FROM $table_name "
             . "WHERE leagueID = ".$leagueID;
		$funds = $wpdb->get_results($sql);
        $data = array();
        if($funds != null)
        {
            $funds = json_decode(json_encode($funds), true);
            foreach($funds as $fund){
                $data[$fund['leagueID']."_".$fund['userID']."_".$fund['entry_number']."_".$fund['operation']."_".$fund['type']] = $fund;
            }
        }
        return $data;
	}
    
    ###########################
	#
	#       WITHDRAWLS
	#
	###########################
    public function isAllowWithdraw($amount = 0, $user_id = null)
    {
        $aUser = $this->getUserData($user_id);
        if($aUser['balance'] >= $amount)
        {
            return true;
        }
        return false;
    }
    
    public function getWithdraw($iId = null)
    {
        global $wpdb;
        $table_name = $wpdb->prefix.'withdrawls';
        $sCond = "WHERE userID = ".$_COOKIE['fanvictor_user_id'];
        if((int)$iId > 0)
        {
            $sCond = "WHERE withdrawlID = ".$iId;
        }
        $sql = "SELECT *, DATE_FORMAT(requestDate, '%Y-%m-%d') as requestDate, DATE_FORMAT(processedDate, '%Y-%m-%d') as processedDate "
             . "FROM $table_name "
             . $sCond." "
             . "ORDER BY withdrawlID DESC ";
        if((int)$iId > 0)
        {
            $data = $wpdb->get_row($sql);
        }
        else
        {
            $data = $wpdb->get_results($sql);
        }
        $data = json_decode(json_encode($data), true);
        return $data;
    }
    
    public function getListWithdraw($aConds, $sSort = 'withdrawlID DESC', $iPage = '', $iLimit = '')
	{	
        global $wpdb;
        $table_name = $wpdb->prefix."withdrawls";
        $aConds .= 'userID = '.(int)$_COOKIE['fanvictor_user_id'];
        $sCond = $aConds != null ? "WHERE ".$aConds : '';
        $sql = "SELECT COUNT(*) "
             . "FROM $table_name "
             . $sCond;
        $iCnt = $wpdb->get_var($sql);

        $sCond = $aConds != null ? "WHERE ".$aConds : '';
        $sql = "SELECT *, DATE_FORMAT(requestDate, '%Y-%m-%d') as requestDate, DATE_FORMAT(processedDate, '%Y-%m-%d') as processedDate "
             . "FROM $table_name "
             . $sCond." "
             . "ORDER BY $sSort "
             . "limit $iPage, $iLimit ";
        $aRows = $wpdb->get_results($sql);
        $aRows = json_decode(json_encode($aRows), true);
        
        return array($iCnt, $aRows);
	}
    
    public function addWithdraw($data = array())
    {
        global $wpdb;
        $userID = $_COOKIE['fanvictor_user_id'];
        if(!empty($data['userID']))
        {
            $userID = $data['userID'];
        }
        $amount = !empty($data['amount']) ? $data['amount'] : 0;
        $gateway = $data['gateway'];
        $values = array(
            'userID' => $userID, 
            'amount' => $amount,
            'real_amount' => $this->changeCashToCredit($amount),
            'credit_to_cash' => get_option('fanvictor_credit_to_cash'), 
            'new_balance' => !empty($data['new_balance']) ? $data['new_balance'] : 0,
            'reason' => !empty($data['reason']) ? $data['reason'] : "",
            'requestDate' => date('Y-m-d H:i:s'),
            'gateway' => $gateway
        );
        if($gateway == FANVICTOR_GATEWAY_FTTECH){
            $values['fftech_app_name']      = $fftech_app_name;
            $values['fftech_app_password']  = $fftech_app_password;
        }
        if($gateway == FANVICTOR_GATEWAY_DFSCOIN && !empty($data['dfscoin_wallet_address'])){
            $values['dfscoin_wallet_address'] = $data['dfscoin_wallet_address'];
        }
        if($gateway == FANVICTOR_GATEWAY_FOOTYCASHCOIN && !empty($data['footycashcoin_address'])){
            $values['footycashcoin_address'] = $data['footycashcoin_address'];
        }
        if($gateway == FANVICTOR_GATEWAY_BITCOIN && !empty($data['bitcoin_wallet_address'])){
            $values['bitcoin_wallet_address'] = $data['bitcoin_wallet_address'];
        }
        if($gateway == FANVICTOR_GATEWAY_CHEESE && !empty($data['cheese_wallet_address'])){
            $values['cheese_wallet_address'] = $data['cheese_wallet_address'];
        }
        if($gateway == FANVICTOR_GATEWAY_MOLPAY && !empty($data['molpay_application_code'])){
            $values['molpay_application_code'] = $data['molpay_application_code'];
            $values['molpay_secret_key'] = $data['molpay_secret_key'];
        }
        $wpdb->insert($wpdb->prefix.'withdrawls', $values);
        return $wpdb->insert_id;
    }
    
    public function updateWithdraw($iId, $aValues)
    {
        global $wpdb;
        return $wpdb->update($wpdb->prefix."withdrawls", $aValues, array('withdrawlID' => (int)$iId));
    }
    
    public function getPaymentInfoByUserID($user_id){
         global $wpdb;
        $sCond = "WHERE user_id = ".$user_id;
        $table_name = $wpdb->prefix."user_payment";
        $sql = "SELECT * "
             . "FROM $table_name "
             . $sCond;
        $aData = $wpdb->get_row($sql);

        if(count($aData) == 1)
        {
            return $aData;
        }
        return false;
    }
    
    public function moneywaveWithdrawl($data, $withdrawal_id)
    {
        $moneywave = new Moneywave(get_option('fanvictor_moneywave_api_key'), get_option('fanvictor_moneywave_secret'));
        $password = get_option('fanvictor_moneywave_wallet_password');
        $senderName = (!empty($data['firstname']) ? $data['firstname'] : '').' '.(!empty($data['lastname']) ? $data['lastname'] : '');
        $tran = new \HngX\Moneywave\Transactions\WalletToAccountTransaction($moneywave, $password);
        $tran->setDetails(array(
            "lock" => $password,
            "amount" => !empty($data['amount']) ? $data['amount'] : '',
            "bankcode" => !empty($data['sender_bank']) ? $data['sender_bank'] : '',
            "accountNumber" => !empty($data['sender_account_number']) ? $data['sender_account_number'] : '',
            "currency" => "NGN",
            "senderName" => !empty($data['sender_name']) ? $data['sender_name'] : '',
            "ref" => "moneywave".$withdrawal_id."_".rand(0, 1000)
        ))->dispatch();
        $response = $tran->getResponse();
        
        $fail_message = __('Failed!!','fantasy-sports');
        if($response != null)
        {
            if($response['status'] == "success")
            {
                return array(
                    'success' => 1,
                    'data' => array(
                        'transactionID' => $response['data']['data']['uniquereference']
                    )
                );
            }
            $fail_message = $response['message'];
        }
        return array(
            'success' => 0,
            'msg'=> $fail_message
        );
    }
}
?>