<div class="f-row">
    <div class="f-game-info-fixtures">
        <?php if($league['is_playerdraft'] && $league['only_playerdraft'] == 0 && ($contest_url != '')):?>
            <p>
                <?php echo __("Pick a team of players from the following games", "fantasy-sports");?>
                <a href="<?php echo $contest_url;?>"><?php echo __("here", "fantasy-sports");?></a>
            </p>
        <?php elseif($league['is_playerdraft'] && $league['only_playerdraft == 1'] && ($contest_url != '')):?>
            <p>
                <?php echo __("Pick players from", "fantasy-sports");?> 
                <a href="<?php echo $contest_url;?>"><?php echo __("here", "fantasy-sports");?></a>
            </p>
        <?php endif;?>
        <?php if($pool['yearly'] && isset($pool['total_week'])):?>
            <?php echo __("Week", "fantasy-sports");?>
            <select name="week" id="week_filter" onchange="jQuery.global.loadWeeklyFixture()">
                <?php for($i = 1; $i <= $pool['total_week']; $i++):?>
                    <option value="<?php echo $i;?>">
                        <?php echo $i;?>
                    </option>
                <?php endfor;?>
            </select>
        <?php endif;?>
        <ul class="f-game-info-fixture-list">
            <?php if($fights != null):?>
                <?php foreach($fights as $fight):?>
                    <li <?php if($pool['yearly']){ echo 'class="fixture_weekly fixture_week_'.$fight['week'].'" style="display:none"';}?>>
                        <b><?php echo __("H:", "fantasy-sports")." ".$fight['nickName1'];?> @ <?php echo __("A:", "fantasy-sports")." ".$fight['nickName2'];?></b> <?php echo FV_DateTranslate($fight['startDate']);?>
                    </li>
                <?php endforeach;?>
            <?php endif;?>
            <?php if($rounds != null):?>
                <?php foreach($rounds as $round):?>
                    <li><b><?php echo $round['name'];?></b> <?php echo FV_DateTranslate($round['startDate']);?></li>
                <?php endforeach;?>
            <?php endif;?>
        </ul>
    </div>
    <div class="f-game-info-start-time">
        <div class="f-stat">
            <?php echo __("Start", "fantasy-sports");?>
            <b><?php echo FV_DateTranslate($pool['startDate']);?></b>
        </div>
    </div>
</div>
<hr class="f-divider">
<div class="f-row">
    <div class="f-column-12 game-info-scoring">
        <h5 class="f-game-info-scoring-title"><?php echo __("Scoring Categories", "fantasy-sports");?></h5>
        <div class="f-game-info-scoring-categories">
            <?php if($scorings['normal'] != null):?>
                <?php foreach($scorings['normal'] as $scoring):?>
                    <div style="margin-left:20px;">
                        <?php echo $scoring;?>
                    </div>
                <?php endforeach;?>
            <?php endif;?>
            <div style="margin-left:20px;text-transform: capitalize;">
                <?php if($scorings['playerdraft'] != null && count($scorings['playerdraft']) > 0):?>
                    <?php foreach($scorings['playerdraft'] as $scoring):?>
                        <?php $scoring_name = (!empty($scoring['alias']) ? $scoring['alias'] : str_replace('_', ' ', $scoring['name']));
                            echo FV_ScoringTranslate($scoring_name).' = '.$scoring['points'];
                        ?><br/>
                    <?php endforeach;?>
                <?php elseif($scorings['playerdraft'] != null && $league['is_mixing']):?>
                    <?php foreach($scorings['playerdraft'] as $aPlayerDraftScoring):?>
                        <h5><?php echo $aPlayerDraftScoring;?></h5>
                        <?php foreach($aPlayerDraftScorings['name_sport'] as $aScoring):?>
                            <?php $scoring_name = (!empty($scoring['alias']) ? $scoring['alias'] : str_replace('_', ' ', $scoring['name']));
                                echo FV_ScoringTranslate($scoring_name).' = '.$scoring['points'];
                            ?><br/>
                        <?php endforeach;?>
                    <?php endforeach;?>
                <?php endif;?>
            </div>
        </div>
        <?php if($league['bonus'] != null):?>
            <h5 class="f-game-info-scoring-title">Bonus</h5>
            <div class="f-game-info-scoring-categories">
                <?php echo $league['bonus'];?>
            </div>
        <?php endif;?>
    </div>
</div>
