<?php if($scores != null):?>
    <div <?php if($standing_type == 2):?>class="table_overflow"<?php endif;?>>
        <table class="f-condensed">
            <thead>
                <tr>
                    <th style="width:8%;">&nbsp;</th>
                    <th><?php echo __('User', 'fantasy-sports') ?></th>
                    <?php if ($league['multi_entry'] == 1): ?>
                        <th style="width:20%;"><?php echo __('Entry', 'fantasy-sports') ?></th>
                    <?php endif; ?>
                    <?php if($standing_type == 1):?>
                        <?php if (get_option('fanvictor_no_cash') == 0): ?>
                            <th class="f-text-align-right" style="width:15%;"><?php echo __('Prizes', 'fantasy-sports') ?></th>
                        <?php endif; ?>
                    <?php endif;?>
                    <?php if($standing_type == 2 && $fights != null):?>
                        <?php foreach($fights as $fight):
                            $home_team = $fight['home_team'];
                            $away_team = $fight['away_team'];
                        ?>
                        <th class="f-text-align-right">
                            <?php echo $home_team['name']?>
                            <?php echo __('VS', 'fantasy-sports') ?>
                            <?php echo $away_team['name']?>
                        </th>
                        <?php endforeach;?>
                    <?php endif;?>
                </tr>
            </thead>
            <tbody>
                <?php foreach($scores as $score):?>
                    <tr id="user_result_item_<?php echo $score['id'];?>" class="<?php if($standing_type == 1):?>user_result_item<?php endif;?> <?php if($score['current']):?>f-user-highlight<?php endif;?>" data-user_id="<?php echo $score['userID'];?>" data-entry_number="<?php echo $score['entry_number'];?>">
                        <td style="text-align:center">
                            <?php echo $score['rank'] > 0 ? $score['rank'] : "-";?>
                        </td>
                        <td>
                            <div style="background-image: url('<?php echo $score['avatar'];?>')" class="f-avatar">
                            </div>
                            <a class="f-truncate">
                                <?php echo $score['username'];?>
                            </a>
                        </td>
                        <?php if($league['multi_entry']):?>
                            <td style="text-align:center">
                                <?php echo $score['entry_number'];?>
                            </td>
                        <?php endif;?>
                        <?php if($standing_type == 1):?>
                            <?php if($no_cash == 0):?>
                                <td class="f-num" style="text-align: center">
                                    <?php echo $score['amount'];?>
                                </td>
                            <?php endif;?>
                        <?php endif;?>
                        <?php if($standing_type == 2 && $fights != null):
                            $picks = $score['picks'];
                        ?>
                            <?php foreach($fights as $fight):
                                $home_team = $fight['home_team'];
                                $away_team = $fight['away_team'];
                                $pick = $picks[$fight['fightID']];
                            ?>
                            <td class="f-text-align-right <?php echo !$fight['started'] ? 'upcoming_matches_cell' : '';?>">
                                <?php if($pick['survivor_tie']):?>
                                    <?php echo __('Tie', 'fantasy-sports') ?>
                                <?php else:?>
                                    <span class="<?php echo $fight['winnerID'] > 0 && $fight['winnerID'] != $pick['winnerID'] ? 'survival_incorrect' : '';?>">
                                        <?php echo $pick['winnerID'] == $home_team['teamID'] ? $home_team['name'] : $away_team['name']; ?>
                                    </span>
                                <?php endif;?>
                            </td>
                            <?php endforeach;?>
                        <?php endif;?>
                    </tr>
                <?php endforeach;?>
            </tbody>
        </table>
    </div>
    <?php require_once(FANVICTOR__PLUGIN_DIR_VIEW_ELEMENT.'pagination.php');?>
<?php endif; ?>
