<?php $creator = get_user_by("id", $league['creator_userID']);?>
<h3 class="widget-title"><?php echo $league['name'];?></h3>
<div class="contestStructure">
    <div class="left">
        <div>
            <div class="label"><?php echo __('Prize structure', 'fantasy-sports');?>:</div>
            <?php echo $league['prize_structure'];?>
        </div>
        <div>
            <div class="label"><?php echo __('Sport', 'fantasy-sports');?>:</div>
            <?php echo $league['sport_name'];?>
        </div>
        <div>
            <div class="label"><?php echo __('Event', 'fantasy-sports');?>:</div>
            <?php echo $league['poolName'];?>
        </div>
        <div>
            <div class="label"><?php echo __('Game Type', 'fantasy-sports');?>:</div>
             <?php echo FV_ParseGameTypeName($league['gameType']);?>
            <?php if($league['multi_entry'] == 1):?>
                - <?php echo __('Multi entry', 'fantasy-sports');?>
            <?php endif;?>
        </div>
        <div>
            <div class="label"><?php echo __('Start', 'fantasy-sports');?>:</div>
            <?php echo FV_DateTranslate($league['startDate']);?>
        </div>
        <div>
            <div class="label"><?php echo __('Creator', 'fantasy-sports');?>:</div>
            <?php echo $creator->data->user_login;?>
        </div>
        <div>
            <div class="label"><?php echo __('Players', 'fantasy-sports');?>:</div>
            <?php echo $league['size'];?> player game, <?php echo $league['entries'];?> entries</td>
        </div>
        <?php if(strtolower($league['gameType']) == "picksquares" && !empty($payoutPickSquare)): ?>
            <div>
                <div class="label"><?php echo __('Payout', 'fantasy-sports');?>:</div>
                <div style="font-size: 17px;">
                <?php foreach($payoutPickSquare as $payouts): ?>
                    <?php echo $payouts['name'];?>&nbsp;&nbsp; <?php echo $payouts['price'];?><br>
                <?php endforeach; ?>
                  </div>
            </div>
        <?php endif; ?>
        <?php if(strtolower($league['gameType']) == "roundpickem" && empty($is_result)): ?>
            <div>
                <div class="label"><?php echo __('Current week', 'fantasy-sports'); ?>:</div>
                <?php echo $current_week; ?>
                <input type="hidden" value="<?php echo $current_week; ?>" name="current_week">
            </div>
            <div>
                <div class="label"><?php echo __('Select week', 'fantasy-sports'); ?>:</div>
                <select name="week" id="select_week">
                    <?php for($i = $current_week; $i <= $league['end_week']; $i++):?>
                        <option value="<?php echo $i;?>">
                            Week <?php echo $i;?>
                        </option>
                    <?php endfor;?>
                </select>
            </div>
        <?php endif; ?>
        <?php if(strtolower($league['gameType']) == "roundpickem" && !empty($is_result)): ?>
            <div>
                <div class="label"><?php echo __('Results of', 'fantasy-sports'); ?>:</div>
                <select id="result_week" style="max-width: 250px;">
                    <?php for($week = $league['start_week']; $week <= $league['end_week']; $week++): ?>
                        <option value="<?php echo $week; ?>" <?php echo $current_week == $week ? 'selected="selected"' : "";?>>
                            <?php echo sprintf(__('Week %s','fantasy-sports'), $week); ?>
                        </option>
                    <?php endfor; ?>
                    <option value="">
                        <?php echo __('All weeks','fantasy-sports'); ?>
                    </option>
                </select>
            </div>
        <?php endif; ?>
        <?php if(!empty($league['show_weekly_pick'])):?>
            <div>
                <div class="label"><?php echo __('Current week', 'fantasy-sports');?>:</div>
                <?php echo $aFights[0]['week'];?>
                <input type="hidden" value="<?php echo $aFights[0]['week'];?>" name="current_week">
            </div>
        <?php endif;?>
    </div>
    <div class="right">
        <div class="boxEntry">
            <span><?php echo __('Entry', 'fantasy-sports');?></span> <?php echo FV_FormatMoney($league['entry_fee']);?>
        </div>
        <div class="boxPrizes">
            <span><?php echo __('Prizes', 'fantasy-sports');?></span> <?php echo FV_FormatMoney($league['prizes']);?>
        </div>
    </div>
</div>

<?php if(!empty($otherLeagues) && get_option('fanvictor_show_import_pick') == 1):?>
    <p><?php echo __('Below is a list of games you have already entered for this event. Simply click on \'Import Picks\' to import your picks from that game.', 'fantasy-sports')?></p>
    <table width="100%" cellspacing="0" cellpadding="0" border="0" class="table table-striped table-bordered">
        <thead>
            <tr>
                <th><?php echo __('Contest ID', 'fantasy-sports')?></th>
                <th><?php echo __('Name', 'fantasy-sports')?></th>
                <th><?php echo __('Opponent', 'fantasy-sports')?></th>
                <th><?php echo __('Type', 'fantasy-sports')?></th>
                <th><?php echo __('Entry Fee', 'fantasy-sports')?></th>
                <th><?php echo __('Size', 'fantasy-sports')?></th>
                <th><?php echo __('Structure', 'fantasy-sports')?></th>
                <th colspan="2">&nbsp;</th>
            </tr>
        </thead>
        <tbody>
            <?php foreach($otherLeagues as $otherLeague):?>
            <tr>
                <td>
                    <div><?php echo $otherLeague['leagueID'];?></div>
                </td>
                <td>
                    <div><?php echo $otherLeague['name'];?></div>
                </td>
                <td>
                    <div><?php echo $otherLeague['opponent'];?></div>
                </td>
                <td>
                    <div><?php echo $otherLeague['gameType'];?></div>
                </td>
                <td>
                    <div><?php echo $otherLeague['entry_fee'];?></div>
                </td>
                <td>
                    <div><?php echo $otherLeague['size'];?></div>
                </td>
                <td>
                    <div><?php echo $otherLeague['prize_structure'];?></div>
                </td>
                <td colspan="2">
                    <div>
                        <input type="button" value="<?php echo __('Import Picks', 'fantasy-sports')?>" onclick="importPicks('<?php echo $otherLeague["winnerID"];?>', '<?php echo $otherLeague["methodID"];?>', '<?php echo $otherLeague["roundID"];?>', '<?php echo $otherLeague["minuteID"];?>', '<?php echo $otherLeague["winner_spreadID"];?>', '<?php echo $otherLeague["over_under_value"];?>')" class="btn btn-success">
                    </div>
                </td>
            </tr>
            <?php endforeach;?>
        </tbody>
    </table>
<?php endif;?>