<?php
    $user_sort_class = $rank_sort_class = '';
    switch ($sort_by)
    {
        case 'user':
            $user_sort_class = $sort_value;
            break;
        case 'rank':
            $rank_sort_class = $sort_value;
            break;
    }
    $current_user = '';
?>
<div id="listPlayers">
    <table class="table table-bordered table-responsive table-condensed">
        <tr>
            <th class="sort <?php echo $user_sort_class;?>" onclick="jQuery.ranking.doSort('<?php echo $entry_number;?>', '<?php echo $page;?>', 'user')">
                <?php echo __("User", "fantasy-sports");?>
            </th>
            <?php if ($league['multi_entry'] == 1):?>
                <th style="width:13%">Entry number</th>
            <?php endif;?>
            <th style="width:10%;" class="sort <?php echo $rank_sort_class;?>" onclick="jQuery.ranking.doSort(<?php echo $entry_number;?>, <?php echo $page;?>, \'rank\')">
                <?php echo __("Rank", "fantasy-sports");?>
            </th>
            <th style="width:10%"><?php echo __("Points", "fantasy-sports");?></th>
            <th style="width:10%"><?php echo __("Winners", "fantasy-sports");?></th>
            <?php if ($pool['allow_method'] == 1):?>
                <th><?php echo __("Methods", "fantasy-sports");?></th>
                <th><?php echo __("Rounds", "fantasy-sports");?></th>
                <th><?php echo __("Minutes", "fantasy-sports");?></th>
                <th><?php echo __("Bonuses", "fantasy-sports");?></th>
            <?php endif;?>
            <?php if ($league['gameType'] == 'PICKULTIMATE'):?>
                <th><?php echo __("Game Vs. Points", "fantasy-sports");?></th>
                <th><?php echo __("Total Score", "fantasy-sports");?></th>
            <?php endif;?>
            <?php if ($no_cash == 0):?>
                <th style="width:10%"><?php echo __("Winnings", "fantasy-sports");?></th>
            <?php endif;?>
        </tr>
        <?php if ($users != null):?>
            <?php for ($i = 0; $i < count($users); $i++):
                $user = $users[$i];
            ?>
                <tr>
                    <td>
                        <?php if (!$user['current']):?>
                            <?php if ($league['gameType'] == 'PICKSQUARES'):?>
                               <input type="radio" id="userinfo<?php echo $user['userID'] + $user['entry_number'];?>" name="user" onclick="jQuery.ranking.selectPickSquaresUser('<?php echo $user['userID'];?>', '<?php echo $user['entry_number'];?>');">
                            <?php else:?>
                                <input type="radio" id="userinfo<?php echo $user['userID'] + $user['entry_number'];?>" name="user" onclick="jQuery.ranking.selectUser('<?php echo $user['userID'];?>', '<?php echo $user['entry_number'];?>');">
                            <?php endif;?>
                        <?php endif;?>
                        <label for="userinfo<?php echo $user['userID'] + $user['entry_number'];?>"><?php echo $user['user_login'];?></label>
                        <?php if ($league['gameType'] == 'PICKTIE'):?>
                            <br/>
                            <?php echo __("Predict total point", "fantasy-sports");?>: <?php echo $user['predict_point'];?>
                        <?php endif;?>
                    </td>
                    <?php if ($league['multi_entry'] == 1):?>
                        <td><?php echo $user['entry_number'];?></td>
                    <?php endif;?>
                    <td><?php echo $user['rank'];?></td>
                    <td><?php echo $user['points'];?></td>
                    <td><?php echo $user['winners'];?></td>
                    <?php if ($pool['allow_method'] == 1):?>
                        <td><?php echo $user['methods'];?></td>
                        <td><?php echo $user['rounds'];?></td>
                        <td><?php echo $user['minutes'];?></td>
                        <td><?php echo $user['bonuses'];?></td>
                    <?php endif;?>
                    <?php if ($league['gameType'] == 'PICKULTIMATE'):?>
                        <td><?php echo $user['winner_spread'];?></td>
                        <td><?php echo $user['winner_over_under'];?></td>
                    <?php endif;?>
                    <?php if ($no_cash == 0):?>
                        <td><?php echo $user['winnings'];?></td>
                    <?php endif;?>
                </tr>
                <?php if ($user['current'] == 1){
                    $current_user = $user;
                }
                ?>
            <?php endfor;?>
        <?php endif;?>
    </table>
</div>
<br/>
<div class="results_caption">
    <?php echo __('Results for')?>:  
    <span class="competitor_name competitor_name_2">
        <?php echo __('Please select a user', 'fantasy-sports');?>
    </span>
</div>
<div id="listFixtures">
    <table class="table table-bordered table-responsive table-condensed">
        <tr>
            <th><?php echo __("Fixture", "fantasy-sports");?></th>
            <th style="width:25%" id="myResultHeader">
                <?php echo __("My Pick", "fantasy-sports");?> (<?php $current_user['user_login'];?>)
            </th>
            <th style="width:25%" id="yourResultHeader">
                <?php echo __("Competitor Pick", "fantasy-sports");?>
            </th>
            <th style="width:25%">
                <?php echo __("Actual Result", "fantasy-sports");?>
            </th>
        </tr>
        <?php if ($fights != null && $league['gameType'] != 'PICKSQUARES'):?>
            <?php foreach($fights as $fight):
                $styleTeam1Win = $styleTeam2Win = 'style="color:red"';
                if ($fight['winnerID'] == $fight['fighterID1'])
                {
                    $styleTeam1Win = 'style="color:green"';
                }
                if ($fight['winnerID'] == $fight['fighterID2'])
                {
                    $styleTeam2Win = 'style="color:green"';
                }
                if ($fight['winnerID'] == 0) {
                    $styleTeamTie = 'style="color:green"';
                }
                $team1_spread_points = $team2_spread_points = '';
                if ($league['gameType'] == "PICKSPREAD" || $league['gameType'] == "PICKULTIMATE")
                {
                    $team1_spread_points = ' '.$fight['team1_spread_points'];
                    $team2_spread_points = ' '.$fight['team2_spread_points'];
                } 
                else if ($league['gameType'] == "PICKMONEY")
                {
                    $team1_spread_points = ' '.$fight['team1_moneyline'];
                    $team2_spread_points = ' '.$fight['team2_moneyline'];
                }
            ?>
                <tr>
                    <td>
                        <?php echo $fight['name1'];?><br/>
                        <?php echo $team1_spread_points;?>
                        <div>VS</div>
                        <?php echo $fight['name2'];?><br/>
                        <?php echo $team2_spread_points;?>
                    </td>
                    <td id="myresult_<?php echo $fight['fightID'];?>"></td>
                    <td id="yourresult_<?php echo $fight['fightID'];?>"></td>
                    <td>
                        <div class="h_column actual_result">
                            <?php if ($league['is_complete']):?>
                                <div <?php echo $styleTeam1Win;?>>
                                    <?php echo $fight['name1'].' '.$fight['team1score'];?>
                                </div>
                                <div <?php echo $styleTeam2Win;?>>
                                    <?php echo $fight['name2'].' '.$fight['team2score'].'&nbsp;';?>
                                </div>
                                <?php if ($fight['winnerID'] == 0):?>
                                    <div <?php echo $styleTeamTie;?>>
                                        <?php echo $fight['name1'].' '.$fight['team1score'];?>
                                    </div>
                                    <div <?php echo $styleTeamTie;?>>
                                        <?php echo $fight['name2'].' '.$fight['team2score'].'&nbsp;';?>
                                    </div>
                                <?php endif;?>
                                <?php if ($fight['method'] != ''):?>
                                    <div><?php echo __("Method", "fantasy-sports");?>: <?php echo $fight['method'];?></div>
                                <?php endif;?>
                                <?php if ($fight['round'] != ''):?>
                                    <div><?php echo __("Round", "fantasy-sports");?>: <?php echo $fight['round'];?></div>
                                <?php endif;?>
                                <?php if ($fight['minute'] != ''):?>
                                    <div><?php echo __("Minute", "fantasy-sports");?>: <?php echo $fight['minute'];?></div>
                                <?php endif;?>
                            <?php endif;?>
                        </div>
                    </td>
                </tr>
            <?php endforeach;?>
            <?php if ($league['allow_new_tie_breaker'] == 1):?>
                <tr>
                    <td><?php echo __("Highest scoring team", "fantasy-sports");?></td>
                    <td id="myresult_<?php echo $highest_scoring_team;?>">
                    </td>
                    <td id="yourresult_<?php echo $highest_scoring_team;?>"></td>
                    <td>
                        <div style="color:green;" class="h_column actual_result_highest_scoring_team">
                        </div>
                    </td>
                </tr>
                <tr>
                    <td><?php echo __("Player to score", "fantasy-sports");?></td>
                    <td id="myresult_<?php echo $player_to_score;?>">
                    </td>
                    <td id="yourresult_<?php echo $player_to_score;?>"></td>
                    <td>
                        <div style="color:green;" class="h_column actual_result_player_to_score">
                        </div>
                    </td>
                </tr>
                <tr>
                    <td><?php echo __("Total Goals", "fantasy-sports");?></td>
                    <td id="myresult_<?php echo $total_goals;?>">
                    </td>
                    <td id="yourresult_<?php echo $total_goals;?>"></td>
                    <td>
                        <div style="color:green;" class="h_column actual_result_total_goals">
                        </div>
                    </td>
                </tr>
            <?php endif;?>
            <tr>
                <td>&nbsp;</td>
                <td>
                    <div id="myTotalPoints"></div>
                </td>
                <td>
                    <div id="YourTotalPoints"></div>
                </td>
                <td>&nbsp;</td>
            </tr>
        <?php elseif ($fights != null && $league['gameType'] == 'PICKSQUARES'):
            $fight = $fights[0];
            $picksquare = [];
            if ($users != null) {
                $user = $users[0];
                $picksquare = json_decode($user['picks']);
            }
        ?>
            <tr>
                <td>
                    <?php echo $fight['name1'];?><br/>
                    <div>VS</div>
                    <?php echo $fight['name2'];?><br/>
                </td>
                <td id="myresult_<?php echo $fight['fightID'];?>">
                    <?php echo implode(',', $picksquare);?>
                </td>
                <td id="yourresult_<?php echo $fight['fightID'];?>"></td>
                <td>
                    <div class="h_column actual_result">
                        <div>
                            <?php echo (abs($fight['team1score']) % 10);?>_<?php echo (abs($fight['team2score']) % 10);?>
                        </div>
                    </div>
                </td>
            </tr>
        <?php endif;?>
    </table>

    <div id="paging_ranking" class="pg-wrapper">
        <?php if ($num_page > 0):?>
            <?php for ($i = 1; $i <= $num_page; $i++):
                $class_active = '';
                if ($current_page == i)
                {
                    $class_active = 'active';
                }
            ?>
                <div class="dib <?php echo $class_active;?>" onclick="jQuery.ranking.enterLeagueHistory('<?php echo $entry_number;?>', '<?php echo $i;?>')">
                    <?php echo $i;?>
                </div>
            <?php endfor;?>
        <?php endif;?>
    </div>
</div>

<script type="text/template" id="dataResult">
    <?php echo json_encode($result);?>
</script>
<script type="text/template" id="dataCurrentUser">
    <?php echo json_encode($current_user);?>
</script>
<script type="text/javascript">
    jQuery.ranking.showUserResult(1);
</script>