<div>
    <div class="f-player-stats-lightbox">
        <div class="f-player-chunk">
            <div class="f-player-image" style="background-image: none;">
                <img alt="<?php echo $player['name']; ?>" src="<?php echo $player['full_image_path']; ?>" onerror="jQuery.playerdraft.setNoImage(jQuery(this))">
            </div>
            <div class="f-player-container">
                <div class="f-player-info">
                    <span class="f-player-pos"><?php echo $player['position_name'];?></span>
                    <h1 class="f-player-name"><?php echo $player['name']; ?></h1>
                    <?php if (!empty($player['team_name'])): ?>
                        <span class="f-player-team"><?php echo $player['team_name']; ?></span>
                    <?php endif; ?>
                    <?php if ($sport['is_team']): ?>
                        <div id="playerGame" class="f-player-team" style="margin-top: 5px;"></div>
                    <?php endif; ?>
                </div>
                <div class="f-player-stats f-brief">
                    <div class="f-stat">
                        <b><?php echo $played; ?></b> <?php echo __("Played", "fantasy-sports"); ?></div>
                    <div class="f-stat">
                        <b><?php echo FV_FormatMoney($player['salary'], "USD|$"); ?></b> <?php echo __("Salary", "fantasy-sports"); ?> </div>
                </div>
            </div>
            <div class="f-add-button" style="display: none" id="btnAdd">
                <input type="button" value="<?php echo __("Add Player", "fantasy-sports");?>" class="f-button f-primary f-mini f-plbARB" onclick="jQuery.playerdraft.addPlayer(<?php echo $player['id'];?>); jQuery.playerdraft.closeDialog('#dlgInfo');">
            </div>
            <div class="f-add-button" style="display: none" id="btnRemove">
                <input type="button" value="<?php echo __("Remove Player", "fantasy-sports");?>" class="f-button f-primary f-mini f-plbARB" onclick="jQuery.playerdraft.clearPlayer(<?php echo $player['id'];?>); jQuery.playerdraft.closeDialog('#dlgInfo');">
            </div>
            <ul class="f-tabs">
                <li>
                    <a data-tabname="tab1" href="#tab1"><?php echo __("Summary", "fantasy-sports"); ?></a>
                </li>
                <li>
                    <a data-tabname="tab2" href="#tab2"><?php echo __("Game Log", "fantasy-sports"); ?></a>
                </li>
                <li>
                    <a data-tabname="tab3" href="#tab3"><?php echo __("Player News", "fantasy-sports"); ?></a>
                </li>
            </ul>
        </div>
        <div class="f-player-stats-lb-tab tab1" id="tab1">
            <div class="f-player-stats f-season">
                <h1><?php echo __("Season Statistics", "fantasy-sports"); ?></h1>
                <div class="f-well f-clearfix" id="playerStatistic">
                    <div class="f-stat">
                        <b><?php echo $played; ?></b> <?php echo __("Game(s)", "fantasy-sports"); ?>
                    </div>
                    <?php if ($player_stats != null): ?>
                        <?php foreach ($player_stats as $stat): ?>
                            <div class="f-stat">
                                <b><?php echo $stat['points']; ?></b> <?php echo $stat['name']; ?> 
                            </div>
                        <?php endforeach; ?>
                    <?php endif; ?>
                    <?php if ($opponent_stats != null): ?>
                        <h1><?php echo __("Opposing Pitcher", "fantasy-sports"); ?> - <?php echo $opponent_name; ?></h1>
                        <div id="playerStatistic" class="f-well f-clearfix">
                            <div class="f-stat">
                                <b><?php echo $opponent_played; ?></b> <?php echo __("Game(s)", "fantasy-sports"); ?>
                            </div>
                            <?php foreach ($opponent_stats as $stat): ?>
                                <div class="f-stat">
                                    <b><?php echo $stat['points']; ?></b> <?php echo $stat['name']; ?>  
                                </div>
                            <?php endforeach; ?>
                        </div>
                    <?php endif; ?>
                </div>
                <div class="clear"></div>
                <?php if($performance_chart != null):?>
                <br/>
                <h1><?php echo __("Recent Perfomances", "fantasy-sports"); ?></h1>
                <div class="f-well f-clearfix recent_performances" id="recentPerformances">
                    <div class="player_perfomance">
                        <?php foreach($performance_chart as $chart):?>
                        <div class="performance_item">
                            <div class="fantasy_point">
                                <b><?php echo $chart['total_fantasy_points'];?></b>
                                <br/>
                                <?php echo date('M d Y', strtotime($chart['date']));?>
                            </div>
                            <?php if(!empty($chart['opponent_team'])):?>
                            <div class="player_opponent">
                                @ <?php echo $chart['opponent_team']['name'];?>
                            </div>
                            <?php endif;?>
                            <div class="clear"></div>
                        </div>
                        <?php endforeach;?>
                    </div>
                    <div class="player_chart">
                        <div id="perfomance_chart" style="width: 100%; height: 100%"></div>
                    </div>
                </div>
                <?php endif;?>
            </div>
        </div>
        <div class="f-player-stats-lb-tab f-tab2" id="tab2">
            <div class="f-game-log">
                <h1><?php echo __("Game Log", "fantasy-sports"); ?></h1>
                <div class="f-table-container" id="gameLog">
                    <?php if(!empty($stats['scoring'])):?>
                        <table class="f-game-log f-condensed f-text-align-right">
                            <thead>
                                <tr>
                                    <?php foreach ($stats['cats'] as $stat): ?>
                                        <th><?php echo $stat; ?></th>
                                    <?php endforeach; ?>
                                </tr>
                            </thead>
                            <tbody class="f-text-align-right">
                                <?php foreach ($stats['scoring'] as $stat): ?>
                                    <tr>
                                        <?php foreach ($stat as $scoring): ?>
                                            <td><?php echo $scoring; ?></td>
                                        <?php endforeach; ?>
                                    </tr>
                                <?php endforeach; ?>
                            </tbody>
                        </table>
                    <?php else:?>
                        <?php echo __("This player has not played any matches yet.", "fantasy-sports");?>
                    <?php endif; ?>
                </div>
            </div>
        </div>
        <div id="tab3" class="f-player-stats-lb-tab f-tab3">
            <div class="f-player-news">
                <div class="f-row">
                    <h1 class="f-left"><?php echo __("Player News", "fantasy-sports"); ?></h1>
                </div>
                <div class="f-clear f-news-item" data-role="scrollable-body" id="playerNews" data-google="<?php echo $allow_google_news;?>">
                    <?php if($player_news != null):
                        $style = 'style="padding-bottom:5px;margin-bottom:5px;border-bottom:solid 1px #8b8b8b"';
                    ?>
                        <?php foreach($player_news as $k => $news):
                            if (count($player_news) == $k + 1)
                            {
                                $style = '';
                            }
                        ?>
                            <div <?php echo $style;?>>
                                <?php echo $news['updated']; ?><br/>
                                <?php echo $news['title']; ?><br/>
                                <?php echo $news['content']; ?>
                            </div>
                        <?php endforeach;?>
                    <?php else:?>
                        <?php echo __("No news", "fantasy-sports");?>
                    <?php endif;?>
                </div>
            </div>
        </div>
    </div>
</div>

<?php if($performance_chart != null):
    $chart_data = array();
    usort($performance_chart, function($a, $b) {
        return strtotime($a['date']) - strtotime($b['date']);
    });
    foreach($performance_chart as $chart_item)
    {
        $chart_data[] = array(
            date('M d', strtotime($chart_item['date'])),
            (float)$chart_item['total_fantasy_points']
        );
    }
    $chart_data = json_encode($chart_data);
?>
<script type="text/javascript">
    google.charts.load('current', {'packages':['line']});
    google.charts.setOnLoadCallback(drawChart);

    function drawChart() {
        var chart_date = jQuery.parseJSON('<?php echo $chart_data;?>');
        var data = new google.visualization.DataTable();
        data.addColumn('string', '');
        data.addColumn('number', 'AVG');

        data.addRows(chart_date);

        var options = {
            chart: {
                title: '',
                subtitle: ''
            },
            backgroundColor: 'transparent',
            is3D:true
        };
        var chart = new google.charts.Line(document.getElementById('perfomance_chart'));
        chart.draw(data, google.charts.Line.convertOptions(options));
    }
</script>
<?php endif;?>