<div class="contentPlugin">
    <div id="f-live-scoring-app">
        <input type="hidden" id="scoringCats" value='<?php echo json_encode($scoringCats); ?>' />
        <input type="hidden" id="multiEntry" value='<?php echo $league['multi_entry']; ?>' />
        <input type="hidden" id="leagueOptionType" value='<?php echo $league['option_type']; ?>' />
        <input type="hidden" id="gameType" value='<?php echo $league['gameType']; ?>' />
        <input type="hidden" id="leagueID" value='<?php echo $league['leagueID']; ?>' />
        <input type="hidden" id="entry_number" value='<?php echo $entry_number; ?>' />
        <div class="f-column-12 f-clearfix">
            <div id="f-scoring-table-name">
                <h1>
                    <?php echo $league['name']; ?>
                    <?php if ($league['multi_entry'] == 1): ?>
                        (<?php echo __("Multi Entry", 'fantasy-sports'); ?>)
                    <?php endif; ?>
                </h1>
            </div>
            <div id="f-current-table-status">
                <span class="f-final">FINAL</span>
                <?php echo __("Start", 'fantasy-sports'); ?> <?php echo FV_DateTranslate($league['startDate']); ?>
            </div>
        </div>
        <div class="f-column-12" id="f-scoring-table-info">
            <div class="f-clearfix" id="f-table-meta-information">
                <ul class="f-column-8">
                    <li class="f-table-type"><?php echo __('Multiplayer league', 'fantasy-sports') ?> (<?php echo $league['entries']; ?> <?php echo ('entries') ?>)</li>
                    <?php if (get_option('fanvictor_no_cash') == 0): ?>
                        <li class="f-entry"><?php echo __('Entry', 'fantasy-sports') ?>: <?php echo FV_FormatMoney($league['entry_fee']); ?></li>
                    <?php endif; ?>
                </ul>
                <ul class="f-prizes-breakdown">
                    <li class="f-prize-row">
                        <span class="f-pos-name">1st:</span> $0
                    </li>
                </ul>
            </div>
        </div>
        <?php if (!empty($aFights)): ?>
            <div class="f-column-12" id="f-live-scoring-fixture-info">
                <section>
                    <ul>
                        <?php foreach ($aFights as $aFight): ?>
                            <li class="f-fixture-card">
                                <ul class="f-fixture-card-live-status f-pending">
                                    <li class="f-fixture-card-away"><?php echo $aFight['nickName1']; ?> <?php echo $aFight['team1score']; ?></li>
                                    <li class="f-fixture-card-home"><?php echo $aFight['nickName2']; ?> <?php echo $aFight['team2score']; ?></li>
                                    <li class="f-fixture-card-time">
                                        <?php if (empty($aFight['status'])): ?>
                                            <?php if ($aFight['is_closed'] == 1): ?>
                                                <?php echo __('FINAL', 'fantasy-sports'); ?>
                                            <?php elseif ($aFight['is_closed'] == 2): ?>
                                                <?php echo __('POSTPONE', 'fantasy-sports'); ?>
                                            <?php endif; ?>
                                        <?php else: ?>
                                            <?php echo $aFight['status'] ?>
                                        <?php endif; ?>&nbsp;
                                    </li>
                                </ul>
                            </li>
                        <?php endforeach; ?>
                    </ul>
                </section>
            </div>
        <?php endif; ?>
        <div class="clear"></div>
        <div id="tabs">
            <ul>
              <li>
                  <a href="#tabs_weekly_result">
                      <?php echo __('Weekly Result','fantasy-sports'); ?>
                  </a>
              </li>
              <li>
                  <a href="#tabs_score_board">
                      <?php echo __('League Standings','fantasy-sports'); ?>
                  </a>
              </li>
            </ul>
            <div id="tabs_weekly_result">
                <div class="f-column-12" style="padding:25px 0;">
                    <select id="week" style="max-width: 250px;" onchange="jQuery.livedraft.loadOpponentByweek();jQuery.livedraft.loadOpponentScores();">
                        <?php foreach($week as $key=>$value): ?>
                        <option <?php echo $key + 1 == $week_select ?"selected":""; ?> value="<?php echo  $value; ?>">
                           <?php if($value != 'final'): ?>
                             <?php echo sprintf(__('Week %s','fantasy-sports'),$value); ?>
                            <?php else: ?>
                                <?php echo __('Final','fantasy-sports'); ?>
                            <?php endif; ?>
                        </option>
                        <?php endforeach; ?>
                    </select>
                    <select id="opponent" style="max-width: 250px;" onchange="jQuery.livedraft.loadOpponentScores();">
                        <?php foreach($opponents as $week => $opponent_list): ?>
                            <optgroup id="opponent_week_<?php echo $week;?>" style="display: none">
                                <?php foreach($opponent_list as $opponent): ?>
                                    <option value="<?php echo $opponent['id']; ?>">
                                        <?php echo $opponent['user_name']." ".__('vs','fantasy-sports')." ".$opponent['opponent_name']; ?>
                                    </option>
                                <?php endforeach; ?>
                            </optgroup>
                        <?php endforeach; ?>
                    </select>
                </div>
                <div id="result_detail_data"></div>
                <div class="clear"></div>
                <?php if ($scoringCats != null): ?> 
                    <div>
                        <h3 style="margin-bottom: 0"><?php echo __('Scoring Categories', 'fantasy-sports'); ?></h3>
                        <?php foreach ($scoringCats as $item): ?> 
                            <?php $scoring_name = (!empty($item['alias']) ? $item['alias'] : str_replace('_', ' ', $item['name']));
                                echo FV_ScoringTranslate($scoring_name).' = '.$item['points'];
                            ?><br/>
                        <?php endforeach; ?>
                    </div>
                <?php endif; ?> 
                <?php if ($bonus != null): ?>
                    <div id="bonusPoints">
                        <h3 style="margin-bottom: 0"><?php echo __('Bonus', 'fantasy-sports'); ?></h3>
                        <?php echo $bonus; ?>
                    </div>
                <?php endif; ?>
            </div>
            <div id="tabs_score_board">
                <div class="f-column-12 f-small-screen-pane score_board" id="f-live-scoring-leaderboard">
                    <div>
                        <table class="f-condensed" id="tableScores">
                            <thead>
                                <tr>
                                    <th style="width:7%;"></th>
                                    <th><?php echo __('User', 'fantasy-sports') ?></th>
                                    <th class="f-text-align-right" style="width:8%;"><?php echo __('GP', 'fantasy-sports') ?></th>
                                    <th class="f-text-align-right" style="width:8%;"><?php echo __('W', 'fantasy-sports') ?></th>
                                    <th class="f-text-align-right" style="width:8%;"><?php echo __('L', 'fantasy-sports') ?></th>
                                    <th class="f-text-align-right" style="width:10%;"><?php echo __('PF', 'fantasy-sports') ?></th>
                                    <th class="f-text-align-right" style="width:10%;"><?php echo __('PA', 'fantasy-sports') ?></th>
                                    <th class="f-text-align-right" style="width:10%;"><?php echo __('PTS', 'fantasy-sports') ?></th>
                                    <?php if (get_option('fanvictor_no_cash') == 0): ?>
                                        <th class="f-text-align-right" style="width:14%;"><?php echo __('Prizes', 'fantasy-sports') ?></th>
                                    <?php endif; ?>
                                </tr>
                            </thead>
                            <tbody></tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
        <div class="clear"></div>
    </div>
</div>
<script type="text/javascript">
    jQuery(window).load(function () {
        jQuery("#tabs" ).tabs();
        jQuery.livedraft.loadOpponentByweek();
        var isLive = <?php echo $league['is_live']; ?>;
        if (isLive)
        {
            jQuery.livedraft.liveEntriesResult(<?php echo $league['poolID']; ?>, <?php echo $league['leagueID']; ?>, <?php echo $entry_number; ?>, 1);
            setInterval(function () {
                jQuery.livedraft.liveEntriesResult(<?php echo $league['poolID']; ?>, <?php echo $league['leagueID']; ?>, <?php echo $entry_number; ?>, 1)
            }, 60000);
        } 
        else
        {
            jQuery.livedraft.loadFixtureScores(<?php echo $league['leagueID']; ?>);
            jQuery.livedraft.loadOpponentScores();
            jQuery.livedraft.loadContestScores();
        }
    });
</script>