<?php if($predict_match != null):?>
<div class="contestStructure">
    <div class="left">
        <div>
            <div class="label"><?php echo __('Predict for match', 'fantasy-sports') ?>:</div>
            <?php echo $predict_match['name'];?>        
        </div>
        <div>
            <div class="label"><?php echo __('Total predict match score', 'fantasy-sports') ?>:</div>
            <?php echo $total_predict_match_score;?>
        </div>
    </div>
</div>
<div class="clear"></div>
<?php endif;?>
<div class="f-column-12 f-small-screen-pane score_board" id="f-live-scoring-leaderboard">
    <div id="wrapper_standing">
        <table class="f-condensed" id="table_standing">
            <thead>
                <tr>
                    <th style="width:7%;"><?php echo __('Rank', 'fantasy-sports') ?></th>
                    <th class="f-text-align-left"><?php echo __('User', 'fantasy-sports') ?></th>
                    <?php if($week > 0):?>
                    <th style="width:15%;"><?php echo __('Tiebreaker', 'fantasy-sports') ?></th>
                    <?php endif;?>
                    <th style="width:10%;"><?php echo __('Points', 'fantasy-sports') ?></th>
                    <?php if (get_option('fanvictor_no_cash') == 0): ?>
                        <th style="width:14%;"><?php echo __('Prizes', 'fantasy-sports') ?></th>
                    <?php endif; ?>
                </tr>
            </thead>
            <tbody>
                <?php if($standing != null):?>
                    <?php foreach($standing as $item):
                        $user = $item['user'];
                    ?>
                        <tr <?php if($user_id == $item['userID'] && $entry_number == $item['entry_number']):?>class="f-user-highlight"<?php endif;?> data-user_id="<?php echo $item['userID'];?>" data-entry_number="<?php echo $item['entry_number'];?>">
                            <td class="f-text-align-center">
                                <?php echo !empty($item['rank']) ? $item['rank'] : "-";?>
                            </td>
                            <td>
                                <div style="background-image: url('<?php echo $user['avatar'];?>')" class="f-avatar">
                                </div>
                                <a class="f-truncate">
                                    <?php echo $user['username'];?>
                                </a>
                            </td>
                            <?php if($week > 0):?>
                            <td class="f-text-align-center">
                                <?php echo $item['predict_point'];?>
                            </td>
                            <?php endif;?>
                            <td class="f-text-align-center">
                                <?php echo $item['points'];?>
                            </td>
                            <?php if (get_option('fanvictor_no_cash') == 0): ?>
                                <td class="f-text-align-center">
                                    <?php if(!empty($item['prize'])):
                                        $prize = $item['prize'];
                                    ?>
                                        <?php echo $prize['amount'].' - '.strtolower($prize['type']);?>
                                    <?php endif;?>
                                </td>
                            <?php endif;?>
                        </tr>
                    <?php endforeach;?>
                <?php endif; ?>
            </tbody>
        </table>
        
        <div id="paging_ranking" class="pg-wrapper">
            <?php if ($total_page > 1):?>
                <?php for ($page = 1; $page <= $total_page; $page++):
                    $class_active = '';
                    if ($current_page == $page)
                    {
                        $class_active = 'active';
                    }
                ?>
                    <div class="dib <?php echo $class_active;?>" onclick="jQuery.roundpickem.loadResult('<?php echo $league_id;?>', '<?php echo $entry_number;?>', '<?php echo $page;?>')">
                        <?php echo $page;?>
                    </div>
                <?php endfor;?>
            <?php endif;?>
        </div>
    </div>
</div>