<div class="f-loading" style="display: none"></div>
<div id="wrap_outerdiv">
    <?php if($playerstats != null):?>
        <table id="stats-table">
            <thead>
                <tr>
                    <th data-sort_name="position" data-sort_value="<?php echo $sort_name == 'position' ? $sort_value : '';?>" title="<?php echo __("Position", 'fantasy-sports');?>" class="data_filter" style="width:15%">
                        <?php echo __("Position", 'fantasy-sports');?>
                        <?php if($sort_name == 'position'):?>
                            <i class="fa fa-sort-up" style="margin-left:5px;<?php echo $sort_value == '' || $sort_value == 'asc' ? 'display: none' : '';?>"></i>
                            <i class="fa fa-sort-down" style="margin-left:5px;<?php echo $sort_value == '' || $sort_value == 'desc' ? 'display: none' : '';?>"></i>
                        <?php endif;?>
                    </th>
                    <th data-sort_name="player_name" data-sort_value="<?php echo $sort_name == 'player_name' ? $sort_value : '';?>" class="data_filter" title="<?php echo __("Name", 'fantasy-sports');?>">
                        <?php echo __("Name", 'fantasy-sports');?>
                        <?php if($sort_name == 'player_name'):?>
                            <i class="fa fa-sort-up" style="margin-left:5px;<?php echo $sort_value == '' || $sort_value == 'asc' ? 'display: none' : '';?>"></i>
                            <i class="fa fa-sort-down" style="margin-left:5px;<?php echo $sort_value == '' || $sort_value == 'desc' ? 'display: none' : '';?>"></i>
                        <?php endif;?>
                    </th>
                    <th data-sort_name="team" data-sort_value="<?php echo $sort_name == 'team' ? $sort_value : '';?>" style="width:15%" class="data_filter" title="<?php echo __("Team", 'fantasy-sports');?>">
                        <?php echo __("Team", 'fantasy-sports');?>
                        <?php if($sort_name == 'team'):?>
                            <i class="fa fa-sort-up" style="margin-left:5px;<?php echo $sort_value == '' || $sort_value == 'asc' ? 'display: none' : '';?>"></i>
                            <i class="fa fa-sort-down" style="margin-left:5px;<?php echo $sort_value == '' || $sort_value == 'desc' ? 'display: none' : '';?>"></i>
                        <?php endif;?>
                    </th>
                    <th data-sort_name="owner" data-sort_value="<?php echo $sort_name == 'owner' ? $sort_value : '';?>" title="<?php echo __("Owner", 'fantasy-sports');?>" class="data_filter" style="width:15%">
                        <?php echo __("Owner", 'fantasy-sports');?>
                        <?php if($sort_name == 'owner'):?>
                            <i class="fa fa-sort-up" style="margin-left:5px;<?php echo $sort_value == '' || $sort_value == 'asc' ? 'display: none' : '';?>"></i>
                            <i class="fa fa-sort-down" style="margin-left:5px;<?php echo $sort_value == '' || $sort_value == 'desc' ? 'display: none' : '';?>"></i>
                        <?php endif;?>
                    </th>
                    <th title="<?php echo __("Opposition", 'fantasy-sports');?>" style="width:15%;cursor: default">
                        <?php echo __("Opposition", 'fantasy-sports');?>
                    </th>
                    <th data-sort_name="<?php echo !empty($params['scoring_category_id']) ? $params['scoring_category_id'] : 'value';?>" data-sort_value="<?php echo $sort_name == 'value' || $sort_name == $params['scoring_category_id'] ? $sort_value : '';?>" title="<?php echo __("Value", 'fantasy-sports');?>" class="data_filter" style="width:10%">
                        <?php echo __("Value", 'fantasy-sports');?>
                        <?php if($sort_name == 'value'|| $sort_name == $params['scoring_category_id']):?>
                            <i class="fa fa-sort-up" style="margin-left:5px;<?php echo $sort_value == '' || $sort_value == 'asc' ? 'display: none' : '';?>"></i>
                            <i class="fa fa-sort-down" style="margin-left:5px;<?php echo $sort_value == '' || $sort_value == 'desc' ? 'display: none' : '';?>"></i>
                        <?php endif;?>
                    </th>
                </tr>
            </thead>
            <tbody>
                <?php if($playerstats != null):?>
                    <?php foreach($playerstats as $k => $playerstat):?>
                        <tr class="<?php if($k %2 == 0):?>tr0<?php else:?>tr1<?php endif;?>">
                            <td>
                                <?php echo $playerstat['position_name'];?>
                            </td>
                            <td>
                                <a onclick="jQuery.stats.playerInfo(<?php echo $playerstat['player_id'];?>)" href="javascript:void(0)">
                                    <?php echo $playerstat['name'];?>
                                </a>
                            </td>
                            <td title="<?php echo $playerstat['team'];?>">
                                <?php echo $playerstat['team_alias'];?>
                            </td>
                            <td>
                                <?php echo $playerstat['owner'] != null ? $playerstat['owner'] : __("Free agent", 'fantasy-sports');?>
                            </td>
                            <td title="<?php echo $playerstat['team_opponent'];?>">
                                <?php echo $playerstat['team_opponent_alias'];?>
                            </td>
                            <td>
                                <?php 
                                    if($params['scoring_category_id'] > 0)
                                    {
                                        foreach($playerstat['scoring'] as $scoring)
                                        {
                                            if($scoring['scoring_category_id'] == $params['scoring_category_id'])
                                            {
                                                echo $scoring['points'];
                                                break;
                                            }
                                        }
                                    }
                                    else
                                    {
                                        echo $playerstat['total_points'];
                                    }
                                ;?>
                            </td>
                        </tr>
                    <?php endforeach;?>
                <?php endif;?>
            </tbody>
        </table>
    <?php else:?>
        <div class="no-data"><?php echo __("No data", 'fantasy-sports');?></div>
    <?php endif;?>
</div>
<?php if($playerstats != null && $total_page > 1):?>
<div id="stats-page" class="pg-wrapper">
    <?php for($i = 1; $i <= $total_page; $i++):?>
        <div class="page-item <?php if($page == $i):?>active<?php endif;?>" data-page="<?php echo $i;?>">
            <?php echo $i;?>
        </div>
    <?php endfor;?>
</div>
<?php endif;?>