<section class="teampage-header-container ng-scope">
    <div class="team">
        <div class="team-logo logo-gradient">
            <img src="<?php echo FV_parseTeamImage($team['image_url']); ?>"/>
        </div>
        <div class="team-stats gradient">
            <ul>
                <li>
                    <span class="stat-name"><?php echo __("Win", "fantasy-sports");?></span>
                    <span class="value ng-binding"><?php echo $team['wins'];?></span>
                </li>
                <li>
                    <span class="stat-name"><?php echo __("Loss", "fantasy-sports");?></span>
                    <span class="value ng-binding"><?php echo $team['losses'];?></span>
                </li>
                <li class="last">
                    <span class="stat-name"><?php echo __("Draw", "fantasy-sports");?></span>
                    <span class="value ng-binding"><?php echo $team['draws'];?></span>
                </li>
            </ul>
        </div>
        <div class="team-info ng-isolate-scope" style="background: linear-gradient(rgb(117, 0, 0) 0%, rgb(117, 0, 0) 60%, rgb(230, 0, 0) 100%);">
            <div class="gloss gradient"></div>
            <ul>
                <li class="team-name ng-binding"><?php echo $team['name'];?></li>
                <li class="team-name-mobile ng-binding"><?php echo $team['nickName'];?></li>
            </ul>
        </div>
        <div class="clear"></div>
    </div>
    <div class="team-stats mobile mobile-nhl gradient">
        <ul>
            <li>
                <span class="stat-name"><?php echo __("Win", "fantasy-sports");?></span>
                <span class="value ng-binding"><?php echo $team['wins'];?></span>
            </li>
            <li>
                <span class="stat-name"><?php echo __("Loss", "fantasy-sports");?></span>
                <span class="value ng-binding"><?php echo $team['losses'];?></span>
            </li>
            <li>
                <span class="stat-name"><?php echo __("Draw", "fantasy-sports");?></span>
                <span class="value ng-binding"><?php echo $team['draws'];?></span>
            </li>
        </ul>
    </div>
    <div class="clear"></div>
    <div class="schedule">
        <div class="games-container">
            <?php if($nearest_fixtures != null):?>
                <?php foreach($nearest_fixtures as $k => $fixture):
                    $away_team = $fixture['away_team'];
                    $home_team = $fixture['home_team'];
                    if($home_team['teamID'] == $team_id)
                    {
                        $opponent_team = $away_team;
                        $current_team = $home_team;
                    }
                    else
                    {
                        $opponent_team = $home_team;
                        $current_team = $away_team;
                    }
                ?>
                <?php if($k != 2):?>
                    <div class="game ng-scope <?php echo $k < 2 ? "post" : "";?> <?php echo $k > 2 ? "pre" : "";?> <?php echo $k == 0 ? "first" : "";?> <?php echo $k == count($nearest_fixtures) - 1 ? "last" : "";?>">
                        <div class="game-header final">
                            <h4 class="date ng-binding ng-scope">
                                <?php echo date('D, M d', strtotime($fixture['startDate']));?>
                            </h4>
                        </div>
                        <div class="results">
                            <a href="<?php echo FANVICTOR_URL_LIVESCORE.'?detail=1&team_id='.$opponent_team['teamID'];?>" class="ng-scope">
                                <img src="<?php echo FV_parseTeamImage($opponent_team['image_url']); ?>"/>
                                <span class="opponent row">
                                    <strong>
                                        <span ng-switch-when="1" class="ng-scope">vs</span>
                                        <span class="acronym ng-binding">
                                            <?php echo $opponent_team['nickName'];?>
                                        </span>
                                    </strong>
                                </span>
                                <?php if($k > 2):?>
                                    <span class="start-time row ng-binding">
                                        <?php echo date('g:i a', strtotime($fixture['startDate']));?>
                                    </span>
                                <?php else:?>
                                    <span class="score row">
                                        <span>
                                            <span class="ng-scope">
                                                <?php if($opponent_team['score'] > $current_team['score']):?>
                                                    <?php echo __("Loss", "fantasy-sports");?>
                                                <?php elseif($current_team['score'] > $opponent_team['score']):?>
                                                    <?php echo __("win", "fantasy-sports");?>
                                                <?php else:?>
                                                    <?php echo __("Draw", "fantasy-sports");?>
                                                <?php endif;?>
                                            </span>
                                        </span>
                                        <span>
                                            <span class="ng-binding ng-scope">
                                                <?php if($opponent_team['score'] > $current_team['score']):?>
                                                    <?php echo $opponent_team['score'].'-'.$current_team['score'];?>
                                                <?php elseif($current_team['score'] > $opponent_team['score']):?>
                                                    <?php echo $current_team['score'].'-'.$opponent_team['score'];?>
                                                <?php else:?>
                                                    <?php echo $current_team['score'].'-'.$opponent_team['score'];?>
                                                <?php endif;?>
                                            </span>
                                        </span>
                                    </span>
                                <?php endif;?>
                            </a>
                        </div>
                    </div>
                <?php else:?>
                    <div class="game ng-scope featured">
                        <div class="game-header pre">
                            <h4 class="date ng-scope">
                                <span ng-switch-default="" class="ng-binding ng-scope">
                                    <?php echo date('D, M d', strtotime($fixture['startDate']));?>
                                </span>
                            </h4>
                        </div>
                        <div class="results">
                            <div class="score-container ng-scope">
                                <div class="featured-team">
                                    <a href="<?php echo FANVICTOR_URL_LIVESCORE.'?detail=1&team_id='.$home_team['teamID'];?>">
                                        <img class="ng-scope" src="<?php echo FV_parseTeamImage($home_team['image_url']); ?>"/>
                                        <span class="acronym">
                                            <strong class="ng-binding ng-scope">
                                                <?php echo $home_team['nickName'];?>
                                            </strong>
                                        </span>
                                    </a>
                                </div>
                                <div class="status">
                                    <span class="score ng-scope">
                                        <h1>vs</h1>
                                    </span>
                                   <span class="start-time ng-binding ng-scope">
                                       <?php echo date('g:i a Y', strtotime($fixture['startDate']));?>
                                   </span>
                                </div>
                                <div class="featured-team">
                                    <a href="<?php echo FANVICTOR_URL_LIVESCORE.'?detail=1&team_id='.$away_team['teamID'];?>">
                                        <img class="ng-scope" src="<?php echo FV_parseTeamImage($away_team['image_url']); ?>"/>
                                        <span class="acronym">
                                            <strong class="ng-binding">
                                                <?php echo $away_team['nickName'];?>
                                            </strong>
                                        </span>
                                    </a>
                                </div>
                                <div class="clear"></div>
                            </div>
                        </div>
                    </div>
                <?php endif;?>
                <?php endforeach;?>
            <?php endif;?>
            <div class="clear"></div>
        </div>
    </div>
</section>
<div id="PageTabs" class="page-tabs Team">
    <ul class="page-nav">
        <li>
            <a href="javascript:void(0)" onclick="jQuery.livescore.loadTeamNews(<?php echo $team_id;?>)">
                <?php echo __("News", "fantasy-sports");?>
            </a>
        </li>
        <li>
            <a href="javascript:void(0)" onclick="jQuery.livescore.loadTeamRoster(<?php echo $team_id;?>)">
                <?php echo __("Roster", "fantasy-sports");?>
            </a>
        </li>
        <li>
            <a href="javascript:void(0)" onclick="jQuery.livescore.loadTeamSchedule(<?php echo $team_id;?>)">
                <?php echo __("Schedule", "fantasy-sports");?>
            </a>
        </li>
        <li>
            <a href="javascript:void(0)" onclick="jQuery.livescore.loadTeamStatistic(<?php echo $team_id;?>)">
                <?php echo __("Statistics", "fantasy-sports");?>
            </a>
        </li>
        <li>
            <a href="javascript:void(0)" onclick="jQuery.livescore.loadTeamInjuries(<?php echo $team_id;?>)">
                <?php echo __("Injuries", "fantasy-sports");?>
            </a>
        </li>
    </ul>
</div>
<div class="content-main" id="team_detail"></div>

<script>
    jQuery(window).load(function(){
        jQuery('#PageTabs ul li:first a').trigger('click');
    })
    
    jQuery(document).on('click', '#PageTabs ul li a', function(){
        jQuery('#PageTabs ul li').removeClass('active');
        jQuery(this).closest('li').addClass('active');
    })
    
    jQuery(document).on('click', '#team-stats .sortable', function(){
        jQuery('.sortable').removeClass('current_sortable');
        jQuery(this).addClass('current_sortable');
        if(jQuery(this).data('sorttype') == "desc")
        {
            jQuery(this).data('sorttype', 'asc');
        }
        else
        {
            jQuery(this).data('sorttype', 'desc');
        }
        jQuery.livescore.loadTeamStatistic(<?php echo $team_id;?>);
    })
    
    jQuery(document).on('click', '#team-roster .sortable', function(){
        jQuery('.sortable').removeClass('current_sortable');
        jQuery(this).addClass('current_sortable');
        if(jQuery(this).data('sorttype') == "desc")
        {
            jQuery(this).data('sorttype', 'asc');
        }
        else
        {
            jQuery(this).data('sorttype', 'desc');
        }
        jQuery.livescore.loadTeamRoster(<?php echo $team_id;?>);
    })
</script>