<?php
    $fanvictor = new Fanvictor();
    $global_setting = $fanvictor->getGlobalSetting();
    if($global_setting['multiple_currency_support'])
    {
        $fanvictor->updateCoinExchangeRate();
    }
    else
    {
        update_option( 'fanvictor_global_currency_enable', 0);
    }
?>
<script>
  $( function() {
        $( "#tabs").tabs();
        $(".subtabs").tabs();
  } );
</script>
<div class="wrap">
<h2><?php echo __('Fan Victor Settings', 'fantasy-sports');?></h2>
<?php include FANVICTOR__PLUGIN_DIR_VIEW."Elements/check-api-token.php";?>
<form method="post" action="options.php" id="tabs">
    <?php settings_fields( 'fanvictor-settings-group' ); ?>
    <?php do_settings_sections( 'fanvictor-settings-group' ); ?>
    <ul>
        <li><a href="#tabs-1"><?php echo __('General', 'fantasy-sports');?></a></li>
        <li><a href="#tabs-2"><?php echo __('Contest', 'fantasy-sports');?></a></li>
        <li><a href="#tabs-3"><?php echo __('Gateway', 'fantasy-sports');?></a></li>
        <li><a href="#tabs-4"><?php echo __('Currency', 'fantasy-sports');?></a></li>
        <li><a href="#tabs-5"><?php echo __('Social', 'fantasy-sports');?></a></li>
        <?php if($global_setting['allow_push_notification']):?>
        <li><a href="#tabs-6"><?php echo __('Google Firebase', 'fantasy-sports');?></a></li>
        <?php endif;?>
        <li><a href="#tabs-7"><?php echo __('Bracket points', 'fantasy-sports');?></a></li>
    </ul>
    <div id="tabs-1">
        <table class="form-table">
            <tr valign="top">
                <th scope="row"><?php echo __('Api Token', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_api_token" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_api_token'));?>" />
                    <p class="description"><?php echo __('This is your unique license key for your plugin. You must get this by logging into FanVictor.com. Then copy and paste your key here.', 'fantasy-sports');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Api Url', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_api_url" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_api_url'));?>" />
                    <p class="description"><?php echo __("This is the URL that your plugin will connect to in order to set and get data. This should not be modified unless you are instructed to by Fan Victor's technical staff.", 'fantasy-sports');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Api Admin Url', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_api_url_admin" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_api_url_admin'));?>" />
                    <p class="description"><?php echo __("This is the URL that your plugin will connect to in order to set and get admin data. This should not be modified unless you are instructed to by Fan Victor's technical staff.", 'fantasy-sports');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Timezone', 'fantasy-sports');?></th>
                <td>
                    <select id="fanvictor_timezone" name="fanvictor_timezone">
                        <option value="">
                            <?php echo __('None', 'fantasy-sports');?>
                        </option>
                        <?php echo wp_timezone_choice(get_option('fanvictor_timezone')); ?>
                    </select>
                    <p class="description"><?php echo __("Change timezone in case you have a problem with date time.", 'fantasy-sports');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Date format', 'fantasy-sports');?></th>
                <td>
                    <select id="fanvictor_timezone" name="fanvictor_date_format">
                        <option value="">
                            <?php echo __('Default', 'fantasy-sports')." ".FV_DateTranslate(__('Ex: Mon Jan 22', 'fantasy-sports'), false);?>
                        </option>
                        <option value="D d M" <?php if(get_option("fanvictor_date_format") == "D d M"):?>selected="true"<?php endif;?>>
                            M D d <?php echo FV_DateTranslate(__('Ex: Mon 22 Jan', 'fantasy-sports'), false);?>
                        </option>
                    </select>
                </td>
            </tr>
        </table>
    </div>
    <div id="tabs-2">
        <table class="form-table">
            <tr valign="top">
                <th scope="row"><?php echo __('Entry Fee', 'fantasy-sports');?></th>
                <td class="array-holder">
                    <?php $aEntrys = get_option('fanvictor_entry_fee');?>
                    <?php 
                        if($aEntrys != null):
                        foreach($aEntrys as $aEntry):
                    ?>
                    <div class="array-item">
                        <input type="text" name="fanvictor_entry_fee[]" class="regular-text ltr entry_fee" value="<?php echo $aEntry;?>" />
                        <a href="#" onclick="return removeArray(this)"><?php echo __('Remove', 'fantasy-sports');?></a>
                    </div>
                    <?php 
                        endforeach;
                        else:;
                    ?>
                    <div class="array-item">
                        <input type="text" name="fanvictor_entry_fee[]" class="regular-text ltr entry_fee"/>
                        <a href="#" onclick="return removeArray(this)"><?php echo __('Remove', 'fantasy-sports');?></a>
                    </div>
                    <?php endif;?>
                    <input type="button" data-name="fanvictor_entry_fee[]" value="<?php echo __('Add', 'fantasy-sports');?>" class="button button-primary" style="margin-top: 5px" onclick="return addArray(this)" >
                    <p class="description"><?php echo __('These are the values that will appear in the Entry Fee drop down menu when creating a new contest.', 'fantasy-sports');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('League Size', 'fantasy-sports');?></th>
                <td class="array-holder">
                    <?php $aSizes = get_option('fanvictor_league_size');?>
                    <?php 
                        if($aSizes != null):
                        foreach($aSizes as $aSize):
                    ?>
                    <div class="array-item">
                        <input type="text" name="fanvictor_league_size[]" class="regular-text ltr entry_fee" value="<?php echo $aSize;?>" />
                        <a href="#" onclick="return removeArray(this)"><?php echo __('Remove', 'fantasy-sports');?></a>
                    </div>
                    <?php 
                        endforeach;
                        else:;
                    ?>
                    <div class="array-item">
                        <input type="text" name="fanvictor_league_size[]" class="regular-text ltr entry_fee"/>
                        <a href="#" onclick="return removeArray(this)"><?php echo __('Remove', 'fantasy-sports');?></a>
                    </div>
                    <?php endif;?>
                    <input type="button" data-name="fanvictor_league_size[]" value="<?php echo __('Add', 'fantasy-sports');?>" class="button button-primary" style="margin-top: 5px" onclick="return addArray(this)" >
                    <p class="description"><?php echo __('This are the values that will appear in the League Size drop down menu when creating a new contest.', 'fantasy-sports');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Payout Percentage', 'fantasy-sports');?>(%)</th>
                <td>
                    <input type="text" name="fanvictor_winner_percent" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_winner_percent'));?>" />
                    <p class="description"><?php echo __('This is the percentage that is paid out to winners. For example if the payout is 90%, then this means the site would have a rake of 10% per contest. 10% Would be the profit the site makes on a contest.', 'fantasy-sports');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('First Place Payout Percentage', 'fantasy-sports');?>(%)</th>
                <td>
                    <input type="text" name="fanvictor_first_place_percent" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_first_place_percent'));?>" />
                    <p class="description"><?php echo __('This is the percentage that is paid out to the first place winner in a top 3 get paid contest.', 'fantasy-sports');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Second Place Payout Percentage', 'fantasy-sports');?>(%)</th>
                <td>
                    <input type="text" name="fanvictor_second_place_percent" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_second_place_percent'));?>" />
                    <p class="description"><?php echo __('This is the percentage that is paid out to the second place winner in a top 3 get paid contest.', 'fantasy-sports');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Third Place Payout Percentage', 'fantasy-sports');?>(%)</th>
                <td>
                    <input type="text" name="fanvictor_third_place_percent" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_third_place_percent'));?>" />
                    <p class="description"><?php echo __('This is the percentage that is paid out to the third place winner in a top 3 get paid contest.', 'fantasy-sports');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Processing fee percentage', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_fee_percentage" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_fee_percentage'));?>" />%
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Credit Exchange Rate (Deposit)', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_cash_to_credit" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_cash_to_credit'));?>" />
                    <p class="description"><?php echo __('In addition to making money from a rake per contest. You can also set a rate for when user purchase credits. For example, $1 USD can buy 10 Credits. But to withdraw funds, it might cost 11 Credits to cash out $1 USD. In this field enter how many credits a user will receive for $1. It is not uncommon to say 1. So $1 buys 1 credit.', 'fantasy-sports');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Credit Exchange Rate (Withdraw)', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_credit_to_cash" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_credit_to_cash'));?>" />
                    <p class="description"><?php echo __('In this field enter how many credits a user needs to withdraw to receive $1.', 'fantasy-sports');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Allow Create Contest', 'fantasy-sports');?></th>
                <td>
                    <select class="postform" name="fanvictor_create_contest">
                        <option <?php echo get_option('fanvictor_create_contest') == 1 ? 'selected="true"' : '';?> value="1"><?php echo __('True', 'fantasy-sports');?></option>
                        <option <?php echo get_option('fanvictor_create_contest') == 0 ? 'selected="true"' : '';?> value="0"><?php echo __('False', 'fantasy-sports');?></option>
                    </select>
                    <p class="description"><?php echo __('Allow user create new contest at frontend.', 'fantasy-sports');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('No cash', 'fantasy-sports');?></th>
                <td>
                    <select class="postform" name="fanvictor_no_cash">
                        <option <?php echo get_option('fanvictor_no_cash') == 0 ? 'selected="true"' : '';?> value="0"><?php echo __('False', 'fantasy-sports');?></option>
                        <option <?php echo get_option('fanvictor_no_cash') == 1 ? 'selected="true"' : '';?> value="1"><?php echo __('True', 'fantasy-sports');?></option>
                    </select>
                    <p class="description"><?php echo __('This will hide ALL references to Entry Fee and Prizes.  This is mainly used for site who are NOT offering CASH games.', 'fantasy-sports');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('No invite user list', 'fantasy-sports');?></th>
                <td>
                    <select class="postform" name="fanvictor_no_invite_user_list">
                        <option <?php echo get_option('fanvictor_no_invite_user_list') == 0 ? 'selected="true"' : '';?> value="0"><?php echo __('False', 'fantasy-sports');?></option>
                        <option <?php echo get_option('fanvictor_no_invite_user_list') == 1 ? 'selected="true"' : '';?> value="1"><?php echo __('True', 'fantasy-sports');?></option>
                    </select>
                    <p class="description"><?php echo __('This will hide user list when invite user to a contest.', 'fantasy-sports');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Minimum Deposit', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_minimum_deposit" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_minimum_deposit'));?>" />
                    <p class="description"><?php echo __('Minimum Deposit Value', 'fantasy-sports');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Show import picks', 'fantasy-sports');?></th>
                <td>
                    <input type="checkbox"  name="fanvictor_show_import_pick" <?php checked( 1, get_option( 'fanvictor_show_import_pick' ) ); ?>  value="1"/>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Recieve email when players join a contest', 'fantasy-sports');?></th>
                <td>
                    <input type="checkbox"  name="fanvictor_get_email_from_better_join_contest" <?php checked( 1, get_option( 'fanvictor_get_email_from_better_join_contest' ) ); ?>  value="1"/>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Allow share teams and players', 'fantasy-sports');?></th>
                <td>
                    <input type="checkbox"  name="fanvictor_share_teams_players" <?php checked( 1, get_option( 'fanvictor_share_teams_players' ) ); ?>  value="1"/>
                    <p class="description"><?php echo __('Note: This function only works if facebook app id is entered.', 'fantasy-sports');?></a>
                </td>
            </tr>

            <tr valign="top">
                <th scope="row"><?php echo __('B icon', 'fantasy-sports');?></th>
                <td>
                    <select class="postform" name="fanvictor_b_icon">
                        <option <?php echo get_option('fanvictor_b_icon') == 1 ? 'selected="true"' : '';?> value="1"><?php echo __('True', 'fantasy-sports');?></option>
                        <option <?php echo get_option('fanvictor_b_icon') == 0 ? 'selected="true"' : '';?> value="0"><?php echo __('False', 'fantasy-sports');?></option>
                    </select>
                    <p class="description"><?php echo __('Show B icon next to user name that have entered less that 50 contests.', 'fantasy-sports');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Send weekly statistic to', 'fantasy-sports');?></th>
                <td>
                    <input type="text" placeholder="sample@abc.com" class="regular-text ltr" name="fanvictor_weekly_statistic_email"  value="<?php echo get_option( 'fanvictor_weekly_statistic_email' );?>"/>
                </td>
            </tr>
        </table>
    </div>
    <div id="tabs-3" class="subtabs">
        <table class="form-table">
            <tr valign="top">
                <th scope="row"><?php echo __('Deposit Gateway', 'fantasy-sports');?></th>
                <td>
                    <?php 
                        $gateway_type = get_option('fanvictor_payout_gateway');
                        $gateway_type = !empty($gateway_type) ? $gateway_type : array();
                    ?>
                    <select class="postform" name="fanvictor_payout_gateway[]" multiple="">
                        <option <?php echo in_array(FANVICTOR_GATEWAY_PAYPAL, $gateway_type) ? 'selected="true"' : '';?> value="<?php echo FANVICTOR_GATEWAY_PAYPAL;?>"><?php echo __('Paypal', 'fantasy-sports');?></option>
                        <option <?php echo in_array(FANVICTOR_GATEWAY_PRIORITY, $gateway_type) ? 'selected="true"' : '';?> value="<?php echo FANVICTOR_GATEWAY_PRIORITY;?>"><?php echo __('Priority', 'fantasy-sports');?></option>
                        <option <?php echo in_array(FANVICTOR_GATEWAY_FLUTTERWAVE, $gateway_type) ? 'selected="true"' : '';?> value="<?php echo FANVICTOR_GATEWAY_FLUTTERWAVE;?>"><?php echo __('Flutterwave', 'fantasy-sports');?></option>
                        <option <?php echo in_array(FANVICTOR_GATEWAY_FTTECH, $gateway_type) ? 'selected="true"' : '';?> value="<?php echo FANVICTOR_GATEWAY_FTTECH;?>"><?php echo __('FT Tech', 'fantasy-sports');?></option>
                        <option <?php echo in_array(FANVICTOR_GATEWAY_BILLMAP, $gateway_type) ? 'selected="true"' : '';?> value="<?php echo FANVICTOR_GATEWAY_BILLMAP;?>"><?php echo __('BillMap', 'fantasy-sports');?></option>
                        <option <?php echo in_array(FANVICTOR_GATEWAY_BITCOIN, $gateway_type) ? 'selected="true"' : '';?> value="<?php echo FANVICTOR_GATEWAY_BITCOIN;?>"><?php echo __('Bitcoin', 'fantasy-sports');?></option>
                        <option <?php echo in_array(FANVICTOR_GATEWAY_CHEESE, $gateway_type) ? 'selected="true"' : '';?> value="<?php echo FANVICTOR_GATEWAY_CHEESE;?>"><?php echo __('Cheese', 'fantasy-sports');?></option>
                        <option <?php echo in_array(FANVICTOR_GATEWAY_MOLPAY, $gateway_type) ? 'selected="true"' : '';?> value="<?php echo FANVICTOR_GATEWAY_MOLPAY;?>"><?php echo __('Molpay', 'fantasy-sports');?></option>
                    </select>
                    <p class="description"><?php echo __('Select gateway to payout.', 'fantasy-sports');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Withdrawal Gateway', 'fantasy-sports');?></th>
                <td>
                     <?php 
                        $gateway_payout = get_option('fanvictor_payout_method');
                        $gateway_payout = !empty($gateway_payout) ? $gateway_payout : array();
                    ?>
                    <select class="postform" name="fanvictor_payout_method[]" multiple="">
                         <option <?php echo in_array(FANVICTOR_GATEWAY_PAYPAL, $gateway_payout) ? 'selected="true"' : '';?> value="<?php echo FANVICTOR_GATEWAY_PAYPAL;?>"><?php echo __('Paypal', 'fantasy-sports');?></option>
                        <option <?php echo in_array(FANVICTOR_GATEWAY_PRIORITY, $gateway_payout) ? 'selected="true"' : '';?> value="<?php echo FANVICTOR_GATEWAY_PRIORITY;?>"><?php echo __('Priority', 'fantasy-sports');?></option>
                        <option <?php echo in_array(FANVICTOR_GATEWAY_MONEYWAVE, $gateway_payout) ? 'selected="true"' : '';?> value="<?php echo FANVICTOR_GATEWAY_MONEYWAVE;?>"><?php echo __('Moneywave', 'fantasy-sports');?></option>
                        <option <?php echo in_array(FANVICTOR_GATEWAY_FTTECH, $gateway_payout) ? 'selected="true"' : '';?> value="<?php echo FANVICTOR_GATEWAY_FTTECH;?>"><?php echo __('FT Tech', 'fantasy-sports');?></option>
                        <option <?php echo in_array(FANVICTOR_GATEWAY_BILLMAP, $gateway_payout) ? 'selected="true"' : '';?> value="<?php echo FANVICTOR_GATEWAY_BILLMAP;?>"><?php echo __('BillMap', 'fantasy-sports');?></option>
                        <option <?php echo in_array(FANVICTOR_GATEWAY_BITCOIN, $gateway_payout) ? 'selected="true"' : '';?> value="<?php echo FANVICTOR_GATEWAY_BITCOIN;?>"><?php echo __('Bitcoin', 'fantasy-sports');?></option>
                        <option <?php echo in_array(FANVICTOR_GATEWAY_CHEESE, $gateway_payout) ? 'selected="true"' : '';?> value="<?php echo FANVICTOR_GATEWAY_CHEESE;?>"><?php echo __('Cheese', 'fantasy-sports');?></option>
                        <option <?php echo in_array(FANVICTOR_GATEWAY_MOLPAY, $gateway_payout) ? 'selected="true"' : '';?> value="<?php echo FANVICTOR_GATEWAY_MOLPAY;?>"><?php echo __('Molpay', 'fantasy-sports');?></option>
                    </select>
                    <p class="description"><?php echo __('Select method to withdraw.', 'fantasy-sports');?></p>
                </td>
            </tr>
        </table>
        <ul>
            <li><a href="#tabs-31"><?php echo __('Paypal', 'fantasy-sports');?></a></li>
            <li><a href="#tabs-32"><?php echo __('Paypal Pro', 'fantasy-sports');?></a></li>
            <li><a href="#tabs-33"><?php echo __('Paypal App', 'fantasy-sports');?></a></li>
            <li><a href="#tabs-34"><?php echo __('Priority', 'fantasy-sports');?></a></li>
            <li><a href="#tabs-35"><?php echo __('Moneywave', 'fantasy-sports');?></a></li>
            <li><a href="#tabs-36"><?php echo __('Flutterwave', 'fantasy-sports');?></a></li>
            <li><a href="#tabs-37"><?php echo __('FT Tech', 'fantasy-sports');?></a></li>
            <li><a href="#tabs-38"><?php echo __('BillMap', 'fantasy-sports');?></a></li>
            <li><a href="#tabs-41"><?php echo __('Bitcoin', 'fantasy-sports');?></a></li>
            <li><a href="#tabs-42"><?php echo __('Cheese', 'fantasy-sports');?></a></li>
            <li><a href="#tabs-43"><?php echo __('MolPay', 'fantasy-sports');?></a></li>
        </ul>
        <div id="tabs-31">
            <table class="form-table">
                <tr valign="top">
                    <th scope="row"><?php echo __('Paypal Type', 'fantasy-sports');?></th>
                    <td>
                        <?php 
                            $paypal_type = get_option('fanvictor_paypal_type');
                            $paypal_type = !empty($paypal_type) ? $paypal_type : array();
                        ?>
                        <select class="postform" name="fanvictor_paypal_type[]" multiple="">
                            <option <?php echo in_array(FANVICTOR_PAYPAL_TYPE_NORMAL, $paypal_type) ? 'selected="true"' : '';?> value="<?php echo FANVICTOR_PAYPAL_TYPE_NORMAL;?>"><?php echo __('Normal', 'fantasy-sports');?></option>
                            <option <?php echo in_array(FANVICTOR_PAYPAL_TYPE_PRO, $paypal_type) ? 'selected="true"' : '';?> value="<?php echo FANVICTOR_PAYPAL_TYPE_PRO;?>"><?php echo __('Pro', 'fantasy-sports');?></option>
                        </select>
                        <p class="description"><?php echo __('Select paypal method to payout', 'fantasy-sports');?></p>
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Paypal Sandbox', 'fantasy-sports');?></th>
                    <td>
                        <select class="postform" name="paypal_test">
                            <option <?php echo get_option('paypal_test') == 1 ? 'selected="true"' : '';?> value="1"><?php echo __('True', 'fantasy-sports');?></option>
                            <option <?php echo get_option('paypal_test') == 0 ? 'selected="true"' : '';?> value="0"><?php echo __('False', 'fantasy-sports');?></option>
                        </select>
                        <p class="description"><?php echo __('If value is True, Paypal will change to testing mode.', 'fantasy-sports');?></p>
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Paypal Email', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="paypal_email_account" class="regular-text ltr" value="<?php echo esc_attr(get_option('paypal_email_account'));?>" />
                        <p class="description"><?php echo __('The email that represents your PayPal account.', 'fantasy-sports');?></p>
                    </td>
                </tr>
            </table>
        </div>
        <div id="tabs-32">
            <table class="form-table">
                <tr valign="top">
                    <th scope="row"><?php echo __('Paypal Pro Username', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_paypal_pro_username" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_paypal_pro_username'));?>" />
                        <p class="description"><?php echo __('The Username used for PayPal Pro account.', 'fantasy-sports');?></p>
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Paypal Pro Password', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_paypal_pro_password" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_paypal_pro_password'));?>" />
                        <p class="description"><?php echo __('The Password used for PayPal Pro account.', 'fantasy-sports');?></p>
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Paypal Pro Signature', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_paypal_pro_signature" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_paypal_pro_signature'));?>" />
                        <p class="description"><?php echo __('The Signature used for PayPal Pro account.', 'fantasy-sports');?></p>
                    </td>
                </tr>
            </table>
        </div>
        <div id="tabs-33">
            <table class="form-table">
                <tr valign="top">
                    <th scope="row"><?php echo __('Paypal Client Id', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_paypal_client_id" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_paypal_client_id'));?>" />
                        <p class="description"><?php echo __('This is used for PayPal App.', 'fantasy-sports');?></p>
                    </td>
                </tr>
            </table>
        </div>
        <div id="tabs-34">
            <table class="form-table">
                <tr valign="top">
                    <th scope="row"><?php echo __('Priority gateway password', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_priority_password" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_priority_password'));?>" />
                        <p class="description"><?php echo __('Password for the specified username.', 'fantasy-sports');?></p>
                    </td>
                </tr>
                 <tr valign="top">
                    <th scope="row"><?php echo __('Priority credit card', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_priority_credit_card" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_priority_credit_card'));?>" />
                        <p class="description"><?php echo __('Credit card number.', 'fantasy-sports');?></p>
                    </td>
                </tr>
                 <tr valign="top">
                    <th scope="row"><?php echo __('Priority credit card expiration date.', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_priority_credit_card_expiration_date" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_priority_credit_card_expiration_date'));?>" />
                        <p class="description"><?php echo __('Credit card expiration date.', 'fantasy-sports');?></p>
                    </td>
                </tr>
                 <tr valign="top">
                    <th scope="row"><?php echo __('Priority card security code.', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_priority_credit_card_ccv" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_priority_credit_card_ccv'));?>" />
                        <p class="description"><?php echo __('Priority CVV.', 'fantasy-sports');?></p>
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Priority gateway username', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_priority_username" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_priority_username'));?>" />
                        <p class="description"><?php echo __('Username assigned to merchant account.', 'fantasy-sports');?></p>
                    </td>
                </tr>
            </table>
        </div>
        <div id="tabs-35">
            <table class="form-table">
                <tr valign="top">
                    <th scope="row"><?php echo __('Moneywave api key', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_moneywave_api_key" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_moneywave_api_key'));?>" />
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Moneywave secret', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_moneywave_secret" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_moneywave_secret'));?>" />
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Moneywave wallet password', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_moneywave_wallet_password" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_moneywave_wallet_password'));?>" />
                    </td>
                </tr>
            </table>
        </div>
        <div id="tabs-36">
            <table class="form-table">
                <tr valign="top">
                    <th scope="row"><?php echo __('Flutterwave mode', 'fantasy-sports');?></th>
                    <td>
                        <select class="postform" name="fanvictor_flutterwave_mode">
                            <option <?php echo get_option('fanvictor_flutterwave_mode') == 0 ? 'selected="true"' : '';?> value="0"><?php echo __('Test', 'fantasy-sports');?></option>
                            <option <?php echo get_option('fanvictor_flutterwave_mode') == 1 ? 'selected="true"' : '';?> value="1"><?php echo __('Live', 'fantasy-sports');?></option>
                        </select>
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Flutterwave merchant key', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_flutterwave_merchant_key" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_flutterwave_merchant_key'));?>" />
                    </td>
                </tr>
                 <tr valign="top">
                    <th scope="row"><?php echo __('Flutterwave api key', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_flutterwave_api_key" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_flutterwave_api_key'));?>" />
                    </td>
                </tr>
            </table>
        </div>
        <div id="tabs-37">
            <table class="form-table">
                <tr valign="top">
                    <th scope="row"><?php echo __('FTTech Test', 'fantasy-sports');?></th>
                    <td>
                        <select class="postform" name="fanvictor_fftech_test">
                            <option <?php echo get_option('fanvictor_fftech_test') == 1 ? 'selected="true"' : '';?> value="1"><?php echo __('True', 'fantasy-sports');?></option>
                            <option <?php echo get_option('fanvictor_fftech_test') == 0 ? 'selected="true"' : '';?> value="0"><?php echo __('False', 'fantasy-sports');?></option>
                        </select>
                        <p class="description"><?php echo __('If value is True, FT Tech will change to testing mode.', 'fantasy-sports');?></p>
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('App Name', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_fttech_app_name" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_fttech_app_name'));?>" />
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('App Password', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_fttech_app_password" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_fttech_app_password'));?>" />
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row" colspan="2"><h3><?php echo __('Card info for withdrawal', 'fantasy-sports');?></h3></th>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Email', 'fantasy-sports');?></th>
                    <td>
                    <?php
                        $current_user = wp_get_current_user();
                     ?>
                        <input type="text" name="fanvictor_fttech_user_email" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_fttech_user_email'));?>" />
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Username', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_fttech_username" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_fttech_username'));?>" />
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Password', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_fttech_user_password" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_fttech_user_password'));?>" />
						<p><?php echo __('Password length must be greater 6 characters and contains special characters', 'fantasy-sports');?></p>
					</td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('First name', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_fttech_first_name" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_fttech_first_name'));?>" />
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Last name', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_fttech_last_name" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_fttech_last_name'));?>" />
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Phone number', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_fttech_phone" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_fttech_phone'));?>" />
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Card number', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_fttech_card_number" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_fttech_card_number'));?>" />
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Card verification value(CVV)', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_fttech_card_verification_value" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_fttech_card_verification_value'));?>" />
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Expert Month / Years', 'fantasy-sports');?></th>
                    <td>
                        <select name="fanvictor_fttech_expire_month" class="col-md-12">
                            <?php for($i = 1; $i <= 12; $i++):?>
                                <option <?php echo ($i == get_option('fanvictor_fttech_expire_month')) ? ' selected="selected"' : ''; ?> value="<?php echo $i < 10 ? '0' : '';?><?php echo $i;?>"><?php echo $i < 10 ? '0' : '';?><?php echo $i;?></option>
                            <?php endfor;?>
                        </select>    
                        <select name="fanvictor_fttech_expire_year" class="col-md-12">
                            <?php for($i = date('Y'); $i <= date('Y') + 10; $i++):?>
                                <option <?php echo ($i == get_option('fanvictor_fttech_expire_year')) ? ' selected="selected"' : ''; ?> value="<?php echo $i;?>"><?php echo $i;?></option>
                            <?php endfor;?>
                        </select>                   
                    </td>
                </tr>
                <!-- <tr valign="top">
                    <th scope="row"><?php echo __('Card description', 'fantasy-sports');?></th>
                    <td>
                        <textarea name="fanvictor_fttech_card_description" class="regular-text ltr"><?php echo esc_attr(get_option('fanvictor_fttech_card_description'));?></textarea>
                    </td>
                </tr> -->
            </table>
        </div>
        <div id="tabs-38">
            <table class="form-table">
                <tr valign="top">
                    <th scope="row"><?php echo __('Username', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_billmap_username" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_billmap_username'));?>" />
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Password', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_billmap_password" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_billmap_password'));?>" />
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Service Code', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_billmap_service_code" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_billmap_service_code'));?>" />
                    </td>
                </tr>
                <!-- <tr valign="top">
                    <th scope="row"><?php echo __('SubscriberID', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_billmap_subscriber_id" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_billmap_subscriber_id'));?>" />
                    </td>
                </tr> -->
                <tr valign="top">
                    <th scope="row"><?php echo __('Reference', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_billmap_reference" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_billmap_reference'));?>" />
                    </td>
                </tr>
            </table>
        </div>
        <div id="tabs-41">
            <table class="form-table">
                <tr valign="top">
                    <th scope="row"><?php echo __('Wallet Address', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_bitcoin_wallet_address" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_bitcoin_wallet_address'));?>" />
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Exchange Rate', 'fantasy-sports');?></th>
                    <td>
                        1 bitcoin = <input type="text" name="fanvictor_bitcoin_exchange_rate" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_bitcoin_exchange_rate'));?>" />$
                    </td>
                </tr>
            </table>
        </div>
        <div id="tabs-42">
            <table class="form-table">
                <tr valign="top">
                    <th scope="row"><?php echo __('Wallet Address', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_cheese_wallet_address" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_cheese_wallet_address'));?>" />
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Exchange Rate', 'fantasy-sports');?></th>
                    <td>
                        1 cheese = <input type="text" name="fanvictor_cheese_exchange_rate" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_cheese_exchange_rate'));?>" />$
                    </td>
                </tr>
            </table>
        </div>
        <div id="tabs-43">
            <table class="form-table">
                <tr valign="top">
                    <th scope="row"><?php echo __('Molpay Sandbox', 'fantasy-sports');?></th>
                    <td>
                        <select class="postform" name="fanvictor_molpay_test">
                            <option <?php echo get_option('fanvictor_molpay_test') == 1 ? 'selected="true"' : '';?> value="1"><?php echo __('True', 'fantasy-sports');?></option>
                            <option <?php echo get_option('fanvictor_molpay_test') == 0 ? 'selected="true"' : '';?> value="0"><?php echo __('False', 'fantasy-sports');?></option>
                        </select>
                        <p class="description"><?php echo __('If value is True, Molpay will change to testing mode.', 'fantasy-sports');?></p>
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Molpay Application Code', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_molpay_application_code" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_molpay_application_code'));?>" />
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row"><?php echo __('Molpay Secret Key', 'fantasy-sports');?></th>
                    <td>
                        <input type="text" name="fanvictor_molpay_secret_key" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_molpay_secret_key'));?>" />
                    </td>
                </tr>
            </table>
        </div>
    </div>
    <div id="tabs-4">
        <table class="form-table">
            <tr valign="top">
                <?php $currencies = FV_Currency();?>
                <th scope="row"><?php echo __('Currency', 'fantasy-sports');?></th>
                <td>
                    <select class="postform" name="fanvictor_currency">
                        <?php foreach($currencies as $key => $currency):?>
                        <option <?php echo get_option('fanvictor_currency') == $key || (get_option('fanvictor_currency') == "" && $key == "USD|$") ? 'selected="true"' : '';?> value="<?php echo $key;?>">
                            <?php echo $currency;?>
                        </option>
                        <?php endforeach;?>
                    </select>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Currency position', 'fantasy-sports');?></th>
                <td>
                    <select class="postform" name="fanvictor_currency_position">
                        <option <?php echo get_option('fanvictor_currency_position') == "before" ? 'selected="true"' : '';?> value="before"><?php echo __('Before value', 'fantasy-sports');?></option>
                        <option <?php echo get_option('fanvictor_currency_position') == "after" ? 'selected="true"' : '';?> value="after"><?php echo __('After value', 'fantasy-sports');?></option>
                    </select>
                </td>
            </tr>
            <?php if($global_setting['multiple_currency_support']):?>
            <tr valign="top">
                <th scope="row"><?php echo __('Use global currency', 'fantasy-sports');?></th>
                <td>
                    <input type="checkbox" id="global_currency_enable" name="fanvictor_global_currency_enable" <?php checked( 1, get_option( 'fanvictor_global_currency_enable' ) ); ?>  value="1" onclick="enableGlobalCurrency()"/>
                </td>
            </tr>
            <tr valign="top" class="global_currency" <?php if(get_option( 'fanvictor_global_currency_enable' ) == 0):?>style="display: none"<?php endif;?>>
                <th scope="row"><?php echo __('Global currency name', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_global_currency_name" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_global_currency_name'));?>" />
                </td>
            </tr>
            <tr valign="top" class="global_currency" <?php if(get_option( 'fanvictor_global_currency_enable' ) == 0):?>style="display: none"<?php endif;?>>
                <th scope="row"><?php echo __('Global currency symbol', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_global_currency_symbol" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_global_currency_symbol'));?>" />
                </td>
            </tr>
            <?php endif;?>
        </table>
    </div>
    <div id="tabs-5">
        <table class="form-table">
            <tr valign="top">
                <th scope="row"><?php echo __('Facebook app id', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_facebook_app_id" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_facebook_app_id'));?>" />
                    <p class="description"><?php echo sprintf(__('Enter your facebook app id or register a new app id %s. Remember add you site url in your app by going to setting menu, then find a box named website.', 'fantasy-sports'), '<a href="https://developers.facebook.com" target="_blank">here</a>');?></p>
                </td>
            </tr>
        </table>
    </div>
    <?php if($global_setting['allow_push_notification']):?>
    <div id="tabs-6">
        <table class="form-table">
            <tr valign="top">
                <th scope="row"><?php echo __('Api key', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_firebase_apikey" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_firebase_apikey'));?>" />
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Sender id', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_firebase_senderid" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_firebase_senderid'));?>" />
                </td>
            </tr>
        </table>
    </div>
    <?php endif;?>
    <div id="tabs-7">
        <table class="form-table">
            <tr valign="top">
                <th scope="row"><?php echo __('Winner of group', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_bracket_point_group_winner" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_bracket_point_group_winner'));?>" />
                    <p class="description"><?php echo sprintf(__('Default %s points.', 'fantasy-sports'), '10');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Runner-up of group', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_bracket_point_group_runnerup" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_bracket_point_group_runnerup'));?>" />
                    <p class="description"><?php echo sprintf(__('Default %s points.', 'fantasy-sports'), '5');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('1/16', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_bracket_point_16" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_bracket_point_16'));?>" />
                    <p class="description"><?php echo sprintf(__('Default %s points.', 'fantasy-sports'), '20');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('1/8', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_bracket_point_8" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_bracket_point_8'));?>" />
                    <p class="description"><?php echo sprintf(__('Default %s points.', 'fantasy-sports'), '25');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('1/4', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_bracket_point_4" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_bracket_point_4'));?>" />
                    <p class="description"><?php echo sprintf(__('Default %s points.', 'fantasy-sports'), '30');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Champion', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_bracket_point_first" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_bracket_point_first'));?>" />
                    <p class="description"><?php echo sprintf(__('Default %s points.', 'fantasy-sports'), '50');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Second', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_bracket_point_second" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_bracket_point_second'));?>" />
                    <p class="description"><?php echo sprintf(__('Default %s points.', 'fantasy-sports'), '45');?></p>
                </td>
            </tr>
            <tr valign="top">
                <th scope="row"><?php echo __('Third', 'fantasy-sports');?></th>
                <td>
                    <input type="text" name="fanvictor_bracket_point_third" class="regular-text ltr" value="<?php echo esc_attr(get_option('fanvictor_bracket_point_third'));?>" />
                    <p class="description"><?php echo sprintf(__('Default %s points.', 'fantasy-sports'), '40');?></p>
                </td>
            </tr>
        </table>
    </div>
    <?php submit_button(); ?>
</form>
</div>

<script>
    function enableGlobalCurrency(){
        if(jQuery('#global_currency_enable').is(':checked')){
            jQuery('.global_currency').show();
        }
        else{
            jQuery('.global_currency').hide();
        }
    }    
</script>